/* Program EWDC, Version 2.2.3
*  Authors: Jochen Wolf, Marie Wolfova, Emil Krupa 2012
*/

#include <stdio.h>
#include <math.h>
#include <time.h>
#define C 137 /* Total number of categories of animals + 1 */
#define C1 113 /* Total number of pure-bred categories of animals + 1 */
#define J 2 
#define L 15 /* Maximal number of reproductive cycles */
#define T 89 /* Number of categories for cows + 1 */
#define P1 21 /* Maximal number of classes for fleshiness */
#define P2 21 /* Maximal number of classes for fat covering */
#define INS 8 /* Maximal number of inseminations */
#define NCP 25 /* Number of categories for progeny + 1 */
#define D 6 /* Maximal number of classes for calving performace */
#define NSCC 7 /* Maximal number of classes for somatic cell count */ 
#define NT 48 /* Number of traits + 1 */
#define ACDD 20 /* Maximal number of age classes for dairy dams */
#define ACSD 20 /* Maximal number of age classes for dairy sires */
#define ACSB 20 /* Maximal number of age classes for beef sires */
#define ACDC 25 /* Maximal number of age classes for crossbred dams */
#define ACM 90 /* Maximal dimension of matrix for gene flow */ 
#define NTHR 10 /* Maximal number of threshold values for milk fat, 
                   milk protein, curd firmness and rennet coagulation time */
#define DL 400 /* Maximal number of days in lactation */ 

void writhead(FILE *fw);
void sysvar(FILE *fr, FILE *fw);
int readsyva(FILE *fr);
void inp07(FILE *fw, int n2, int zz);
void inp15a(FILE *fr, FILE *fw, int cb, float d2, float d3);
void inp15b(FILE *fr, FILE *fw, int cb, int ca0, int ca1, float d2, float d3);
void readcom(FILE *fr);
void readdes(FILE *fr);
void wrides(FILE *fr, FILE *fw);
void outputrw(FILE *fr, FILE *fw);
void outputr(FILE *fr);
float readfloat(FILE *fw, FILE *fr);
float readint(FILE *fw, FILE *fr);
float maxi(float a, float b);
float mini(float a, float b);
double normdis(double x);
double probit (double y);
void nonsense1(int i);
void nonsense2(int i);
void nonsense3();
void nonsense4(int i);
void nonsense5(int i);
void nonsense6(int i, int j, int CC);
void nonsense7();
void nonsense8();
void nonsense9();
void nonsense10();
void nonsense11(int i);
void nonsense12();
void nonsense13(int i);
void nonsense14();
void nonsense15();
float linregm (float xave, float sigma, float xmin, float xmax, float b0, float b1, float xbar);
void printcb(int cb, float par1, float par2, FILE *fw);
float scs(float x);
clock_t zac, kon;

int main()
{
  FILE *fr, *fw, *fw2, *fr2, *fr3;
  char out [128];
  int 
  acsd, acdd, acsb, acdc, acm, cast[J], cb, CC, claw_inc, CT, DD, delta_d[NT],
  delta_m[NT], dyscl,
  ewopt, feedcost, flag[9], gene_flow, gstd, i, i1, i2, i3, i4, 
  ind_a30, ind_RCT, inmax, inmaxh, 
  j, j1, ja, jb, jj, k, L3, LL, 
  mast_inc, matcross, matpur, milkquota, milkprice,
  n, n1, n2, na30, nfat, nprot, nRCT, n_sac, nSCC, 
  p1, p2, paf[J], pbf[J], pff[J], prodsys, prodsys2, rfi_calf, rfi_cow,  
  rfi_fa, rfi_h,  
  tech1, tech2, to[NT], to3[NT], trait, TT, tt[NT], utifemp, utifemcr, zr, zz;
  
  float   
  a1, a2, a9, a30, aa1, aa2, aa3, aa4, ab[L],
  adg1cow, adg10, adg2cow, adg[C], adgcf[J], adgcm[J],
  adghmc[J], adghm[J], adgwsc[J], adgwsf[J], adgwsm[J], age[C], 
  agec1[J], agecwsc[J], agecwsf[J], agecwsm[J], agedcw[J], agedmh[J], 
  agedwsc[J], agedwsf[J], agedwsm[J], ageh1cal[J], agehcmat1[J], 
  agehmat1[J], agesc[J], agesf[J], agesm[J], agew[J], 
  avecalc, avelifecl, avelifecy, avh, avl, 
  b1, b2, b3, b9, bw[C], bwf[J], bwm[J], 
  c1, c2, c3, c9, calfloss[J], 
  cal[J][L], cculcm[L], cculmc[L], ciav, ci[L], clcm[L], clmc[L], 
  cmat[L], cmd, conh[INS], cost[C], costacd, costc, costd[C], costdcf[J],
  costdf[J], costdrug, costdys,
  costf[C], costfc, costfix[C], costfixc, costfixwf[J], costfixwm[J],
  costfwf[J], costfwm[J], costh[C], costhc, costhcd, costhwf[J], 
  costhwm[J], costi[C1],
  costlab, costlabm, costmach, costmilkv[C1], costnacd, costo[C], costoc, 
  costom, costv[C], costvet[C], costvet10,
  costvetc, costvetcd, costvetm, costvetwf[J], costvetwm[J], 
  costwf[J], costwm[J], 
  costwt[C], costwwf[J], costwwm[J], cowyear,
  cpindys[L][INS], cpin[L][INS], cpinndys[L][INS], 
  cp[L], crdys, crinh[INS], culh[L], culvol[L], 
  d[C], d1, d1w[J], d2, d3, d9, dayshc[J], dayslac[L], dc1[C], dc2[C], 
  dccf[J], dcd[L], dcdi[L][DL], ddry[C], ddry2[C], ddry10, ddrywf[J], 
  ddrywf2[J], ddrywm[J], ddrywm2[J],
  dce[L], dcw[J], dd, dead48f[J][L], dead48m[J][L], deadfc[J][L], 
  deadmc[J][L], deltamilk, deltacow, dfcf[J], 
  discd[C1], discow[C1], dismcd, dismilk,
  dl[C1], dmcf[J], dmi[L][DL],
  dmilksum[C1], dot, dotcowh, dotcowo, dotexpm, dottest,
  dotfati, dotmilk, dp[C], dresb[J], dresc[J], drescw, dresh[J],  
  dryf[C], dryf10,
  dryf2[C], dryfwf[J], dryfwf2[J], dryfwm[J], dryfwm2[J], dung[C], dung10,
  dungwf[J], dungwm[J], dysavave, dysav[J], dysavh[D], dysavs[D][J][L], dysc[L],
  dysf[J][L], dysff[D][J][L], dys[J][L], dysmat[L], dysm[J][L],
  dysmm[D][J][L], dysscoreav[J], dysscoreavf[J], dysscoreavm[J],
  ecm, ecrinc[INS], edf[C], edf10,
  edf2[C], edfwf[J], edfwf2[J], edfwm[J], edfwm2[J],
  ew[NT][3], ew0[NT][3], ewc[NT][J], ew_d[NT], ewdiff[NT][J], ew_m[NT],
  ewr_da[NT], ewr_dd[NT], ewr_ma[NT], ewr_mm[NT],   
  ewst_d[NT], ewst_m[NT], ewsum, ewsum_d, ewsum_m, 
  ewwd[NT][ACM], ewwm[NT][ACM], exfc, 
  f[C], f10, f2[C], facSCC[NSCC], fat, fat305ave, fatkg, fe[C], fe10, fe2[C], 
  fewf[J], fewf2[J], fewm[J], fewm2[J], fix[C], fix10,
  fixwf[J], fixwm[J], fpdi[C], fpdi10, 
  fpdi2[C], fpdiwf[J], fpdiwf2[J], fpdiwm[J], fpdiwm2[J], fwf[J], fwf2[J], 
  fwm[J], fwm2[J], gstd_d[NT], gstd_m[NT], 
  hd[ACM], herdbook, hm[ACM], hmpf, inint, intcm, intconc[L], intconh, 
  ircdy[L], ircmy[L],
  kbd, kbl, kbwmf[J], kce[J], kconc[INS], kconh[INS], kcp[J], kdresb, 
  kdresbh[J], kdresc, kdresch[J], kdrescwh, kdresh, kff, kfw, 
  kg10, kgaincf[J], kgainmf[J], kgcmf[J], kghccf[J], kghcf[J], 
  kmatc, kp21[J], kpm1[J], kpm2[J], kpr[C], kslb[J], kslc[J], kslh[J], kt, ktb, 
  ktf, ktp, 
  l1[C], labdys[D], labherd, labherdcd, labvet, labvetcd, lgpre, 
  life[C1], l_inv, losc,
  losfw[J], losff, loshin[J], losmw[J], loswf, lossmcd, lossmilk, 
  losstcd, losstotal,
  mcwb, mcwd, 
  m_gf[ACM], m_gf0[ACM], milk, milk305[L], milk305ave, milk21, milk31,
  milksum[C1], milktot, milktoth, milktotl, milktotm, 
  mSCS, m_sum[ACM], mtest[J], mxmc[J], 
  Ncal[J], Ncalt, nccf[J], ncp[L], ndaycc[L], ndaycd[L], ndaydys, nd[L], 
  NDEc[C], NDEdys, NDEr[C], ne[C], ne10, ne2[C], neg[C1], nel[C1],
  nem[C1], nepc[C], newf[J], newf2[J], newm[J], newm2[J], 
  Nfav, Nfc48a[J], Nfcba[J], 
  nfcf[J], Nfcw[J], Nffa[J], Nfmat, Nfrer, nin[C1], ninr[L],
  nl[L], Nmc48a[J], Nmcba[J], 
  Nmcfb[J], Nmcfc[J], nmcf[J], Nmcf[J], nr,  
  pacd[L], Pb[P1][P2][J], pc, Pc[P1][P2][J],
  pcdys[L], pcmf[J], pconc[L][INS], pconh[INS], pcross[L], pcrossh, 
  Pcs[P1][P2][J], pdi[C], pdi10, pdi2[C], pdid[C], pdid10, pdid2[C],
  pdidwf[J], pdidwf2[J], pdidwm[J], pdidwm2[J], pdig[C1], pdil[C1], pdim[C1], 
  pdiml, pdipc[C], pdiwf[J], pdiwf2[J], pdiwm[J], pdiwm2[J], pdry,
  pf[J][3], 
  Ph[P1][P2][J], pm[J][3], pp[C1], pr[C], praib, praid, 
  prairb, praird, pranim[C], prb, Prb[P1][P2], prc, Prc[P1][P2], 
  prcs,  Prcs[P1][P2], prdg, prf[C], prf10, prf2[C],
  prfwf[J], prfwf2[J], prfwm[J], prfwm2[J], prh,  Prh[P1][P2], prherdcd,
  pricedry, priceherd, pricevet, prmilk, prmilka30[NTHR], 
  prmilkb, prmilkf[NTHR], prmilkfp, prmilkp[NTHR], prmilkRCT[NTHR], 
  prscc, profitab, profitabd, 
  prot, prot305ave, protkg, 
  prSCC[NSCC], prst, prvetcd, prwt, pSCC[NSCC], 
  psum, p_tot[NCP], pydry,
  qc[C], qr[C], RCT,
  rev[C], revc, revcullc, revmilk[C1], revmilkc, 
  ra30[4][NTHR], rf[4][NTHR], rfi[C], rfi2[C], rfi10, rfifc1[J], rfifc2[J], 
  rfimc1[J], rfimc2[J], 
  rp[4][NTHR], rRCT[4][NTHR], sdcd, sdce,
  sfrp[J], sigmaa30, sigmafat, sigmaprot, sigmaRCT, sigmaSCS, 
  sp[C1], stcd[L], stce[L], 
  straw[C], straw10, strawwf[J], strawwm[J], 
  tc[C], tconh, tconh3, Tcost, tdry[C], tdry2[C], tdry10, 
  tdrye[C], tdrye2[C], tdrye10, 
  tdryewf[J], tdryewf2[J], tdryewm[J], tdryewm2[J],  
  tdrypdi[C], tdrypdi2[C], tdrypdi10, 
  tdrypdiwf[J], tdrypdiwf2[J], tdrypdiwm[J], tdrypdiwm2[J],
  tdrywf[J], tdrywf2[J], tdrywm[J], tdrywm2[J], 
  tha30[NTHR], thfat[NTHR], thprot[NTHR], thRCT[NTHR], 
  totcal[J], Tprof, Tprofh, Tprofl, Tprofm,
  tr[C], Trev, tSCC[NSCC], tSCS[NSCC], tvh, tvl, tvm, u, 
  varmilk, vetdys[D], wat[C], wat10, watwm[J], watwf[J], 
  wbfat[J], wbfatb, wcacal[L], wcc[L], wccal[L], wccw[L], wcd[L], 
  wcdys[L], wcfat[J], wcfatb, wcwsc[J], wcwsf[J], wcwsm[J], wdcwf[J], 
  wdwsc[J], wdwsf[J], wdwsm[J], wh1cal, whcmat, whdmh, whfat[J], whfatb, 
  whmat1[J], wpreg, ww[C], wwf[J], wwm[J],
  yacdi, ycdi, ymi, ynacdi, zzdmi[L][DL], zzircmy[L], zzlosc[30], zzmilksum[C1]; 

  double 
  a, aa11, a3, 
  dysff0[D][J][L], dysffl[D][J], dysffld[D][J], dysfflqm[D][J], dysfflmc[J],
  dysfflql[D][J], dysffldl[D][J], dysffll[D][J], dysfflqr[D][J], 
  dysffldr[D][J], dysfflr[D][J],
  dysmm0[D][J][L], dysmml[D][J], dysmmld[D][J], dysmmlqm[D][J], dysmmlmc[J],
  dysmmlql[D][J], dysmmldl[D][J], dysmmll[D][J], dysmmlqr[D][J], 
  dysmmldr[D][J], dysmmlr[D][J],
  l2_0[T], l2[T], l3[L], 
  Pcfl[P1][J], Pcfc[P2][J],Pcflqm[P1][J], Pcfcqm[P2][J], Pcfld[P1][J], 
  Pcfcd[P2][J], Pcfcmc[J], Pcfcmcc[J], Pcfcmcb[J], Pcfcmch[J], Pcfcmcca[J], 
  Pcflmc[J], Pcflmcc[J], Pcflmcb[J], Pcflmch[J], Pcflmcca[J],  Pcflql[P1][J], 
  Pcfcql[P2][J], Pcfldl[P1][J], Pcfcdl[P2][J], Pcfll[P1][J], Pcfcl[P2][J],
  Pc0[P1][P2][J], Pcflqr[P1][J], Pcfcqr[P2][J], Pcfldr[P1][J], Pcfcdr[P2][J], 
  Pcflr[P1][J], Pcfcr[P2][J], Phiscc[NSCC], PM[ACM][ACM],
  sl2, t[T][T]; 
      
  acsd = acdd = acsb = acdc = acm = cb = CC = claw_inc = CT = DD = dyscl =
  ewopt = feedcost = gene_flow = gstd = i = i1 = i2 = i3 = i4 = 
  ind_a30 = ind_RCT = inmax = inmaxh = 
  j = j1 = ja = jb = jj = k = L3 = LL = mast_inc = matcross = matpur = 
  milkquota = milkprice = n = n1 = n2 = na30 = nfat = nprot = 
  nRCT = n_sac = p1 = p2 = 
  nSCC = prodsys = prodsys2 = rfi_calf = rfi_cow = rfi_fa = rfi_h =
  tech1 = tech2 = trait = TT = utifemp = 
  utifemcr = zr = zz = 0;

  a1 = a2 = a9 = a30 = aa1 = aa2 = aa3 = aa4 = adg1cow = adg10 = adg2cow = 
  avecalc = avelifecl = avelifecy = avh = avl = b1 = b2 = b3 = b9 = 
  c1 = c2 = c3 = c9 = ciav = cmd = costacd = costc = costdrug = costdys =
  costfc = costfixc = costhc = costhcd = costlab = costlabm = costmach = 
  costnacd = costoc = costom = costvet10 = costvetc = 
  costvetcd = costvetm = cowyear = crdys = 
  d1 = d2 = d3 = d9 = dd = ddry10 = deltamilk = deltacow = 
  dismcd = dismilk = dot = 
  dotcowh = dotcowo = dotexpm = dottest = dotfati = dotmilk = drescw = 
  dryf10 = dung10 = dysavave = ecm = edf10 = ewsum = ewsum_d = 
  ewsum_m = exfc = 
  f10 = fat = fat305ave = fatkg = fe10 = fix10 = fpdi10 = 
  herdbook = hmpf = inint = intcm = intconh = 
  kbd = kbl = kdresb = kdresc = kdrescwh = kdresh = kff = kfw = 
  kg10 = kmatc = kt = ktb = ktf = ktp = 
  labherd = labherdcd = labvet = labvetcd = lgpre = l_inv = losc = 
  losff = loswf = 
  lossmcd = lossmilk = losstcd = losstotal =
  mcwb = mcwd = milk = milk305ave = milk21 = milk31 =
  milktot = milktoth = milktotl = milktotm = mSCS = 
  Ncalt = ndaydys = NDEdys = ne10 = Nfav = Nfmat = Nfrer = nr =  
  pc = pcrossh = pdi10 = pdid10 = pdiml = pdry = praib = praid = 
  prairb = praird = prb = prc = prcs = prdg = prf10 = prh = prherdcd =
  pricedry = priceherd = pricevet = prmilk = prmilkb = 
  prmilkfp = prscc = profitab = profitabd = prot = prot305ave = 
  protkg = prst = prvetcd = prwt = psum = pydry = sdcd = sdce =
  RCT = revc = revcullc = revmilkc = rfi10 =  
  sigmaa30 = sigmafat = sigmaprot = sigmaRCT = sigmaSCS = straw10 =  
  tconh = tconh3 = Tcost = tdry10 = tdrye10 = tdrypdi10 = 
  Tprof = Tprofh = Tprofl = Tprofm =
  Trev = tvh = tvl = tvm = u = varmilk = 
  wat10 = wbfatb = wcfatb = wh1cal = whcmat = whdmh = whfatb = wpreg = 
  yacdi = ymi = ynacdi = zzlosc[30] = 0.0;
  a = aa11 = a3 = sl2 = 0.0;

  for (i = 0; i < C1; i++) 
    costi[i] = costmilkv[i] = discd[i] = discow[i] = dl[i] = 
    dmilksum[i] = life[i] = milksum[i] = neg[i] = nel[i] = 
    nem[i] = nin[i] = pdig[i] = pdil[i] = pdim[i] = pp[i] = 
    revmilk[i] = sp[i] = zzmilksum[i] = 0.0;
  for (i = 0; i < C; i++) 
    adg[i] = age[i] = bw[i] = cost[i] = costd[i] = costf[i] = 
    costfix[i] = costh[i] = costo[i] = costv[i] = costvet[i] = 
    costwt[i] = d[i] = dc1[i] = dc2[i] = ddry[i] = ddry2[i] = dp[i] = 
    dryf[i] = dryf2[i] = 
    dung[i] = edf[i] = edf2[i] = f[i] = f2[i] = fe[i] = fe2[i] = 
    fix[i] = fpdi[i] = fpdi2[i] = kpr[i] = l1[i] = NDEc[i] = 
    NDEr[i] = ne[i] = ne2[i] = nepc[i] = pdi[i] = pdi2[i] = 
    pdid[i] = pdid2[i] = pdipc[i] = pr[i] = pranim[i] = prf[i] = 
    prf2[i] = rfi[i] = rfi2[i] = qc[i] = qr[i] = rev[i] = 
    straw[i] = tc[i] = tr[i] = tdry[i] = tdry2[i] = 
    tdrye[i] = tdrye2[i] = tdrypdi[i] = tdrypdi2[i] = 
    wat[i] = ww[i] = 0.0;
  for (i = 0; i < J; i++) {
    adgcf[i] = adgcm[i] = adghmc[i] = adghm[i] 
    = adgwsc[i] = adgwsf[i] = adgwsm[i] 
    = agec1[i] = agecwsc[i] = agecwsf[i] = agecwsm[i] = agedcw[i] 
    = agedmh[i] = agedwsc[i] = agedwsf[i] = agedwsm[i] = ageh1cal[i] 
    = agehcmat1[i] = agehmat1[i] = agesc[i] = agesf[i] = agesm[i] 
    = agew[i] = bwf[i] = bwm[i] = calfloss[i] = costdcf[i] = costdf[i] 
    = costfixwf[i] = costfixwm[i] = costfwf[i] = costfwm[i] 
    = costhwf[i] = costhwm[i] = costvetwf[i] = costvetwm[i] = costwf[i] 
    = costwm[i] = costwwf[i] = costwwm[i] 
    = d1w[i] = dayshc[i] = dccf[i] = dcw[i] 
    = ddrywf[i] = ddrywf2[i] = ddrywm[i] = ddrywm2[i] 
    = dfcf[i] = dmcf[i] 
    = dresb[i] = dresc[i] = dresh[i] 
    = dryfwf[i] = dryfwf2[i] = dryfwm[i] = dryfwm2[i] 
    = dungwf[i] = dungwm[i] = dysav[i] 
    = dysscoreav[i] = dysscoreavf[i] = dysscoreavm[i] 
    = edfwf[i] = edfwf2[i] = edfwm[i] = edfwm2[i] 
    = fewf[i] = fewf2[i] = fewm[i] = fewm2[i] = fixwf[i] = fixwm[i] 
    = fpdiwf[i] = fpdiwf2[i] = fpdiwm[i] = fpdiwm2[i] = fwf[i] 
    = fwf2[i] = fwm[i] = fwm2[i] 
    = kbwmf[i] = kce[i] = kcp[i] = kdresbh[i] = kdresch[i] 
    = kgaincf[i] = kgainmf[i] = kgcmf[i] = kghccf[i] = kghcf[i] 
    = kp21[i] = kpm1[i] = kpm2[i] = kslb[i] = kslc[i] = kslh[i] 
    = losfw[i] = loshin[i] = losmw[i] = mtest[i] = mxmc[i] 
    = Ncal[i] = nccf[i] = newf[i] = newf2[i] = newm[i] = newm2[i] 
    = Nfc48a[i] = Nfcba[i] = nfcf[i] = Nfcw[i] = Nffa[i] 
    = Nmc48a[i] = Nmcba[i] = Nmcfb[i] = Nmcfc[i] = nmcf[i] = Nmcf[i] 
    = pcmf[i] = pdidwf[i] = pdidwf2[i] = pdidwm[i] = pdidwm2[i] 
    = pdiwf[i] = pdiwf2[i] = pdiwm[i] = pdiwm2[i] = prfwf[i] 
    = prfwf2[i] = prfwm[i] = prfwm2[i] = rfifc1[i] = rfifc2[i] 
    = rfimc1[i] = rfimc2[i]
    = sfrp[i] = strawwf[i] = strawwm[i] = totcal[i] 
    = tdryewf[i] = tdryewf2[i] = tdryewm[i] = tdryewm2[i] 
    = tdrypdiwf[i] = tdrypdiwf2[i] = tdrypdiwm[i] = tdrypdiwm2[i] 
    = tdrywf[i] = tdrywf2[i] = tdrywm[i] = tdrywm2[i] 
    = watwm[i] = watwf[i] = wbfat[i] = wcfat[i] = wcwsc[i] 
    = wcwsf[i] = wcwsm[i] = wdcwf[i] = wdwsc[i] = wdwsf[i] 
    = wdwsm[i] = whfat[i] = whmat1[i] = wwf[i] = wwm[i] 
    = dysfflmc[i] = dysmmlmc[i] 
    = Pcfcmc[i] = Pcfcmcc[i] = Pcfcmcb[i] = Pcfcmch[i] 
    = Pcfcmcca[i] = Pcflmc[i] = Pcflmcc[i] = Pcflmcb[i] 
    = Pcflmch[i] = Pcflmcca[i] = 0.0;
    cast[i] = paf[i] = pbf[i] = pff[i] = 0;
    }
  for (i = 0; i < L; i++) {
    ab[i] = cculcm[i] = cculmc[i] = ci[i] = clcm[i] 
    = clmc[i] = cmat[i] = cp[i] = culh[i] = culvol[i] 
    = dayslac[i] = dcd[i] = dce[i] = dysc[i] = dysmat[i] 
    = intconc[i] = ircdy[i] = ircmy[i] = milk305[i] = ncp[i] 
    = ndaycc[i] = ndaycd[i] = nd[i] = ninr[i] = nl[i] 
    = pacd[i] = pcdys[i] = pcross[i] = stcd[i] = stce[i] = wcacal[i] 
    = wcc[i] = wccal[i] = wccw[i] = wcd[i] = wcdys[i] = zzircmy[i] 
    = l3[i] = 0.0;
    for (j = 0; j < J; j++) 
      cal[j][i] = dead48f[j][i] = dead48m[j][i] = deadfc[j][i] 
      = deadmc[j][i] = dys[j][i] = dysf[j][i] = dysm[j][i] = 0.0;
    }   
  for (i = 0; i < NTHR; i++) {
    prmilkf[i] = thfat[i] = prmilkp[i] = thprot[i] = prmilka30[i] = 
    tha30[i] = prmilkRCT[i] = thRCT[i] = 0.0;
    for (j = 0; j < 4; j++)
      rf[j][i] = rp[j][i] = ra30[j][i] = rRCT[j][i] = 0.0;
    }
  for (i = 0; i < NSCC; i++) 
    facSCC[i] = prSCC[i] = pSCC[i] = tSCC[i] = tSCS[i] 
    = Phiscc[i] = 0.0;
  for (i = 0; i < INS; i++) {
    conh[i] = crinh[i] = ecrinc[i] = kconc[i] = kconh[i] 
    = pconh[i] = 0.0;
    for (j = 0; j < L; j++)
      cpindys[j][i] = cpin[j][i] = cpinndys[j][i] = pconc[j][i] = 0.0;  
    }
  for (j = 0; j < ACM; j++) {
    hd[j] = hm[j] = m_gf[j] = m_gf0[j] = m_sum[j] = 0.0;
    for (i = 0; i < NT; i++) 
      ewwd[i][j] = ewwm[i][j] = 0.0;
    for (i = 0; i < ACM; i++)   
      PM[j][i] = 0.0;
    }  
  for (i = 0; i < NCP; i++) p_tot[i] = 0.0;    
  for (i = 0; i < NT; i++) {
    to[i] = 2;
    to3[i] = 1;
    tt[i] = delta_d[i] = delta_m[i] = 0;
    ew_d[i]= ew_m[i] = ewr_da[i] = ewr_dd[i] = ewr_ma[i]
    = ewr_mm[i] = ewst_d[i]= ewst_m[i] 
    = gstd_d[i] = gstd_m[i] = 0.0;
    for (j = 0; j < 3; j++)
      ew[i][j] = ew0[i][j] = 0.0;
    for (j = 0; j < J; j++)
      ewc[i][j] = ewdiff[i][j] = 0.0;  
    }
  for (i = 0; i < D; i++) {
    dysavh[i] = labdys[i] = vetdys[i] = 0.0;
    for (j = 0; j < J; j++) {
      dysffl[i][j] = dysffld[i][j] = dysfflqm[i][j] 
      = dysfflql[i][j] = dysffldl[i][j] = dysffll[i][j] 
      = dysfflqr[i][j] = dysffldr[i][j] = dysfflr[i][j] 
      = dysmml[i][j] = dysmmld[i][j] = dysmmlqm[i][j] 
      = dysmmlql[i][j] = dysmmldl[i][j] = dysmmll[i][j] 
      = dysmmlqr[i][j] = dysmmldr[i][j] = dysmmlr[i][j] = 0.0;
      for (i1 = 0; i1 < L; i1++)
        dysavs[i][j][i1] = dysff[i][j][i1] = dysmm[i][j][i1] 
	= dysff0[i][j][i1] = dysmm0[i][j][i1] = 0.0;  
      }  
    }
  for (i = 0; i < P1; i++) {
    for (j = 0; j < P2; j++) {
      Prb[i][j] = Prc[i][j] = Prcs[i][j] = Prh[i][j] = 0.0;
      for (i1 = 0; i1 <= cb; i1++)
        Pb[i][j][i1] = Pc[i][j][i1] = Pcs[i][j][i1] = Ph[i][j][i1] 
	= Pc0[i][j][i1] =  0.0;  
      }  
    }
  for (j = 0; j < J; j++) {
    for (i = 0; i < P1; i++)
      Pcfl[i][j] = Pcflqm[i][j] = Pcfld[i][j] = Pcflql[i][j] 
      = Pcfldl[i][j] = Pcfll[i][j] = Pcflqr[i][j] 
      = Pcfldr[i][j] = Pcflr[i][j] = 0.0;
    for (i = 0; i < i; i++)
      Pcfc[i][j] =Pcfcqm[i][j] = Pcfcd[i][j] = Pcfcql[i][j] 
      = Pcfcdl[i][j] = Pcfcl[i][j] = Pcfcqr[i][j] 
      = Pcfcdr[i][j] = Pcfcr[i][j] = 0.0;  
    }
  for (i = 0; i < L; i++) {
    for (j = 0; j < DL; j++)
      dmi[i][j] = zzdmi[i][j] = dcdi[i][j] = 0.0;
    }
  for (i = 0; i < J; i++) {
    for (j = 0; j < 3; j++)
      pf[i][j] = pm[i][j] = 0.0;
    }
  for (i = 0; i < T; i++) {
    l2_0[i] = l2[i] = 0.0;
    for (j = 0; j < T; j++)
      t[i][j] = 0.0;
    }
  for (i = 0; i < 9; i++) flag[i] = 0;   
  zr = 1;
  zac = clock(); /* Start of measuring time for calculation */

  /* Type of traits: 0 - direct, 1 - maternal, 2 - direct and maternal */
  for (i = 1; i <= 3; i++) tt[i] = 2;
  tt[4] = tt[11] = tt[13] = tt[29] = tt[41] = tt[45] = tt[46] = 1;
  for (i = 5; i <= 8; i++) tt[i] = 2;
  for (i = 24; i <= 28; i++) tt[i] = 2;
  tt[30] = 2;
  for (i = 31; i <= 39; i++) tt[i] = 1;
  
  printf("\n\n\nRunning EWDC Version 2.2.3, July 2012\n"); 
  printf("Authors: Jochen Wolf (wolf.jochen@vuzv.cz)\n");
  printf("         Marie Wolfova (wolfova.marie@vuzv.cz)\n"); 
  printf("         Emil Krupa (krupa.emil@vuzv.cz)\n\n");

  /* Writing the head of the output file */
  fr2 = fopen("TEXTD_OUT.TXT", "r"); /* File for reading text for output */
  printf("Please enter the name of the file for writing results\n");
  scanf("%s", out);
  fw = fopen(out, "w"); /* File for writing results */  
  outputrw(fr2, fw);
  
  /* Reading parameter file PARAD.TXT and writing its information to output file */
  fr = fopen("PARAD.TXT", "r");
  outputrw(fr, fw);
  sysvar(fr, fw);
  fclose(fr); 
  prodsys = 4; 
  fr = fopen("PARAD.TXT", "r");
  printf("Reading data from PARAD.TXT\n");
  outputr(fr);
  cb = readsyva(fr);
  tech1 = readsyva(fr);  
  tech2 = readsyva(fr);
  matpur = readsyva(fr);
  matcross = readsyva(fr);  
  utifemp = readsyva(fr);  
  utifemcr = readsyva(fr);
  cast[0] = readsyva(fr);
  cast[1] = readsyva(fr);   
  feedcost = readsyva(fr); 
  ewopt = readsyva(fr);   
  gene_flow = readsyva(fr);
  mast_inc = readsyva(fr);  
  milkquota = readsyva(fr);  
  milkprice = readsyva(fr);  
  ind_a30 = readsyva(fr);
  ind_RCT = readsyva(fr);  
  LL = readsyva(fr); 
  gstd = readsyva(fr);
  claw_inc = readsyva(fr); 
  rfi_calf = readsyva(fr); 
  rfi_h = readsyva(fr); 
  rfi_fa = readsyva(fr); 
  rfi_cow = readsyva(fr); 
  fclose(fr);  

  if (cb == 0 && gene_flow == 3) {
    nonsense3();
    goto END;
    }
  if (cb == 1 && ewopt == 0) {
    nonsense7();
    goto END;
    }
  if (cb == 1 && ewopt == 1 && gene_flow != 3) {
    nonsense8();
    goto END;
    }
  if (cb == 1 && ewopt == 2 && gene_flow == 3) {
    nonsense9();
    goto END;
    }
  if (ewopt > 0 && cb == 0) {
    nonsense10();
    goto END;
    }
  if (gstd == 3 && cb == 1 && utifemcr == 3) {
    nonsense14();
    goto END;
    }
  if (cb == 0) cast[1] = 0;
     
  TT = (LL-1)*6 + 4;
  CC = TT + 24;
  CT = TT + 48;

  if (ewopt < 2) ja = jb = ewopt;
  if (ewopt == 2) {
    ja = 0;
    jb = 1;
    }  
  if (cb == 1) i4 = CT + 1;
    else i4 = CC + 1;

  outputrw(fr2, fw);

  /* Reading input file INPUT15.TXT and writing its information to output file */
  printf("Reading data from INPUT15.TXT\n");
  n2 = 15;
  zz++;
  inp07(fw,n2,zz);
  fr = fopen("INPUT15.TXT", "r");  
  readcom(fr);   
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &mxmc[i]);
  inp15a(fr, fw, cb, mxmc[0], mxmc[1]);
  fscanf(fr,"%f", &mtest[0]);
  inp15a(fr, fw, 0, mtest[0], mtest[1]);
  for (i = 0; i <= cb; i++) {
    if (mxmc[i] + mtest[i] > 0.999999 && cast[i] == 1) {
      cast[i] = 0;
      fprintf(fw, "\n\n*************************************************\n");
      fprintf(fw, "* W a r n i n g !                               *\n");
      fprintf(fw, "* In PARAD.TXT you have stated that there are   *\n");
      if (i == 0)
        fprintf(fw, "* pure-bred castrates for fattening, but there  *\n");
      if (i == 1)
        fprintf(fw, "* cross-bred castrates for fattening, but there *\n");
      fprintf(fw, "* are no male calves which can be castrated.    *\n");
      fprintf(fw, "* Therefore your wrong parameter from PARAD.TXT *\n");
      fprintf(fw, "* was corrected and set to zero.                *\n");
      fprintf(fw, "*************************************************\n\n");	
      }
    }    
  fscanf(fr,"%f", &pcmf[0]);
  if (cast[0] == 0) pcmf[0] = 0;
  if (cast[1] == 1 && cb == 1) fscanf(fr,"%f", &pcmf[1]);
  if (cast[1] == 0) pcmf[1] = 0;
  inp15b(fr, fw, cb, cast[0], cast[1], pcmf[0], pcmf[1]);
  for (i = 0; i <= cb; i++) {
    if (mxmc[i] + mtest[i] > 0.999999 || cast[i] * pcmf[i] > 0.999999) 
      pbf[i] = 0;
      else pbf[i] = 1;
    } 
  if (cb == 1 && utifemcr == 4) exfc=readfloat(fw,fr);
    else readdes(fr);
  if (utifemp == 2) pff[0] = 1;
    else pff[0] = 0;
  if (cb == 1) {
    if (utifemcr == 2 || (utifemcr == 4 && exfc < 0.999999)) pff[1] = 1;
    else pff[1] = 0;
    } 
  for (i = 0; i <= cb; i++)
    if (pbf[i] == 0 && cast[i] == 0 && pff[i] == 0) paf[i] = 0;
    else paf[i] = 1;  
  if (rfi_fa == 1 && paf[0] + paf[1] == 0) {
    nonsense15();
    goto END;
    }
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &bwf[i]);
  inp15a(fr, fw, cb, bwf[0], bwf[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &bwm[i]);
  inp15a(fr, fw, cb, bwm[0], bwm[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &agec1[i]);
  inp15a(fr, fw, cb, agec1[0], agec1[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &agew[i]);
  inp15a(fr, fw, cb, agew[0], agew[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &age[8 + i*CC]);
  inp15a(fr, fw, cb, age[8], age[CC+8]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &age[9 + i*CC]);
  inp15a(fr, fw, cb, age[9], age[CC+9]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &adgcf[i]);
  inp15a(fr, fw, cb, adgcf[0], adgcf[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &adgcm[i]);
  inp15a(fr, fw, cb, adgcm[0], adgcm[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &age[10 + i*CC]);
  inp15a(fr, fw, cb, age[10], age[CC+10]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &whmat1[i]);
  inp15a(fr, fw, cb, whmat1[0], whmat1[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &adghm[i]);
  inp15a(fr, fw, cb, adghm[0], adghm[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &adghmc[i]);
  inp15a(fr, fw, cb, adghmc[0], adghmc[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &dayshc[i]);
  inp15a(fr, fw, cb, dayshc[0], dayshc[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &age[23 + i*CC]);
  if (cb == 1 && utifemcr != 3) age[23 + CC] = 0;
  inp15a(fr, fw, cb, age[23], age[CC+23]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &age[24 + i*CC]);
  if (cb == 1 && utifemcr != 3) age[24 + CC] = 0;
  inp15a(fr, fw, cb, age[24], age[CC+24]);
  fscanf(fr,"%f", &adgwsf[0]);
  if (pff[0] == 0) adgwsf[0] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &adgwsf[1]);
  inp15b(fr, fw, cb, pff[0], pff[1], adgwsf[0], adgwsf[1]);  
  fscanf(fr,"%f", &adgwsm[0]);
  if (pbf[0] == 0) adgwsm[0] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &adgwsm[1]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], adgwsm[0], adgwsm[1]);  
  fscanf(fr,"%f", &adgwsc[0]);
  if (cast[0] == 0) adgwsc[0] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &adgwsc[1]);
  inp15b(fr, fw, cb, cast[0], cast[1], adgwsc[0], adgwsc[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &dresh[i]);
  inp15a(fr, fw, cb, dresh[0], dresh[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &dresb[i]);
  inp15a(fr, fw, cb, dresb[0], dresb[1]);
  fscanf(fr,"%f", &dresc[0]);
  if (cast[0] == 0) dresc[0] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &dresc[1]);
  inp15b(fr, fw, cb, cast[0], cast[1], dresc[0], dresc[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &dcw[i]);
  inp15a(fr, fw, cb, dcw[0], dcw[1]);
  fscanf(fr,"%f", &dmcf[0]);
  if (pbf[0] == 0) dmcf[0] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &dmcf[1]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], dmcf[0], dmcf[1]);  
  fscanf(fr,"%f", &nmcf[0]);
  if (pbf[0] == 0) nmcf[0] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &nmcf[1]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], nmcf[0], nmcf[1]);  
  fscanf(fr,"%f", &dccf[0]);
  if (cast[0] == 0) dccf[0] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &dccf[1]);
  inp15b(fr, fw, cb, cast[0], cast[1], dccf[0], dccf[1]);
  fscanf(fr,"%f", &nccf[0]);
  if (cast[0] == 0) nccf[0] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &nccf[1]);
  inp15b(fr, fw, cb, cast[0], cast[1], nccf[0], nccf[1]);
  fscanf(fr,"%f", &dfcf[0]);
  if (pff[0] == 0) dfcf[0] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &dfcf[1]);
  inp15b(fr, fw, cb, pff[0], pff[1], dfcf[0], dfcf[1]);  
  fscanf(fr,"%f", &nfcf[0]);
  if (pff[0] == 0) nfcf[0] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &nfcf[1]);
  inp15b(fr, fw, cb, pff[0], pff[1], nfcf[0], nfcf[1]);  
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &loshin[i]);
  inp15a(fr, fw, cb, loshin[0], loshin[1]);
  for (i = 0; i <= cb; i++)  fscanf(fr,"%f", &sfrp[i]);
  inp15a(fr, fw, cb, sfrp[0], sfrp[1]);
  fprintf(fw, "\n\n");
  fclose(fr);
  for (i = 0; i <= cb; i++) 
    if (mxmc[i] + mtest[i] > 1.000001) {
      nonsense1(i);
      goto END; 
    }
  for (i = 0; i <= cb; i++) 
    if (cast[i] == 1 && pcmf[i] < 0.000001) {
      nonsense2(i);
      goto END; 
    }
  i3 = cb;
  if (cast[1] + pbf[1] + pff[1] < 1) i3 = 0;
  for (i = 0; i <= i3; i++) {
    if (pff[i] == 0) {
      if (pbf[i] == 1) adgwsf[i] = adgwsm[i];
      if (pbf[i] == 0 && cast[i] == 1) adgwsf[i] = adgwsc[i];
      }
    } 

  /* Reading input file INPUT11.TXT and writing its information to output file */
  n2 = 11;
  zz++;
  inp07(fw,n2,zz);
  printf("Reading data from INPUT11.TXT\n");
  fr = fopen("INPUT11.TXT", "r");
  readcom(fr); 
  DD=readint(fw,fr);
  dyscl=readint(fw,fr);
  lgpre=readfloat(fw,fr);
  intcm=readfloat(fw,fr);
  inint=readfloat(fw,fr);
  dd=readfloat(fw,fr);
  inmax=readint(fw,fr);
  inmaxh=readint(fw,fr);
  nr=readfloat(fw,fr);
  crdys=readfloat(fw,fr); 
  cmd=readfloat(fw,fr);
  fat=readfloat(fw,fr);
  prot=readfloat(fw,fr);   
  mcwd=readfloat(fw,fr); 
  if (cb == 1) mcwb=readfloat(fw,fr);
    else readdes(fr);
  wpreg=readfloat(fw,fr);  
  adg1cow=readfloat(fw,fr);
  ndaydys=readfloat(fw,fr);
  drescw=readfloat(fw,fr);
  loswf=readfloat(fw,fr);
  if (paf[0] + paf[1] > 0) losff=readfloat(fw,fr);
    else readdes(fr);
  dryf[30]=readfloat(fw,fr);  
  edf[30]=readfloat(fw,fr);
  pdid[30]=readfloat(fw,fr); 
  if (rfi_cow == 1) rfi[30]=readfloat(fw,fr); 
    else readdes(fr);
  kbd=readfloat(fw,fr);
  kbl=readfloat(fw,fr);
  ktp=readfloat(fw,fr);
  ktb=readfloat(fw,fr);
  ktf=readfloat(fw,fr);    
  wat[30]=readfloat(fw,fr);
  straw[30]=readfloat(fw,fr);
  dung[30]=readfloat(fw,fr);  
  prf[30]=readfloat(fw,fr);
  prdg=readfloat(fw,fr);
  prst=readfloat(fw,fr);
  prwt=readfloat(fw,fr);
  praid=readfloat(fw,fr);
  praird=readfloat(fw,fr);
  if (cb == 1) {
    praib=readfloat(fw,fr);
    prairb=readfloat(fw,fr);
    }
  else for (i = 1; i <= 2; i++) readdes(fr);  
  prc=readfloat(fw,fr);
  kpr[30]=readfloat(fw,fr);
  costd[25]=readfloat(fw,fr);
  costv[30]=readfloat(fw,fr);
  for (i = 0; i < DD; i++) vetdys[i]=readfloat(fw,fr);
  for (i = 1; i <= D - DD; i++) readdes(fr);
  for (i = 0; i < DD; i++) labdys[i]=readfloat(fw,fr);
  for (i = 1; i <= D - DD; i++) readdes(fr);
  costlab=readfloat(fw,fr);
  varmilk=readfloat(fw,fr);
  fix[30]=readfloat(fw,fr);
  u=readfloat(fw,fr);
  dotmilk=readfloat(fw,fr);
  dotcowo=readfloat(fw,fr);
  dotcowh=readfloat(fw,fr);
  dotexpm=readfloat(fw,fr);
  if (paf[0] + paf[1] > 0) dotfati=readfloat(fw,fr);
    else readdes(fr);
  herdbook=readfloat(fw,fr);
  if (cb == 1) pcrossh=readfloat(fw,fr);
    else readdes(fr);
  fprintf(fw,"\n\n");
  fclose(fr); 

  /* Reading input file INPUT23.TXT and writing its information to output file */
  n2 = 23;
  zz++;
  inp07(fw,n2,zz);
  printf("Reading data from INPUT23.TXT\n");
  fr = fopen("INPUT23.TXT", "r");
  readcom(fr); 
  if (pff[0] + pff[1] > 0) kpr[12]=readfloat(fw,fr);
    else readdes(fr);
  if (pbf[0] + pbf[1] > 0) kpr[14]=readfloat(fw,fr);
    else readdes(fr);
  if (cast[0] + cast[1] > 0) kpr[17]=readfloat(fw,fr);
    else readdes(fr);
  if (pff[0] + pff[1] > 0) kdresh=readfloat(fw,fr);
    else readdes(fr);
  if (pbf[0] + pbf[1] > 0) kdresb=readfloat(fw,fr);
    else readdes(fr);
  if (cast[0] + cast[1] > 0) kdresc=readfloat(fw,fr);
    else readdes(fr);
  prh=readfloat(fw,fr);
  if (pbf[0] + pbf[1] > 0) prb=readfloat(fw,fr);
    else readdes(fr);
  if (cast[0] + cast[1] > 0) prcs=readfloat(fw,fr);
    else readdes(fr);
  p1=readint(fw,fr);
  p2=readint(fw,fr);
  if (pbf[1] == 1) wbfatb=readfloat(fw,fr);
    else readdes(fr);
  if (pff[1] == 1) whfatb=readfloat(fw,fr);
    else readdes(fr);
  if (cast[1] == 1) wcfatb=readfloat(fw,fr);
    else readdes(fr);
  if (pff[0] + pff[1] > 0) whfat[0]=readfloat(fw,fr);
    else readdes(fr);  
  if (pbf[0] + pbf[1] > 0) wbfat[0]=readfloat(fw,fr);
    else readdes(fr);
  if (cast[0] + cast[1] > 0) wcfat[0]=readfloat(fw,fr);  
    else readdes(fr);
  fprintf(fw,"\n\n");
  fclose(fr);
 
/* Reading input file INPUT22.TXT and writing its information to output file */
  n2 = 22;
  zz++;
  inp07(fw,n2,zz);
  printf("Reading data from INPUT22.TXT\n");
  fr = fopen("INPUT22.TXT", "r");
  readcom(fr); 
  milk=readfloat(fw,fr);
  b1=readfloat(fw,fr);
  b2=readfloat(fw,fr);
  b3=readfloat(fw,fr);
  c1=readfloat(fw,fr);
  c2=readfloat(fw,fr);
  c3=readfloat(fw,fr);
  d1=readfloat(fw,fr);
  d2=readfloat(fw,fr);
  d3=readfloat(fw,fr);
  fprintf(fw,"\n\n");
  fclose(fr);

  /* Reading input file INPUT21.TXT and writing its information to output file */
  printf("Reading data from INPUT21.TXT\n");
  n2 = 21;
  zz++;
  inp07(fw,n2,zz);
  fr = fopen("INPUT21.TXT", "r");  
  readcom(fr);   
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &dryfwf[i]);
  inp15a(fr, fw, cb, dryfwf[0], dryfwf[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &edfwf[i]);
  inp15a(fr, fw, cb, edfwf[0], edfwf[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pdidwf[i]);
  inp15a(fr, fw, cb, pdidwf[0], pdidwf[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &prfwf[i]);
  inp15a(fr, fw, cb, prfwf[0], prfwf[1]);
  if (rfi_calf == 1) {
    for (i = 0; i <= cb; i++) fscanf(fr,"%f", &rfifc1[i]);
    inp15a(fr, fw, cb, rfifc1[0], rfifc1[1]);
    for (i = 0; i <= cb; i++) fscanf(fr,"%f", &rfimc1[i]);
    inp15a(fr, fw, cb, rfimc1[0], rfimc1[1]);
    }
  else for (i = 1; i <= 2; i++) readdes(fr);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &dryfwf2[i]);
  inp15a(fr, fw, cb, dryfwf2[0], dryfwf2[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &edfwf2[i]);
  inp15a(fr, fw, cb, edfwf2[0], edfwf2[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pdidwf2[i]);
  inp15a(fr, fw, cb, pdidwf2[0], pdidwf2[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &prfwf2[i]);
  inp15a(fr, fw, cb, prfwf2[0], prfwf2[1]);
  if (rfi_calf == 1) {
    for (i = 0; i <= cb; i++) fscanf(fr,"%f", &rfifc2[i]);
    inp15a(fr, fw, cb, rfifc2[0], rfifc2[1]);
    for (i = 0; i <= cb; i++) fscanf(fr,"%f", &rfimc2[i]);
    inp15a(fr, fw, cb, rfimc2[0], rfimc2[1]);
    }
  else for (i = 1; i <= 2; i++) readdes(fr);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &watwf[i]);
  inp15a(fr, fw, cb, watwf[0], watwf[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &dungwf[i]);
  inp15a(fr, fw, cb, dungwf[0], dungwf[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &strawwf[i]);
  inp15a(fr, fw, cb, strawwf[0], strawwf[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &costvetwf[i]);
  inp15a(fr, fw, cb, costvetwf[0], costvetwf[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &fixwf[i]);
  inp15a(fr, fw, cb, fixwf[0], fixwf[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &dryf[i*CC+22]);
  if (cb == 1 && utifemcr != 3) dryf[CC+22] = 0;
  inp15a(fr, fw, cb, dryf[22], dryf[CC+22]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &edf[i*CC+22]);
  if (cb == 1 && utifemcr != 3) edf[CC+22] = 0;
  inp15a(fr, fw, cb, edf[22], edf[CC+22]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pdid[i*CC+22]);
  if (cb == 1 && utifemcr != 3) pdid[CC+22] = 0;
  inp15a(fr, fw, cb, pdid[22], pdid[CC+22]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &prf[i*CC+22]);
  if (cb == 1 && utifemcr != 3) prf[CC+22] = 0;
  inp15a(fr, fw, cb, prf[22], prf[CC+22]);
  if (rfi_h == 1) {
    for (i = 0; i <= cb; i++) fscanf(fr,"%f", &rfi[i*CC+22]);
    if (cb == 1 && utifemcr != 3) rfi[CC+22] = 0;
    inp15a(fr, fw, cb, rfi[22], rfi[CC+22]);
    }
  else readdes(fr);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &wat[i*CC+22]);
  if (cb == 1 && utifemcr != 3) wat[CC+22] = 0;
  inp15a(fr, fw, cb, wat[22], wat[CC+22]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &dung[i*CC+22]);
  if (cb == 1 && utifemcr != 3) dung[CC+22] = 0;
  inp15a(fr, fw, cb, dung[22], dung[CC+22]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &straw[i*CC+22]);
  if (cb == 1 && utifemcr != 3) straw[CC+22] = 0;
  inp15a(fr, fw, cb, straw[22], straw[CC+22]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &costvet[i*CC+22]);
  if (cb == 1 && utifemcr != 3) costvet[CC+22] = 0;
  inp15a(fr, fw, cb, costvet[22], costvet[CC+22]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &fix[i*CC+22]);
  if (cb == 1 && utifemcr != 3) fix[CC+22] = 0;
  inp15a(fr, fw, cb, fix[22], fix[CC+22]);
  fscanf(fr,"%f", &dryf[14]);
  if (pbf[0] == 0) dryf[14] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &dryf[CC+14]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], dryf[14], dryf[CC+14]);
  fscanf(fr,"%f", &edf[14]);
  if (pbf[0] == 0) edf[14] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &edf[CC+14]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], edf[14], edf[CC+14]);
  fscanf(fr,"%f", &pdid[14]);
  if (pbf[0] == 0) pdid[14] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &pdid[CC+14]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], pdid[14], pdid[CC+14]);
  fscanf(fr,"%f", &prf[14]);
  if (pbf[0] == 0) prf[14] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &prf[CC+14]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], prf[14], prf[CC+14]);
  if (rfi_fa == 1) {
    fscanf(fr,"%f", &rfi[14]);
    if (pbf[0] == 0) rfi[14] = 0;
    if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &rfi[CC+14]);
    inp15b(fr, fw, cb, pbf[0], pbf[1], rfi[14], rfi[CC+14]);
    }
  else readdes(fr);
  fscanf(fr,"%f", &wat[14]);
  if (pbf[0] == 0) wat[14] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &wat[CC+14]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], wat[14], wat[CC+14]);
  fscanf(fr,"%f", &dung[14]);
  if (pbf[0] == 0) dung[14] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &dung[CC+14]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], dung[14], dung[CC+14]);
  fscanf(fr,"%f", &straw[14]);
  if (pbf[0] == 0) straw[14] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &straw[CC+14]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], straw[14], straw[CC+14]);
  fscanf(fr,"%f", &costvet[14]);
  if (pbf[0] == 0) costvet[14] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &costvet[CC+14]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], costvet[14], costvet[CC+14]);
  fscanf(fr,"%f", &fix[14]);
  if (pbf[0] == 0) fix[14] = 0;
  if (pbf[1] > 0 && cb == 1) fscanf(fr,"%f", &fix[CC+14]);
  inp15b(fr, fw, cb, pbf[0], pbf[1], fix[14], fix[CC+14]);
  fscanf(fr,"%f", &dryf[17]);
  if (cast[0] == 0) dryf[17] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &dryf[CC+17]);
  inp15b(fr, fw, cb, cast[0], cast[1], dryf[17], dryf[CC+17]);
  fscanf(fr,"%f", &edf[17]);
  if (cast[0] == 0) edf[17] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &edf[CC+17]);
  inp15b(fr, fw, cb, cast[0], cast[1], edf[17], edf[CC+17]);
  fscanf(fr,"%f", &pdid[17]);
  if (cast[0] == 0) pdid[17] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &pdid[CC+17]);
  inp15b(fr, fw, cb, cast[0], cast[1], pdid[17], pdid[CC+17]);
  fscanf(fr,"%f", &prf[17]);
  if (cast[0] == 0) prf[17] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &prf[CC+17]);
  inp15b(fr, fw, cb, cast[0], cast[1], prf[17], prf[CC+17]);
  if (rfi_fa == 1) {
    fscanf(fr,"%f", &rfi[17]);
    if (cast[0] == 0) rfi[17] = 0;
    if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &rfi[CC+17]);
    inp15b(fr, fw, cb, cast[0], cast[1], rfi[17], rfi[CC+17]);
    }
  else readdes(fr);
  fscanf(fr,"%f", &wat[17]);
  if (cast[0] == 0) wat[17] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &wat[CC+17]);
  inp15b(fr, fw, cb, cast[0], cast[1], wat[17], wat[CC+17]);
  fscanf(fr,"%f", &dung[17]);
  if (cast[0] == 0) dung[17] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &dung[CC+17]);
  inp15b(fr, fw, cb, cast[0], cast[1], dung[17], dung[CC+17]);
  fscanf(fr,"%f", &straw[17]);
  if (cast[0] == 0) straw[17] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &straw[CC+17]);
  inp15b(fr, fw, cb, cast[0], cast[1], straw[17], straw[CC+17]);
  fscanf(fr,"%f", &costvet[17]);
  if (cast[0] == 0) costvet[17] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &costvet[CC+17]);
  inp15b(fr, fw, cb, cast[0], cast[1], costvet[17], costvet[CC+17]);
  fscanf(fr,"%f", &fix[17]);
  if (cast[0] == 0) fix[17] = 0;
  if (cast[1] > 0 && cb == 1) fscanf(fr,"%f", &fix[CC+17]);
  inp15b(fr, fw, cb, cast[0], cast[1], fix[17], fix[CC+17]);
  fscanf(fr,"%f", &dryf[12]);
  if (pff[0] == 0) dryf[12] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &dryf[CC+12]);
  inp15b(fr, fw, cb, pff[0], pff[1], dryf[12], dryf[CC+12]);
  fscanf(fr,"%f", &edf[12]);
  if (pff[0] == 0) edf[12] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &edf[CC+12]);
  inp15b(fr, fw, cb, pff[0], pff[1], edf[12], edf[CC+12]);
  fscanf(fr,"%f", &pdid[12]);
  if (pff[0] == 0) pdid[12] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &pdid[CC+12]);
  inp15b(fr, fw, cb, pff[0], pff[1], pdid[12], pdid[CC+12]);
  fscanf(fr,"%f", &prf[12]);
  if (pff[0] == 0) prf[12] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &prf[CC+12]);
  inp15b(fr, fw, cb, pff[0], pff[1], prf[12], prf[CC+12]);
  if (rfi_fa == 1) {
    fscanf(fr,"%f", &rfi[12]);
    if (pff[0] == 0) rfi[12] = 0;
    if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &rfi[CC+12]);
    inp15b(fr, fw, cb, pff[0], pff[1], rfi[12], rfi[CC+12]);
    }
  else readdes(fr);
  fscanf(fr,"%f", &wat[12]);
  if (pff[0] == 0) wat[12] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &wat[CC+12]);
  inp15b(fr, fw, cb, pff[0], pff[1], wat[12], wat[CC+12]);
  fscanf(fr,"%f", &dung[12]);
  if (pff[0] == 0) dung[12] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &dung[CC+12]);
  inp15b(fr, fw, cb, pff[0], pff[1], dung[12], dung[CC+12]);
  fscanf(fr,"%f", &straw[12]);
  if (pff[0] == 0) straw[12] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &straw[CC+12]);
  inp15b(fr, fw, cb, pff[0], pff[1], straw[12], straw[CC+12]);
  fscanf(fr,"%f", &costvet[12]);
  if (pff[0] == 0) costvet[12] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &costvet[CC+12]);
  inp15b(fr, fw, cb, pff[0], pff[1], costvet[12], costvet[CC+12]);
  fscanf(fr,"%f", &fix[12]);
  if (pff[0] == 0) fix[12] = 0;
  if (pff[1] > 0 && cb == 1) fscanf(fr,"%f", &fix[CC+12]);
  inp15b(fr, fw, cb, pff[0], pff[1], fix[12], fix[CC+12]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &costdf[i]);
  inp15a(fr, fw, cb, costdf[0], costdf[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &costdcf[i]);
  inp15a(fr, fw, cb, costdcf[0], costdcf[1]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pr[i*CC+8]);
  inp15a(fr, fw, cb, pr[8], pr[CC+8]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pranim[i*CC+8]);
  inp15a(fr, fw, cb, pranim[8], pranim[CC+8]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pr[i*CC+9]);
  inp15a(fr, fw, cb, pr[9], pr[CC+9]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pranim[i*CC+9]);
  inp15a(fr, fw, cb, pranim[9], pranim[CC+9]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pr[i*CC+10]);
  inp15a(fr, fw, cb, pr[10], pr[CC+10]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pranim[i*CC+10]);
  inp15a(fr, fw, cb, pranim[10], pranim[CC+10]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pr[i*CC+23]);
  inp15a(fr, fw, cb, pr[23], pr[CC+23]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pranim[i*CC+23]);
  inp15a(fr, fw, cb, pranim[23], pranim[CC+23]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pr[i*CC+24]);
  inp15a(fr, fw, cb, pr[24], pr[CC+24]);
  for (i = 0; i <= cb; i++) fscanf(fr,"%f", &pranim[i*CC+24]);
  inp15a(fr, fw, cb, pranim[24], pranim[CC+24]);
  fprintf(fw, "\n\n");
  fclose(fr); 
  for (i = 8; i <= 24; i++) {
    if (i == 11) i = 23;
    for (j = 0; j <= cb; j++) {
      if (pr[i+j*CC] > 0.000001 && pranim[i+j*CC] > 0.000001) {
      nonsense6(i,j,CC);
      goto END; 
      }
    } 
  }

  if (age[10] > agew[0]) {
    /* Reading input file INPUT12.TXT and writing its information to output file */
    n2 = 12;
    zz++;
    inp07(fw,n2,zz);
    printf("Reading data from INPUT12.TXT\n");
    fr = fopen("INPUT12.TXT", "r");
    readcom(fr); 
    adg10=readfloat(fw,fr);
    prf10=readfloat(fw,fr);
    pdid10=readfloat(fw,fr);
    edf10=readfloat(fw,fr);
    dryf10=readfloat(fw,fr);
    if (rfi_fa == 1) rfi10=readfloat(fw,fr);
      else readdes(fr);
    dung10=readfloat(fw,fr);
    straw10=readfloat(fw,fr);
    wat10=readfloat(fw,fr);
    costvet10=readfloat(fw,fr);
    fix10=readfloat(fw,fr);
    dottest=readfloat(fw,fr);
    fprintf(fw,"\n\n");
    fclose(fr); 
    }

  /* Reading input file INPUT07.TXT and writing its information to output file */
  printf("Reading data from INPUT07.TXT\n");
  fr = fopen("INPUT07.TXT", "r");
  n2 = 7;
  zz++;
  inp07(fw,n2,zz);
  fclose(fr); 
  fr = fopen("INPUT07.TXT", "r");  
  readcom(fr); 
  for (i = 1; i <= LL; i++) fscanf(fr, "%f", &pp[19+i*6]);
  wrides(fr,fw);
  for (i = 1; i <= LL; i++) fprintf(fw, "%8.4f", pp[19+i*6]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &culh[i]);
  wrides(fr,fw);
  for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", culh[i]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &culvol[i]);
  wrides(fr,fw);
  for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", culvol[i]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &ab[i]);
  wrides(fr,fw);
  for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", ab[i]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &stcd[i]);
  wrides(fr,fw);
  for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", stcd[i]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &stce[i]);
  wrides(fr,fw);
  for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", stce[i]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &dcd[i]);
  wrides(fr,fw);
  for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dcd[i]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &dce[i]);
  wrides(fr,fw);
  for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dce[i]);
  if (cb == 1) {
    for (i = 0; i < LL-1; i++) fscanf(fr, "%f", &pcross[i]);
    wrides(fr,fw);
    for (i = 0; i < LL-1; i++) fprintf(fw, "%8.4f", pcross[i]);
    }
    else readdes(fr);
  for (i=0; i < inmax; i++) fscanf(fr, "%f", &ecrinc[i]);
  wrides(fr,fw);
  for (i=0; i < inmax; i++) fprintf(fw, "%8.4f", ecrinc[i]);
  for (i=0; i < inmaxh; i++) fscanf(fr, "%f", &crinh[i]);
  wrides(fr,fw);
  for (i = 0; i < inmaxh; i++) fprintf(fw, "%8.4f", crinh[i]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[1][0][i]);
  wrides(fr,fw);
  for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysff[1][0][i]);
  for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[1][0][i]);
  wrides(fr,fw);
  for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysmm[1][0][i]);
  if (DD >= 3) {
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[2][0][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysff[2][0][i]);
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[2][0][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysmm[2][0][i]);
    }
    else for (i = 1; i <= 2; i++) readdes(fr);
  if (DD >= 4) {  
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[3][0][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysff[3][0][i]);
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[3][0][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysmm[3][0][i]);
    }
    else for (i = 1; i <= 2; i++) readdes(fr);
  if (DD >= 5) {  
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[4][0][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysff[4][0][i]);
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[4][0][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysmm[4][0][i]);
    }
    else for (i = 1; i <= 2; i++) readdes(fr);
  if (DD == 6) {  
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[5][0][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysff[5][0][i]);
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[5][0][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysmm[5][0][i]);
    }
    else for (i = 1; i <= 2; i++) readdes(fr);
  if (cb == 1) {
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[1][1][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysff[1][1][i]);
    for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[1][1][i]);
    wrides(fr,fw);
    for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysmm[1][1][i]);
    if (DD >= 3) {
      for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[2][1][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysff[2][1][i]);
      for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[2][1][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysmm[2][1][i]);
      }
      else for (i = 1; i <= 2; i++) readdes(fr);
    if (DD >= 4) {
      for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[3][1][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysff[3][1][i]);
      for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[3][1][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysmm[3][1][i]);
      }
      else for (i = 1; i <= 2; i++) readdes(fr);
    if (DD >= 5) {
      for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[4][1][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysff[4][1][i]);
      for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[4][1][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysmm[4][1][i]);
      }
      else for (i = 1; i <= 2; i++) readdes(fr);
    if (DD == 6) {
      for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysff[5][1][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysff[5][1][i]);
      for (i = 0; i < LL; i++) fscanf(fr, "%f", &dysmm[5][1][i]);
      wrides(fr,fw);
      for (i = 0; i < LL; i++) fprintf(fw, "%8.4f", dysmm[5][1][i]);
      }
      else for (i = 1; i <= 2; i++) readdes(fr);
    }
    else for (i = 1; i <= 10; i++) readdes(fr);
  fprintf(fw, "\n\n");
  fclose(fr);
  
  /* Reading input file INPUT24.TXT and writing its information to output file */
  n1 = 8;
  n2 = 24;
  zz++;
  inp07(fw,n2,zz);
  printf("Reading data from INPUT24.TXT\n");
  /* Reading input file INPUT24.TXT */
  fr = fopen("INPUT24.TXT", "r");
  readcom(fr);
  /* Reading the input parameters */
  for (i1 = 1; i1 <= n1; i1++) {
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (i1 == 1 && pbf[0] == 1) fscanf(fr, "%f", &Pb[j][i][0]); 
	if (i1 == 2) fscanf(fr, "%f", &Ph[j][i][0]);
	if (i1 == 3 && cast[0] == 1) fscanf(fr, "%f", &Pcs[j][i][0]);
	if (i1 == 4) fscanf(fr, "%f", &Pc[j][i][0]);
	if (i1 == 5 && pbf[0] + pbf[1] > 0) fscanf(fr, "%f", &Prb[j][i]); 
	if (i1 == 6) fscanf(fr, "%f", &Prh[j][i]);
	if (i1 == 7 && cast[0] + cast[1] > 0) fscanf(fr, "%f", &Prcs[j][i]);
	if (i1 == 8) fscanf(fr, "%f", &Prc[j][i]);
        }
      }
    if (i1 != 1 && i1 != 3 && i1 != 5 && i1 != 7) {
      wrides(fr,fw); 
      fprintf(fw, "\n");
      }  
    if (i1 == 1) {
      if (pbf[0] == 0) readdes(fr);
      else {
        wrides(fr,fw); 
        fprintf(fw, "\n");
        }      
      }  
    if (i1 == 3) {
      if (cast[0] == 0) readdes(fr);
      else {
        wrides(fr,fw); 
        fprintf(fw, "\n");
        }      
      }  
    if (i1 == 5) {
      if (pbf[0] + pbf[1] == 0) readdes(fr);
      else {
        wrides(fr,fw); 
        fprintf(fw, "\n");
        }      
      }  
    if (i1 == 7) {
      if (cast[0] + cast[1] == 0) readdes(fr);
      else {
        wrides(fr,fw); 
        fprintf(fw, "\n");
        }      
      }  
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	if (i1 == 1 && pbf[0] == 1) fprintf(fw, "%9.3f", Pb[j][i][0]);
	if (i1 == 2) fprintf(fw, "%9.3f", Ph[j][i][0]);
	if (i1 == 3 && cast[0] == 1) fprintf(fw, "%9.3f", Pcs[j][i][0]);
	if (i1 == 4) fprintf(fw, "%9.3f", Pc[j][i][0]);
	if (i1 == 5 && pbf[0] + pbf[1] > 0) fprintf(fw, "%9.3f", Prb[j][i]); 
	if (i1 == 6) fprintf(fw, "%9.3f", Prh[j][i]);
	if (i1 == 7 && cast[0] + cast[1] > 0) fprintf(fw, "%9.3f", Prcs[j][i]);
	if (i1 == 8) fprintf(fw, "%9.3f", Prc[j][i]);
        }
      if (i1 != 1 && i1 != 3 && i1 != 5 && i1 != 7) fprintf(fw, "\n");
      if (i1 == 1 && pbf[0] > 0) fprintf(fw, "\n");
      if (i1 == 3 && cast[0] > 0) fprintf(fw, "\n");
      if (i1 == 5 && pbf[0] + pbf[1] > 0) fprintf(fw, "\n");
      if (i1 == 7 && cast[0] + cast[1] > 0) fprintf(fw, "\n");
      }
    }
  fprintf(fw,"\n\n");  
  fclose(fr);
  
  /* Reading input file INPUT25.TXT and writing its information to output file */
  if (cb == 1 && paf[1] == 1) {
    n1 = 3;
    n2 = 25;
    zz++;
    inp07(fw, n2, zz);
    printf("Reading data from INPUT25.TXT\n");
    /* Reading input file INPUT25.TXT */
    fr = fopen("INPUT25.TXT", "r");
    readcom(fr);
    /* Reading the input parameters */
    for (i1 = 1; i1 <= n1; i1++) {
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  if (i1 == 1 && pbf[1] == 1) fscanf(fr, "%f", &Pb[j][i][1]); 
	  if (i1 == 2 && (pff[1] == 1 || utifemcr == 3)) 
	    fscanf(fr, "%f", &Ph[j][i][1]);
	  if (i1 == 3 && cast[1] == 1) fscanf(fr, "%f", &Pcs[j][i][1]);
          }
	}
      if (i1 == 1) {
	if (pbf[1] == 0) readdes(fr);
	else {
	  wrides(fr,fw); 
	  fprintf(fw, "\n");
	  }
	}
      if (i1 == 2) {
	if (pff[1] == 0 && utifemcr != 3) readdes(fr);
	else {
	  wrides(fr,fw); 
	  fprintf(fw, "\n");
	  }
	}
      if (i1 == 3) {
	if (cast[1] == 0) readdes(fr);
	else {
	  wrides(fr,fw); 
	  fprintf(fw, "\n");
	  }
	}
      for (j = 0; j < p1; j++) {
	for (i = 0; i < p2; i++) {
	  if (i1 == 1 && pbf[1] == 1) fprintf(fw, "%9.3f", Pb[j][i][1]);
	  if (i1 == 2 && (pff[1] == 1 || utifemcr == 3)) 
	    fprintf(fw, "%9.3f", Ph[j][i][1]);
	  if (i1 == 3 && cast[1] == 1) fprintf(fw, "%9.3f", Pcs[j][i][1]);
          }
	if (i1 == 1 && pbf[1] == 1) fprintf(fw, "\n");
	if (i1 == 2 &&  (pff[1] == 1 || utifemcr == 3)) 
	  fprintf(fw, "\n");
	if (i1 == 3 && cast[1] == 1) fprintf(fw, "\n");
	}
      }
    fprintf(fw,"\n\n");  
    fclose(fr);
    }
    
/* Reading input file INPUT27.TXT and writing its information to output file */
  n2 = 27;
  zz++;
  inp07(fw,n2,zz);  
  printf("Reading data from INPUT27.TXT\n");
  fr = fopen("INPUT27.TXT", "r");
  readcom(fr);
  /* Reading the input parameters */
  acsd = readint(fw,fr);
  acdd = readint(fw,fr);
  if (cb == 1) {
    acsb = readint(fw,fr);
    if (utifemcr == 3) acdc = readint(fw,fr);
      else readdes(fr);
    }
  else for (i = 1; i <=2; i++) readdes(fr);  
  n_sac = readint(fw,fr);
  l_inv = readfloat(fw,fr);
  for (i = 0; i < ACM; i++) { 
    for (j = 0; j < ACM; j++) PM[i][j] = 0;
    }
  i = acsb + acdd + 1;
  aa1 = 0;
  for (j = acsb+acdd+1; j <=acsb+acdd+acsd; j++) {
    fscanf(fr, "%lf", &PM[i][j]);
    aa1 += PM[i][j];
    }
  if (aa1 < 0.49999 || aa1 > 0.50001) {
    nonsense4(1);
    goto END; 
    }
    wrides(fr,fw);
    for (j = acsb+acdd+1; j <=acsb+acdd+acsd; j++) fprintf(fw, "%7.4f", PM[i][j]);
  i = acsb + 1;
  aa1 = 0;
  for (j = acsb+acdd+1; j <=acsb+acdd+acsd; j++) {
    fscanf(fr, "%lf", &PM[i][j]);
    aa1 += PM[i][j];
    }
  if (aa1 < 0.49999 || aa1 > 0.50001) {
    nonsense4(2);
    goto END; 
    }
    wrides(fr,fw);  
    for (j = acsb+acdd+1; j <=acsb+acdd+acsd; j++) fprintf(fw, "%7.4f", PM[i][j]);
  i = acsb + acdd + 1;
  aa1 = 0;
  for (j = acsb+1; j <=acsb+acdd; j++) {
    fscanf(fr, "%lf", &PM[i][j]);
    aa1 += PM[i][j];
    }
  if (aa1 < 0.49999 || aa1 > 0.50001) {
    nonsense4(3);
    goto END; 
    }
    wrides(fr,fw);    
    for (j = acsb+1; j <=acsb+acdd; j++) fprintf(fw, "%7.4f", PM[i][j]);
  i = acsb + acdd + acsd + 1;
  aa1 = 0;
  if (ewopt > 0) {
    for (j = 1; j <=acsb; j++) {
      fscanf(fr, "%lf", &PM[i][j]);
      aa1 += PM[i][j];
      }
    if (aa1 < 0.49999 || aa1 > 0.50001) {
      nonsense4(4);
      goto END; 
      }
      wrides(fr,fw);    
    for (j = 1; j <=acsb; j++) fprintf(fw, "%7.4f", PM[i][j]);
    }
  fprintf(fw, "\n\n");
  fclose(fr);

  /* Reading input file INPUT28.TXT and writing its information to output file */
  printf("Reading data from INPUT28.TXT\n");
  n2 = 28;
  zz++;
  inp07(fw,n2,zz);
  fr = fopen("INPUT28.TXT", "r");  
  readcom(fr);
  prmilkb=0;
  if (milkprice == 1 || milkprice == 3 || milkprice == 5) 
    prmilkb = readfloat(fw,fr);
    else readdes(fr);
  readcom(fr);  
  if (milkprice == 1 || milkprice == 2) {
    nfat = -1;
    nprot = -1;
    }  
  if (milkprice == 1 || milkprice ==3) nSCC=1;  
  if (milkprice > 2) {  
    nfat = readint(fw,fr);
    if (nfat < 1) readdes(fr); 
    if (nfat > 0) {
      for (i = 0; i < nfat; i++) fscanf(fr, "%f", &thfat[i]); 
      wrides(fr,fw);
      for (i = 0; i < nfat; i++) fprintf(fw, "%6.2f", thfat[i]);
      }
    nprot = readint(fw,fr);  
    if (nprot < 1) readdes(fr); 
    if (nprot > 0) {
      for (i = 0; i < nprot; i++) fscanf(fr, "%f", &thprot[i]); 
      wrides(fr,fw);
      for (i = 0; i < nprot; i++) fprintf(fw, "%6.2f", thprot[i]);
      }
    if (nfat == -1) readdes(fr); 
    if (nfat > -1) {
      for (j = 0; j <= nfat; j++) {
	for (i = 0; i <= 2; i++) fscanf(fr, "%f", &rf[i][j]);
	}
      wrides(fr,fw);
      fprintf(fw, "\n         ");
      for (j = 0; j <= nfat; j++) {
	for (i = 0; i <= 2; i++) fprintf(fw, "%8.3f", rf[i][j]);
	if (j<nfat) fprintf(fw, "\n         ");
	}      
      }  
    if (nprot == -1) readdes(fr); 
    if (nprot > -1) {
      for (j = 0; j <= nprot; j++) {
	for (i = 0; i <= 2; i++) fscanf(fr, "%f", &rp[i][j]);
	}
      wrides(fr,fw);
      fprintf(fw, "\n         ");    
      for (j = 0; j <= nprot; j++) {
	for (i = 0; i <= 2; i++) fprintf(fw, "%8.3f", rp[i][j]);
	if (j<nprot) fprintf(fw, "\n         ");      
	}
      }  
    sigmafat = readfloat(fw,fr);
    sigmaprot = readfloat(fw,fr);  
    }
  else 
    for (i = 1; i <= 8; i++) readdes(fr);  
  readcom(fr);   
  if (milkprice == 2 || milkprice > 3){ 
    mSCS = readfloat(fw,fr);
    sigmaSCS = readfloat(fw,fr);
    nSCC = readint(fw,fr);
    for (i=0; i<nSCC-1; i++) fscanf(fr, "%f", &tSCC[i]);
    wrides(fr,fw);
    for (i = 0; i<nSCC-1; i++) fprintf(fw, "%8.0f", tSCC[i]);
    }
  else 
    for (i = 1; i <= 4; i++) readdes(fr);   
  readcom(fr); 
  if (milkprice == 2 || milkprice == 4){
    for (i=0; i < nSCC; i++) fscanf(fr, "%f", &prSCC[i]);
    wrides(fr,fw);
    for (i = 0; i < nSCC; i++) fprintf(fw, "%8.4f", prSCC[i]);
    }  
  else readdes(fr);
  readcom(fr);   
  if (milkprice == 5){  
    for (i=0; i < nSCC; i++) {
      fscanf(fr, "%f", &facSCC[i]);
      fscanf(fr, "%f", &prSCC[i]);
      }
    wrides(fr,fw);
    fprintf(fw, "\n         ");    
    for (i = 0; i < nSCC; i++) {
      fprintf(fw, "%10.3f", facSCC[i]);
      fprintf(fw, "%10.3f", prSCC[i]);
      if (i<nSCC-1) fprintf(fw, "\n         ");      
      }
    }
  else readdes(fr);  
  readcom(fr);
  if (ind_a30 == 1) {
    a30 = readfloat(fw,fr);
    sigmaa30 = readfloat(fw,fr);
    }
  else 
    for (i = 1; i < 3; i++) readdes(fr);
  readcom(fr);
  if (ind_RCT == 1) {
    RCT = readfloat(fw,fr);
    sigmaRCT = readfloat(fw,fr);
    }
  else 
    for (i = 1; i < 3; i++) readdes(fr);
  readcom(fr);  
  if (milkprice > 2) {  
    if (ind_a30 == 1) {
      na30 = readint(fw,fr);
      if (na30 > 0) {
	for (i = 0; i < na30; i++) fscanf(fr, "%f", &tha30[i]); 
	wrides(fr,fw);
	for (i = 0; i < na30; i++) fprintf(fw, "%6.2f", tha30[i]);
        }
      else readdes(fr);	
      if (na30 > -1) {
	for (j = 0; j <= na30; j++) {
	  for (i = 0; i <= 2; i++) fscanf(fr, "%f", &ra30[i][j]);
	  }
	wrides(fr,fw);
	fprintf(fw, "\n         ");
	for (j = 0; j <= na30; j++) {
	  for (i = 0; i <= 2; i++) fprintf(fw, "%12.6f", ra30[i][j]);
	  if (j<na30) fprintf(fw, "\n         ");
	  }      
	}  
      else readdes(fr);	      
      }
    else for (i = 1; i < 4; i++) readdes(fr);
    readcom(fr);  
    if (ind_RCT == 1) {
      nRCT = readint(fw,fr);
      if (nRCT > 0) {
	for (i = 0; i < nRCT; i++) fscanf(fr, "%f", &thRCT[i]); 
	wrides(fr,fw);
	for (i = 0; i < nRCT; i++) fprintf(fw, "%6.2f", thRCT[i]);
        }
      else readdes(fr);	
      if (nRCT > -1) {
	for (j = 0; j <= nRCT; j++) {
	  for (i = 0; i <= 2; i++) fscanf(fr, "%f", &rRCT[i][j]);
	  }
	wrides(fr,fw);
	fprintf(fw, "\n         ");
	for (j = 0; j <= nRCT; j++) {
	  for (i = 0; i <= 2; i++) fprintf(fw, "%12.6f", rRCT[i][j]);
	  if (j<nRCT) fprintf(fw, "\n         ");
	  }      
	}  
      else readdes(fr);	      
      }
    else for (i = 1; i < 4; i++) readdes(fr);
  }    
  else for (i = 1; i < 7; i++) readdes(fr);    
  fprintf(fw, "\n\n");
  fclose(fr);

  if (mast_inc == 1) {
    /* Reading input file INPUT29.TXT and writing its information to output file */
    n2 = 29;
    zz++;
    inp07(fw,n2,zz);
    printf("Reading data from INPUT29.TXT\n");
    fr = fopen("INPUT29.TXT", "r");
    readcom(fr); 
    costdrug=readfloat(fw,fr);
    labvet=readfloat(fw,fr);
    pricevet=readfloat(fw,fr);
    labherd=readfloat(fw,fr);
    priceherd=readfloat(fw,fr);
    costmach=readfloat(fw,fr);
    pricedry=readfloat(fw,fr); 
    pdry=readfloat(fw,fr);
    for (i=0; i<LL; i++) fscanf(fr, "%f", &ircmy[i]);
    wrides(fr,fw);
    for (i = 0; i<LL; i++) fprintf(fw, "%7.2f", ircmy[i]);
    fprintf(fw,"\n\n");
    fclose(fr);

    /* Reading input file INPUT30.TXT and writing its information to output file */
    printf("Reading data from INPUT30.TXT\n");
    n2 = 30;
    zz++;
    inp07(fw,n2,zz);
    fr = fopen("INPUT30.TXT", "r");  
    readcom(fr); 
    for (i = 0; i < DL; i++) {
      fscanf(fr, "%d", &i1);
      if (i1-1 != i){
	nonsense13(30);
	goto END;
	}
	fprintf(fw, "%5d", i1);
      for (j = 0; j <=2; j++) fscanf(fr, "%f", &dmi[j][i]);
      for (j = 0; j <=2; j++) fprintf(fw, "%10.4f",dmi[j][i]);
      fprintf(fw, "\n");
      }
    fprintf(fw, "\n\n");
    fclose(fr);
    }

  if (claw_inc == 1) {
    /* Reading input file INPUT37.TXT and writing its information to output
       file */
    n2 = 37;
    zz++;
    inp07(fw,n2,zz);
    printf("Reading data from INPUT37.TXT\n");
    fr = fopen("INPUT37.TXT", "r");
    readcom(fr); 
    costacd = readfloat(fw,fr);
    labvetcd = readfloat(fw,fr);
    prvetcd = readfloat(fw,fr);
    costnacd = readfloat(fw,fr);
    labherdcd = readfloat(fw,fr);
    prherdcd = readfloat(fw,fr);
    for (i=0; i<LL; i++) fscanf(fr, "%f", &ircdy[i]);
    wrides(fr,fw);
    for (i = 0; i<LL; i++) fprintf(fw, "%7.2f", ircdy[i]); 
    for (i=0; i<LL; i++) fscanf(fr, "%f", &pacd[i]);
    wrides(fr,fw);
    for (i = 0; i<LL; i++) fprintf(fw, "%7.2f", pacd[i]);
    fprintf(fw,"\n\n");
    fclose(fr);

    /* Reading input file INPUT38.TXT and writing its information to output file
    */
    printf("Reading data from INPUT38.TXT\n");
    n2 = 38;
    zz++;
    inp07(fw,n2,zz);
    fr = fopen("INPUT38.TXT", "r");  
    readcom(fr); 
    for (i = 0; i < DL; i++) {
      fscanf(fr, "%d", &i1);
      if (i1-1 != i) {
	nonsense13(38);
	goto END;
	}
	fprintf(fw, "%5d", i1);
      for (j = 0; j <=2; j++) fscanf(fr, "%f", &dcdi[j][i]);
      for (j = 0; j <=2; j++) fprintf(fw, "%10.4f",dcdi[j][i]);
      fprintf(fw, "\n");
      }
    fprintf(fw, "\n\n");
    fclose(fr);
    }

  /* Reading input file INPUT31.TXT and writing its information to output file
     */
  printf("Reading data from INPUT31.TXT\n");
  n2 = 31;
  zz++;
  inp07(fw,n2,zz);
  fr = fopen("INPUT31.TXT", "r");  
  readcom(fr); 
  for (i = 1; i < 4; i++) flag[i] = readint(fw,fr);
  readcom(fr);  
  for (i = 7; i < 9; i++) flag[i] = readint(fw,fr);
  fprintf(fw, "\n");
  fclose(fr);

  if (cb == 1 && utifemcr == 3) {
    fr3 = fopen("T.TXT", "r");
    readcom(fr3);
    fscanf(fr3, "%d", &flag[4]);
    fscanf(fr3, "%d", &flag[5]);
    fscanf(fr3, "%d", &flag[6]);
    fscanf(fr3, "%d", &flag[3]);
    fscanf(fr3, "%d", &to3[43]);
    fscanf(fr3, "%d", &to3[44]);
    fscanf(fr3, "%d", &to3[47]);
    fscanf(fr3, "%d", &to3[45]);
    fclose(fr3);
    outputrw(fr2, fw);
    fprintf(fw,"):  %d ", flag[4]);   
    outputrw(fr2, fw);
    fprintf(fw,"):  %d ", flag[5]);   
    outputrw(fr2, fw);
    fprintf(fw,"):  %d\n\n", flag[6]); 
    }
  else for (i = 1; i < 4; i++) outputr(fr2);
  
  /* Selecting traits for the calculation of economic weights.
     to[i] is set to zero for traits not considered. */
  /* - For the following traits, economic weights are never printed */
  to[14] = to[15] = to[16] = to[17] =
    to[19] = to[20] = to[21] = to[22] =
    to[24] = to[25] = 0;    
  /* - If there is no cross-breeding in dairy herds or the cross-bred 
       heifers are not tranfered to a cow-calf production system,
       then the following traits are not considered (to[i] is set to 1). */  
  if (cb == 0)
    to[6] = to[7] = to[8] = to[26] = to[27] = to[28] = to[47] = 1;
  if (paf[0] + paf[1] == 0) to[9] = 1;  
  if (rfi_calf == 0) to[42] = 1;
  if (rfi_h == 0 && to3[43] == 1) to[43] = 1;
  if ((rfi_fa == 0 || (paf[0] + paf[1] == 0)) && to3[44] == 1) to[44] = 1;
  if (rfi_cow == 0 && to3[45] == 0) to[45] = 1;
  if (mast_inc == 0) to[37] = 1;
  if (claw_inc == 0 || ewopt == 1) to[46] = 1;
  /* - Omitting traits as consequence of selecting in pairs of traits */
  if (flag[1] == 32) to[33] = 1; else to[32] = 1;
  if (flag[2] == 34) to[35] = 1; else to[34] = 1;  
  if (flag[3] == 11) to[29] = 1; else to[11] = 1;  
  if (cb == 1 && utifemcr == 3) {
    if (flag[4] == 6) to[26] = 1; else to[6] = 1;
    if (flag[5] == 7) to[27] = 1; else to[7] = 1;
    if (flag[6] == 8) to[28] = 1; else to[8] = 1;      
    }
  if ((cb == 1 && utifemcr != 3) || cb == 0) {
    if (flag[7] == 12) to[40] = 1; else to[12] = 1;
    if (flag[8] == 13) to[41] = 1; else to[13] = 1;
    to[6] = to[7] = to[8] = to[26] = to[27] = to[28] = 1;
    }
  if (cb == 1 && utifemcr == 3) {
    to[40] = 1; 
    to[12] = 2;
    to[41] = 1; 
    to[13] = 2;
    to[47] = to3[47];
    }
  else to[47] = 1;  
  if (ewopt == 1 && gene_flow == 3 && utifemcr != 3) to[4] = 1;  
  /* - Milk coagulation traits */
  if (ind_RCT == 0) to[38] = 1;   
  if (ind_a30 == 0) to[39] = 1; 
  /* Omitting milk traits when economic weight are calculated for beef bulls */
  if (ewopt == 1) 
    for (i = 31; i < 40; i++) to[i] = 1; 
  /* delta_d and delta_m - indicators for direct and maternal traits */   
  for (i = 1; i < NT; i++) {
    if (to[i] == 2 && (tt[i] == 0 || tt[i] == 2)) delta_d[i] = 1;
    if (gene_flow < 3 || (gene_flow == 3 && utifemcr == 3)) {
      if (to[i] == 2 && tt[i] > 0) delta_m[i] = 1;
      }
    }
    
  if (gstd == 2) {
    /* Reading input file INPUT32.TXT and writing its information to 
       output file */
    printf("Reading data from INPUT32.TXT\n");
    n2 = 32;
    zz++;
    inp07(fw,n2,zz);
    fr = fopen("INPUT32.TXT", "r");  
    readcom(fr); 
    for (i = 1; i < NT; i++) {
      if (to[i] > 0) {
	if (to[i] == 1) readdes(fr);
	else {
	  if (tt[i] == 2) {
	    fscanf(fr, "%f", &gstd_d[i]); 
	    fscanf(fr, "%f", &gstd_m[i]); 
	    wrides(fr,fw); 
	    fprintf(fw, "%12.4f %12.4f", gstd_d[i],gstd_m[i]);
	  }
 	  if (tt[i] == 0) {
	    fscanf(fr, "%f", &gstd_d[i]);
	    wrides(fr,fw); 
	    fprintf(fw, "%12.4f", gstd_d[i]);
	  } 
	  if (tt[i] == 1) {
	    fscanf(fr, "%f", &gstd_m[i]); 
	    wrides(fr,fw); 
            fprintf(fw, "%12.4f", gstd_m[i]);
	  }   
	}  
      }
    } 
    fprintf(fw, "\n\n");
    fclose(fr);
  }

  if (gstd == 3 && (cb == 0 || (cb == 1 && utifemcr != 3))) {  
    /* Reading input file INPUT33.TXT and writing its information to 
       output file */
    printf("Reading data from INPUT33.TXT\n");
    n2 = 33;
    zz++;
    inp07(fw,n2,zz);
    fr = fopen("INPUT33.TXT", "r");  
    readcom(fr);
    for (i = 1; i < NT; i++) {
      if (to[i] > 0) {
        if (to[i] == 1) readdes(fr);
        if (to[i] == 2) {
	  fscanf(fr, "%f", &gstd_d[i]);
	  wrides(fr,fw); 
	  fprintf(fw, "%12.4f", gstd_d[i]);
	}
      }
    }
    fprintf(fw, "\n\n");
    fclose(fr);  
  } 
          
  /* Testing data and calculating several coefficients */
  printf("Testing data and calculating several coefficients\n");
  for (j=0; j<inmax; j++) kconc[j] = ecrinc[j] / ecrinc[0];
  for (j=0; j<inmaxh; j++) kconh[j] = crinh[j] / crinh[0]; 
  for (j=0; j<=cb; j++) {
    kbwmf[j] = bwm[j] / bwf[j];
    kgcmf[j] = adgcm[j] / adgcf[j];
    kghcf[j] = adghm[j] / adgcf[j];
    kghccf[j] = adghmc[j] / adgcf[j];
    kdresbh[j] = dresb[j] / dresh[j];
    if (cast[j] == 1) kdresch[j] = dresc[j] / dresh[j];
    }
  if (age[10] > agew[0]) kg10 = adg10 / adgcf[0];  
  kdrescwh = drescw / dresh[0];
  kmatc = whmat1[0]/mcwd;
  for (j=0; j<=cb; j++) {
    if (pbf[j] == 1) kgainmf[j] = adgwsm[j] / adgwsf[j];
    if (cast[j] == 1) kgaincf[j] = adgwsc[j] / adgwsf[j];
    }
  if (pff[0] + pff[1] > 0) kslh[0] = whfat[0] / mcwd;
  if (cb == 1 && pff[1] == 1) kslh[1] = whfatb / mcwb;
  if (cast[0] + cast[1] > 0) kslc[0] = wcfat[0] / mcwd;
  if (cb == 1 && cast[1] == 1) kslc[1] = wcfatb / mcwb;
  if (pbf[0] + pbf[1] > 0) kslb[0] = wbfat[0] / mcwd;
  if (cb == 1 && pbf[1] == 1) kslb[1] = wbfatb / mcwb;
  for (j=0; j<inmaxh; j++) kconh[j] = crinh[j] / crinh[0];
  
  /* Calculating of several quantities which do not vary in the
     calculation of economic weights */
  for (i = 0; i < nSCC-1; i++) tSCS[i] = scs(tSCC[i]);      

Start:
  /* Structure of the dairy cow herd */
  if (trait == 0)
    printf("Calculating parameters describing the structure of the cow herd\n");
  for (j = 0; j < inmax; j++) ecrinc[j] = ecrinc[0] * kconc[j];
  for (i = 1; i <= LL; i++) {
    clcm[i-1] = pp[19+6*i] * (intcm/365);
    clmc[i-1] = pp[19+6*i] - clcm[i-1];
    pp[21+6*i] = culvol[i-1] + culh[i-1];
    cculcm[i-1] = pp[21+6*i] * (intcm / 365);
    cculmc[i-1] = pp[21+6*i] - cculcm[i-1];
    }
  for (j = 0; j <= cb; j++) {
    for (i1 = 0; i1 < LL; i1++) {
      dysff[0][j][i1] = dysmm[0][j][i1] = 1;
      for (i = 1; i < DD; i++) {
        dysff[0][j][i1] -= dysff[i][j][i1];
	dysmm[0][j][i1] -= dysmm[i][j][i1];
	}
      dysf[j][i1] = dysm[j][i1] = 0;
      for (i = dyscl-1; i < DD; i++) {
        dysf[j][i1] += dysff[i][j][i1];
	dysm[j][i1] += dysmm[i][j][i1];
        } 
      }
    }
  for (i = 0; i < LL; i++) {
    for (j = 0; j <= cb; j++) dys[j][i] = (dysf[j][i] + dysm[j][i]) * 0.5;
    }  
  if (cb == 1) {
    cal[1][0] = pcrossh;
    for (i = 1; i < LL; i++) cal[1][i] = pcross[i-1];
    }
    else
      for (i = 0; i < LL; i++) cal[1][i] = 0;    
  for (i = 0; i < LL; i++) cal[0][i] = 1 - cal[1][i];
  dysmat[LL-1] = cmat[LL-1] = 0;
  for (i = 0; i < LL-1; i++) {
    cpindys[i][0] = cpinndys[i][0] = cp[i] = intconc[i] = 0;
    dysc[i] = dys[0][i] * cal[0][i] +  dys[1][i] * cal[1][i];
    pcdys[i] = dysc[i] * cmd;
    dysmat[i] = dysc[i] - pcdys[i];
    cmat[i] = 1 - pcdys[i] - cculcm[i+1] - clcm[i+1];
    for (j = 0; j < inmax; j++) {
      cpindys[i][j] = dysmat[i];
      for (j1 = 0; j1 < j; j1++) cpindys[i][j] -= cpindys[i][j1];
      cpindys[i][j] *= (ecrinc[j] - crdys);
      }  
    for (j = 0; j < inmax; j++) {
      cpinndys[i][j] = cmat[i] - dysmat[i];
      for (j1 = 0; j1 < j; j1++) cpinndys[i][j] -= cpinndys[i][j1];
      cpinndys[i][j] *= ecrinc[j];
      }
    for (j = 0; j < inmax; j++) cpin[i][j] = cpindys[i][j] + cpinndys[i][j];
    for (j = 0; j < inmax; j++) cp[i] += cpin[i][j];
    ncp[i] = cmat[i] - cp[i];
    for (j = 0; j < inmax; j++) { pconc[i][j] = cpin[i][j] / cp[i];
      }
    for (j = 0; j < inmax; j++) intconc[i] += pconc[i][j] * j * inint;
    ci[i] = intcm + intconc[i] + lgpre;
    dayslac[i] = ci[i] - dd;
  }
  
  ci[LL-1] = dayslac[LL-1] = dayslac[LL-2];
  dysc[LL-1] = dys[0][LL-1] * cal[0][LL-1] +  dys[1][LL-1] * cal[1][LL-1];
  pcdys[LL-1] = dysc[LL-1] * cmd;
  
  /* Construction of matrix T for system 4 */
  /* Preparation of data for matrix T */
  if (trait == 0)
    printf("  Constructing matrix T for system 4\n");  
  for (i = 1; i <=LL; i++) pp[20+6*i] = pcdys[i-1];
  for (i = 1; i <=LL-1; i++) {
    pp[22+6*i] = ncp[i-1];
    pp[23+6*i] = 0;
    pp[24+6*i] = 1 - pp[19+6*i] - pp[20+6*i] - pp[21+6*i] - pp[22+6*i] - pp[23+6*i];
    }
  pp[22+6*LL] = 1 - pp[19+6*LL] - pp[20+6*LL] - pp[21+6*LL];
  /* Filling matrix T */
  /* Setting all elements to 0 */
  for (i1=0; i1 <= TT; i1++) {
    for (i2=0; i2 <= TT; i2++) {
      t[i1][i2] = 0;
      } 
    }
  /* Filling columns 1 to 6 */
  for (i1=1; i1<=5; i1++) {
    for (i2=1; i2<=6; i2++) {
      for (i3=0; i3<LL; i3++) {
	if (i3 == LL-1 && i1 == 5) break;
	t[6*i3+i1][i2] = (double) pp[24+i2];
	}
      }
    }  
  /* Filling columns 7 to TT */  
  for (i1=1; i1<=LL-1; i1++) {
    for (i3=1; i3<=6; i3++) {
      t[6*i1][6*i1+i3] = (double) pp[24+i1*6+i3];
      if (i1 == LL-1 && i3 == 4) break;
      }
    }  
  /* Testing the correctness of matrix T */
  for (i1=1; i1 <= TT; i1++) {
    aa11 = 0;
    for (i2=1; i2 <= TT; i2++) {
      aa11 += t[i1][i2];
      }
    if (aa11 < 0.999999 || aa11 > 1.000001) {
      printf("Sum of elements of T is different from 1: \n");
      printf("     %d %12.9f\n", i1, aa11);
      goto END; }
    }
  /* Calculating vector l2 by iteration */
  n = TT; /* Dimension of the vector l2 */
  /* Initial values of the elements of l2 */
    l2[0] = 0;
    l2[1] = 1;
    for (i = 2; i <= n; i++) {
      l2[i] = 0;
      }
  /* Starting the iteration */
    k = 0;
    a = 1.;
    for (i = 1; i <= n; i++) {
      l2_0[i] = 0;
      }
    while (a>.0000000001) {k++;
      if (k > 2000) break;
      sl2 = 0; /* Sum of elements of l2 */
      a3 = 0;
      for (i = 1; i <= n; i++) {
        for (j = 1; j <= n; j++) {
	  l2_0[i] = l2_0[i] + t[j][i] * l2[j];
	  }
	}            
      for (i = 1; i <= n; i++) {
        sl2 = sl2 + l2_0[i];
	}
      for (i = 1; i <= n; i++) {
        l2_0[i] = l2_0[i]/sl2;
	a3 += ((l2_0[i] - l2[i]) * (l2_0[i] - l2[i]));
	}
	a = a3/(double) n;
      for (i = 1; i <= n; i++) {
        l2[i] = l2_0[i];	
	}	
      }  		
      
   sl2 = 0;
   for (i = 1; i <= TT; i++) {
     sl2 += l2[i];
     }
     
  /* Proportion of cows in individual reproductive cycles */
  Ncalt = 0;
  for (i = 0; i < LL; i++) {
    l3[i] = 0;
    }
  for (i = 0; i < LL-1; i++) {
    for (j = 1; j <= 6; j++) {
      l3[i] += l2[i*6 + j];
      }
    Ncalt += l3[i];  
    }
  i = LL-1;  
  for (j = 1; j <= 4; j++) {
    l3[LL-1] += l2[i*6 + j];
    }  
  Ncalt += l3[LL-1];
  avecalc = 0;
  for (i = 0; i < LL; i++) avecalc += l3[i]*cal[1][i];

  /* Calculation of  the average lifetime of cows */
  for (i = 0; i <= CC; i++) life[i] = 0;
  aa1 = 0;
  for (i = 1; i <= LL; i++) {
    if (i >= 2) aa1 += ci[i-2];
    life[19+6*i] = aa1 + ci[i-1] / 2;
    life[20+6*i] = aa1 + ndaydys;
    life[21+6*i] = aa1 + ci[i-1] / 2;
    life[22+6*i] = aa1 + dayslac[i-1];
    }
  aa1 = 0;  
  for (i = 1; i < LL; i++) {
    aa1 += ci[i-1];
    life[23+6*i] = 0;
    life[24+6*i] = aa1;
    }    
  aa1 = 0; 
  ciav = 0; 
  for (i = 1; i < LL; i++) {
    ciav += ci[i-1]*l2[6*i];
    aa1 += l2[6*i];
    }
  ciav /= aa1;  
  avelifecy = 0;
/*  for (i = 1; i <= TT; i++) avelifecy += l2[i] * life[i+24];
  avelifecy /= 365; */
  for (i = 1; i <= TT; i++) 
    if (fmod(i,6) > 0.01) avelifecy += l2[i] * life[i+24];
  avelifecy /= (365 * l3[0]);
  avelifecl = 1/l3[0];
  
  /* Average cow losses */
  losc = 0;
  for (i = 1; i <= LL; i++) 
    losc += (pp[19+6*i] + culh[i-1])*l3[i-1];

  /* Structure of the progeny */
  if (trait == 0)
    printf("Calculating parameters describing the structure of the progeny\n");
  dysav[0] = dysav[1] = dysavave = totcal[0] = totcal[1] = 0;
  for (i = 0; i < LL; i++) dysav[0] += dys[0][i] * (cal[0][i]*l3[i]);
  if (cb == 1) for (i = 0; i < LL; i++) dysav[1] += dys[1][i] * (cal[1][i]*l3[i]);
  for (j = 0; j <= cb; j++) dysavave += dysav[j];
  if (cb == 1) for (i = 0; i < LL; i++) totcal[1] += cal[1][i]*l3[i];
  for (i = 0; i < LL; i++) totcal[0] += cal[0][i]*l3[i];  
  for (j = 0; j <= cb; j++) dysav[j] = dysav[j]/totcal[j];
  for (j = 0; j <= cb; j++) 
    pf[j][1] = pm[j][1] = pf[j][2] = pm[j][2] = Ncal[j] = 0;
  sdcd = 0;
  sdce = 0;
  for (i = 0; i < LL; i++) {
    sdcd += dcd[i];
    sdce += dce[i];
    }  
  for (i = 0; i < LL; i++) {
    for (j = 0; j <= cb ; j++) {
      deadfc[j][i] = 0.5* (ab[i] + dysf[j][i] * stcd[i] 
        + (1 - dysf[j][i]) * stce[i]);
      deadmc[j][i] = 0.5* (ab[i] + dysm[j][i] * stcd[i] 
        + (1 - dysm[j][i]) * stce[i]);
      pf[j][1] += deadfc[j][i] * (cal[j][i] * l3[i]);
      pm[j][1] += deadmc[j][i] * (cal[j][i] * l3[i]);
      Ncal[j] += l3[i] * cal[j][i];
      if (sdcd + sdce > 0.000001) {
	dead48f[j][i] = (0.5 - deadfc[j][i]) * (dysf[j][i] * dcd[i] 
          + (1 - dysf[j][i]) * dce[i]);
	dead48m[j][i] = (0.5 - deadmc[j][i]) * (dysm[j][i] * dcd[i] 
          + (1 - dysm[j][i]) * dce[i]);
	pf[j][2] += dead48f[j][i] * (cal[j][i] * l3[i]);
	pm[j][2] += dead48m[j][i] * (cal[j][i] * l3[i]);
        }
      }
    }
  if (trait == 2) {
    for (j = ja; j <= jb; j++) {
      l1[j*CC+1] = calfloss[j]/(1 + kp21[j]);
      pf[j][1] = l1[j*CC+1]/(1 + kpm1[j]);
      pm[j][1] = l1[j*CC+1] - pf[j][1];
      if (sdcd + sdce > 0.000001) {
	l1[j*CC+2] = calfloss[j] - l1[j*CC+1];
	pf[j][2] = l1[j*CC+2]/(1 + kpm2[j]);
	pm[j][2] = l1[j*CC+2] - pf[j][2];
        }
      }
    }    
  for (j = 0; j <= cb ; j++) {
    l1[j*CC+1] = pf[j][1] + pm[j][1];
    Nfcba[j] = 0.5 * Ncal[j] - pf[j][1];
    Nmcba[j] = 0.5 * Ncal[j] - pm[j][1];
    l1[j*CC+2] = pf[j][2] + pm[j][2];
    calfloss[j] = l1[j*CC+1] + l1[j*CC+2];
    Nfc48a[j] = Nfcba[j] - pf[j][2];
    Nmc48a[j] = Nmcba[j] - pm[j][2];
    losfw[j] = Nfc48a[j] * dcw[j];
    Nfcw[j] = Nfc48a[j] - losfw[j];
    losmw[j] = Nmc48a[j]*dcw[j] * (mxmc[j]*age[CC*j+9]/agew[j]
              + mtest[j]*age[10+CC*j]/agew[j] + (1-mxmc[j]-mtest[j]));
    l1[j*CC+3] = losfw[j] + losmw[j];
    l1[j*CC+9] = Nmc48a[j] * mxmc[j] * (1- dcw[j] *age[CC*j+9] / agew[j]);
    l1[j*CC+11] = 0;
    }
  l1[10] = Nmc48a[0] * mtest[0] * (1 - dcw[0] *age[10] /agew[0]);
  l1[CC+10] = 0;

  for (j = 0; j <= cb ; j++) {   
    Nmcf[j] = Nmc48a[j] - l1[j*CC+9] - l1[j*CC+10] - l1[j*CC+11] - losmw[j];
    if (Nmcf[j] < 0 && Nmcf[j] > -0.000001) Nmcf[j] = fabs(0);
    Nmcfc[j] = Nmcf[j] * pcmf[j];
    if (cast[j] == 1 && pbf[j] == 1) Nmcfb[j] = Nmcf[j] * (1 - pcmf[j]);
    if (cast[j] == 0 && pbf[j] == 1) Nmcfb[j] = Nmcf[j];
    if (pbf[j] == 0) Nmcfb[j] = 0;
    l1[j*CC+4] = Nmcfb[j] * dmcf[j];
    l1[j*CC+5] = Nmcfc[j] * dccf[j];
    l1[j*CC+15] = Nmcfb[j] * nmcf[j];
    l1[j*CC+16] = Nmcfc[j] * nccf[j];
    l1[j*CC+17] = Nmcfc[j] - l1[j*CC+5] - l1[j*CC+16];
    l1[j*CC+14] = Nmcfb[j] - l1[j*CC+4] - l1[j*CC+15];
  }

  for (j = 0; j < inmaxh; j++) {
    crinh[j] = crinh[0] * kconh[j];
    conh[j] = 1;
    for (j1 = 0; j1 < j; j1++) conh[j] -= conh[j1];
    conh[j] *= crinh[j];
    }  
  tconh = 0;
  for (j = 0; j < inmaxh; j++) tconh += conh[j];
  for (j = 0; j < inmaxh; j++) pconh[j] = conh[j] / tconh;
  hmpf = (1 - tconh);
  Nfmat = l3[0] / tconh;
  Nfrer = Nfmat / ((1 - loshin[0]) * (1 - sfrp[0]));
  if (Nfrer > Nfcw[0]) {
    nonsense11(cb);
    goto END; 
    }
    
  l1[20] = l1[21] = 0;
  l1[22] = l3[0];   
  l1[18] = Nfrer * sfrp[0];
  l1[19] = Nfmat * hmpf;
  l1[7] = Nfrer -l1[22]-l1[18]-l1[19];
  if (Nfrer == Nfcw[0]) l1[6] =  l1[12] =  l1[13] =  l1[23] =  l1[24] = 0;
  if (Nfrer < Nfcw[0]) Nfav = Nfcw[0] - Nfrer;
  if (utifemp == 1) {
    l1[8] = Nfav;
    l1[6] = l1[12] =  l1[13] =  l1[23] =  l1[24] = 0;
    }
  if (utifemp == 2) {
    Nffa[0] = Nfav;
    l1[8] = l1[23] = l1[24] = 0;
    if (pff[0] == 1) {
      l1[6] = Nffa[0] * dfcf[0];
      l1[13] = Nffa[0] * nfcf[0];
      l1[12] = Nffa[0] - l1[6] - l1[13];
      }
    }
  if (utifemp == 3) {
    l1[23] = Nfav * (1-loshin[0]) * (1-sfrp[0]);
    l1[7] += Nfav * loshin[0];
    l1[18] += Nfav - l1[23] -  Nfav * loshin[0];
    l1[6] = l1[8] =  l1[12] =  l1[13] =  l1[24] = 0;
    }
  if (utifemp == 4) {
    l1[24] = Nfav * (1-loshin[0]) * (1-sfrp[0]) * tconh;
    l1[18] += Nfav * sfrp[0];
    l1[19] += Nfav * (1-loshin[0]) * (1-sfrp[0]) * (1-tconh);
    l1[7] += Nfav * (1 + sfrp[0] - (1-loshin[0]) * (1-sfrp[0]) * (1-tconh))
      - l1[24];
    l1[6] = l1[8] =  l1[12] =  l1[13] =  l1[23] = 0;
    }
  if (cb == 1) {
    l1[CC+7] = l1[CC+18] =  l1[CC+19] =  l1[CC+20] =  l1[CC+21] =  
      l1[CC+22] =  l1[CC+24] = 0;
    if (utifemcr == 1) {
      l1[CC+8] = Nfcw[1];
      l1[CC+6] =  l1[CC+12] =  l1[CC+13] =  l1[CC+23] = 0;
      }
    if (utifemcr == 2) {
      l1[CC+8] = l1[CC+23] = 0;
      if (pff[1] == 1) {
	l1[CC+6] = Nfcw[1] * dfcf[1];
	l1[CC+13] = Nfcw[1] * nfcf[1];
	l1[CC+12] = Nfcw[1] - l1[CC+6] - l1[CC+13];
        }
      }
    if (utifemcr == 3) {
      l1[CC+23] = Nfcw[1];
      if (age[23+CC] > agew[1]) {
        l1[CC+23] *= (1-loshin[1]) * (1-sfrp[1]);
	d[CC+7] = (age[23+CC] - agew[1])/2;
	l1[CC+18] = Nfcw[1] * sfrp[1];
        l1[CC+7] = Nfcw[1] - l1[23+CC] - l1[18+CC];
	}
      l1[CC+6] = l1[CC+8] =  l1[CC+12] =  l1[CC+13] = 0;
      }
    if (utifemcr == 4) {
      l1[CC+23] = 0;
      l1[CC+8] = Nfcw[1] * exfc;
      Nffa[1] = Nfcw[1] - l1[CC+8];
      if (pff[1] == 1) {
	l1[CC+6] = Nffa[1] * dfcf[1];
	l1[CC+13] = Nffa[1] * nfcf[1];
	l1[CC+12] = Nffa[1] - l1[CC+6] - l1[CC+13];
        }
      }
    }  
  for (i = 1; i < NCP; i++) {
    p_tot[i] = 0;
    for (j = 0; j <= cb; j++) p_tot[i] += l1[j*CC+i];  
    }
  psum = 0;  
  for (i = 1; i < NCP; i++) psum += p_tot[i];

  if (trait == 0) {  
    for (j=0; j<= cb; j++) kp21[j] = l1[j*CC+2] / l1[j*CC+1];
    for (j=0; j<= cb; j++) kpm1[j] = pm[j][1] / pf[j][1];
    if (sdcd + sdce > 0.000001) 
      for (j=0; j<= cb; j++) kpm2[j] = pm[j][2] / pf[j][2];
    }

  /* Eliminating of very small negative values (rounding errors) of l1[i] */
  for (i = 1; i < NCP; i++) {
    for (j = 0; j <= cb; j++)
      if (l1[j*CC+i] < 0 && l1[j*CC+i] > -0.000001) l1[j*CC+i] = fabs(0);
    }

  /* Growth */
  if (trait == 0)
    printf("Calculating parameters for growth\n");
  for (j=0; j<= cb; j++) {
    wwf[j] = bwf[j] + agew[j] * adgcf[j];
    wwm[j] = bwf[j] * kbwmf[j] + agew[j] * kgcmf[j] * adgcf[j];
    ww[8+j*CC] = bwf[j] + age[8+j*CC] * adgcf[j];
    ww[9+j*CC] = bwf[j] * kbwmf[j] + age[9+j*CC] * kgcmf[j] * adgcf[j];
    agedcw[j] = agew[j] / 2;
    wdcwf[j] = bwf[j] + adgcf[j] * agedcw[j];
    if (cast[j] > 0) dresc[j] = dresh[j] * kdresch[j];
    dresb[j] = dresh[j] * kdresbh[j];
    }
  if (pff[0] == 1) whfat[0] = mcwd * kslh[0];
  if (cb == 1 && pff[1] == 1) 
    whfat[1] = 0.5 * (kslh[0] * mcwd + kslh[1] * mcwb);
  if (cast[0] == 1) wcfat[0] = mcwd * kslc[0];
  if (cb == 1 && cast[1] == 1) 
    wcfat[1] = 0.5 * (kslc[0] * mcwd + kslc[1] * mcwb);
  if (pbf[0] == 1) wbfat[0] = mcwd * kslb[0];
  if (cb == 1 && pbf[1] == 1) 
    wbfat[1] = 0.5 * (kslb[0] * mcwd + kslb[1] * mcwb);
  whmat1[0] = mcwd*kmatc;
  for (j=0; j<= cb; j++) {
    if (pbf[j] == 1) adgwsm[j] = adgwsf[j] * kgainmf[j];
    if (cast[j] == 1) adgwsc[j] = adgwsf[j] * kgaincf[j];
    if (pff[j] == 1) agesf[j] = agew[j] + (whfat[j] - wwf[j]) / adgwsf[j];
    if (pbf[j] == 1) agesm[j] = agew[j] + (wbfat[j] - wwm[j]) / adgwsm[j];
    if (cast[j] == 1) agesc[j] = agew[j] + (wcfat[j] - wwm[j]) / adgwsc[j];
    if (pff[j] == 1) agedwsf[j] = agew[j] + (agesf[j] - agew[j]) / 2;
    if (pbf[j] == 1) agedwsm[j] = agew[j] + (agesm[j] - agew[j]) / 2;
    if (cast[j] == 1) agedwsc[j] = agew[j] + (agesc[j] - agew[j]) / 2;
    if (pff[j] == 1) wdwsf[j] = wwf[j] + adgwsf[j] * (agedwsf[j] - agew[j]);
    if (pbf[j] == 1) wdwsm[j] = wwm[j] + adgwsm[j] * (agedwsm[j] - agew[j]);
    if (cast[j] == 1) wdwsc[j] = wwm[j] + adgwsc[j] * (agedwsc[j] - agew[j]);
    if (pff[j] == 1) agecwsf[j] = agew[j] + (agesf[j] - agew[j]) / 2;
    if (pbf[j] == 1) agecwsm[j] = agew[j] + (agesm[j] - agew[j]) / 2;
    if (cast[j] == 1) agecwsc[j] = agew[j] + (agesc[j] - agew[j]) / 2;
    if (pff[j] == 1) wcwsf[j] = wwf[j] + adgwsf[j] * (agedwsf[j] - agew[j]);
    if (pbf[j] == 1) wcwsm[j] = wwm[j] + adgwsm[j] * (agedwsm[j] - agew[j]);
    if (cast[j] == 1) wcwsc[j] = wwm[j] + adgwsc[j] * (agedwsc[j] - agew[j]);
    agehmat1[j] = agew[j] + 
      ((whmat1[j] - bwf[j] - adgcf[j] * agew[j]) / (adgcf[j] * kghcf[j]));
    if (utifemcr != 3) agehmat1[1] = 0;  
    }
  adg10 = adgcf[0] * kg10;  
  if (age[10] <= agew[0]) 
    ww[10] = bwf[0]*kbwmf[0] + adgcf[0] * kgcmf[0] * age[10];
  else  
    ww[10] = bwf[0]*kbwmf[0] + adgcf[0] * kgcmf[0] * agew[0] 
      + adg10 * (age[10] - agew[0]);
  intconh = 0;
  for (i = 1; i <= inmaxh; i++) intconh += inint * pconh[i-1] * (i-1);
  ageh1cal[0] = agehmat1[0] + intconh + lgpre;
  wh1cal = whmat1[0] + (ageh1cal[0] - agehmat1[0]) * adghmc[0] + wpreg;
  agedmh[0] = agew[0] + (ageh1cal[0] - agew[0]) / 2;
  whdmh = wwf[0] + adgcf[0] * kghcf[0] * (agedmh[0] - agew[0]);
  agehcmat1[0] = agehmat1[0] + dayshc[0];
  agehcmat1[1] = 0;
  whcmat = whmat1[0] + adgcf[0] * adghmc[0] * dayshc[0];
  for (j=0; j<= cb; j++){
    ww[24+CC*j] = whmat1[j] + adgcf[j] * kghccf[j] * (age[24+j*CC] - agehmat1[j]);
    if (age[23+j*CC] > agew[j]) ww[23+j*CC] = bwf[j] + adgcf[j] * agew[j] 
      + adgcf[j] * kghcf[j] * (age[23+j*CC] - agew[j]);
    if (fabs(age[23+j*CC] - agew[j]) < 0.000001) 
      ww[23+j*CC] = bwf[j] + adgcf[j] * age[23+j*CC];
    }
  wcacal[0] = wh1cal - wpreg;
  wcacal[1] = wcacal[0] + adg1cow * ci[1];
  if (wcacal[1] > mcwd) {
    nonsense12();
    goto END;
    }
  for (i=2; i<LL; i++) wcacal[i] = mcwd;
  wccal[0] = wh1cal;
  for (i=1; i<LL; i++) wccal[i] = wcacal[i] + wpreg;
  for (i=0; i<LL; i++) ndaycd[i] = ndaycc[i] = ci[i] / 2;
  adg2cow = (wcacal[2] - wcacal[1])/ci[1];
  wcd[0] = wcacal[0] + adg1cow * ndaycd[0];
  wcd[1] = wcacal[1] + adg2cow * ndaycd[1];
  for (i=2; i<LL; i++) wcd[i] = wcacal[i];
  for (i=0; i<LL; i++) wcdys[i] = wcacal[i];
  wcc[0] = wcacal[0] + adg1cow * ndaycc[0];
  wcc[1] = wcacal[1] + adg2cow * ndaycc[1];
  for (i=2; i<LL; i++) wcc[i] = wcacal[i];
  wccw[0] = wcacal[0] + adg1cow * dayslac[0];
  wccw[1] = wcacal[1] + adg2cow * dayslac[1];
  for (i=2; i<LL; i++) wccw[i] = wcacal[i];
  i = ceil(ageh1cal[0]/365-0.5) + LL - 1;
  if (acdd < i || acdd > i) {
    nonsense5(i);
    goto END; 
    }

  /* Nutrition */
  if (trait == 0) printf("Calculating parameters for nutrition\n");
  if (paf[0] + paf[1] > 0) kff = 100 / (100 - losff);
  kfw = 100 / (100 - loswf);
  for (i=0; i<= CT; i++) ne[i] = ne2[i] = nepc[i] = pdi[i] = pdi2[i] = pdipc[i] = 0;

  /* Energy and protein requirement per animal of categories 3, 8, 9, 10 
     of purebred and CC+3, CC+8, CC+9 of crossbred progeny*/  
  for (j =0 ; j <= cb ; j++) { 
    bw[8+CC*j] = bwf[j];
    bw[9+CC*j] = bwf[j] * kbwmf[j];
    bw[3+CC*j] = (bw[8+CC*j] + bw[9+CC*j])/2;
    adg[8+CC*j] = adgcf[j];
    adg[9+CC*j] = adgcf[j]*kgcmf[j];
    d[8+CC*j] = age[8+CC*j];
    d[9+CC*j]= age[9+CC*j];
    d[3+CC*j] = agew[j]/2;
    }
  d[10] = age[10];
  adg[10] = adg[9];
  bw[10] = bw[9];
  
  /* First feeding period */  
  for (j = 0; j <= cb; j++) {
    for (i = 8; i <= 10; i++) {
      if (i == 10 && j == 1) break;
      if (agec1[j] <= d[i+CC*j]) dc1[i+CC*j] = agec1[j];
	else dc1[i+CC*j] = d[i+CC*j];      
      for (i1 = 1; i1 <= (int) dc1[i+CC*j]; i1++) {      
	ne[i+CC*j] += pow(bw[i+CC*j] + i1*adg[i+CC*j], 0.75);
	pdi[i+CC*j] += pow(bw[i+CC*j] + i1*adg[i+CC*j], 0.75);
	}      
      ne[i+CC*j] = 0.42*ne[i+CC*j] + dc1[i+CC*j]*(5.69*adg[i+CC*j] 
	+ 1.75*adg[i+CC*j]*adg[i+CC*j] - 2.67);
      pdi[i+CC*j] = 3.25*pdi[i+CC*j]+dc1[i+CC*j]*(274.48*adg[i+CC*j]
        -16.53*adg[i+CC*j]*adg[i+CC*j]-8.88);  		  	
      }  
    }

  /* Second feeding period */
  for (j = 0; j <= cb; j++) {
    for (i = 8; i <= 9; i++) {
      if (d[i+CC*j] > agec1[j]) {
	for (i1 = (int) (dc1[i+CC*j]+1); i1 <= (int) d[i+CC*j]; i1++) 
	  ne2[i+CC*j] += pow(bw[i+CC*j] + i1 * adg[i+CC*j], 0.75);
	ne2[i+CC*j] += (d[i+CC*j]-(int)d[i+CC*j])*pow(bw[i+CC*j]
          + d[i+CC*j] * adg[i+CC*j], 0.75);
	pdi2[i+CC*j] = ne2[i+CC*j];     
	ne2[i+CC*j] *= 0.319 + 0.2581 * adg[i+CC*j];
	pdi2[i+CC*j] = (3.25 + 0.98*adg[i+CC*j])*pdi2[i+CC*j] 
          + (d[i+CC*j]-(int)dc1[i+CC*j])*220.5*adg[i+CC*j];
	}
      }  
    }
  if (d[10] > agec1[0]) {
    if (d[10] <= agew[0]) {
      i2 = (int) d[10];
      i3 = d[10] - (int)dc1[10];
      j1 = d[10]-(int)d[10];
      }
    else {
      i2 = (int) agew[0];
      i3 = agew[0] - (int) dc1[10];
      j1 = 0;
      }
    for (i1 = (int) (dc1[10]+1); i1 <= i2; i1++) 
      ne2[10] += pow(bw[10] + i1 * adg[10], 0.75);
    ne2[10] += j1 * pow(bw[10]
      + d[10] * adg[10], 0.75);
    pdi2[10] = ne2[10];     
    ne2[10] *= 0.302 + 0.228 * adg[10];
    pdi2[10] = (3.25 + 0.98*adg[10])*pdi2[10] 
      + i3*220.5*adg[10];
    }
     
  /* Third feeding period (for breeding bulls) */
  pdi10 = ne10 = 0;
  if (d[10] > agew[0]) {
    if (tech1 == 1) kt = ktb;
    if (tech1 == 2) kt = ktf;
    a2 = d[10] - agew[0];
    for (i1 = 1; i1 <= (int) a2; i1++) {
      ne10 += pow((bw[10]+agew[0]*adg[10]) + i1*adg10, 0.75);
      pdi10 += pow((bw[10]+agew[0]*adg[10]) + i1*adg10, 0.75);
      }          
    ne10 *= (0.34*kt+0.25*adg10);
    ne10 += (a2-(int)a2)*(0.34*kt+0.25*adg10)*pow((bw[10] + agew[0]*adg[10]) 
      + a2*adg10, 0.75);      	  	
    pdi10 += (a2-(int)a2)* pow((bw[10]+agew[0]*adg[10]) 
      + a2 * adg10, 0.75);            
    pdi10 = (3.25+0.70*adg10)*pdi10 + a2*220*adg10;
    } 
  
  /* Energy for categories 4, 14 and 15 of purebred and CC+4, CC+14 and 
     CC+15 of crossbred progeny*/
  if (pbf[0] + pbf[1] > 0) {
    if (tech1 == 1) kt = ktb;
    if (tech1 == 2) kt = ktf;
    i1 = 1 - pbf[0];
    if (pbf[1] == 1 && cb == 1) i2 = 1;
      else i2 = 0;
    for (j = i1 ; j <= i2; j++) { 
      adg[4+CC*j] = adg[14+CC*j] = adg[15+CC*j] = adgwsf[j]*kgainmf[j];
      d[4+CC*j] = agedwsm[j] - agew[j];
      d[14+CC*j] = agesm[j] - agew[j];
      d[15+CC*j] = agecwsm[j] - agew[j];
      }
    j = 0;
    if (pbf[0] == 1) {
      for (i = 4; i <= 15; i++) {
	if (i == 5) i = 14;
	for (i1 = 1; i1 <= (int)d[i]; i1++) {
	  ne[i] += pow(wwm[j] + i1*adg[i], 0.75);
	  pdi[i] += pow(wwm[j] + i1*adg[i], 0.75);
	  }          
	ne[i] = (0.34*kt+0.25*adg[i])*ne[i];
	ne[i] += (d[i]-(int)d[i])*(0.34*kt+0.25*adg[i])*pow(wwm[j] + d[i]*adg[i], 0.75);      	  	
	pdi[i] += (d[i]-(int)d[i])* pow(wwm[j] + d[i] * adg[i], 0.75);            
	pdi[i] = (3.25+0.70*adg[i])*pdi[i] + d[i]*220*adg[i];		  	
	} 
      }
    if (cb == 1 && pbf[1] == 1) {
      j = 1; 
      for (i = 4; i <= 15; i++) {
	if (i == 5) i = 14;
	for (i1 = 1; i1 <= (int)d[i+CC]; i1++) {
	  ne[i+CC] += pow(wwm[j] + i1*adg[i+CC], 0.75);
	  pdi[i+CC] += pow(wwm[j] + i1*adg[i+CC], 0.75);
	  }
	ne[i+CC] = (0.34*kt+0.16*adg[i+CC])*ne[i+CC]+d[i+CC]*2.5*adg[i+CC];
	ne[i+CC] += (d[i+CC]-(int)d[i+CC])*(0.34*kt+0.16*adg[i+CC])*pow(wwm[j] + d[i+CC]*adg[i+CC], 0.75);
	pdi[i+CC] += (d[i+CC]-(int)d[i+CC])* pow(wwm[j] + d[i+CC] * adg[i+CC], 0.75);            
	pdi[i+CC] = (3.25+0.85*adg[i+CC])*pdi[i+CC] + d[i+CC]*220*adg[i+CC];		  	 
	}    
      }
    }

  /* Energy for categories 5, 16 and 17 of purebred and CC+5, CC+16 and CC+17
     of crossbred progeny */
  if (matpur == 1) {
    kce[0] = 1.15;
    kcp[0] = 0.9;
    }
  if (matpur == 2) {
    kce[0] = 1.0;
    kcp[0] = 1.0;
    }
  if (matpur == 3) {    
    kce[0] = 0.85;
    kcp[0] = 1.1;
    }
  if (cb == 1) {
    if (matcross == 1) {
      kce[1] = 1.15;
      kcp[1] = 0.9;
      }
    if (matcross == 2) {
      kce[1] = 1.0;
      kcp[1] = 1.0;
      }
    if (matcross == 3) {    
      kce[1] = 0.85;
      kcp[1] = 1.1;
      }
    }
  for (j = 0; j <= cb; j++) {  
    if (cast[j] == 1) {
      d[5+CC*j] = agedwsc[j] - agew[j];
      d[16+CC*j] = agecwsc[j] - agew[j];
      d[17+CC*j] = agesc[j] - agew[j];
      if (tech1 == 1) kt = ktb;
      if (tech1 == 2) kt = ktf;
      adg[5+CC*j] = adg[16+CC*j] = adg[17+CC*j] = adgwsf[j] * kgaincf[j];
      for (i = 5; i <= 17; i++) {
	if (i == 6) i = 16;
	for (i1 = 1; i1 <= (int)d[i+CC*j]; i1++) {      
	  ne[i+CC*j] += pow(wwm[j] + i1*adg[i+CC*j], 0.75); 
	  pdi[i+CC*j] += pow(wwm[j] + i1*adg[i+CC*j], 0.75);
	  }
	ne[i+CC*j] += (d[i+CC*j]-(int)d[i+CC*j])*pow(wwm[j] + d[i+CC*j]*adg[i+CC*j], 0.75); 	     
	ne[i+CC*j] = (0.34*kt+0.275*adg[i+CC*j])*ne[i+CC*j]*kce[j];
	pdi[i+CC*j] += (d[i+CC*j]-(int)d[i+CC*j])* pow(wwm[j] + d[i+CC*j] * adg[i+CC*j], 0.75);            
	pdi[i+CC*j] = kcp[j]*((3.25+1.05*adg[i+CC*j])*pdi[i+CC*j] + d[i+CC*j]*220*adg[i+CC*j]);     
	}
      }          
    }

  /* Energy for categories 6, 12, 13 of purebred and CC+6, CC+18 
     and CC+19 of crossbred progeny*/  
  if (tech1 == 1) kt = ktb;
  if (tech1 == 2) kt = ktf;
  for (j = 0; j <= cb; j++) { 
    if (pff[j] == 1) {    
      d[6+CC*j] = agedwsf[j] - agew[j];
      d[13+CC*j] = agecwsf[j] - agew[j];
      d[12+CC*j] = agesf[j] - agew[j]; 
      adg[6+CC*j] = adg[12+CC*j] = adg[13+CC*j] = adgwsf[j];
      }
    }
  j = 0;  
  if (pff[0] == 1) {
    for (i = 6; i <= 13; i++) {
      if (i == 7) i = 12;
      aa1 = aa3 = 0;
      for (i1 = 1; i1 <= (int)d[i]; i1++) {
	aa1 += pow(wwf[j]+i1*adg[i], 0.75);
	aa3 += pow(wwf[j]+i1*adg[i], 1.4);
	}
      aa4 = pow(adg[i],1.7);	
      ne[i] += 0.348*kt*aa1 + 0.0022*aa3;      
      ne[i] += 7.254*aa4*d[i];
      aa1 = pow(wwf[j]+d[i]*adg[i], 0.75);
      aa2 = pow(wwf[j]+d[i]*adg[i], 1.4);
      aa3 = 0.348*kt*aa1 + 0.0022*aa2;
      ne[i] += (d[i]-(int)d[i])*aa3;
      }
    }
  if (cb == 1 && pff[1] == 1) {
    j = 1;
    for (i = 6; i <= 13; i++) {
      if (i == 7) i = 12;
      aa1 = aa2 = 0;
      for (i1 = 1; i1 <= (int)d[i+CC]; i1++) {
	aa1 += pow(wwf[j]+i1*adg[i+CC], 0.75);
	aa2 += pow(wwf[j]+i1*adg[i+CC], 1.3);
	}
      ne[i+CC] += 0.348*kt*aa1 + 0.004*aa2;      
      ne[i+CC] += 5.584*adg[i+CC]*adg[i+CC]*d[i+CC];
      aa1 = pow(wwf[j]+d[i+CC]*adg[i+CC], 0.75);
      aa2 = pow(wwf[j]+d[i+CC]*adg[i+CC], 1.3);
      aa3 = 0.348*kt*aa1 + 0.004*aa2;
      ne[i+CC] += (d[i+CC]-(int)d[i+CC])*aa3;
      }
    }  
    for (j = 0; j <= cb; j++) {  
      if (pff[j] == 1) {
	for (i = 6; i <= 13; i++) {
	  if (i == 7) i = 12;
	  for (i1 = 1; i1 <= (int)d[i+CC*j]; i1++)  
	    pdi[i+CC*j] += 3.25*pow(wwf[j]+i1*adg[i+CC*j], 0.75) 
	                     + 0.147*(wwf[j]+i1*adg[i+CC*j]);	     
	  pdi[i+CC*j] += (d[i+CC*j]-(int)d[i+CC*j])
            *(3.25*pow(wwf[j]+d[i+CC*j]*adg[i+CC*j],0.75)
            +0.147*(wwf[j]+d[i+CC*j]*adg[i+CC*j]));	     		
	  pdi[i+CC*j] = pdi[i+CC*j]+(216.3*adg[i+CC*j]-5)*d[i+CC*j];
	  }    
        }
      }
    
  /* Energy for categories 7, 18, 19, 22, 23, 24 of purebred and 
     CC+18, CC+19, CC+23 and CC+24 of crossbred progeny */  
  d[7] = agedmh[0] - agew[0];
  d[18] = agehmat1[0] - agew[0];
  d[19] = dayshc[0] + d[18];
  d[22] = ageh1cal[0] - agew[0];
  d[24] = age[24] - agew[0];
  if (cb == 1 && utifemcr == 3) {
    d[CC+18] = agehmat1[1] - agew[1];
    d[CC+19] = dayshc[1] + d[CC+18];
    d[CC+24] = age[CC+24] - agew[1];
    }
  for (j = 0; j <= cb; j++)
    if (age[23+j*CC]>agew[j]) {
      d[23+CC*j] = age[23+j*CC] - agew[j];
      adg[23+CC*j] = adghm[j];      
      }
  adg[7] = adg[22] = adg[24] = (wh1cal-wwf[0])/(ageh1cal[0]-agew[0]);
  adg[18] = adg[19] = adghm[0];
  if (cb == 1 && utifemcr == 3) {
    adg[CC+7] = adg[CC+18] = adg[CC+19] = adghm[1];
    adg[CC+24] = (adghm[1]*(agehmat1[1]-agew[1]) + adghmc[1]*(age[CC+24] -
               agehmat1[1]))/(age[CC+24] - agew[1]);  
    }
  for (i = 7; i <= 24; i++) {
    if (i == 8) i = 18;
    if (i == 20) i = 22;
    if (age[23]<=agew[0] && i == 23) i = 24;
    for (i1 = 1; i1 <= (int)d[i]; i1++)      
      ne[i] += pow(wwf[0] + i1*adg[i], 0.75);
    ne[i] += (d[i]-(int)d[i])*pow(wwf[0] + d[i]*adg[i], 0.75);        
    ne[i] = (0.311*kt+0.261*adg[i])*ne[i];
    for (i1 = 1; i1 <= (int)d[i]; i1++)
      pdi[i] += pow(wwf[0] + i1 * adg[i], 0.75);
    pdi[i] += (d[i]-(int)d[i])* pow(wwf[0] + d[i] * adg[i], 0.75);  
    pdi[i] = (3.25 + 0.98*adg[i])*pdi[i] + d[i]*220.5*adg[i];
  }    
  if (cb == 1) {
    for (i = CC+7; i <= CC+24; i++) {
      if (i == CC+8) i = CC+18;
      if (i == CC+20) i = CC+23;
      if (age[23+CC]<=agew[1] && i == CC+23) i = CC+24;    
      for (i1 = 1; i1 <= (int)d[i]; i1++)      
	ne[i] += pow(wwf[1] + i1*adg[i], 0.75);
      ne[i] += (d[i]-(int)d[i])*pow(wwf[1] + d[i]*adg[i], 0.75);        
      ne[i] = (0.311*kt+0.261*adg[i])*ne[i];
      for (i1 = 1; i1 <= (int)d[i]; i1++)
	pdi[i] += pow(wwf[1] + i1 * adg[i], 0.75);
      pdi[i] += (d[i]-(int)d[i])* pow(wwf[1] + d[i] * adg[i], 0.75);  
      pdi[i] = (3.25 + 0.98*adg[i])*pdi[i] + d[i]*220.5*adg[i];
    } 
  }

  /* Energy for pregnancy and total energy for categories 22, 24 and CC+24 */
  dp[24] = age[24] - agehmat1[0];
  if (cb == 1) dp[CC+24] = age[CC+24] - agehmat1[1];
  for (i1 = 1; i1 <= (int)(lgpre+.001); i1++) {     
    nepc[22] += (0.4504 - 0.000766*i1)*exp((0.03233-0.0000275*i1)*i1);
    if (i1 == (int)dp[24]) nepc[24] = nepc[22]; 
    if (cb == 1 && i1 == (int)dp[CC+24]) nepc[CC+24] = nepc[22]; 
    }
  nepc[22] *= 0.0042*0.576*bw[3];
  nepc[24] *= 0.0042*0.576*bw[3];
  if (cb == 1) nepc[CC+24] *= 0.0042*0.576*bw[CC+3];
  ne[22] += nepc[22];
  ne[24] += nepc[24];
  if (cb == 1) ne[CC+24] += nepc[CC+24];
  for (i1 = 1; i1 <= (int)(lgpre+.001); i1++) {     
    pdipc[22] += (0.00167-0.00000211*i1)*exp((0.0278-0.0000176*i1)*i1);
    if (i1 == (int)dp[24]) pdipc[24] = pdipc[22]; 
    if (cb == 1 && i1 == (int)dp[CC+24]) pdipc[CC+24] = pdipc[22]; 
    }
  pdipc[22] = (1.64*6.25*bw[3]) * pdipc[22];
  pdipc[24] = (1.64*6.25*bw[3]) * pdipc[24];
  if (cb == 1) pdipc[CC+24] = (1.64*6.25*bw[CC+3]) * pdipc[CC+24];
  pdi[22] += pdipc[22];
  pdi[24] += pdipc[24];    
  if (cb == 1) pdi[CC+24] += pdipc[CC+24];    

  /* Energy for cows (categories 25 to CC) */  
  for (i = 1; i <= LL; i++){
    d[19 + 6*i] = d[21 + 6*i] = ci[i-1]/2;
    d[20 + 6*i] = ndaydys;
    d[22 + 6*i] = dayslac[i-1];
    if (i < LL) d[24 + 6*i] = ci[i-1];
    nl[i-1] = dayslac[i-1]/ci[i-1];
    nd[i-1] = dd/ci[i-1];
    }
  nd[LL-1] = 0;
  cowyear = 0;
  for (i = NCP; i <= CC; i++) cowyear += l2[i-24]*d[i];
  cowyear /= 365;  
  ww[26] = wcacal[0];
  ww[32] = wcacal[1];
  for (i = NCP; i <= 30; i++) {
    if (i == 26) i = 27;
    ww[i] = wcacal[0] + (wcacal[1] - wcacal[0])/2;
    }    
  for (i = 31; i <= 36; i++) {
    if (i == 32) i = 33;
    ww[i] = wcacal[1] + (wcacal[2] - wcacal[1])/2;
    } 
  for (i = 37; i <= CC; i++) ww[i] = mcwd;

  for (i = NCP; i <= 30; i++) adg[i] = adg1cow;  
  for (i = 31; i <= 36; i++) adg[i] = adg2cow;      

  for (i = 1; i < LL; i++){
    dp[19 + 6*i] = d[19 + 6*i] - intcm - intconc[i-1];
    dp[21 + 6*i] = d[21 + 6*i] - intcm - intconc[i-1];
    dp[20 + 6*i] = dp[22 + 6*i] = 0;
    dp[24 + 6*i] = lgpre;
    } 
 
  for (i = NCP; i <= CC; i++) dl[i] = d[i];
  for (i = 1; i < LL; i++) dl[24 + 6*i] = dayslac[i-1];

  /* Energy for maintenance */    
  if (tech2 == 1) kt = ktb;
  if (tech2 == 2) kt = ktf;
  if (tech2 == 3) kt = ktp;
  for (i = NCP; i <= CC; i++) {
    nem[i] = kt*0.293*pow(ww[i], 0.75)*kbl*d[i];
    pdim[i] = 3.25*pow(ww[i], 0.75)*d[i];
    }
  for (i = 1; i < LL; i++)
    nem[24+6*i] = kt*0.293*pow(ww[24+6*i], 0.75)*(kbl*nl[i] + kbd*nd[i])
      *d[24+6*i];  

  /* Energy for growth */    
  for (i = NCP; i <= CC; i++) {
    neg[i] = 22*adg[i]*d[i];
    pdig[i] = 230*adg[i]*d[i];
    }

  /* Energy for pregnancy */
  for (i = NCP; i <= CC; i++) {
    for (j = 1; j <= (int)dp[i]; j++) 
      nepc[i] += (0.4504-0.000766*j)*exp((0.03233-0.0000275*j)*j);
    nepc[i] += (dp[i]-(int)dp[i])*(0.4504-0.000766*dp[i])
               *exp((0.03233-0.0000275*dp[i])*dp[i]);  
    nepc[i] = 0.0042*0.576*bw[3]*nepc[i];
    for (j = 1; j <= (int)dp[i]; j++) 
      pdipc[i] += (0.00167-0.00000211*j)*exp((0.0278-0.0000176*j)*j);
    pdipc[i] += (dp[i]-(int)dp[i])*(0.00167-0.00000211*dp[i])
                *exp((0.0278-0.0000176*dp[i])*dp[i]);
    pdipc[i] = 1.64*6.25*bw[3]*pdipc[i];  
    }
  for (i = 1; i <= LL; i++) 
    nepc[20+6*i] = nepc[22+6*i] = pdipc[20+6*i] = pdipc[22+6*i] = 0;
  for (i = 79; i <= CC; i++) nepc[i] = pdipc[i] = 0;
  
  /*Energy for lactation*/ 
  /*Energy and protein requirement for 1 kg milk with fat percentage (fat) 
    and protein percentage (prot)*/
  ecm = (0.95 + 0.37*fat + 0.21*prot) + 0.07;
  pdiml = 6.7 + 1.05*fat + 11.5*prot;

  for (i = NCP; i <= 78; i++) {
    j = (int)((i-25)/6+.05);
    sp[i] = intcm + intconc[j];  
    }  
  for (i = 79; i <= CC; i++) sp[i] = 0;
  for (i = 1; i < LL; i++) sp[22+6*i] = sp[23+6*i] = 0;
  for (i = 1; i < LL; i++) sp[20+6*i] = d[20+6*i];

  /* Parameters for lactation curve according to Fox et al. 1990 */   
  a1 = (milk*0.01 - 20*0.453592)/2.96;
  a2 = (milk*0.01 + 14*0.453592)/2.96;
  for (i = NCP; i <= CC; i++) {
    if (i == 29 || i == 35 || i == 41 || i == 47 || i == 53 ||
      i == 59 || i == 65 || i == 71 || i == 77) i++;
    if (i < 31) { 
      a9 = a1;
      b9 = b1;
      c9 = c1;
      d9 = d1;
      }
    if ((i > 30) && (i < 37)) {
      a9 = a2;
      b9 = b2;
      c9 = c2;
      d9 = d2;
      }
    if (i > 36) {
      a9 = a2;
      b9 = b3;
      c9 = c3;
      d9 = d3;
      }
    milksum[i] = 0;
    if (i == 28 || i == 34 || i == 40 || i == 46 || i == 52 || i == 58 ||
      i == 64 || i == 70 || i == 76 || i > 78) d9 = 0;
    if (i == 26 || i == 32 || i == 38 || i == 44 || i == 50 || i == 56 ||
      i == 62 || i == 68 || i == 74) d9 = 0; 
    for (j = 1; j <= (int)sp[i]; j++) 
      milksum[i] += a9 * pow(j, b9) * exp(j*c9);
    milksum[i] += (sp[i]-(int)sp[i]) * a9 * pow(sp[i], b9) * exp(sp[i]*c9);
    milksum[i] += ((int)(sp[i]+1)-sp[i]) * a9 * pow(sp[i], b9) 
      * exp(sp[i]*c9) * exp(d9*((int)(sp[i]+1)-sp[i]));  
    for (j = (int)(sp[i]+1); j <= (int)dl[i]; j++)       
      milksum[i] += a9 * pow(j, b9) * exp(j*c9) * exp(d9*(j-sp[i]));  
    milksum[i] += (dl[i]-(int)dl[i]) * a9 * pow(dl[i], b9) * exp(dl[i]*c9)
      * exp(d9*(dl[i]-sp[i]));  
    if (trait == 0 && zr == 1) zzmilksum[i]=milksum[i];  
    if (i == 30||i == 36||i == 42) {
      i1 = (int) (i-30)/6;
      milk305[i1] = 0;   
      for (j = 1; j <= (int)sp[i]; j++) 
	milk305[i1] += a9 * pow(j, b9) * exp(j*c9);
      milk305[i1] += (sp[i]-(int)sp[i]) * a9 * pow(sp[i], b9) * exp(sp[i]*c9);
      milk305[i1] += ((int)(sp[i]+1)-sp[i]) * a9 * pow(sp[i], b9) 
	* exp(sp[i]*c9) * exp(d9*((int)(sp[i]+1)-sp[i]));  
      for (j = (int)(sp[i]+1); j <= 305; j++)       
	milk305[i1] += a9 * pow(j, b9) * exp(j*c9) * exp(d9*(j-sp[i]));  
      }    
    }
  milk21=milk305[1]/milk305[0];
  milk31=milk305[2]/milk305[0]; 
  milk305ave=l3[0]*milk305[0]+l3[1]*milk305[1]+(1-l3[0]-l3[1])*milk305[2]; 
  fat305ave = 0.01*milk305ave * fat;
  prot305ave = 0.01*milk305ave * prot;

  for (i = NCP; i <= CC; i++) {  
    nel[i] = milksum[i]*ecm;
    pdil[i] = milksum[i]*pdiml;
    ne[i] = nem[i] + neg[i] + nepc[i] + nel[i];
    pdi[i] = pdim[i] + pdig[i] + pdipc[i] + pdil[i];      
    }
  
  /* Fresh feed matter and water requirement */
  /* Water */
  for (j = 0; j <= cb; j++) {
    wat[CC*j+9] = wat[CC*j+10] = watwm[j] = wat[CC*j+8] = watwf[j];
    if (pbf[j] == 1) wat[CC*j+4] = wat[CC*j+15] = wat[CC*j+14];
    if (cast[j] == 1) wat[CC*j+5] = wat[CC*j+16] = wat[CC*j+17];
    if (pff[j] == 1) wat[CC*j+6] = wat[CC*j+13] = wat[CC*j+12];
    wat[CC*j+7] = wat[CC*j+18] = wat[CC*j+19] = wat[CC*j+23] 
      = wat[CC*j+24] = wat[CC*j+22];
    edf[CC*j+9] = edf[CC*j+10] = edfwm[j] = edf[CC*j+8] = edfwf[j];
    edf2[CC*j+9] = edf2[CC*j+10] = edfwm2[j] = edf2[CC*j+8] = edfwf2[j];
    if (pbf[j] == 1) edf[CC*j+4] = edf[CC*j+15] = edf[CC*j+14];
    if (cast[j] == 1) edf[CC*j+5] = edf[CC*j+16] = edf[CC*j+17];
    if (pff[j] == 1) edf[CC*j+6] = edf[CC*j+13] = edf[CC*j+12];
    edf[CC*j+7] = edf[CC*j+18] = edf[CC*j+19] = edf[CC*j+23] 
      = edf[CC*j+24] = edf[CC*j+22];
    pdid[CC*j+9] = pdid[CC*j+10] = pdidwm[j] = pdid[CC*j+8] = pdidwf[j];
    pdid2[CC*j+9] = pdid2[CC*j+10] = pdidwm2[j] = pdid2[CC*j+8] 
       = pdidwf2[j];      
    if (pbf[j] == 1) pdid[CC*j+4] = pdid[CC*j+15] = pdid[CC*j+14];
    if (cast[j] == 1) pdid[CC*j+5] = pdid[CC*j+16] = pdid[CC*j+17];
    if (pff[j] == 1) pdid[CC*j+6] = pdid[CC*j+13] = pdid[CC*j+12];
    pdid[CC*j+7] = pdid[CC*j+18] = pdid[CC*j+19] = pdid[CC*j+23] 
      = pdid[CC*j+24] = pdid[CC*j+22];
    dryf[CC*j+9] = dryf[CC*j+10] = dryfwm[j] = dryf[CC*j+8] = dryfwf[j];
    dryf2[CC*j+9] = dryf2[CC*j+10] = dryfwm2[j] = dryf2[CC*j+8] = dryfwf2[j];
    rfi[CC*j+8] = rfifc1[j];
    rfi[CC*j+9] = rfi[CC*j+10] = rfimc1[j];
    rfi2[CC*j+8] = rfifc2[j];
    rfi2[CC*j+9] = rfi2[CC*j+10] = rfimc2[j];
    if (pbf[j] == 1) {
      dryf[CC*j+4] = dryf[CC*j+15] = dryf[CC*j+14];
      rfi[CC*j+4] = rfi[CC*j+15] = rfi[CC*j+14];
      }
    if (cast[j] == 1) {
      dryf[CC*j+5] = dryf[CC*j+16] = dryf[CC*j+17];
      rfi[CC*j+5] = rfi[CC*j+16] = rfi[CC*j+17];
      }
    if (pff[j] == 1) {
      dryf[CC*j+6] = dryf[CC*j+13] = dryf[CC*j+12];
      rfi[CC*j+6] = rfi[CC*j+13] = rfi[CC*j+12];
      }
    dryf[CC*j+7] =  dryf[CC*j+18] = dryf[CC*j+19] = dryf[CC*j+23] 
      = dryf[CC*j+24] = dryf[CC*j+22];
    rfi[CC*j+7] =  rfi[CC*j+18] = rfi[CC*j+19] = rfi[CC*j+23] 
      = rfi[CC*j+24] = rfi[CC*j+22];
    prf[CC*j+9] = prf[CC*j+10] = prfwm[j] = prf[CC*j+8] = prfwf[j];
    prf2[CC*j+9] = prf2[CC*j+10] = prfwm2[j] = prf2[CC*j+8] = prfwf2[j];      
    if (pbf[j] == 1) prf[CC*j+4] = prf[CC*j+15] = prf[CC*j+14];
    if (cast[j] == 1) prf[CC*j+5] = prf[CC*j+16] = prf[CC*j+17];
    if (pff[j] == 1) prf[CC*j+6] = prf[CC*j+13] = prf[CC*j+12];
    prf[CC*j+7] =  prf[CC*j+18] = prf[CC*j+19] = prf[CC*j+23] 
      = prf[CC*j+24] = prf[CC*j+22];
    }
  for (i = NCP; i <= CC; i++) {
    wat[i] = wat[30];
    edf[i] = edf[30];
    pdid[i] = pdid[30];
    dryf[i] = dryf[30];
    prf[i] = prf[30];
    rfi[i] = rfi[30];
    }
  for (i = 1; i < i4; i++) {
    if (i == 4 && pbf[0] == 0) i = 5;
    if (i == 5 && cast[0] == 0) i = 6;
    if (i == 6 && pff[0] == 0) i = 7;
    if (i == 12 && pff[0] == 0) i = 14;    
    if (i == 14 && pbf[0] == 0) i = 16;
    if (i == 16 && cast[0] == 0) i = 18;
    if (i == CC + 4 && pbf[1] == 0) i = CC + 5;
    if (i == CC + 5 && cast[1] == 0) i = CC + 6;
    if (i == CC + 6 && pff[1] == 0) i = CC + 7;    
    if (i == CC + 12 && pff[1] == 0) i = CC + 14;
    if (i == CC + 14 && pbf[1] == 0) i = CC + 16;
    if (i == CC + 16 && cast[1] == 0) i = CC + 18;
    costwt[i] = wat[i] * prwt * d[i];
    if (i == 10 && d[i] > agew[0]) costwt[i] = wat[i] * prwt * agew[0] +
      wat10 * prwt * (d[i] - agew[0]); 
    if (edf[i] * dryf[i] > 0) fe[i] = ne[i] / (edf[i] * dryf[i]);
    if (pdid[i] * dryf[i] > 0) fpdi[i] = pdi[i] / (pdid[i] * dryf[i]);
    if (edf[i] > 0) tdrye[i] = ne[i] / edf[i];
    if (pdid[i] > 0) tdrypdi[i] = pdi[i] / pdid[i];
    /* Predicted total DMI */
    if (feedcost == 1) tdry[i] = maxi(tdrye[i], tdrypdi[i]); 
    if (feedcost == 2) tdry[i] = tdrye[i];
    if (i == 8 || i == 9 || i == CC + 8 || i == CC + 9 || i == 10) aa2 = dc1[i];
      else aa2 = d[i];
    if (aa2 > 0) ddry[i] = tdry[i] / aa2;
    /* Actual daily DMI */
    ddry[i] += rfi[i];  
    /* Amount of fresh feed matter without feed loss */                  
    if(dryf[i] > 0) f[i] = ddry[i] * aa2 / dryf[i];  
    if (((i>3) && (i<7))||((i>11) && (i<18))) aa1 = kff;
      else aa1 = kfw;
    /* Feed cost including feed losses through waisting */  
    costf[i] = prf[i] * f[i] * aa1 + costwt[i]; 
    }
  for (j = 0; j <= cb; j++) {
    for (i = 8; i <= 10; i++) {
      if (i == 10 && j == 1) break;   
      fe2[i+CC*j] = ne2[i+CC*j] / (edf2[i+CC*j] * dryf2[i+CC*j]);
      fpdi2[i+CC*j] = pdi2[i+CC*j] / (pdid2[i+CC*j] * dryf2[i+CC*j]);
      if (edf2[i+CC*j] > 0) tdrye2[i+CC*j] = ne2[i+CC*j] / edf2[i+CC*j];
      if (pdi2[i+CC*j] > 0) tdrypdi2[i+CC*j] = pdi2[i+CC*j] / pdid2[i+CC*j];
      if (feedcost == 1) 
        tdry2[i+CC*j] = maxi(tdrye2[i+CC*j], tdrypdi2[i+CC*j]);
      if (feedcost == 2) tdry2[i+CC*j] = tdrye2[i+CC*j];
      if (i == 8 || i == 9) dc2[i+CC*j] = d[i+CC*j] - dc1[i+CC*j];
      if (i == 10) dc2[i+CC*j] = agew[0] - dc1[10];
      if (dc2[i+CC*j] > 0) 
        ddry2[i+CC*j] = tdry2[i+CC*j] / dc2[i+CC*j];
      ddry2[i+CC*j] += rfi2[i+CC*j];
      if (dryf2[i+CC*j] > 0) 
        f2[i+CC*j] = ddry2[i+CC*j] * dc2[i+CC*j] / dryf2[i+CC*j];
      costf[i+CC*j] += prf2[i+CC*j] * f2[i+CC*j] * kfw; 
     }
    } 
  f10 = fe10 = fpdi10 = tdrye10 = tdrypdi10 = tdry10 = ddry10 = 0;  
  if (d[10] > agew[0]) {
    fe10 = ne10 / (edf10 * dryf10);
    fpdi10 = pdi10 / (pdid10 * dryf10);
    if (edf10 > 0)  tdrye10 = ne10 / edf10;
    if (pdid10 > 0) tdrypdi10 = pdi10 / pdid10;
    if (feedcost == 1) tdry10 = maxi(tdrye10, tdrypdi10);
    if (feedcost == 2) tdry10 = tdrye10;
    ddry10 = tdry10 / (d[10] - agew[0]);
    ddry10 += rfi10;
    if (dryf10 > 0.000001) f10 = ddry10 * (d[10] - agew[0]) / dryf10;
    costf[10] += prf10 * f10 * kfw; 
    }
  /* Energy and protein requirement per male (newm[j], pdiwm[j]) and 
     female (newf[j], pdiwf[j]) from birth to the and of rearing period */
  for (j = 0; j <= cb; j++) {
    adgcm[j] = adgcf[j]*kgcmf[j];    
    newm[j] = newf[j] = pdiwm[j] = pdiwf[j] = 0;
    newm2[j] = newf2[j] = pdiwm2[j] = pdiwf2[j] = 0;
    /* First feeding period */
    if (agec1[j] <= agew[j]) d1w[j] = agec1[j];
      else d1w[j] = agew[j];  
    for (i = 1; i <= (int)d1w[j]; i++) {
      newm[j] += pow(bwf[j] * kbwmf[j] + i*adgcm[j], 0.75);
      pdiwm[j] += pow(bwf[j] * kbwmf[j] + i*adgcm[j], 0.75);
      newf[j] += pow(bwf[j] + i*adgcf[j], 0.75);
      pdiwf[j] += pow(bwf[j] + i*adgcf[j], 0.75);
      }      
    newm[j] = 0.42*newm[j] + d1w[j]*(5.69*adgcm[j] 
      + 1.75*adgcm[j]*adgcm[j] - 2.67);
    pdiwm[j] = 3.25*pdiwm[j]+d1w[j]*(274.48*adgcm[j]
      -16.53*adgcm[j]*adgcm[j]-8.88);  		  	
    newf[j] = 0.42*newf[j] + d1w[j]*(5.69*adgcf[j] 
      + 1.75*adgcf[j]*adgcf[j] - 2.67);
    pdiwf[j] = 3.25*pdiwf[j]+d1w[j]*(274.48*adgcf[j]
      -16.53*adgcf[j]*adgcf[j]-8.88);  		  	
    /* Second feeding period */    
    if (agew[j] > agec1[j]) {
      for (i = (int)(d1w[j]+1); i <= (int)agew[j]; i++) {
	newm2[j] += pow(bwf[j] * kbwmf[j] + i*adgcm[j], 0.75);
	newf2[j] += pow(bwf[j] + i*adgcf[j], 0.75);
	}
      newm2[j] += (agew[j]-(int)agew[j])*pow(bwf[j] * kbwmf[j] + agew[j]*adgcm[j], 0.75);
      newf2[j] += (agew[j]-(int)agew[j])*pow(bwf[j] + agew[j]*adgcf[j], 0.75); 
      pdiwm2[j] = newm2[j];
      pdiwf2[j] = newf2[j];        
      newm2[j] *= 0.302 + 0.228 * adgcm[j];
      newf2[j] *= 0.302 + 0.228 * adgcf[j];
      pdiwm2[j] = (3.25 + 0.98*adgcm[j])*pdiwm2[j] 
	+ (agew[j] - (int)d1w[j])*220.5*adgcm[j];
      pdiwf2[j] = (3.25 + 0.98*adgcf[j])*pdiwf2[j] 
	+ (agew[j] - (int)d1w[j])*220.5*adgcf[j];
      }	
    }

  /* Male and female calves in rearing period */
  for(j = 0; j <= cb; j++) {  
    costwwm[j] = watwm[j] * prwt * agew[j];
    costwwf[j] = watwf[j] * prwt * agew[j];      
    fewm[j] = newm[j] / (edfwm[j] * dryfwm[j]);
    fpdiwm[j] = pdiwm[j] / (pdidwm[j] * dryfwm[j]);
    fewf[j] = newf[j] / (edfwf[j] * dryfwf[j]);
    fpdiwf[j] = pdiwf[j] / (pdidwf[j] * dryfwf[j]);
    if (edfwm[j] > 0) tdryewm[j] = newm[j] / edfwm[j];
    if (pdidwm[j] > 0) tdrypdiwm[j] = pdiwm[j] / pdidwm[j];
    if (edfwf[j] > 0) tdryewf[j] = newf[j] / edfwf[j];
    if (pdidwf[j] > 0) tdrypdiwf[j] = pdiwf[j] / pdidwf[j];
    if (feedcost == 1) tdrywm[j] = maxi(tdryewm[j], tdrypdiwm[j]);
    if (feedcost == 2) tdrywm[j] = tdryewm[j];    
    if (feedcost == 1) tdrywf[j] = maxi(tdryewf[j], tdrypdiwf[j]);
    if (feedcost == 2) tdrywf[j] = tdryewf[j];          
    fewm2[j] = newm2[j] / (edfwm2[j] * dryfwm2[j]);
    fpdiwm2[j] = pdiwm2[j] / (pdidwm2[j] * dryfwm2[j]);
    fewf2[j] = newf2[j] / (edfwf2[j] * dryfwf2[j]);
    fpdiwf2[j] = pdiwf2[j] / (pdidwf2[j] * dryfwf2[j]);
    if (edfwm2[j] > 0) tdryewm2[j] = newm2[j] / edfwm2[j];
    if (pdidwm2[j] > 0)  tdrypdiwm2[j] = pdiwm2[j] / pdidwm2[j];
    if (edfwf2[j] > 0) tdryewf2[j] = newf2[j] / edfwf2[j];
    if (pdidwf2[j] > 0)  tdrypdiwf2[j] = pdiwf2[j] / pdidwf2[j];
    if (feedcost == 1) tdrywm2[j] = maxi(tdryewm2[j], tdrypdiwm2[j]);
    if (feedcost == 2) tdrywm2[j] = tdryewm2[j];    
    if (feedcost == 1) tdrywf2[j] = maxi(tdryewf2[j], tdrypdiwf2[j]);
    if (feedcost == 2) tdrywf2[j] = tdryewf2[j];   
    if (d1w[j] > 0) ddrywm[j] = tdrywm[j]/d1w[j];
    if (agew[j]-d1w[j] > 0) ddrywm2[j] = tdrywm2[j] / (agew[j] - d1w[j]);
    if (d1w[j] > 0) ddrywf[j] = tdrywf[j]/d1w[j];
    if (agew[j]-d1w[j] > 0) ddrywf2[j] = tdrywf2[j] / (agew[j] - d1w[j]);
    ddrywm[j] += rfimc1[j];
    ddrywm2[j] += rfimc2[j];
    ddrywf[j] += rfifc1[j];
    ddrywf2[j] += rfifc2[j];
    if (dryfwm[j] > 0) fwm[j] = ddrywm[j]*d1w[j]/dryfwm[j];
    if (dryfwf[j] > 0) fwf[j] = ddrywf[j]*d1w[j]/dryfwf[j];
    if (dryfwm2[j] > 0) fwm2[j] = ddrywm2[j]*(agew[j]-d1w[j])/dryfwm2[j];
    if (dryfwf2[j] > 0) fwf2[j] = ddrywf2[j]*(agew[j]-d1w[j])/dryfwf2[j];  
    costfwm[j] = prfwm[j]*fwm[j]*kfw + prfwm2[j]*fwm2[j]*kfw + costwwm[j];
    costfwf[j] = prfwf[j]*fwf[j]*kfw + prfwf2[j]*fwf2[j]*kfw + costwwf[j];      
    }

  /* Other costs */
  if (trait == 0) printf("Calculating costs\n");  
  for (j = 0; j <= cb; j++) {
    for (i = 8; i <= 9; i++) {
      costvet[CC*j+i] = d[CC*j+i] * costvetwf[j] / agew[j]; 
      }
    costvetwm[j] = costvetwf[j];  
    costvet[CC*j+7] = costvet[CC*j+18] = costvet[CC*j+19] 
      = costvet[CC*j+23] = costvet[CC*j+24] = costvet[CC*j+22];
    if (pbf[j] == 1) costvet[CC*j+6] = costvet[CC*j+13] = costvet[CC*j+12];
    if (cast[j] == 1) costvet[CC*j+5] = costvet[CC*j+16] = costvet[CC*j+17];
    if (pbf[j] == 1) costvet[CC*j+4] = costvet[CC*j+15] = costvet[CC*j+14];
    for (i = 8; i <= 9; i++) {
      straw[CC*j+i] = strawwf[j]; 
      }
    strawwm[j] = strawwf[j];  
    straw[CC*j+7] = straw[CC*j+18] = straw[CC*j+19] = straw[CC*j+23] 
      = straw[CC*j+24] = straw[CC*j+22];
    if (pff[j] == 1) straw[CC*j+6] = straw[CC*j+13] = straw[CC*j+12];
    if (cast[j] == 1) straw[CC*j+5] = straw[CC*j+16] = straw[CC*j+17];
    if (pbf[j] == 1) straw[CC*j+4] = straw[CC*j+15] = straw[CC*j+14];
    for (i = 8; i <= 9; i++) {
      dung[CC*j+i] = dungwf[j]; 
      }
    dungwm[j] = dungwf[j];  
    dung[CC*j+7] = dung[CC*j+18] = dung[CC*j+19] = dung[CC*j+23] 
      = dung[CC*j+24] = dung[CC*j+22];
    if (pff[j] == 1) dung[CC*j+6] = dung[CC*j+13] = dung[CC*j+12];
    if (cast[j] == 1) dung[CC*j+5] = dung[CC*j+16] = dung[CC*j+17];
    if (pbf[j] == 1) dung[CC*j+4] = dung[CC*j+15] = dung[CC*j+14];
    for (i = 8; i <= 9; i++) {
      fix[CC*j+i] = fixwf[j]; 
      }
    fixwm[j] = fixwf[j];  
    fix[CC*j+7] = fix[CC*j+18] = fix[CC*j+19] = fix[CC*j+23] 
      = fix[CC*j+24] = fix[CC*j+22];
    fix[CC*j+6] = fix[CC*j+13] = fix[CC*j+12];
    if (cast[j] == 1) fix[CC*j+5] = fix[CC*j+16] = fix[CC*j+17];
    if (pbf[j] == 1) fix[CC*j+4] = fix[CC*j+15] = fix[CC*j+14];
    if (pff[j] == 1) costd[CC*j+6] = costdf[j];
    if (pbf[j] == 1) costd[CC*j+4] = costdf[j];
    costd[CC*j+7] = costdf[j];
    if (cast[j] > 0.000001) costd[CC*j+5] = costdf[j];
    }
  if (cb == 1 && utifemcr != 3) costd[CC+7] = 0;
  if (d[10] <= agew[0]) 
    costvet[10] = d[10] * costvetwf[0] / agew[0]; 
  straw[10] = strawwf[0]; 
  dung[10] = dungwf[0];      
  fix[10] = fixwf[0];       
  if (d[10] > agew[0]) {
    costvet[10] = costvetwf[0] + costvet10; 
    straw[10] = (straw[10] * agew[0] + straw10 * (d[10] - agew[0])) / d[10];
    dung[10] = (dung[10] * agew[0] + dung10 * (d[10] - agew[0])) / d[10];
    fix[10] = (fix[10] * agew[0] + (fix10 -dottest) 
      * (d[10] - agew[0])) / d[10];
    }      
  for (i = NCP; i <= CC; i++) {
    fix[i]= fix[30];
    straw[i]= straw[30];
    dung[i]= dung[30];
    }  
  for (i = 2; i <= LL; i++) costd[19+6*i]= costd[25];
  for (j = 0; j <= cb; j++) {
    for (i = 1; i < NCP; i++) {
      if (i == 4 && pbf[j] == 0) i = 5;
      if (i == 5 && cast[j] == 0) i = 6;
      if (i == 6 && pff[j] == 0) i = 7;
      if (i == 12 && pff[j] == 0) i = 14;
      if (i == 14 && pbf[j] == 0) i = 16;
      if (i == 16 && cast[j] == 0) i = 18;
      costh[CC*j+i] = (straw[CC*j+i]*prst - dung[CC*j+i]*prdg) * d[CC*j+i];
      costfix[CC*j+i] = fix[CC*j+i] * d[CC*j+i];
      }
    /* for male and female calves in rearing period */      
    costhwm[j] = (strawwm[j] * prst - dungwm[j] * prdg)*agew[j];
    costfixwm[j] = fixwm[j] * agew[j];
    costhwf[j] = (strawwf[j] * prst - dungwf[j] * prdg)*agew[j];
    costfixwf[j] = fixwf[j] * agew[j];
    }
  /* Cost for insemination = costi[i] */
  /* nin[i] number of inseminations */
  for (i = 1; i <= CC; i++) costi[i] = nin[i] = 0;
  for (i = 0; i < inmaxh; i++) nin[22] += (i+1)*conh[i]/tconh;
  nin[24] = nin[22];
  nin[19] = inmaxh;
  costi[19] = (praid+nr*praird) * nin[19];
  if (utifemp == 4)
    costi[19]=nin[19]*(praid+nr*praird)*(1-pcrossh)
      +(praib+nr*prairb)* pcrossh;    
  costi[22] = nin[22] * (praid+nr*praird);
  costi[24] = nin[24] * (praid+nr*praird);
  /* For male and female calves in rearing period */
  for (j = 0; j <= cb; j++) {
    costwm[j] = costfwm[j] + costhwm[j] + costvetwm[j] + costfixwm[j];
    costwf[j] = costfwf[j] + costhwf[j] + costvetwf[j] + costfixwf[j];
    }
  for (j = 0; j <= cb; j++) {
    for (i = 1; i < NCP; i++) {
      if (i == 4 && pbf[j] == 0) i = 5;
      if (i == 5 && cast[j] == 0) i = 6;
      if (i == 6 && pff[j] == 0) i = 7;
      if (i == 12 && pff[j] == 0) i = 14;
      if (i == 14 && pbf[j] == 0) i = 16;
      if (i == 16 && cast[j] == 0) i = 18;
      costo[CC*j+i] = costd[CC*j+i] + (1-j) * costi[CC*j+i]; 
      }    
    }
  for (i = 0; i <= CT; i++) cost[i] = 0;
  for (i = 4; i < NCP; i++) {
    if (i == 11) i = 12;
    if (i == 20) i = 22;
    for (j = 0; j <= cb; j++) {
      cost[CC*j+i] = costf[CC*j+i] + costh[CC*j+i] + costvet[CC*j+i]
        + costo[CC*j+i] + costfix[CC*j+i];
      if ((i == 4 || i == 14 || i == 15) && pbf[j] == 0) cost[CC*j+i] = 0;
      if ((i == 5 || i == 16 || i == 17) && cast[j] == 0) cost[CC*j+i] = 0;
      if ((i == 6 || i == 12 || i == 13) && pff[j] == 0) cost[CC*j+i] = 0;  	
      if ((i == 4 || i == 14 || i == 15) && pbf[j] == 1)	  
        cost[CC*j+i] += costwm[j];
      if ((i == 5 || i == 16 || i == 17) && cast[j] == 1)
        cost[CC*j+i] += costwm[j];
      if (i == 7 || i == 18 || i == 19 || i == 22 || i == 24 )
        cost[CC*j+i] += costwf[j];
      if ((i == 6 || i == 12 || i == 13) && pff[j] == 1)
      	cost[CC*j+i] += costwf[j];
      if (i == 23 && (age[CC*j+i] > agew[j])) cost[CC*j+i] += costwf[j];
      }    
    }
  if (cb == 1 && utifemcr != 3) 
    cost[CC+7] = cost[CC+18] = cost[CC+19] = cost[CC+20] = cost[CC+21] =  
      cost[CC+22] = cost[CC+23] = cost[CC+24] = 0; 
  /* Costs for categories 3 and CC+3 */
  for(j = 0; j <= cb; j++) {  
    costf[3+CC*j] = (1/(2*l1[j*CC+3]))*(costfwf[j]*losfw[j]
      + Nmc48a[j]* dcw[j]*(costf[CC*j+9]*mxmc[j]*age[CC*j+9]/agew[j]
      + costf[CC*j+10]*mtest[j]*age[10+CC*j]/agew[j]
      + costfwm[j]*(1-mxmc[j]-mtest[j])));
    costh[3+CC*j] = (1/(2*l1[j*CC+3]))*(costhwf[j]*losfw[j]
      + Nmc48a[j]* dcw[j]*(costh[CC*j+9]*mxmc[j]*age[CC*j+9]/agew[j]
      + costh[CC*j+10]*mtest[j]*age[10+CC*j]/agew[j]
      + costhwm[j]*(1-mxmc[j]-mtest[j])));
    costfix[3+CC*j] = (1/(2*l1[j*CC+3]))*(costfixwf[j]*losfw[j]
      + Nmc48a[j]* dcw[j]*(costfix[CC*j+9]*mxmc[j]*age[CC*j+9]/agew[j]
      + costfix[CC*j+10]*mtest[j]*age[10+CC*j]/agew[j]
      + costfixwm[j]*(1-mxmc[j]-mtest[j])));
    costvet[3+CC*j] = (1/(2*l1[j*CC+3]))*(costvetwf[j]*losfw[j]
      + Nmc48a[j]* dcw[j]*(costvet[CC*j+9]*mxmc[j]*age[CC*j+9]/agew[j]
      + costvet[CC*j+10]*mtest[j]*age[10+CC*j]/agew[j]
      + costvetwm[j]*(1-mxmc[j]-mtest[j]))); 
    costo[3+CC*j] = costdcf[j];       
    cost[3+CC*j] = costf[3+CC*j] + costh[3+CC*j] + costfix[3+CC*j] 
      + costvet[3+CC*j] + costo[3+CC*j];       
    }
  for (j = 0; j < LL; j++) ninr[j] = 0;
  for (j = 0; j < LL-1; j++) {
    for (i = 0; i < inmax; i++) ninr[j] += (i+1)*cpin[j][i]/cp[j];
    }
  for (i = 1; i < LL; i++) {
    nin[19+6*i] = nin[21+6*i] = nin[24+6*i] = ninr[i-1];        
    nin[22+6*i] = inmax;
    }    
  for (i = NCP; i <= CC; i++) {
    j = floor((i-25)/6);
    costi[i] = ((praid+nr*praird)*(1-pcross[j])
      +(praib+nr*prairb)*pcross[j])*nin[i];
    dmilksum[i] = milksum[i] - zzmilksum[i];
    }
  for (i = 1; i < LL; i++) {
    for (j = 19; j < NCP; j++) {
      if (j == 23) j = 24;
        costvet[j+6*i] = costv[30]*d[j+6*i]/(ci[i-1]-dd);        
        costmilkv[j+6*i] = dmilksum[j+6*i]*varmilk;
	costo[j+6*i] = costd[j+6*i] + costi[j+6*i] + costmilkv[j+6*i]; 
      }
    costvet[23+6*i] = costmilkv[23+6*i] = costo[23+6*i] = 0;   
    }  
  for (i = NCP; i <= CC; i++) {
    costfix[i] = fix[i] * d[i];
    costh[i] = (straw[i]*prst - dung[i]*prdg) * d[i];
    cost[i] = costf[i] + costh[i] + costvet[i] + costo[i] + costfix[i];
    }
  for(j = 0; j <= cb; j++) {  
    if (fabs(age[23+j*CC] - agew[j]) < 0.000001) {
      costf[23+CC*j] = costfwf[j];
      costh[23+CC*j] = costhwf[j];
      costfix[23+CC*j] = costfixwf[j];       
      costvet[23+CC*j] = costvetwf[j];
      cost[23+CC*j] = costfwf[j] + costhwf[j]+ costfixwf[j] + costvetwf[j];       
      }
    }
       
  /* Cost components per cow and year*/ 
  costvetc = costhc = costoc = costfixc = costfc = costc = 0;
  for (i = NCP; i <= CC; i++) {
    costvetc += l2[i-24]*costvet[i];
    costhc += l2[i-24]*costh[i];
    costoc += l2[i-24]*costo[i];
    costfixc += l2[i-24]*costfix[i];
    costfc += l2[i-24]*costf[i];	 
    costc += l2[i-24]*cost[i];       
    }
  costvetc *= 365/ciav;
  costhc *= 365/ciav;
  costoc *= 365/ciav;
  costfixc *= 365/ciav;
  costfc *= 365/ciav;	 
  costc *= 365/ciav;       
    
  for (i1 = 0; i1 < LL; i1++) {
    for (j = 0; j <= cb ; j++) { 
      for (i = 0 ; i < DD; i++) 
        dysavs[i][j][i1] = 0.5*(dysff[i][j][i1] + dysmm[i][j][i1]);
      }	
    }
  for (i = 0 ; i < DD; i++) {
    dysavh[i] = 0;
    for (i1 = 0; i1 < LL; i1++)
      dysavh[i] += (dysavs[i][0][i1]*cal[0][i1] + dysavs[i][1][i1]*cal[1][i1])*l3[i1];
    }
  costdys = 0;
  for (i = 0; i < DD; i++) costdys += dysavh[i]*(costlab*labdys[i] + vetdys[i]);

  /* Somatic cell count, milk price */
  prmilk = prmilkb;  
  if (milkprice == 2 || milkprice > 3) {
    for (i = 0; i < nSCC-1; i++) Phiscc[i] = normdis((tSCS[i]-mSCS)/sigmaSCS);
    pSCC[0] = Phiscc[0];
    for (i = 1; i < nSCC-1; i++) pSCC[i] = Phiscc[i] - Phiscc[i-1];
    pSCC[nSCC-1] = 1 - Phiscc[nSCC - 2];
    }
  if (milkprice == 2 || milkprice == 4) {  
    prscc = 0;
    for (i = 0; i < nSCC; i++) prscc += pSCC[i]*prSCC[i];
    prmilk += prscc;
    }
  if (milkprice == 3 || milkprice == 4 || milkprice == 5) {    
    if (nfat>-1) {
      for (i=0; i<=nfat; i++) {
	if (i==0) aa1=0;
          else aa1=thfat[i-1];
	if (i==nfat) aa2=100;
          else aa2=thfat[i];
	prmilkf[i]=linregm(fat,sigmafat,aa1,aa2,rf[0][i],rf[1][i],rf[2][i]);
	prmilk += prmilkf[i];
	} 
      }
    if (nprot>-1) {
      for (i=0; i<=nprot; i++) {
	if (i==0) aa1=0;
          else aa1=thprot[i-1];
	if (i==nprot) aa2=100;
          else aa2=thprot[i];
	prmilkp[i]=linregm(prot,sigmaprot,aa1,aa2,rp[0][i],rp[1][i],rp[2][i]);
	prmilk += prmilkp[i];		  
          } 
        }
    if (ind_a30==1 && na30>-1) {
      for (i=0; i<=na30; i++) {
	if (i==0) aa1=0;
          else aa1=tha30[i-1];
	if (i==na30) aa2=100;
          else aa2=tha30[i];
        prmilka30[i]=linregm(a30,sigmaa30,aa1,aa2,ra30[0][i],ra30[1][i],
	  ra30[2][i]);
	prmilk += prmilka30[i];		  
          } 
        }
    if (ind_RCT==1 && nRCT>-1) {
      for (i=0; i<=nRCT; i++) {
	if (i==0) aa1=2;
          else aa1=thRCT[i-1];
	if (i==nRCT) aa2=60;
          else aa2=thRCT[i];
        prmilkRCT[i]=linregm(RCT,sigmaRCT,aa1,aa2,rRCT[0][i],rRCT[1][i],
	  rRCT[2][i]);
	prmilk += prmilkRCT[i];		  
          } 
        }
      }
  if (milkprice == 5) {  
    prmilkfp = prmilk;
    prmilk = 0;
    for (i = 0; i < nSCC; i++) prmilk += pSCC[i]*(prmilkfp*facSCC[i] +                 prSCC[i]);
    }
      
  /* Calculation of losses due to clinical mastistis */
  if (mast_inc == 1) {
    /* Discarded milk for individual categories */   
    for (i = NCP; i <= CC; i++) {
      if (i == 29 || i == 35 || i == 41 || i == 47 || i == 53 ||
	i == 59 || i == 65 || i == 71 || i == 77) i++;
      if (i < 31) { 
	a9 = a1;
	b9 = b1;
	c9 = c1;
	d9 = d1;
	i1 = 0;
	}
      if ((i > 30) && (i < 37)) {
	a9 = a2;
	b9 = b2;
	c9 = c2;
	d9 = d2;
	i1 = 1;
	}
      if (i > 36) {
	a9 = a2;
	b9 = b3;
	c9 = c3;
	d9 = d3;
	i1 = 2;
	}
      discow[i] = 0;
      if (i == 28 || i == 34 || i == 40 || i == 46 || i == 52 || i == 58 ||
	i == 64 || i == 70 || i == 76 || i > 78) d9 = 0;
      if (i == 26 || i == 32 || i == 38 || i == 44 || i == 50 || i == 56 ||
	i == 62 || i == 68 || i == 74) d9 = 0; 
      for (j = 1; j <= (int)sp[i]; j++) 
	discow[i] += a9 * pow(j, b9) * exp(j*c9) * dmi[i1][j];
      discow[i] += (sp[i]-(int)sp[i]) * a9 * pow(sp[i], b9) * exp(sp[i]*c9)
	* dmi[i1][j];
      discow[i] += ((int)(sp[i]+1)-sp[i]) * a9 * pow(sp[i], b9) 
	* exp(sp[i]*c9) * exp(d9*((int)(sp[i]+1)-sp[i]))* dmi[i1][j];  
      for (j = (int)(sp[i]+1); j <= (int)dl[i]; j++)       
	discow[i] += a9 * pow(j, b9) * exp(j*c9) * exp(d9*(j-sp[i])) * dmi[i1][j];  
      discow[i] += (dl[i]-(int)dl[i]) * a9 * pow(dl[i], b9) * exp(dl[i]*c9)
	* exp(d9*(dl[i]-sp[i]))* dmi[i1][j];  
      }
    dismilk = 0;  
    for (i = NCP; i <= CC; i++) dismilk += 365*discow[i]*l2[i-NCP+1];
    dismilk /= ciav;
    lossmilk = prmilk*dismilk;  
    ymi = 0;
    for (i = 0; i < LL; i++) ymi += ircmy[i]*l3[i];
    costvetm = (costdrug + labvet*pricevet) * ymi;
    costlabm = labherd * priceherd * ymi;
    pydry = 0;
    for (i = 0; i < LL-1; i++) pydry += l2[6*(i+1)]/ci[i];
    pydry *= pdry*365;
    costom = costmach*ymi + 4*pricedry*pydry;
    losstotal = lossmilk+costvetm+costlabm+costom;
    }

  /* Calculation of losses due to claw disease */
  if (claw_inc == 1) {
    /* Discarded milk for individual categories */   
    for (i = NCP; i <= CC; i++) {
      if (i == 29 || i == 35 || i == 41 || i == 47 || i == 53 ||
	i == 59 || i == 65 || i == 71 || i == 77) i++;
      if (i < 31) { 
	a9 = a1;
	b9 = b1;
	c9 = c1;
	d9 = d1;
	i1 = 0;
	}
      if ((i > 30) && (i < 37)) {
	a9 = a2;
	b9 = b2;
	c9 = c2;
	d9 = d2;
	i1 = 1;
	}
      if (i > 36) {
	a9 = a2;
	b9 = b3;
	c9 = c3;
	d9 = d3;
	i1 = 2;
	}
      discd[i] = 0;
      if (i == 28 || i == 34 || i == 40 || i == 46 || i == 52 || i == 58 ||
	i == 64 || i == 70 || i == 76 || i > 78) d9 = 0;
      if (i == 26 || i == 32 || i == 38 || i == 44 || i == 50 || i == 56 ||
	i == 62 || i == 68 || i == 74) d9 = 0; 
      for (j = 1; j <= (int)sp[i]; j++) 
	discd[i] += a9 * pow(j, b9) * exp(j*c9) * dcdi[i1][j];
      discd[i] += (sp[i]-(int)sp[i]) * a9 * pow(sp[i], b9) * exp(sp[i]*c9)
	* dcdi[i1][j];
      discd[i] += ((int)(sp[i]+1)-sp[i]) * a9 * pow(sp[i], b9) 
	* exp(sp[i]*c9) * exp(d9*((int)(sp[i]+1)-sp[i]))* dcdi[i1][j];  
      for (j = (int)(sp[i]+1); j <= (int)dl[i]; j++)       
	discd[i] += a9 * pow(j, b9) * exp(j*c9) * exp(d9*(j-sp[i])) * 
	dcdi[i1][j];  
      discd[i] += (dl[i]-(int)dl[i]) * a9 * pow(dl[i], b9) * exp(dl[i]*c9)
	* exp(d9*(dl[i]-sp[i]))* dcdi[i1][j];  
      }
    dismcd = 0;  
    for (i = NCP; i <= CC; i++) dismcd += 365*discd[i]*l2[i-NCP+1];
    dismcd /= ciav;
    lossmcd = prmilk*dismcd;  
    yacdi = 0; 
    for (i = 0; i < LL; i++) yacdi += ircdy[i]*pacd[i]*l3[i];
    ynacdi = 0;
    for (i = 0; i < LL; i++) ynacdi += ircdy[i]*(1-pacd[i])*l3[i];
    ycdi = yacdi + ynacdi;
    costvetcd = (costacd + labvetcd*prvetcd) * yacdi;
    costhcd = (costnacd + labherdcd * prherdcd) * ynacdi;
    losstcd = lossmcd+costvetcd+costhcd;
    }

  /* Calculation of revenues */
  if (trait == 0) printf("Calculating revenues\n"); 
  for (i = 0; i < i4; i++) {
    if (i == 8) i = 10;
    if (i == 11) i = 12;
    if (i == 23) i = 25;
    if (i ==CC+8) i = CC+10;
    if (i ==CC+11) i = CC+12;
    if (i ==CC+23) i = CC+25;
    pr[i] = 0;
    }
  for (i = 0; i < p1; i++) {
    for (j = 0; j < p2; j++) {
      pr[12] += Prh[i][j]*Ph[i][j][0];
      if (pbf[0] == 1) pr[14] += Prb[i][j]*Pb[i][j][0];
      if (cast[0] == 1) pr[17] += Prcs[i][j]*Pcs[i][j][0];
      pr[30] += Prc[i][j]*Pc[i][j][0]; 
      }
    }
  for (i = 0; i < p1; i++) {
    for (j = 0; j < p2; j++) {
      pr[CC+12] += Prh[i][j]*Ph[i][j][1];
      if (pbf[1] == 1) pr[CC+14] += Prb[i][j]*Pb[i][j][1];
      if (cast[1] == 1) pr[CC+17] += Prcs[i][j]*Pcs[i][j][1];
      }
    }
  for  (j = 0; j <= cb; j++) { 
    pr[12+CC*j] *= prh/100;
    if (pbf[j] == 1) pr[14+CC*j] *= prb/100;
    if (cast[j] == 1) pr[17+CC*j] *= prcs/100;
    }
  pr[30] *= prc/100;
  for (i = 0; i <= CC; i++) revmilk[i] = 0;
  for (i = NCP; i <= CC; i++) {
    j = (int)((i-25)/6+.05);
    if (i-6*j == 29) i++;
    if (mast_inc == 1) revmilk[i] = prmilk*(milksum[i]-discow[i]);
      else  revmilk[i] = prmilk*milksum[i];
    }
  for (i = 0; i <= CT; i++) rev[i] = 0;
  for (j = 0; j <= cb; j++) {
    if (pr[CC*j+8] > 0.000001) rev[CC*j+8] = pr[CC*j+8]*ww[8+j*CC];
      else rev[CC*j+8] = pranim[CC*j+8];
    if (pr[CC*j+9] > 0.000001) rev[CC*j+9] = pr[CC*j+9]*ww[9+j*CC];
      else rev[CC*j+9] = pranim[CC*j+9];
    if (pr[CC*j+10] > 0.000001) rev[CC*j+10] = pr[CC*j+10]*ww[10+j*CC];      
      else rev[CC*j+10] = pranim[CC*j+10];
    if (pff[j] == 1) {
      rev[CC*j+12] = whfat[j]*dresh[j]*pr[CC*j+12];
      rev[CC*j+13] = wcwsf[j]*dresh[j]*kdresh*pr[CC*j+12]*kpr[12];
      }
    if (pbf[j] == 1) {
      rev[CC*j+14] = wbfat[j]*dresh[j]*kdresbh[j]*pr[CC*j+14];
      rev[CC*j+15] = wcwsm[j]*dresh[j]*kdresbh[j]*kdresb*pr[CC*j+14]*kpr[14];
      }
    if (cast[j] == 1) {
      rev[CC*j+17] = wcfat[j]*dresh[j]*kdresch[j]*pr[CC*j+17];
      rev[CC*j+16] = wcwsc[j]*dresh[j]*kdresch[j]*kdresc*pr[CC*j+17]*kpr[17];
      }
    if (l1[CC*j+18] > 0.000001) 
      rev[CC*j+18] = whmat1[j]*dresh[j]*pr[CC*j+12];
    if (l1[CC*j+19] > 0.000001) 
      rev[CC*j+19] = whcmat*dresh[j]*pr[CC*j+12];
    if (pr[CC*j+23] > 0.000001) rev[CC*j+23] = ww[23+CC*j]*pr[CC*j+23];
      else rev[CC*j+23] = pranim[CC*j+23];
    if (pr[CC*j+24] > 0.000001) rev[CC*j+24] = ww[24+CC*j]*pr[CC*j+24]; 
      else rev[CC*j+24] = pranim[CC*j+24];
    }
  for (i = 1; i <= LL; i++) {
    rev[19+6*i] = revmilk[19+6*i];
    rev[20+6*i] = wcdys[i-1]*dresh[0]*kdrescwh*pr[30]*kpr[30]+revmilk[20+6*i];
    rev[21+6*i] = wcc[i-1]*dresh[0]*kdrescwh*pr[30]*kpr[30]+revmilk[21+6*i];
    rev[22+6*i] = wccw[i-1]*dresh[0]*kdrescwh*pr[30]+revmilk[22+6*i];
    if (i < LL) rev[24+6*i] = revmilk[24+6*i];
    }
  
  /* Revenues per cow and year */
  revc = revmilkc = 0;
  for (i = NCP; i <= CC; i++) revc += l2[i-24]*rev[i];
  revc *= 365/ciav;    
  for (i = NCP; i <= CC; i++) revmilkc += revmilk[i]*l2[i-24];
  revmilkc *= 365/ciav;   
  revcullc = revc-revmilkc; 
    
  /* End of revenues */
  
  /* Calculating Numbers of discounted expressions */
  if (trait == 0)
    printf("Calculating number of discounted expressions\n");  
  for (i = 0; i <= CT; i++) tr[i] = 0;
  for (j = 0; j <= cb; j++) {
    if (rev[CC*j+8] > 0) tr[CC*j+8] = age[CC*j+8]/365;
    if (rev[CC*j+9] > 0) tr[CC*j+9] = age[CC*j+9]/365;
    if (rev[CC*j+10] > 0) tr[CC*j+10] = age[10+CC*j]/365;
    if (rev[CC*j+12] > 0) tr[CC*j+12] = agesf[j]/365;
    if (rev[CC*j+13] > 0) tr[CC*j+13] = agecwsf[j]/365;
    if (rev[CC*j+14] > 0) tr[CC*j+14] = agesm[j]/365;
    if (rev[CC*j+15] > 0) tr[CC*j+15] = agecwsm[j]/365;
    if (rev[CC*j+16] > 0) tr[CC*j+16] = agecwsc[j]/365;
    if (rev[CC*j+17] > 0) tr[CC*j+17] = agesc[j]/365;
    if (rev[CC*j+18] > 0) tr[CC*j+18] = agehmat1[j]/365;
    if (rev[CC*j+19] > 0) tr[CC*j+19] = agehcmat1[j]/365;
    if (rev[CC*j+23] > 0) tr[CC*j+23] = age[23+j*CC]/365;
    if (rev[CC*j+24] > 0) tr[CC*j+24] = age[24+j*CC]/365;
    }
  for (i = 1; i <= LL; i++) {
    if (rev[19+6*i] > 0) tr[19+6*i] = d[19+6*i]/(365*2);
    if (rev[20+6*i] > 0) tr[20+6*i] = d[20+6*i]/(365*2);
    if (rev[21+6*i] > 0) tr[21+6*i] = d[21+6*i]/(365*2);
    if (rev[22+6*i] > 0) tr[22+6*i] = d[22+6*i]/(365*2);
    if (i == LL) break;
    if (rev[23+6*i] > 0) tr[23+6*i] = d[23+6*i]/(365*2);
    if (rev[24+6*i] > 0) tr[24+6*i] = d[24+6*i]/(365*2);
    }
  for (i = NCP; i <= CC; i++) l1[i] = l2[i-24];  
  aa1 = 1/(1 + u);
  for (i = 1; i < i4; i++) {
    qr[i] = pow(aa1, tr[i]);
    if(rev[i] > 0) NDEr[i] = l1[i]*qr[i];
    }  
  for (i = 0; i <= CT; i++) tc[i] = 0;
  for (j = 0; j <= cb; j++) {
    if (cost[CC*j+4] > 0) tc[CC*j+4] = agedwsm[j]/(365*2);
    if (cost[CC*j+5] > 0) tc[CC*j+5] = agedwsc[j]/(365*2);
    if (cost[CC*j+6] > 0) tc[CC*j+6] = agedwsf[j]/(365*2);	
    if (cost[CC*j+7] > 0) tc[CC*j+7] = agedmh[j]/(365*2);
    if (cost[CC*j+8] > 0) tc[CC*j+8] = age[CC*j+8]/(365*2);
    if (cost[CC*j+9] > 0) tc[CC*j+9] = age[CC*j+9]/(365*2);
    if (cost[CC*j+10] > 0) tc[CC*j+10] = age[10+CC*j]/(365*2);
    if (cost[CC*j+3] > 0)  
      tc[CC*j+3] = (1 / (4*l1[j*CC+3])) * (agew[j] * losfw[j]
      / (365*2) + Nmc48a[j] * dcw[j] * (tc[CC*j+9] * mxmc[j] * age[CC*j+3] 
      /agew[j]+ tc[CC*j+10] * mtest[j] * age[10+CC*j] / agew[j] + agew[j] * 
      (1 - mxmc[j] - mtest[j]) / (365*2))); 
    if (cost[CC*j+12] > 0) tc[CC*j+12] = agesf[j]/(365*2);
    if (cost[CC*j+13] > 0) tc[CC*j+13] = agecwsf[j]/(365*2);
    if (cost[CC*j+14] > 0) tc[CC*j+14] = agesm[j]/(365*2);
    if (cost[CC*j+15] > 0) tc[CC*j+15] = agecwsm[j]/(365*2);
    if (cost[CC*j+16] > 0) tc[CC*j+16] = agecwsc[j]/(365*2);
    if (cost[CC*j+17] > 0) tc[CC*j+17] = agesc[j]/(365*2);
    if (cost[CC*j+18] > 0) tc[CC*j+18] = agehmat1[j]/(365*2);
    if (cost[CC*j+19] > 0) tc[CC*j+19] = agehcmat1[j]/(365*2);
    if (cost[CC*j+22] > 0) tc[CC*j+22] = ageh1cal[j]/(365*2);
    if (cost[CC*j+23] > 0) tc[CC*j+23] = age[23+j*CC]/(365*2);
    if (cost[CC*j+24] > 0) tc[CC*j+24] = age[24+j*CC]/(365*2);
    }
  for (i = 1; i <= LL; i++) {
    if(cost[19+6*i] > 0) tc[19+6*i] = d[19+6*i]/(365*2);
    if(cost[20+6*i] > 0) tc[20+6*i] = d[20+6*i]/(365*2);
    if(cost[21+6*i] > 0) tc[21+6*i] = d[21+6*i]/(365*2);
    if(cost[22+6*i] > 0) tc[22+6*i] = d[22+6*i]/(365*2);
    if (i == LL) break;
    if(cost[23+6*i] > 0) tc[23+6*i] = d[23+6*i]/(365*2);
    if(cost[24+6*i] > 0) tc[24+6*i] = d[24+6*i]/(365*2);
    }
  for (i = 1; i < i4; i++) {
    qc[i] = pow(aa1, tc[i]);
    if(cost[i] > 0) NDEc[i] = l1[i]*qc[i];
    }  
  NDEdys = 1;
  /* End Number of discounted expressions */  

  /* Calculating profit */
  if (trait == 0) printf("Calculating profit\n");
  Trev = Tcost = Tprof = 0;
  for (i = 1; i < i4; i++) {
    Trev += rev[i]*NDEr[i];
    Tcost += cost[i]*NDEc[i];
    }
  milktot = fatkg = protkg = 0;
  for (i = NCP; i <= CC; i++) {
    milktot += milksum[i]*l2[i-24];
    fatkg += 0.01*milksum[i]*l2[i-24]*fat;
    protkg += 0.01*milksum[i]*l2[i-24]*prot;
    }
  dot = dotmilk*milktot + dotcowo + dotcowh*herdbook + dotexpm*(l1[9]+l1[CC+9])
    + dotfati*(l1[12]+l1[14]+l1[17]+l1[CC+12]+l1[CC+14]+l1[CC+17]);
  Tcost += costdys * NDEdys;
  Tcost *= 365/ciav;
  Trev *= 365/ciav;
  dot *= 365/ciav;
  Tprof = Trev - Tcost + dot;
  profitab = 100*(Trev-Tcost)/Tcost;
  profitabd = 100*Tprof/Tcost;
  
  /* Calculation of economic values and economic weights */
  if (trait == 0 && zr == 1) goto Part_20;
EW: if (trait == 0) {
      printf("Calculating economic weights (This will take some time)\n");
      for (i = 0; i < NT; i++) {
        ew_d[i]= ew_m[i] = 0;
        for (j = 0; j <= 2; j++)
	  ew[i][j] = ew0[i][j] = 0;
        }
      if (milkquota > 1) Tprofm = Tprof;
      if (milkquota > 1) milktotm = milktot;
      }	 
  /* Trait: mature weight of cows */
  if (trait == 0) trait = 4;
  if (trait == 4 && zr < 11) {
    if (ewopt == 1 && zr == 1) zr += 5;
    for (j = ja; j <= jb; j++) {  
      if (zr == 1 + 5*j) {
        if (j == 0) tvm = mcwd;
        if (j == 1) tvm = mcwb;	
	if (j == 0) mcwd = tvh = 1.01*tvm;
	if (j == 1) mcwb = tvh = 1.01*tvm; 
	zr++;
	goto Start;
	}
      if (zr == 2 + 5*j) {
	Tprofh = Tprof;
	if (j == 0) mcwd = tvl = 0.99*tvm;
	if (j == 1) mcwb = tvl = 0.99*tvm; 
	zr++;
	goto Start;
	}
      if (zr == 3 + 5*j) {
	Tprofl = Tprof;
	ew0[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
	tvh = 1.005*tvm;
	tvl = 0.995*tvm;
	if (j == 0) mcwd = tvh;
	if (j == 1) mcwb = tvh;
	zr++;
	goto Start;
	}
      if (zr == 4 + 5*j) {
	Tprofh = Tprof;
	if (j == 0) mcwd = tvl;
	if (j == 1) mcwb = tvl;
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
	}
      if (zr == 5 + 5*j) {
	Tprofl = Tprof;
	ew[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
	if (j == 0) mcwd = tvm;
	if (j == 1) mcwb = tvm;
	zr++;
	goto Start;
	} 
      }
      if (zr < 11) zr = 11;
    }
    
  /* Trait: birth weight of calves */
  if (trait == 4) trait = 5;
  if (trait == 5 && zr < 21) {
    if (ewopt == 1 && zr == 11) zr += 5;  
    for (j = ja; j <= jb; j++) {  
      if (zr == 11 + 5*j) {
        tvm = bwf[j];
        bwf[j] = tvh = 1.01*tvm;
	zr++;
	goto Start;
	}
      if (zr == 12 + 5*j) {
	Tprofh = Tprof;
	bwf[j] = tvl = 0.99*tvm;
	zr++;
	goto Start;
	}
      if (zr == 13 + 5*j) {
	Tprofl = Tprof;
	ew0[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
	tvh = 1.005*tvm;
	tvl = 0.995*tvm;
	bwf[j] = tvh;
	zr++;
	goto Start;
	}
      if (zr == 14 + 5*j) {
	Tprofh = Tprof;
	bwf[j] = tvl;
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
	}
      if (zr == 15 + 5*j) {
	Tprofl = Tprof;
	ew[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
	bwf[j]  = tvm;
	zr++;
	goto Start;
	} 
      }
    if (zr < 21) zr = 21;
    }

  /* Trait: average daily gain from birth to the end of the rearing period */
  if (trait == 5) trait = 30;
  if (trait == 30 && zr < 31) {
    if (ewopt == 1 && zr == 21) zr += 5;  
    for (j = ja; j <= jb; j++) {  
      if (zr == 21 + 5*j) {
        tvm = adgcf[j];
        adgcf[j] = tvh = 1.01*tvm;
	zr++;
	goto Start;
	}
      if (zr == 22 + 5*j) {
	Tprofh = Tprof;
	if (milkquota > 1) milktoth = milktot;
	adgcf[j] = tvl = 0.99*tvm;
	zr++;
	goto Start;
	}
      if (zr == 23 + 5*j) {
	Tprofl = Tprof;
	if (milkquota > 1) {
	  milktotl = milktot;
	  deltamilk = (milktoth - milktotl)/(tvh - tvl);
	  deltacow = deltamilk/milktotm; 
	  }
	ew0[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
        if (milkquota > 1) ew0[trait][j] = ew0[trait][j]-deltacow*Tprofm;
	ew0[trait][j] *= 0.001;
	tvh = 1.005*tvm;
	tvl = 0.995*tvm;
	adgcf[j] = tvh;
	zr++;
	goto Start;
	}
      if (zr == 24 + 5*j) {
	Tprofh = Tprof;
	if (milkquota > 1) milktoth = milktot;
	adgcf[j] = tvl;
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
	}
      if (zr == 25 + 5*j) {
	Tprofl = Tprof;
	if (milkquota > 1) {
	  milktotl = milktot;
	  deltamilk = (milktoth - milktotl)/(tvh - tvl);
	  deltacow = deltamilk/milktotm; 
	  }	
	ew[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
	if (milkquota > 1) ew[trait][j] = ew[trait][j]-deltacow*Tprofm;
	ew[trait][j] *= 0.001;
	adgcf[j]  = tvm;
	zr++;
	goto Start;
	} 
      }
    if (zr < 31) zr = 31;      
    }

  /* Trait: average daily gain in fattening */
  if (trait == 30) trait = 9;
  if (trait == 9 && paf[0] == 0 && paf[1] == 0) zr = 41;
  if (trait == 9 && zr < 41) {
    if ((ewopt == 1 || paf[0] == 0) && zr == 31) zr += 5; 
    i2 = ja;
    i3 = jb;
    if (paf[0] == 0 && paf[1] == 1) i2 = 1;
    if (paf[1] == 0) i3 = 0;
    for (j = i2; j <= i3; j++) {  
      if (zr == 31 + 5*j) {
        tvm = adgwsf[j];
        adgwsf[j] = tvh = 1.01*tvm;
	zr++;
	goto Start;
	}
      if (zr == 32 + 5*j) {
	Tprofh = Tprof;
	adgwsf[j] = tvl = 0.99*tvm;
	zr++;
	goto Start;
	}
      if (zr == 33 + 5*j) {
	Tprofl = Tprof;
	ew0[trait][j] = 0.001*(Tprofh - Tprofl)/(tvh - tvl);
	tvh = 1.005*tvm;
	tvl = 0.995*tvm;
	adgwsf[j] = tvh;
	zr++;
	goto Start;
	}
      if (zr == 34 + 5*j) {
	Tprofh = Tprof;
	adgwsf[j] = tvl;
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
	}
      if (zr == 35 + 5*j) {
	Tprofl = Tprof;
	ew[trait][j] = 0.001*(Tprofh - Tprofl)/(tvh - tvl);
	adgwsf[j]  = tvm;
	zr++;
	goto Start;
	} 
      }
    if (zr < 41) zr = 41;      
    }

  /* Trait: losses of calves from 48 hours after calving till the end
     of the rearing period */
  if (trait == 9) trait = 3;
  if (trait == 3 && zr < 51) {
    if (ewopt == 1 && zr == 41) zr += 5;  
    for (j = ja; j <= jb; j++) {  
      if (zr == 41 + 5*j) {
        tvm = dcw[j];
        dcw[j] = tvh = 1.01*tvm;
	zr++;
	goto Start;
	}
      if (zr == 42 + 5*j) {
	Tprofh = Tprof;
	dcw[j] = tvl = 0.99*tvm;
	zr++;
	goto Start;
	}
      if (zr == 43 + 5*j) {
	Tprofl = Tprof;
	ew0[trait][j] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	tvh = 1.005*tvm;
	tvl = 0.995*tvm;
	dcw[j] = tvh;
	zr++;
	goto Start;
	}
      if (zr == 44 + 5*j) {
	Tprofh = Tprof;
	dcw[j] = tvl;
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
	}
      if (zr == 45 + 5*j) {
	Tprofl = Tprof;
	ew[trait][j] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	dcw[j] = tvm;
	zr++;
	goto Start;
	} 
      if (zr < 46 + 5*j) zr = 46 + 5*j;
      }
    if (zr < 51) zr = 51;      
    }

  /* Trait: conception rate of heifers */
  if (trait == 3) {
    trait = 12;
    tvm = crinh[0];
    }
  if (ewopt == 0 || ewopt == 2) {
    if (trait == 12 && zr == 51) {
      crinh[0] = tvh = 1.01*tvm;
      zr++;
      goto Start;
      }
    if (trait == 12 && zr == 52) {
      Tprofh = Tprof;
      if (milkquota > 1) milktoth = milktot;  
      avh = intconh;    
      crinh[0] = tvl = 0.99*tvm;
      zr++;
      goto Start;
      }
    if (trait == 12 && zr == 53) {
      Tprofl = Tprof;
      avl = intconh;
      if (milkquota > 1) {
	milktotl = milktot;
	deltamilk = (milktoth - milktotl)/(tvh - tvl);
	deltacow = deltamilk/milktotm; 
	} 
      ew0[trait][0] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      if (milkquota > 1) ew0[trait][0] = ew0[trait][0]-0.01*deltacow*Tprofm;
      if (milkquota > 1) {
	deltamilk = (milktoth - milktotl)/(avh - avl);
	deltacow = deltamilk/milktotm; 
	} 
      ew0[40][0] = (Tprofh - Tprofl)/(avh - avl);
      if (milkquota > 1) ew0[40][0] = ew0[40][0]-deltacow*Tprofm;   
      tvh = 1.005*tvm;
      tvl = 0.995*tvm;
      crinh[0] = tvh;
      zr++;
      goto Start;
      }
    if (trait == 12 && zr == 54) {
      Tprofh = Tprof;
      if (milkquota > 1) milktoth = milktot;  
      avh = intconh;    
      crinh[0] = tvl;
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
      }
    if (trait == 12 && zr == 55) {
      Tprofl = Tprof;
      avl = intconh;
      if (milkquota > 1) {
	milktotl = milktot;
	deltamilk = (milktoth - milktotl)/(tvh - tvl);
	deltacow = deltamilk/milktotm; 
	}
      ew[trait][0] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      if (milkquota > 1) ew[trait][0] = ew[trait][0]-0.01*deltacow*Tprofm;
      if (milkquota > 1) {
	deltamilk = (milktoth - milktotl)/(avh - avl);
	deltacow = deltamilk/milktotm; 
	}
      ew[40][0] = (Tprofh - Tprofl)/(avh - avl);
      if (milkquota > 1) ew[40][0] = ew[40][0]-deltacow*Tprofm;
      crinh[0] = tvm;
      zr++;
      goto Start;
      } 
    }
  if (zr < 56) zr = 56;

  /* Trait: Conception rate of cows */
  if (trait == 12) {
    trait = 13;
    tvm = ecrinc[0];
    }
  if (ewopt == 0 || ewopt == 2) {
    if (trait == 13 && zr == 56) {
      ecrinc[0] = tvh = 1.01*tvm;
      zr++;
      goto Start;
      }
    if (trait == 13 && zr == 57) {
      Tprofh = Tprof;
      if (milkquota > 1) milktoth = milktot;    
      avh = ciav;
      ecrinc[0] = tvl = 0.99*tvm;
      zr++;
      goto Start;
      }
    if (trait == 13 && zr == 58) {
      Tprofl = Tprof;
      avl = ciav;
      if (milkquota > 1) {
	milktotl = milktot;
	deltamilk = (milktoth - milktotl)/(tvh - tvl);
	deltacow = deltamilk/milktotm; 
	}
      ew0[trait][0] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      if (milkquota > 1) ew0[trait][0] = ew0[trait][0]-0.01*deltacow*Tprofm;
      if (milkquota > 1) {
	deltamilk = (milktoth - milktotl)/(avh - avl);
	deltacow = deltamilk/milktotm; 
	}
      ew0[41][0] = (Tprofh - Tprofl)/(avh - avl);
      if (milkquota > 1) ew0[41][0] = ew0[41][0]-deltacow*Tprofm;
      tvh = 1.005*tvm;
      tvl = 0.995*tvm;
      ecrinc[0] = tvh;
      zr++;
      goto Start;
      }
    if (trait == 13 && zr == 59) {
      Tprofh = Tprof;
      if (milkquota > 1) milktoth = milktot;
      avh = ciav;
      ecrinc[0] = tvl;
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
      }
    if (trait == 13 && zr == 60) {
      Tprofl = Tprof;
      avl = ciav;
      if (milkquota > 1) {
	milktotl = milktot;
	deltamilk = (milktoth - milktotl)/(tvh - tvl);
	deltacow = deltamilk/milktotm; 
	}
      ew[trait][0] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      if (milkquota > 1) ew[trait][0] = ew[trait][0]-0.01*deltacow*Tprofm;
      if (milkquota > 1) {
	deltamilk = (milktoth - milktotl)/(avh - avl);
	deltacow = deltamilk/milktotm; 
	}
      ew[41][0] = (Tprofh - Tprofl)/(avh - avl);
      if (milkquota > 1) ew[41][0] = ew[41][0]-deltacow*Tprofm;
      ecrinc[0] = tvm;
      zr++;
      goto Start;
      } 
    }
  if (zr < 61) zr = 61;

  /* Trait: Cow losses */
  if (trait == 13 && zr == 61) {
    trait = 11;
    tvm = losc;
    for (i = 1; i <= LL; i++) {
      zzlosc[i] = pp[19+6*i];
      zzlosc[i+LL] = culh[i-1];
      }
    }   
  if (ewopt == 0 || ewopt == 2) {      
    if (trait == 11 && zr == 61) {
      for (i = 1; i <= LL; i++) {
	pp[19+6*i] = 1.01 * zzlosc[i];
	culh[i-1] = 1.01 * zzlosc[i+LL];
	}
      zr++;
      goto Start;
      }
    if (trait == 11 && zr == 62) {
      Tprofh = Tprof;
      tvh = losc;
      avh = avelifecy;
      if (milkquota > 1) milktoth = milktot;      
      for (i = 1; i <= LL; i++) {
	pp[19+6*i] = 0.99 * zzlosc[i];
	culh[i-1] = 0.99 * zzlosc[i+LL];
	}
      zr++;
      goto Start;
      }
    if (trait == 11 && zr == 63) {
      Tprofl = Tprof;
      tvl = losc;
      avl = avelifecy;
      if (milkquota > 1) {
	milktotl = milktot;
	deltamilk = (milktoth - milktotl)/(tvh - tvl);
	deltacow = deltamilk/milktotm; 
	}
      ew0[trait][0] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      ew0[29][0] = (Tprofh - Tprofl)/(avh - avl);
      if (milkquota > 1) {
        ew0[trait][0] = ew0[trait][0]-0.01*deltacow*Tprofm;
	deltamilk = (milktoth - milktotl)/(avh - avl);
	deltacow = deltamilk/milktotm; 
	ew0[29][0] = ew0[29][0]-deltacow*Tprofm;
        }
      for (i = 1; i <= LL; i++) {
	pp[19+6*i] = 1.005 * zzlosc[i];
	culh[i-1] = 1.005 * zzlosc[i+LL];
	}
      zr++;
      goto Start;
      }
    if (trait == 11 && zr == 64) {
      Tprofh = Tprof;
      tvh = losc;
      avh = avelifecy;
      if (milkquota > 1) milktoth = milktot;      
      for (i = 1; i <= LL; i++) {
	pp[19+6*i] = 0.995 * zzlosc[i];
	culh[i-1] = 0.995 * zzlosc[i+LL];
	}
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
      }
    if (trait == 11 && zr == 65) {
      Tprofl = Tprof;
      tvl = losc;
      avl = avelifecy;
      if (milkquota > 1) {
	milktotl = milktot;
	deltamilk = (milktoth - milktotl)/(tvh - tvl);
	deltacow = deltamilk/milktotm; 
	}
      ew[trait][0] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      ew[29][0] = (Tprofh - Tprofl)/(avh - avl);
      if (milkquota > 1) {
        ew[trait][0] = ew[trait][0]-0.01*deltacow*Tprofm;
	deltamilk = (milktoth - milktotl)/(avh - avl);
	deltacow = deltamilk/milktotm; 
	ew[29][0] = ew[29][0]-deltacow*Tprofm;
        }
      for (i = 1; i <= LL; i++) {
	pp[19+6*i] = zzlosc[i];
	culh[i-1] = zzlosc[i+LL];
	}
      zr++;
      goto Start;
      }
    } 
  if (zr < 66) zr = 66;

  /* Trait: dressing percentage */
  if (trait == 11) trait = 10;
  if (trait == 10 && zr < 76) {
    if (ewopt == 1 && zr == 66) zr += 5;
    for (j = ja; j <= jb; j++) {  
      if (zr == 66 + 5*j) {
        tvm = dresh[j];
        dresh[j] = tvh = 1.01*tvm;
	zr++;
	goto Start;
	}
      if (zr == 67 + 5*j) {
	Tprofh = Tprof;
	dresh[j] = tvl = 0.99*tvm;
	zr++;
	goto Start;
	}
      if (zr == 68 + 5*j) {
	Tprofl = Tprof;
	ew0[trait][j] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	tvh = 1.005*tvm;
	tvl = 0.995*tvm;
	dresh[j] = tvh;
	zr++;
	goto Start;
	}
      if (zr == 69 + 5*j) {
	Tprofh = Tprof;
	dresh[j] = tvl;
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
	}
      if (zr == 70 + 5*j) {
	Tprofl = Tprof;
	ew[trait][j] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	dresh[j]  = tvm;
	zr++;
	goto Start;
	} 
      }
    if (zr < 76) zr = 76;     
    }

  /* Trait: Calving performance - female calves */
  if (trait == 10) trait = 24;
  if (trait == 24 && zr < 86) {
    if (ewopt == 1 && zr == 76) zr += 5;    
    for (j = ja; j <= jb; j++) {  
      if (zr == 76 + 5*j) {
	/* Saving the original values of matrix dysff */
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    dysff0[j1][j][i] = (double)dysff[j1][j][i];
	    }
	  } 
	/* Frequencies of calving performance classes summed over lactations 
	   and cumulative frequencies */
	for (j1 = 0; j1 < DD; j1++) {
	  dysffl[j1][j] = dysffld[j1][j] = 0; 
	  for (i = 0; i < LL; i++) {	    
	    dysffl[j1][j] += (double) (dysff[j1][j][i]*l3[i]*cal[j][i]/totcal[j]);
	    }  
	  if (j1==0) dysffld[j1][j] = dysffl[j1][j];
	  if (j1>0) dysffld[j1][j] = dysffld[j1-1][j] + dysffl[j1][j]; 
	  }
	/* Threshold values for classes of calving performance */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysfflqm[j1][j] = probit(dysffld[j1][j]); 
	  } 
	/* Mean score for calving performance */
	dysfflmc[j] = 0;
	for (j1 = 0; j1 < DD; j1++) {
	  dysfflmc[j] += (j1+1)*dysffl[j1][j]; 
	  } 
	tvm = dysscoreavf[j] = dysfflmc[j];      
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysfflql[j1][j] = dysfflqm[j1][j] - 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysffldl[j1][j] = normdis(dysfflql[j1][j]); 
	  } 
	dysffldl[DD-1][j] = 1;
	for (j1 = 0; j1 < DD; j1++) {
	  } 
	dysffll[0][j] = dysffldl[0][j];
	for (j1 = 0; j1 < DD - 1; j1++) {
	  dysffll[j1+1][j] = dysffldl[j1+1][j] - dysffldl[j1][j];
	  } 
	/* New matrix dysff for shifted distribution */
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    if (dysffl[j1][j] == 0) dysff[j1][j][i] = 0;      
	      else dysff[j1][j][i] = dysffll[j1][j]*dysff0[j1][j][i]/dysffl[j1][j]; 
	    }
	  }  
	/* Mean score for calving performance */
	dysfflmc[j] = 0;
	for (j1 = 0; j1 < DD; j1++) {
	  dysfflmc[j] += (j1+1)*dysffll[j1][j]; 
	  } 
	tvh = dysfflmc[j];
	zr++;
	goto Start; 
	}
      if (zr == 77 + 5*j) {
	Tprofh = Tprof;
	if (milkquota > 1) milktoth = milktot;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysfflqr[j1][j] = dysfflqm[j1][j] + 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysffldr[j1][j] = normdis(dysfflqr[j1][j]); 
	  } 
	dysffldr[DD-1][j] = 1;
	dysfflr[0][j] = dysffldr[0][j];
	for (j1 = 0; j1 < DD - 1; j1++) {
	  dysfflr[j1+1][j] = dysffldr[j1+1][j] - dysffldr[j1][j];
	  } 
	/* New matrix dysff for shifted distribution */
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    if (dysffl[j1][j] == 0) dysff[j1][j][i] = 0;      
	      else dysff[j1][j][i] = dysfflr[j1][j]*dysff0[j1][j][i]/dysffl[j1][j]; 
	    }
	  }  
	/* Mean score for calving performance */
	dysfflmc[j] = 0;
	for (j1 = 0; j1 < DD; j1++) {
	  dysfflmc[j] += (j1+1)*dysfflr[j1][j]; 
	  } 
	tvl = dysfflmc[j];
	zr++;
	goto Start;
      }
      if (zr == 78 + 5*j) {
	Tprofl = Tprof;
	if (milkquota > 1) {
	  milktotl = milktot;
	  deltamilk = (milktoth - milktotl)/(tvh - tvl);
	  deltacow = deltamilk/milktotm; 
	  }
	ew0[trait][j] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	if (milkquota > 1) ew0[trait][j] = ew0[trait][j]-0.01*deltacow*Tprofm;
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysfflql[j1][j] = dysfflqm[j1][j] - 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysffldl[j1][j] = normdis(dysfflql[j1][j]); 
	  } 
	dysffldl[DD-1][j] = 1;
	dysffll[0][j] = dysffldl[0][j];
	for (j1 = 0; j1 < DD - 1; j1++) {
	  dysffll[j1+1][j] = dysffldl[j1+1][j] - dysffldl[j1][j];
	  } 
	/* New matrix dysff for shifted distribution */
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    if (dysffl[j1][j] == 0) dysff[j1][j][i] = 0;      
	      else dysff[j1][j][i] = dysffll[j1][j]*dysff0[j1][j][i]/dysffl[j1][j]; 
	    }
	  }  
	/* Mean score for calving performance */
	dysfflmc[j] = 0;
	for (j1 = 0; j1 < DD; j1++) {
	  dysfflmc[j] += (j1+1)*dysffll[j1][j]; 
	  } 
	tvh = dysfflmc[j];
	zr++;
	goto Start; 
	}
      if (zr == 79 + 5*j) {
	Tprofh = Tprof;
	if (milkquota > 1) milktoth = milktot;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysfflqr[j1][j] = dysfflqm[j1][j] + 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysffldr[j1][j] = normdis(dysfflqr[j1][j]); 
	  } 
	dysffldr[DD-1][j] = 1;
	dysfflr[0][j] = dysffldr[0][j];
	for (j1 = 0; j1 < DD - 1; j1++) {
	  dysfflr[j1+1][j] = dysffldr[j1+1][j] - dysffldr[j1][j];
	  } 
	/* New matrix dysff for shifted distribution */
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    if (dysffl[j1][j] == 0) dysff[j1][j][i] = 0;      
	      else dysff[j1][j][i] = dysfflr[j1][j]*dysff0[j1][j][i]/dysffl[j1][j]; 
	    }
	  }  
	/* Mean score for calving performance */
	dysfflmc[j] = 0;
	for (j1 = 0; j1 < DD; j1++) {
	  dysfflmc[j] += (j1+1)*dysfflr[j1][j]; 
	  } 
	tvl = dysfflmc[j];
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
        }

      if (zr == 80 + 5*j) {
	Tprofl = Tprof;
	if (milkquota > 1) {
	  milktotl = milktot;
	  deltamilk = (milktoth - milktotl)/(tvh - tvl);
	  deltacow = deltamilk/milktotm; 
	  }
	ew[trait][j] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
        if (milkquota > 1) ew[trait][j] = ew[trait][j]-0.01*deltacow*Tprofm;	
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    dysff[j1][j][i] = dysff0[j1][j][i];
	    }
	  } 
	zr++;
	goto Start;
        } 
      if (zr < 81 + 5*j) zr = 81 + 5*j;	
      }
    if (zr < 86) zr = 86;      
    }    

  /* Trait: calving performance - male calves */
  if (trait == 24) trait = 25;
  if (trait == 25 && zr < 96) {
    if (ewopt == 1 && zr == 86) zr += 5;    
    for (j = ja; j <= jb; j++) {  
      if (zr == 86 + 5*j) {
	/* Saving the original values of matrix dysmm */
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    dysmm0[j1][j][i] = (double)dysmm[j1][j][i];
	    }
	  } 
	/* Frequencies of calving performance classes summed over lactations 
	   and cumulative frequencies */
	for (j1 = 0; j1 < DD; j1++) {
	  dysmml[j1][j] = dysmmld[j1][j] = 0; 
	  for (i = 0; i < LL; i++) {	    
	    dysmml[j1][j] += (double) (dysmm[j1][j][i]*l3[i]*cal[j][i]/totcal[j]);
	    }  
	  if (j1==0) dysmmld[j1][j] = dysmml[j1][j];
	  if (j1>0) dysmmld[j1][j] = dysmmld[j1-1][j] + dysmml[j1][j]; 
	  }
	/* Threshold values for classes of calving performance */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysmmlqm[j1][j] = probit(dysmmld[j1][j]); 
	  } 
	/* Mean score for calving performance */
	dysmmlmc[j] = 0;
	for (j1 = 0; j1 < DD; j1++) {
	  dysmmlmc[j] += (j1+1)*dysmml[j1][j]; 
	  } 
	tvm = dysscoreavm[j] = dysmmlmc[j];
	dysscoreav[j] = (dysscoreavf[j] + dysscoreavm[j])/2;
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysmmlql[j1][j] = dysmmlqm[j1][j] - 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysmmldl[j1][j] = normdis(dysmmlql[j1][j]); 
	  } 
	dysmmldl[DD-1][j] = 1;
	for (j1 = 0; j1 < DD; j1++) {
	  } 
	dysmmll[0][j] = dysmmldl[0][j];
	for (j1 = 0; j1 < DD - 1; j1++) {
	  dysmmll[j1+1][j] = dysmmldl[j1+1][j] - dysmmldl[j1][j];
	  } 
	/* New matrix dysmm for shifted distribution */
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    if (dysmml[j1][j] == 0) dysmm[j1][j][i] = 0;      
	      else dysmm[j1][j][i] = dysmmll[j1][j]*dysmm0[j1][j][i]/dysmml[j1][j]; 
	    }
	  }  
	/* Mean score for calving performance */
	dysmmlmc[j] = 0;
	for (j1 = 0; j1 < DD; j1++) {
	  dysmmlmc[j] += (j1+1)*dysmmll[j1][j]; 
	  } 
	tvh = dysmmlmc[j];
	zr++;
	goto Start; 
	}
      if (zr == 87 + 5*j) {
	Tprofh = Tprof;
	if (milkquota > 1) milktoth = milktot;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysmmlqr[j1][j] = dysmmlqm[j1][j] + 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysmmldr[j1][j] = normdis(dysmmlqr[j1][j]); 
	  } 
	dysmmldr[DD-1][j] = 1;
	dysmmlr[0][j] = dysmmldr[0][j];
	for (j1 = 0; j1 < DD - 1; j1++) {
	  dysmmlr[j1+1][j] = dysmmldr[j1+1][j] - dysmmldr[j1][j];
	  } 
	/* New matrix dysmm for shifted distribution */
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    if (dysmml[j1][j] == 0) dysmm[j1][j][i] = 0;      
	      else dysmm[j1][j][i] = dysmmlr[j1][j]*dysmm0[j1][j][i]/dysmml[j1][j]; 
	    }
	  }  
	/* Mean score for calving performance */
	dysmmlmc[j] = 0;
	for (j1 = 0; j1 < DD; j1++) {
	  dysmmlmc[j] += (j1+1)*dysmmlr[j1][j]; 
	  } 
	tvl = dysmmlmc[j];
	zr++;
	goto Start;
      }
      if (zr == 88 + 5*j) {
	Tprofl = Tprof;
	if (milkquota > 1) {
	  milktotl = milktot;
	  deltamilk = (milktoth - milktotl)/(tvh - tvl);
	  deltacow = deltamilk/milktotm; 
	  }
	ew0[trait][j] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
        if (milkquota > 1) ew0[trait][j] = ew0[trait][j]-0.01*deltacow*Tprofm;
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysmmlql[j1][j] = dysmmlqm[j1][j] - 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysmmldl[j1][j] = normdis(dysmmlql[j1][j]); 
	  } 
	dysmmldl[DD-1][j] = 1;
	dysmmll[0][j] = dysmmldl[0][j];
	for (j1 = 0; j1 < DD - 1; j1++) {
	  dysmmll[j1+1][j] = dysmmldl[j1+1][j] - dysmmldl[j1][j];
	  } 
	/* New matrix dysmm for shifted distribution */
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    if (dysmml[j1][j] == 0) dysmm[j1][j][i] = 0;      
	      else dysmm[j1][j][i] = dysmmll[j1][j]*dysmm0[j1][j][i]/dysmml[j1][j]; 
	    }
	  }  
	/* Mean score for calving performance */
	dysmmlmc[j] = 0;
	for (j1 = 0; j1 < DD; j1++) {
	  dysmmlmc[j] += (j1+1)*dysmmll[j1][j]; 
	  } 
	tvh = dysmmlmc[j];
	zr++;
	goto Start; 
	}
      if (zr == 89 + 5*j) {
	Tprofh = Tprof;
	if (milkquota > 1) milktoth = milktot;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysmmlqr[j1][j] = dysmmlqm[j1][j] + 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < DD-1; j1++) {
	  dysmmldr[j1][j] = normdis(dysmmlqr[j1][j]); 
	  } 
	dysmmldr[DD-1][j] = 1;
	dysmmlr[0][j] = dysmmldr[0][j];
	for (j1 = 0; j1 < DD - 1; j1++) {
	  dysmmlr[j1+1][j] = dysmmldr[j1+1][j] - dysmmldr[j1][j];
	  } 
	/* New matrix dysmm for shifted distribution */
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    if (dysmml[j1][j] == 0) dysmm[j1][j][i] = 0;      
	      else dysmm[j1][j][i] = dysmmlr[j1][j]*dysmm0[j1][j][i]/dysmml[j1][j]; 
	    }
	  }  
	/* Mean score for calving performance */
	dysmmlmc[j] = 0;
	for (j1 = 0; j1 < DD; j1++) {
	  dysmmlmc[j] += (j1+1)*dysmmlr[j1][j]; 
	  } 
	tvl = dysmmlmc[j];
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
        }

      if (zr == 90 + 5*j) {
	Tprofl = Tprof;
	if (milkquota > 1) {
	  milktotl = milktot;
	  deltamilk = (milktoth - milktotl)/(tvh - tvl);
	  deltacow = deltamilk/milktotm; 
	  }
	ew[trait][j] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	if (milkquota > 1) ew[trait][j] = ew[trait][j]-0.01*deltacow*Tprofm;
	for (j1 = 0; j1 < DD; j1++) {
	  for (i = 0; i < LL; i++) {
	    dysmm[j1][j][i] = dysmm0[j1][j][i];
	    }
	  } 
	zr++;
	goto Start;
        } 
      }
    if (zr < 96) zr = 96;            
    }    

  /* Trait: calving performance summed over both sexes */
  if (trait == 25 && zr == 96) trait = 1;
  if (trait == 1 && zr == 96) {
    for (j = 0; j <= 1; j++) {
      ew[trait][j] = ew[24][j]+ew[25][j];
      ew0[trait][j] = ew0[24][j]+ew0[25][j];
      }
    zr++;
    }      

  /* Trait: fleshiness for bulls */
  if (trait == 1 && zr == 97 && pbf[0] == 0 && pbf[1] == 0) {
    trait = 15;
    zr = 107;
    }
  if (trait == 1 && zr == 97 && ewopt == 1 && pbf[1] == 0) {
    trait = 15;
    zr = 107;
    }
  if (trait == 1 && zr == 97 && ewopt == 0 && pbf[0] == 0) {
    trait = 15;
    zr = 107;
    }
  if (trait == 1 && zr == 97 && pbf[0] + pbf[1] > 0) trait = 15;
  if (trait == 15 && zr < 107) {
    i2 = ja;
    i3 = jb;
    if (pbf[0] == 1 && pbf[1] == 0 && ewopt == 2) i3 = 0;
    if (pbf[0] == 0 && pbf[1] == 1 && ewopt == 2) i2 = 1;
    if (i2 == 1 && zr == 97) zr += 5;    
    for (jj = i2; jj <= i3; jj++) {  
      if (zr == 97 + 5*jj) {
	/* Saving the original values of matrix Pb */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pc0[j1][i][jj] = (double)Pb[j1][i][jj];
	    }
	  } 
	/* Frequencies of fleshiness classes summed over fat covering classes 
	   and cumulative frequencies */
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfl[j1][jj] = Pcfld[j1][jj] = 0; 
	  for (i = 0; i < p2; i++) {
	    Pb[j1][i][jj] /= 100;
	    Pcfl[j1][jj] += Pb[j1][i][jj];
	  }  
	  if (j1==0) Pcfld[j1][jj] = Pcfl[j1][jj];
	  if (j1>0) Pcfld[j1][jj] = Pcfld[j1-1][jj] + Pcfl[j1][jj]; 
	  }
	/* Threshold values for classes of fleshiness */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqm[j1][jj] = probit(Pcfld[j1][jj]); 
	  } 
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfl[j1][jj]; 
	  } 
	tvm = Pcflmcb[jj] = Pcflmc[jj];
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflql[j1][jj] = Pcflqm[j1][jj] - 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldl[j1][jj] = normdis(Pcflql[j1][jj]); 
	  } 
	Pcfldl[p1-1][jj] = 1;
	Pcfll[0][jj] = Pcfldl[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfll[j1+1][jj] = Pcfldl[j1+1][jj] - Pcfldl[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pb[j1][i][jj] = 0;      
	      else Pb[j1][i][jj] = Pcfll[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfll[j1][jj]; 
	  } 
	tvh = Pcflmc[jj];
	zr++;
	goto Start; 
	}
      if (zr == 98 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqr[j1][jj] = Pcflqm[j1][jj] + 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldr[j1][jj] = normdis(Pcflqr[j1][jj]); 
	  } 
	Pcfldr[p1-1][jj] = 1;
	Pcflr[0][jj] = Pcfldr[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflr[j1+1][jj] = Pcfldr[j1+1][jj] - Pcfldr[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pb[j1][i][jj] = 0;      
	      else Pb[j1][i][jj] = Pcflr[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcflr[j1][jj]; 
	  } 
	tvl = Pcflmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 99 + 5*jj) {
	Tprofl = Tprof;
	ew0[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflql[j1][jj] = Pcflqm[j1][jj] - 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldl[j1][jj] = normdis(Pcflql[j1][jj]); 
	  } 
	Pcfldl[p1-1][jj] = 1;
	Pcfll[0][jj] = Pcfldl[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfll[j1+1][jj] = Pcfldl[j1+1][jj] - Pcfldl[j1][jj];
	  }  
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pb[j1][i][jj] = 0;      
	      else Pb[j1][i][jj] = Pcfll[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfll[j1][jj]; 
	  } 
	tvh = Pcflmc[jj];
	zr++;
	printf("  Run #%4d\n", zr);	
	goto Start; 
	}
      if (zr == 100 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqr[j1][jj] = Pcflqm[j1][jj] + 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldr[j1][jj] = normdis(Pcflqr[j1][jj]); 
	  } 
	Pcfldr[p1-1][jj] = 1;
	Pcflr[0][jj] = Pcfldr[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflr[j1+1][jj] = Pcfldr[j1+1][jj] - Pcfldr[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pb[j1][i][jj] = 0;      
	      else Pb[j1][i][jj] = Pcflr[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcflr[j1][jj]; 
	  } 
	tvl = Pcflmc[jj];
	zr++;
	goto Start;
      }

      if (zr == 101 + 5*jj) {
	Tprofl = Tprof;
	ew[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pb[j1][i][jj] = Pc0[j1][i][jj];
	    }
	  } 
	zr++;
	goto Start;
        } 
      }
    if (zr < 107) zr = 107;                  
    }      

  /* Trait: fleshiness for heifers */
  if (trait == 15 && zr == 107) trait = 16;
  if (trait == 16 && zr < 117) {
    if (ewopt == 1 && zr == 107) zr += 5;
    i3 = jb;    
    if (pff[1] == 0) i3 = 0;
    for (jj = ja; jj <= i3; jj++) {  
      if (zr == 107 + 5*jj) {
	/* Saving the original values of matrix Pb */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pc0[j1][i][jj] = (double)Ph[j1][i][jj];
	    }
	  } 
	/* Frequencies of fleshiness classes summed over fat covering classes 
	   and cumulative frequencies */
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfl[j1][jj] = Pcfld[j1][jj] = 0; 
	  for (i = 0; i < p2; i++) {
	    Ph[j1][i][jj] /= 100;
	    Pcfl[j1][jj] += Ph[j1][i][jj];
	  }  
	  if (j1==0) Pcfld[j1][jj] = Pcfl[j1][jj];
	  if (j1>0) Pcfld[j1][jj] = Pcfld[j1-1][jj] + Pcfl[j1][jj]; 
	  }
	/* Threshold values for classes of fleshiness */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqm[j1][jj] = probit(Pcfld[j1][jj]); 
	  } 
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfl[j1][jj]; 
	  } 
	tvm = Pcflmch[jj] = Pcflmc[jj];
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflql[j1][jj] = Pcflqm[j1][jj] - 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldl[j1][jj] = normdis(Pcflql[j1][jj]); 
	  } 
	Pcfldl[p1-1][jj] = 1;
	Pcfll[0][jj] = Pcfldl[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfll[j1+1][jj] = Pcfldl[j1+1][jj] - Pcfldl[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Ph[j1][i][jj] = 0;      
	      else Ph[j1][i][jj] = Pcfll[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfll[j1][jj]; 
	  } 
	tvh = Pcflmc[jj];
	zr++;
	goto Start; 
	}
      if (zr == 108 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqr[j1][jj] = Pcflqm[j1][jj] + 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldr[j1][jj] = normdis(Pcflqr[j1][jj]); 
	  } 
	Pcfldr[p1-1][jj] = 1;
	Pcflr[0][jj] = Pcfldr[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflr[j1+1][jj] = Pcfldr[j1+1][jj] - Pcfldr[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Ph[j1][i][jj] = 0;      
	      else Ph[j1][i][jj] = Pcflr[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcflr[j1][jj]; 
	  } 
	tvl = Pcflmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 109 + 5*jj) {
	Tprofl = Tprof;
	ew0[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflql[j1][jj] = Pcflqm[j1][jj] - 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldl[j1][jj] = normdis(Pcflql[j1][jj]); 
	  } 
	Pcfldl[p1-1][jj] = 1;
	Pcfll[0][jj] = Pcfldl[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfll[j1+1][jj] = Pcfldl[j1+1][jj] - Pcfldl[j1][jj];
	  }  
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Ph[j1][i][jj] = 0;      
	      else Ph[j1][i][jj] = Pcfll[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfll[j1][jj]; 
	  } 
	tvh = Pcflmc[jj];
	zr++;
	printf("  Run #%4d\n", zr);	
	goto Start; 
	}
      if (zr == 110 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqr[j1][jj] = Pcflqm[j1][jj] + 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldr[j1][jj] = normdis(Pcflqr[j1][jj]); 
	  } 
	Pcfldr[p1-1][jj] = 1;
	Pcflr[0][jj] = Pcfldr[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflr[j1+1][jj] = Pcfldr[j1+1][jj] - Pcfldr[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Ph[j1][i][jj] = 0;      
	      else Ph[j1][i][jj] = Pcflr[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcflr[j1][jj]; 
	  } 
	tvl = Pcflmc[jj];
	zr++;
	goto Start;
      }

      if (zr == 111 + 5*jj) {
	Tprofl = Tprof;
	ew[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Ph[j1][i][jj] = Pc0[j1][i][jj];
	    }
	  } 
	zr++;
	goto Start;
        } 
      }
    if (zr < 117) zr = 117;                  
    }      

  /* Trait: fleshiness for castrates */
  if (trait == 16 && zr == 117 && cast[0] == 0 && cast[1] == 0) {
    trait = 17;
    zr = 127;
    }
  if (trait == 16 && zr == 117 && ewopt == 1 && cast[1] == 0) {
    trait = 17;
    zr = 127;
    }
  if (trait == 16 && zr == 117 && ewopt == 0 && cast[0] == 0) {
    trait = 17;
    zr = 127;
    }
  if (trait == 16 && zr == 117 && cast[0] + cast[1] > 0) trait = 17;
  if (trait == 17 && zr < 127) {
    i2 = ja;
    i3 = jb;
    if (cast[0] == 1 && cast[1] == 0 && ewopt == 2) i3 = 0;
    if (cast[0] == 0 && cast[1] == 1 && ewopt == 2) i2 = 1;
    if (i2 == 1 && zr == 117) zr += 5;    
    for (jj = i2; jj <= i3; jj++) {  
      if (zr == 117 + 5*jj) {
	/* Saving the original values of matrix Pb */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pc0[j1][i][jj] = (double)Pcs[j1][i][jj];
	    }
	  } 
	/* Frequencies of fleshiness classes summed over fat covering classes 
	   and cumulative frequencies */
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfl[j1][jj] = Pcfld[j1][jj] = 0; 
	  for (i = 0; i < p2; i++) {
	    Pcs[j1][i][jj] /= 100;
	    Pcfl[j1][jj] += Pcs[j1][i][jj];
	  }  
	  if (j1==0) Pcfld[j1][jj] = Pcfl[j1][jj];
	  if (j1>0) Pcfld[j1][jj] = Pcfld[j1-1][jj] + Pcfl[j1][jj]; 
	  }
	/* Threshold values for classes of fleshiness */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqm[j1][jj] = probit(Pcfld[j1][jj]); 
	  } 
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfl[j1][jj]; 
	  } 
	tvm = Pcflmcca[jj] = Pcflmc[jj];
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflql[j1][jj] = Pcflqm[j1][jj] - 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldl[j1][jj] = normdis(Pcflql[j1][jj]); 
	  } 
	Pcfldl[p1-1][jj] = 1;
	Pcfll[0][jj] = Pcfldl[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfll[j1+1][jj] = Pcfldl[j1+1][jj] - Pcfldl[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pcs[j1][i][jj] = 0;      
	      else Pcs[j1][i][jj] = Pcfll[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfll[j1][jj]; 
	  } 
	tvh = Pcflmc[jj];
	zr++;
	goto Start; 
	}
      if (zr == 118 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqr[j1][jj] = Pcflqm[j1][jj] + 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldr[j1][jj] = normdis(Pcflqr[j1][jj]); 
	  } 
	Pcfldr[p1-1][jj] = 1;
	Pcflr[0][jj] = Pcfldr[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflr[j1+1][jj] = Pcfldr[j1+1][jj] - Pcfldr[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pcs[j1][i][jj] = 0;      
	      else Pcs[j1][i][jj] = Pcflr[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcflr[j1][jj]; 
	  } 
	tvl = Pcflmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 119 + 5*jj) {
	Tprofl = Tprof;
	ew0[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflql[j1][jj] = Pcflqm[j1][jj] - 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldl[j1][jj] = normdis(Pcflql[j1][jj]); 
	  } 
	Pcfldl[p1-1][jj] = 1;
	Pcfll[0][jj] = Pcfldl[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfll[j1+1][jj] = Pcfldl[j1+1][jj] - Pcfldl[j1][jj];
	  }  
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pcs[j1][i][jj] = 0;      
	      else Pcs[j1][i][jj] = Pcfll[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfll[j1][jj]; 
	  } 
	tvh = Pcflmc[jj];
	zr++;
	printf("  Run #%4d\n", zr);	
	goto Start; 
	}
      if (zr == 120 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqr[j1][jj] = Pcflqm[j1][jj] + 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldr[j1][jj] = normdis(Pcflqr[j1][jj]); 
	  } 
	Pcfldr[p1-1][jj] = 1;
	Pcflr[0][jj] = Pcfldr[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflr[j1+1][jj] = Pcfldr[j1+1][jj] - Pcfldr[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pcs[j1][i][jj] = 0;      
	      else Pcs[j1][i][jj] = Pcflr[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcflr[j1][jj]; 
	  } 
	tvl = Pcflmc[jj];
	zr++;
	goto Start;
      }

      if (zr == 121 + 5*jj) {
	Tprofl = Tprof;
	ew[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pcs[j1][i][jj] = Pc0[j1][i][jj];
	    }
	  } 
	zr++;
	goto Start;
        } 
      }
    if (zr < 127) zr = 127;                  
    }      

  /* Trait: fleshiness for cows */
  if (trait == 17 && zr == 127) 
    trait = 14;
  if (ewopt == 0 || ewopt == 2) {
    jj = 0;    
    if (trait == 14 && zr < 132) {   
      if (zr == 127 + 5*jj) {
	/* Saving the original values of matrix Pb */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pc0[j1][i][jj] = (double)Pc[j1][i][jj];
	    }
	  } 
	/* Frequencies of fleshiness classes summed over fat covering classes 
	   and cumulative frequencies */
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfl[j1][jj] = Pcfld[j1][jj] = 0; 
	  for (i = 0; i < p2; i++) {
	    Pc[j1][i][jj] /= 100;
	    Pcfl[j1][jj] += Pc[j1][i][jj];
	  }  
	  if (j1==0) Pcfld[j1][jj] = Pcfl[j1][jj];
	  if (j1>0) Pcfld[j1][jj] = Pcfld[j1-1][jj] + Pcfl[j1][jj]; 
	  }
	/* Threshold values for classes of fleshiness */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqm[j1][jj] = probit(Pcfld[j1][jj]); 
	  } 
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfl[j1][jj]; 
	  } 
	tvm = Pcflmcc[jj] = Pcflmc[jj];
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflql[j1][jj] = Pcflqm[j1][jj] - 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldl[j1][jj] = normdis(Pcflql[j1][jj]); 
	  } 
	Pcfldl[p1-1][jj] = 1;
	Pcfll[0][jj] = Pcfldl[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfll[j1+1][jj] = Pcfldl[j1+1][jj] - Pcfldl[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pc[j1][i][jj] = 0;      
	      else Pc[j1][i][jj] = Pcfll[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfll[j1][jj]; 
	  } 
	tvh = Pcflmc[jj];
	zr++;
	goto Start; 
	}
      if (zr == 128 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqr[j1][jj] = Pcflqm[j1][jj] + 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldr[j1][jj] = normdis(Pcflqr[j1][jj]); 
	  } 
	Pcfldr[p1-1][jj] = 1;
	Pcflr[0][jj] = Pcfldr[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflr[j1+1][jj] = Pcfldr[j1+1][jj] - Pcfldr[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pc[j1][i][jj] = 0;      
	      else Pc[j1][i][jj] = Pcflr[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcflr[j1][jj]; 
	  } 
	tvl = Pcflmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 129 + 5*jj) {
	Tprofl = Tprof;
	ew0[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	/* Shifting the distribution to the left */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflql[j1][jj] = Pcflqm[j1][jj] - 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldl[j1][jj] = normdis(Pcflql[j1][jj]); 
	  } 
	Pcfldl[p1-1][jj] = 1;
	Pcfll[0][jj] = Pcfldl[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcfll[j1+1][jj] = Pcfldl[j1+1][jj] - Pcfldl[j1][jj];
	  }  
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pc[j1][i][jj] = 0;      
	      else Pc[j1][i][jj] = Pcfll[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcfll[j1][jj]; 
	  } 
	tvh = Pcflmc[jj];
	zr++;
	printf("  Run #%4d\n", zr);	
	goto Start; 
	}
      if (zr == 130 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcflqr[j1][jj] = Pcflqm[j1][jj] + 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (j1 = 0; j1 < p1-1; j1++) {
	  Pcfldr[j1][jj] = normdis(Pcflqr[j1][jj]); 
	  } 
	Pcfldr[p1-1][jj] = 1;
	Pcflr[0][jj] = Pcfldr[0][jj];
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflr[j1+1][jj] = Pcfldr[j1+1][jj] - Pcfldr[j1][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfl[j1][jj] == 0) Pc[j1][i][jj] = 0;      
	      else Pc[j1][i][jj] = Pcflr[j1][jj]*Pc0[j1][i][jj]/Pcfl[j1][jj]; 
	    }
	  }  
	/* Mean class for fleshiness */
	Pcflmc[jj] = 0;
	for (j1 = 0; j1 < p1; j1++) {
	  Pcflmc[jj] += (j1+1)*Pcflr[j1][jj]; 
	  } 
	tvl = Pcflmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 131 + 5*jj) {
	Tprofl = Tprof;
	ew[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pc[j1][i][jj] = Pc0[j1][i][jj];
	    }
	  } 
	zr++;
	goto Start;
        } 
      }
    }      
    if (zr < 132) zr = 132;
    
  /* Trait: fleshiness summed over all categories */
  if (trait == 14 && zr == 132) { 
    trait = 18;
    for (i = 14; i <= 17; i++) {
      for (j = ja; j <= jb; j++) {
	ew[trait][j] += ew[i][j];     
	ew0[trait][j] += ew0[i][j];
        }      
      }
    }               

  /* Trait: fat covering for bulls */
  if (trait == 18 && zr == 132 && pbf[0] == 0 && pbf[1] == 0) {
    trait = 20;
    zr = 142;
    }
  if (trait == 18 && zr == 132 && ewopt == 1 && pbf[1] == 0) {
    trait = 20;
    zr = 142;
    }
  if (trait == 18 && zr == 132 && ewopt == 0 && pbf[0] == 0) {
    trait = 20;
    zr = 142;
    }
  if (trait == 18 && zr == 132 && pbf[0] + pbf[1] > 0) trait = 20;
  if (trait == 20 && zr < 142) {
    i2 = ja;
    i3 = jb;
    if (pbf[0] == 1 && pbf[1] == 0 && ewopt == 2) i3 = 0;
    if (pbf[0] == 0 && pbf[1] == 1 && ewopt == 2) i2 = 1;
    if (i2 == 1 && zr == 132) zr += 5;    
    for (jj = i2; jj <= i3; jj++) {  
      if (zr == 132 + 5*jj) {
	/* Saving the original values of matrix Pb */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pc0[j1][i][jj] = (double)Pb[j1][i][jj];
	    }
	  } 
	/* Frequencies of fat covering classes summed over fat covering classes 
	   and cumulative frequencies */
	for (i = 0; i < p2; i++) {
	  Pcfc[i][jj] = Pcfcd[i][jj] = 0; 
	  for (j1 = 0; j1 < p1; j1++) {
	    Pb[j1][i][jj] /= 100;
	    Pcfc[i][jj] += Pb[j1][i][jj];
	  }  
	  if (i==0) Pcfcd[i][jj] = Pcfc[i][jj];
	  if (i>0) Pcfcd[i][jj] = Pcfcd[i-1][jj] + Pcfc[i][jj]; 
	  }
	/* Threshold values for classes of fat covering */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqm[i][jj] = probit(Pcfcd[i][jj]); 
	  } 
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfc[i][jj]; 
	  } 
	tvm = Pcfcmcb[jj] = Pcfcmc[jj];
	/* Shifting the distribution to the left */
	for (i = 0; i < p2-1; i++) {
	  Pcfcql[i][jj] = Pcfcqm[i][jj] - 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdl[i][jj] = normdis(Pcfcql[i][jj]); 
	  } 
	Pcfcdl[p2-1][jj] = 1;
	Pcfcl[0][jj] = Pcfcdl[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcl[i+1][jj] = Pcfcdl[i+1][jj] - Pcfcdl[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pb[j1][i][jj] = 0;      
	      else Pb[j1][i][jj] = Pcfcl[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcl[i][jj]; 
	  } 
	tvh = Pcfcmc[jj];
	zr++;
	goto Start; 
	}
      if (zr == 133 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqr[i][jj] = Pcfcqm[i][jj] + 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdr[i][jj] = normdis(Pcfcqr[i][jj]); 
	  } 
	Pcfcdr[p2-1][jj] = 1;
	Pcfcr[0][jj] = Pcfcdr[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcr[i+1][jj] = Pcfcdr[i+1][jj] - Pcfcdr[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pb[j1][i][jj] = 0;      
	      else Pb[j1][i][jj] = Pcfcr[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcr[i][jj]; 
	  } 
	tvl = Pcfcmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 134 + 5*jj) {
	Tprofl = Tprof;
	ew0[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	/* Shifting the distribution to the left */
	for (i = 0; i < p2-1; i++) {
	  Pcfcql[i][jj] = Pcfcqm[i][jj] - 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdl[i][jj] = normdis(Pcfcql[i][jj]); 
	  } 
	Pcfcdl[p2-1][jj] = 1;
	Pcfcl[0][jj] = Pcfcdl[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcl[i+1][jj] = Pcfcdl[i+1][jj] - Pcfcdl[i][jj];
	  }  
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pb[j1][i][jj] = 0;      
	      else Pb[j1][i][jj] = Pcfcl[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcl[i][jj]; 
	  } 
	tvh = Pcfcmc[jj];
	zr++;
	printf("  Run #%4d\n", zr);	
	goto Start; 
	}
      if (zr == 135 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqr[i][jj] = Pcfcqm[i][jj] + 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdr[i][jj] = normdis(Pcfcqr[i][jj]); 
	  } 
	Pcfcdr[p2-1][jj] = 1;
	Pcfcr[0][jj] = Pcfcdr[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcr[i+1][jj] = Pcfcdr[i+1][jj] - Pcfcdr[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pb[j1][i][jj] = 0;      
	      else Pb[j1][i][jj] = Pcfcr[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcr[i][jj]; 
	  } 
	tvl = Pcfcmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 136 + 5*jj) {
	Tprofl = Tprof;
	ew[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pb[j1][i][jj] = Pc0[j1][i][jj];
	    }
	  } 
	zr++;
	goto Start;
        } 
      }
    if (zr < 142) zr = 142;                  
    }      

  /* Trait: fat covering for heifers */
  if (trait == 20 && zr == 142) trait = 21;
  if (trait == 21 && zr < 152) {
    if (ewopt == 1 && zr == 142) zr += 5; 
    i3 = jb;
    if (pff[1] == 0) i3 = 0;
    for (jj = ja; jj <= i3; jj++) {  
      if (zr == 142 + 5*jj) {
	/* Saving the original values of matrix Ph */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pc0[j1][i][jj] = (double)Ph[j1][i][jj];
	    }
	  } 
	/* Frequencies of fat covering classes summed over fat covering classes 
	   and cumulative frequencies */
	for (i = 0; i < p2; i++) {
	  Pcfc[i][jj] = Pcfcd[i][jj] = 0; 
	  for (j1 = 0; j1 < p1; j1++) {
	    Ph[j1][i][jj] /= 100;
	    Pcfc[i][jj] += Ph[j1][i][jj];
	  }  
	  if (i==0) Pcfcd[i][jj] = Pcfc[i][jj];
	  if (i>0) Pcfcd[i][jj] = Pcfcd[i-1][jj] + Pcfc[i][jj]; 
	  }
	/* Threshold values for classes of fat covering */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqm[i][jj] = probit(Pcfcd[i][jj]); 
	  } 
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfc[i][jj]; 
	  } 
	tvm = Pcfcmch[jj] = Pcfcmc[jj];
	/* Shifting the distribution to the left */
	for (i = 0; i < p2-1; i++) {
	  Pcfcql[i][jj] = Pcfcqm[i][jj] - 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdl[i][jj] = normdis(Pcfcql[i][jj]); 
	  } 
	Pcfcdl[p2-1][jj] = 1;
	Pcfcl[0][jj] = Pcfcdl[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcl[i+1][jj] = Pcfcdl[i+1][jj] - Pcfcdl[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Ph[j1][i][jj] = 0;      
	      else Ph[j1][i][jj] = Pcfcl[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcl[i][jj]; 
	  } 
	tvh = Pcfcmc[jj];
	zr++;
	goto Start; 
	}
      if (zr == 143 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqr[i][jj] = Pcfcqm[i][jj] + 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdr[i][jj] = normdis(Pcfcqr[i][jj]); 
	  } 
	Pcfcdr[p2-1][jj] = 1;
	Pcfcr[0][jj] = Pcfcdr[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcr[i+1][jj] = Pcfcdr[i+1][jj] - Pcfcdr[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Ph[j1][i][jj] = 0;      
	      else Ph[j1][i][jj] = Pcfcr[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcr[i][jj]; 
	  } 
	tvl = Pcfcmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 144 + 5*jj) {
	Tprofl = Tprof;
	ew0[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	/* Shifting the distribution to the left */
	for (i = 0; i < p2-1; i++) {
	  Pcfcql[i][jj] = Pcfcqm[i][jj] - 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdl[i][jj] = normdis(Pcfcql[i][jj]); 
	  } 
	Pcfcdl[p2-1][jj] = 1;
	Pcfcl[0][jj] = Pcfcdl[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcl[i+1][jj] = Pcfcdl[i+1][jj] - Pcfcdl[i][jj];
	  }  
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Ph[j1][i][jj] = 0;      
	      else Ph[j1][i][jj] = Pcfcl[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcl[i][jj]; 
	  } 
	tvh = Pcfcmc[jj];
	zr++;
	printf("  Run #%4d\n", zr);	
	goto Start; 
	}
      if (zr == 145 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqr[i][jj] = Pcfcqm[i][jj] + 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdr[i][jj] = normdis(Pcfcqr[i][jj]); 
	  } 
	Pcfcdr[p2-1][jj] = 1;
	Pcfcr[0][jj] = Pcfcdr[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcr[i+1][jj] = Pcfcdr[i+1][jj] - Pcfcdr[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Ph[j1][i][jj] = 0;      
	      else Ph[j1][i][jj] = Pcfcr[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcr[i][jj]; 
	  } 
	tvl = Pcfcmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 146 + 5*jj) {
	Tprofl = Tprof;
	ew[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Ph[j1][i][jj] = Pc0[j1][i][jj];
	    }
	  } 
	zr++;
	goto Start;
        } 
      }
    if (zr < 152) zr = 152;                  
    }      
  /* Trait: fat covering for castrates */
  if (trait == 21 && zr == 152 && cast[0] == 0 && cast[1] == 0) {
    trait = 22;
    zr = 162;
    }
  if (trait == 21 && zr == 152 && ewopt == 1 && cast[1] == 0) {
    trait = 22;
    zr = 162;
    }
  if (trait == 21 && zr == 152 && ewopt == 0 && cast[0] == 0) {
    trait = 22;
    zr = 162;
    }
  if (trait == 21 && zr == 152 && cast[0] + cast[1] > 0) trait = 22;
  if (trait == 22 && zr < 162) {
    i2 = ja;
    i3 = jb;
    if (cast[0] == 1 && cast[1] == 0 && ewopt == 2) i3 = 0;
    if (cast[0] == 0 && cast[1] == 1 && ewopt == 2) i2 = 1;
    if (i2 == 1 && zr == 152) zr += 5;    
    for (jj = i2; jj <= i3; jj++) {  
      if (zr == 152 + 5*jj) {
	/* Saving the original values of matrix Pcs */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pc0[j1][i][jj] = (double)Pcs[j1][i][jj];
	    }
	  } 
	/* Frequencies of fat covering classes summed over fat covering classes 
	   and cumulative frequencies */
	for (i = 0; i < p2; i++) {
	  Pcfc[i][jj] = Pcfcd[i][jj] = 0; 
	  for (j1 = 0; j1 < p1; j1++) {
	    Pcs[j1][i][jj] /= 100;
	    Pcfc[i][jj] += Pcs[j1][i][jj];
	  }  
	  if (i==0) Pcfcd[i][jj] = Pcfc[i][jj];
	  if (i>0) Pcfcd[i][jj] = Pcfcd[i-1][jj] + Pcfc[i][jj]; 
	  }
	/* Threshold values for classes of fat covering */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqm[i][jj] = probit(Pcfcd[i][jj]); 
	  } 
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfc[i][jj]; 
	  } 
	tvm = Pcfcmcca[jj] = Pcfcmc[jj];
	/* Shifting the distribution to the left */
	for (i = 0; i < p2-1; i++) {
	  Pcfcql[i][jj] = Pcfcqm[i][jj] - 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdl[i][jj] = normdis(Pcfcql[i][jj]); 
	  } 
	Pcfcdl[p2-1][jj] = 1;
	Pcfcl[0][jj] = Pcfcdl[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcl[i+1][jj] = Pcfcdl[i+1][jj] - Pcfcdl[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pcs[j1][i][jj] = 0;      
	      else Pcs[j1][i][jj] = Pcfcl[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcl[i][jj]; 
	  } 
	tvh = Pcfcmc[jj];
	zr++;
	goto Start; 
	}
      if (zr == 153 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqr[i][jj] = Pcfcqm[i][jj] + 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdr[i][jj] = normdis(Pcfcqr[i][jj]); 
	  } 
	Pcfcdr[p2-1][jj] = 1;
	Pcfcr[0][jj] = Pcfcdr[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcr[i+1][jj] = Pcfcdr[i+1][jj] - Pcfcdr[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pcs[j1][i][jj] = 0;      
	      else Pcs[j1][i][jj] = Pcfcr[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcr[i][jj]; 
	  } 
	tvl = Pcfcmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 154 + 5*jj) {
	Tprofl = Tprof;
	ew0[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	/* Shifting the distribution to the left */
	for (i = 0; i < p2-1; i++) {
	  Pcfcql[i][jj] = Pcfcqm[i][jj] - 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdl[i][jj] = normdis(Pcfcql[i][jj]); 
	  } 
	Pcfcdl[p2-1][jj] = 1;
	Pcfcl[0][jj] = Pcfcdl[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcl[i+1][jj] = Pcfcdl[i+1][jj] - Pcfcdl[i][jj];
	  }  
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pcs[j1][i][jj] = 0;      
	      else Pcs[j1][i][jj] = Pcfcl[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcl[i][jj]; 
	  } 
	tvh = Pcfcmc[jj];
	zr++;
	printf("  Run #%4d\n", zr);	
	goto Start; 
	}
      if (zr == 155 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqr[i][jj] = Pcfcqm[i][jj] + 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdr[i][jj] = normdis(Pcfcqr[i][jj]); 
	  } 
	Pcfcdr[p2-1][jj] = 1;
	Pcfcr[0][jj] = Pcfcdr[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcr[i+1][jj] = Pcfcdr[i+1][jj] - Pcfcdr[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pcs[j1][i][jj] = 0;      
	      else Pcs[j1][i][jj] = Pcfcr[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcr[i][jj]; 
	  } 
	tvl = Pcfcmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 156 + 5*jj) {
	Tprofl = Tprof;
	ew[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pcs[j1][i][jj] = Pc0[j1][i][jj];
	    }
	  } 
	zr++;
	goto Start;
        } 
      }
    if (zr < 162) zr = 162;                  
    }      

  /* Trait: fat covering for cows */
  if (trait == 22 && zr == 162) 
    trait = 19;
  if (ewopt == 0 || ewopt == 2) {
    jj = 0;    
    if (trait == 19 && zr < 167) {
      if (zr == 162 + 5*jj) {
	/* Saving the original values of matrix Pc */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pc0[j1][i][jj] = (double)Pc[j1][i][jj];
	    }
	  } 
	/* Frequencies of fat covering classes summed over fat covering classes 
	   and cumulative frequencies */
	for (i = 0; i < p2; i++) {
	  Pcfc[i][jj] = Pcfcd[i][jj] = 0; 
	  for (j1 = 0; j1 < p1; j1++) {
	    Pc[j1][i][jj] /= 100;
	    Pcfc[i][jj] += Pc[j1][i][jj];
	  }  
	  if (i==0) Pcfcd[i][jj] = Pcfc[i][jj];
	  if (i>0) Pcfcd[i][jj] = Pcfcd[i-1][jj] + Pcfc[i][jj]; 
	  }
	/* Threshold values for classes of fat covering */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqm[i][jj] = probit(Pcfcd[i][jj]); 
	  } 
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfc[i][jj]; 
	  } 
	tvm = Pcfcmcc[jj] = Pcfcmc[jj];
	/* Shifting the distribution to the left */
	for (i = 0; i < p2-1; i++) {
	  Pcfcql[i][jj] = Pcfcqm[i][jj] - 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdl[i][jj] = normdis(Pcfcql[i][jj]); 
	  } 
	Pcfcdl[p2-1][jj] = 1;
	Pcfcl[0][jj] = Pcfcdl[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcl[i+1][jj] = Pcfcdl[i+1][jj] - Pcfcdl[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pc[j1][i][jj] = 0;      
	      else Pc[j1][i][jj] = Pcfcl[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcl[i][jj]; 
	  } 
	tvh = Pcfcmc[jj];
	zr++;
	goto Start; 
	}
      if (zr == 163 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqr[i][jj] = Pcfcqm[i][jj] + 0.1; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdr[i][jj] = normdis(Pcfcqr[i][jj]); 
	  } 
	Pcfcdr[p2-1][jj] = 1;
	Pcfcr[0][jj] = Pcfcdr[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcr[i+1][jj] = Pcfcdr[i+1][jj] - Pcfcdr[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pc[j1][i][jj] = 0;      
	      else Pc[j1][i][jj] = Pcfcr[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcr[i][jj]; 
	  } 
	tvl = Pcfcmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 164 + 5*jj) {
	Tprofl = Tprof;
	ew0[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	/* Shifting the distribution to the left */
	for (i = 0; i < p2-1; i++) {
	  Pcfcql[i][jj] = Pcfcqm[i][jj] - 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdl[i][jj] = normdis(Pcfcql[i][jj]); 
	  } 
	Pcfcdl[p2-1][jj] = 1;
	Pcfcl[0][jj] = Pcfcdl[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcl[i+1][jj] = Pcfcdl[i+1][jj] - Pcfcdl[i][jj];
	  }  
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pc[j1][i][jj] = 0;      
	      else Pc[j1][i][jj] = Pcfcl[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcl[i][jj]; 
	  } 
	tvh = Pcfcmc[jj];
	zr++;
	printf("  Run #%4d\n", zr);	
	goto Start; 
	}
      if (zr == 165 + 5*jj) {
	Tprofh = Tprof;
	/* Shifting the distribution to the right */
	for (i = 0; i < p2-1; i++) {
	  Pcfcqr[i][jj] = Pcfcqm[i][jj] + 0.05; 
	  } 
	/* Values of the cumulative normal distribution for the shifted 
	   distribution */
	for (i = 0; i < p2-1; i++) {
	  Pcfcdr[i][jj] = normdis(Pcfcqr[i][jj]); 
	  } 
	Pcfcdr[p2-1][jj] = 1;
	Pcfcr[0][jj] = Pcfcdr[0][jj];
	for (i = 0; i < p2; i++) {
	  Pcfcr[i+1][jj] = Pcfcdr[i+1][jj] - Pcfcdr[i][jj];
	  } 
	/* New matrix Pc for shifted distribution */
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    if (Pcfc[i][jj] == 0) Pc[j1][i][jj] = 0;      
	      else Pc[j1][i][jj] = Pcfcr[i][jj]*Pc0[j1][i][jj]/Pcfc[i][jj]; 
	    }
	  }  
	/* Mean class for fat covering */
	Pcfcmc[jj] = 0;
	for (i = 0; i < p2; i++) {
	  Pcfcmc[jj] += (i+1)*Pcfcr[i][jj]; 
	  } 
	tvl = Pcfcmc[jj];
	zr++;
	goto Start;
      }
      if (zr == 166 + 5*jj) {
	Tprofl = Tprof;
	ew[trait][jj] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	for (j1 = 0; j1 < p1; j1++) {
	  for (i = 0; i < p2; i++) {
	    Pc[j1][i][jj] = Pc0[j1][i][jj];
	    }
	  } 
	zr++;
	goto Start;
        } 
      }
    }      
    if (zr < 167) zr = 167;                  

  /* Trait: fat covering summed over all categories */
  if (trait == 19 && zr == 167) { 
    trait = 23;
    for (i = 19; i <= 22; i++) {
      for (j = ja; j <= jb; j++) {
	ew[trait][j] += ew[i][j];     
	ew0[trait][j] += ew0[i][j];
        }      
      }
    }             
    
  /* Trait: losses of calves at calving */
  if (trait == 23) trait = 2;
  if (trait == 2 && zr < 177) {
    if (ewopt == 1 && zr == 167) zr += 5;  
    for (j = ja; j <= jb; j++) {  
      if (zr == 167 + 5*j) {
        tvm = calfloss[j];
        calfloss[j] = tvh = 1.01*tvm;
	zr++;
	goto Start;
	}
      if (zr == 168 + 5*j) {
	Tprofh = Tprof;
	calfloss[j] = tvl = 0.99*tvm;
	zr++;
	goto Start;
	}
      if (zr == 169 + 5*j) {
	Tprofl = Tprof;
	ew0[trait][j] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	tvh = 1.005*tvm;
	tvl = 0.995*tvm;
	calfloss[j] = tvh;
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
	}
      if (zr == 170 + 5*j) {
	Tprofh = Tprof;
	calfloss[j] = tvl;
	zr++;
	goto Start;
	}
      if (zr == 171 + 5*j) {
	Tprofl = Tprof;
	ew[trait][j] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
	calfloss[j]  = tvm;
	zr++;
	goto Start;
	} 
      }
    if (zr < 177) zr = 177;
    }

  /* Trait: Milk production */
  if (trait == 2) {
    trait = 31;
    tvm = milk;
    }
  if (ewopt == 0 || ewopt == 2) {
    if (trait == 31 && zr == 177) {
      milk = tvh = 1.01*tvm;
      zr++;
      goto Start;
      }
    if (trait == 31 && zr == 178) {
      Tprofh = Tprof;
      if (milkquota > 1) milktoth = milktot;
      avh = milk305ave;
      milk = tvl = 0.99*tvm;
      zr++;
      goto Start;
      }
    if (trait == 31 && zr == 179) {
      Tprofl = Tprof;
      avl = milk305ave;
      if (milkquota > 1) {
	milktotl = milktot;
	deltamilk = (milktoth - milktotl)/(tvh - tvl);
	deltacow = deltamilk/milktotm; 
	}
      ew0[trait][0] = (Tprofh - Tprofl)/(avh - avl);
      if (milkquota > 1) ew0[trait][0] = ew0[trait][0]-deltacow*Tprofm;
      tvh = 1.005*tvm;
      tvl = 0.995*tvm;
      milk = tvh;
      zr++;
      printf("  Run #%4d\n", zr);      
      goto Start;
      }
    if (trait == 31 && zr == 180) {
      Tprofh = Tprof;
      if (milkquota > 1) milktoth = milktot;      
      avh = milk305ave;
      milk = tvl;
      zr++;
      goto Start;
      }
    if (trait == 31 && zr == 181) {
      Tprofl = Tprof;
      avl = milk305ave;
      if (milkquota > 1) {
	milktotl = milktot;
	deltamilk = (milktoth - milktotl)/(tvh - tvl);
	deltacow = deltamilk/milktotm; 
	}
      ew[trait][0] = (Tprofh - Tprofl)/(avh - avl);
      if (milkquota > 1) ew[trait][0] = ew[trait][0]-deltacow*Tprofm;
      milk = tvm;
      zr++;
      goto Start;
      } 
    }
  if (zr < 182) zr = 182;

  /* Trait: fat content */
  if (trait == 31) {
    trait = 32;
    tvm = fat;
    }
  if (ewopt == 0 || ewopt == 2) {
    if (trait == 32 && zr == 182) {
      fat = tvh = 1.01*tvm;
      zr++;
      goto Start;
      }
    if (trait == 32 && zr == 183) {
      Tprofh = Tprof;
      if (milkquota == 3) milktoth = 1.01*milktotm;      
      avh = fat305ave;
      fat = tvl = 0.99*tvm;
      zr++;
      goto Start;
      }
    if (trait == 32 && zr == 184) {
      Tprofl = Tprof;
      avl = fat305ave;
      if (milkquota == 3) {
	milktotl = 0.99*milktot;
	deltamilk = (milktoth - milktotl)/(tvh - tvl);
	deltacow = deltamilk/milktotm; 
	}
      ew0[trait][0] = (Tprofh - Tprofl)/(tvh - tvl);
      if (milkquota == 3) ew0[trait][0] = ew0[trait][0]-deltacow*Tprofm;
      ew0[33][0] = (Tprofh - Tprofl)/(avh - avl);
      if (milkquota == 3) {
	deltamilk = (milktoth - milktotl)/(avh - avl);
	deltacow = deltamilk/milktotm;
	ew0[33][0] = ew0[33][0]-deltacow*Tprofm; 
	}      
      tvh = 1.005*tvm;
      tvl = 0.995*tvm;
      fat = tvh;
      zr++;
      printf("  Run #%4d\n", zr);      
      goto Start;
      }
    if (trait == 32 && zr == 185) {
      Tprofh = Tprof;
      if (milkquota == 3) milktoth = 1.005*milktotm;            
      avh = fat305ave;
      fat = tvl;
      zr++;
      goto Start;
      }
    if (trait == 32 && zr == 186) {
      Tprofl = Tprof;
      avl = fat305ave;
      if (milkquota == 3) {
	milktotl = 0.995*milktot;
	deltamilk = (milktoth - milktotl)/(tvh - tvl);
	deltacow = deltamilk/milktotm; 
	}
      ew[trait][0] = (Tprofh - Tprofl)/(tvh - tvl);
      if (milkquota == 3) ew[trait][0] = ew[trait][0]-deltacow*Tprofm;
      ew[33][0] = (Tprofh - Tprofl)/(avh - avl); 
      if (milkquota == 3) {
	deltamilk = (milktoth - milktotl)/(avh - avl);
	deltacow = deltamilk/milktotm; 
	ew[33][0] = ew[33][0]-deltacow*Tprofm;
	}      
      fat = tvm;
      zr++;
      goto Start;
      } 
    }
  if (zr < 187) zr = 187;

  /* Trait: protein content */
  if (trait == 32) {
    trait = 34;
    tvm = prot;
    }
  if (ewopt == 0 || ewopt == 2) {
    if (trait == 34 && zr == 187) {
      prot = tvh = 1.01*tvm;
      zr++;
      goto Start;
      }
    if (trait == 34 && zr == 188) {
      Tprofh = Tprof;
      avh = prot305ave;
      prot = tvl = 0.99*tvm;
      zr++;
      goto Start;
      }
    if (trait == 34 && zr == 189) {
      Tprofl = Tprof;
      avl = prot305ave;
      ew0[trait][0] = (Tprofh - Tprofl)/(tvh - tvl);
      ew0[35][0] = (Tprofh - Tprofl)/(avh - avl);
      tvh = 1.005*tvm;
      tvl = 0.995*tvm;
      prot = tvh;
      zr++;
      printf("  Run #%4d\n", zr);      
      goto Start;
      }
    if (trait == 34 && zr == 190) {
      Tprofh = Tprof;
      avh = prot305ave;
      prot = tvl;
      zr++;
      goto Start;
      }
    if (trait == 34 && zr == 191) {
      Tprofl = Tprof;
      avl = prot305ave;
      ew[trait][0] = (Tprofh - Tprofl)/(tvh - tvl);
      ew[35][0] = (Tprofh - Tprofl)/(avh - avl);
      prot = tvm;
      zr++;
      goto Start;
      } 
    }
  if (zr < 192) zr = 192;

  /* Trait: somatic cell score */
  if (trait == 34 && zr == 192) {
    trait = 36;
    tvm = mSCS;
    }
  if (nSCC == 1 && zr < 197) {
    zr = 197;  
    }
  if (ewopt == 0 || ewopt == 2) {
    if (trait == 36 && zr == 192) {
      mSCS = tvh = 1.01*tvm;
      zr++;
      goto Start;
      }
    if (trait == 36 && zr == 193) {
      Tprofh = Tprof;
      mSCS = tvl = 0.99*tvm;
      zr++;
      goto Start;
      }
    if (trait == 36 && zr == 194) {
      Tprofl = Tprof;
      ew0[trait][0] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      tvh = 1.005*tvm;
      tvl = 0.995*tvm;
      mSCS = tvh;
      zr++;
      printf("  Run #%4d\n", zr);      
      goto Start;
      }
    if (trait == 36 && zr == 195) {
      Tprofh = Tprof;
      mSCS = tvl;
      zr++;
      goto Start;
      }
    if (trait == 36 && zr == 196) {
      Tprofl = Tprof;
      ew[trait][0] = 0.01*(Tprofh - Tprofl)/(tvh - tvl);
      mSCS = tvm;
      zr++;
      goto Start;
      } 
    }
  if (zr < 197) zr = 197;      

   /* Trait: mastitis incidence */
  if (trait == 36 && zr == 197) {
    trait = 37;
    tvm = ymi;
    for (i = 0; i < LL; i++) zzircmy[i] = ircmy[i];
    for (i = 0; i < DL; i++) {
      for (j = 0; j <= 2; j++) zzdmi[j][i] = dmi[j][i];
      }
    }   
  if (ewopt == 0 || ewopt == 2) {      
    if (trait == 37 && zr == 197) {
      for (i = 0; i < LL; i++) ircmy[i] = 1.01 * zzircmy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) dmi[j][i] = 1.01 * zzdmi[j][i];
	}
      zr++;
      goto Start;
      }
    if (trait == 37 && zr == 198) {
      Tprofh = losstotal;
      tvh = ymi;
      for (i = 0; i < LL; i++) ircmy[i] = 0.99 * zzircmy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) dmi[j][i] = 0.99 * zzdmi[j][i];
	}
      zr++;
      goto Start;
      }
    if (trait == 37 && zr == 199) {
      Tprofl = losstotal;
      tvl = ymi;
      ew0[trait][0] = -(Tprofh - Tprofl)/(tvh - tvl);
      for (i = 0; i < LL; i++) ircmy[i] = 1.005 * zzircmy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) dmi[j][i] = 1.005 * zzdmi[j][i];
	}
      zr++;
      printf("  Run #%4d\n", zr);      
      goto Start;
      }
    if (trait == 37 && zr == 200) {
      Tprofh = losstotal;
      tvh = ymi;
      for (i = 0; i < LL; i++) ircmy[i] = 0.995 * zzircmy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) dmi[j][i] = 0.995 * zzdmi[j][i];
	}
      zr++;
      goto Start;
      }
    if (trait == 37 && zr == 201) {
      Tprofl = losstotal;
      tvl = ymi;
      ew[trait][0] = -(Tprofh - Tprofl)/(tvh - tvl);
      for (i = 0; i < LL; i++) ircmy[i] = zzircmy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) dmi[j][i] = zzdmi[j][i];
	}
      zr++;
      goto Start;
      }
    }  
  if (zr < 202) zr = 202;
  /* Trait: rennet coagulation time */
  if (zr == 202 && ind_RCT == 1) {
    trait = 38;
    tvm = RCT;
    }
  if (ewopt == 0 || ewopt == 2) {
    if (trait == 38 && zr == 202) {
      RCT = tvh = 1.01*tvm;
      zr++;
      goto Start;
      }
    if (trait == 38 && zr == 203) {
      Tprofh = Tprof;
      RCT = tvl = 0.99*tvm;
      zr++;
      goto Start;
      }
    if (trait == 38 && zr == 204) {
      Tprofl = Tprof;
      ew0[trait][0] = (Tprofh - Tprofl)/(tvh - tvl);
      tvh = 1.005*tvm;
      tvl = 0.995*tvm;
      RCT = tvh;
      zr++;
      printf("  Run #%4d\n", zr);      
      goto Start;
      }
    if (trait == 38 && zr == 205) {
      Tprofh = Tprof;
      RCT = tvl;
      zr++;
      goto Start;
      }
    if (trait == 38 && zr == 206) {
      Tprofl = Tprof;
      ew[trait][0] = (Tprofh - Tprofl)/(tvh - tvl);
      RCT = tvm;
      zr++;
      goto Start;
      } 
    }
  if (zr < 207) zr = 207;
  /* Trait: curd firmness */
  if (zr == 207 && ind_a30 == 1) {
    trait = 39;
    tvm = a30;
    }
  if (ewopt == 0 || ewopt == 2) {
    if (trait == 39 && zr == 207) {
      a30 = tvh = 1.01*tvm;
      zr++;
      goto Start;
      }
    if (trait == 39 && zr == 208) {
      Tprofh = Tprof;
      a30 = tvl = 0.99*tvm;
      zr++;
      goto Start;
      }
    if (trait == 39 && zr == 209) {
      Tprofl = Tprof;
      ew0[trait][0] = (Tprofh - Tprofl)/(tvh - tvl);
      tvh = 1.005*tvm;
      tvl = 0.995*tvm;
      a30 = tvh;
      zr++;
      printf("  Run #%4d\n", zr);      
      goto Start;
      }
    if (trait == 39 && zr == 210) {
      Tprofh = Tprof;
      a30 = tvl;
      zr++;
      goto Start;
      }
    if (trait == 39 && zr == 211) {
      Tprofl = Tprof;
      ew[trait][0] = (Tprofh - Tprofl)/(tvh - tvl);
      a30 = tvm;
      zr++;
      goto Start;
      } 
    }
  if (zr < 212) zr = 212;
  
  /* Trait: Residual daily dry matter intake of calves */
  if (zr == 212 && rfi_calf == 1) trait = 42;
  if (zr == 212 && rfi_calf == 0) zr = 222;
  if (trait == 42 && zr < 222) {
    if (ewopt == 1 && zr == 212) zr += 5;
    for (j = ja; j <= jb; j++) {  
      if (zr == 212 + 5*j) {
        if (j == 0) {
	  tvm = rfifc1[0];
	  zzlosc[0] = rfimc1[0];
	  zzlosc[1] = rfifc2[0];
	  zzlosc[2] = rfimc2[0];
	  }
        if (j == 1) {
	  tvm = rfifc1[1];
	  zzlosc[3] = rfimc1[1];
	  zzlosc[4] = rfifc2[1];
	  zzlosc[5] = rfimc2[1];
	  }
	if (j == 0) {
	  rfifc1[0] = tvh = tvm + 0.1;
          rfimc1[0] = zzlosc[0] + 0.1;	   
	  rfifc2[0] = zzlosc[1] + 0.1;	   	   
	  rfimc2[0] = zzlosc[2] + 0.1;	   	   
	  }
	if (j == 1) {
	  rfifc1[1] = tvh = tvm + 0.1; 
          rfimc1[1] = zzlosc[3] + 0.1;	   
	  rfifc2[1] = zzlosc[4] + 0.1;	   	   
	  rfimc2[1] = zzlosc[5] + 0.1;	   	   
	  }
	zr++;
	goto Start;
	}
      if (zr == 213 + 5*j) {
	Tprofh = Tprof;
	if (j == 0) {
	  rfifc1[0] = tvl = tvm - 0.1;
          rfimc1[0] = zzlosc[0] - 0.1;	   
	  rfifc2[0] = zzlosc[1] - 0.1;	   	   
	  rfimc2[0] = zzlosc[2] - 0.1;	   	   
	  }
	if (j == 1) {
	  rfifc1[1] = tvl = tvm - 0.1;
          rfimc1[1] = zzlosc[3] - 0.1;	   
	  rfifc2[1] = zzlosc[4] - 0.1;	   	   
	  rfimc2[1] = zzlosc[5] - 0.1;	   	   
	  }
	zr++;
	goto Start;
	}
      if (zr == 214 + 5*j) {
	Tprofl = Tprof;
	ew0[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
	tvh = tvm + 0.05;
	tvl = tvm - 0.05;
	if (j == 0) {
	  rfifc1[0] = tvh;
          rfimc1[0] = zzlosc[0] + 0.05;	   
	  rfifc2[0] = zzlosc[1] + 0.05;	   	   
	  rfimc2[0] = zzlosc[2] + 0.05;	   	   
	  }
	if (j == 1) {
	  rfifc1[1] = tvh;
          rfimc1[1] = zzlosc[3] + 0.05;	   
	  rfifc2[1] = zzlosc[4] + 0.05;	   	   
	  rfimc2[1] = zzlosc[5] + 0.05;	   	   
	  }
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
	}
      if (zr == 215 + 5*j) {
	Tprofh = Tprof;
	if (j == 0) {
	  rfifc1[0] = tvl;
          rfimc1[0] = zzlosc[0] - 0.05;	   
	  rfifc2[0] = zzlosc[1] - 0.05;	   	   
	  rfimc2[0] = zzlosc[2] - 0.05;	   	   
	  }
	if (j == 1) {
	  rfifc1[1] = tvl;
          rfimc1[1] = zzlosc[3] - 0.05;	   
	  rfifc2[1] = zzlosc[4] - 0.05;	   	   
	  rfimc2[1] = zzlosc[5] - 0.05;	   	   
	  }
	zr++;
	goto Start;
	}
      if (zr == 216 + 5*j) {
	Tprofl = Tprof;
	ew[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
	if (j == 0) {
	  rfifc1[0] = tvm;
	  rfimc1[0] = zzlosc[0];
	  rfifc2[0] = zzlosc[1];
	  rfimc2[0] = zzlosc[2];
	  }
	if (j == 1) {
	  rfifc1[1] = tvm;
	  rfimc1[1] = zzlosc[3];
	  rfifc2[1] = zzlosc[4];
	  rfimc2[1] = zzlosc[5];
	  }
	zr++;
	goto Start;
	} 
      }
    }
  if (zr < 222) zr = 222;    
  /* Trait: Residual daily dry matter intake of heifers */
  if (zr == 222 && rfi_h == 1) trait = 43;
  if (zr == 222 && rfi_h == 0) zr = 232;  
  if (trait == 43 && zr < 232) {
    if (ewopt == 1 && zr == 222) zr += 5;
    if (jb == 1 && utifemcr == 3) i3 = 1;
      else i3 = 0;
    for (j = ja; j <= i3; j++) {  
      if (zr == 222 + 5*j) {
        if (j == 0) tvm = rfi[22];
        if (j == 1) tvm = rfi[CC+22];
	if (j == 0) rfi[22] = tvh = tvm + 0.1;
	if (j == 1) rfi[CC+22] = tvh = tvm + 0.1; 
	zr++;
	goto Start;
	}
      if (zr == 223 + 5*j) {
	Tprofh = Tprof;
	if (j == 0) rfi[22] = tvl = tvm - 0.1;
	if (j == 1) rfi[CC+22] = tvl = tvm - 0.1;
	zr++;
	goto Start;
	}
      if (zr == 224 + 5*j) {
	Tprofl = Tprof;
	ew0[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
	tvh = tvm + 0.05;
	tvl = tvm - 0.05;
	if (j == 0) rfi[22] = tvh;
	if (j == 1) rfi[CC+22] = tvh;
	zr++;
	printf("  Run #%4d\n", zr);
	goto Start;
	}
      if (zr == 225 + 5*j) {
	Tprofh = Tprof;
	if (j == 0) rfi[22] = tvl;
	if (j == 1) rfi[CC+22] = tvl;
	zr++;
	goto Start;
	}
      if (zr == 226 + 5*j) {
	Tprofl = Tprof;
	ew[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
	if (j == 0) rfi[22] = tvm;
	if (j == 1) rfi[CC+22] = tvm;
	zr++;
	goto Start;
	} 
      }
    }
  if (zr < 232) zr = 232;
  
  /* Trait: Residual daily dry matter intake in fattening */
  if (zr == 232 && rfi_fa == 1) trait = 44;
  if (trait == 44 && paf[0] == 0 && paf[1] == 0) zr = 242;
  if (trait == 44 && zr < 242) {
    if ((ewopt == 1 || paf[0] == 0) && zr == 232) zr += 5; 
    i2 = ja;
    i3 = jb;
    if (paf[0] == 0 && paf[1] == 1) i2 = 1;
    if (paf[1] == 0) i3 = 0;
    for (j = i2; j <= i3; j++) {  
      if (zr == 232 + 5*j) {
        if (pff[j] == 1) {
	  tvm = rfi[12+j*CC];
          rfi[12+j*CC] = tvh = tvm + 0.1;
	  if (pbf[j] == 1) {
	    zzlosc[0+j*2] = rfi[14+CC*j];
	    rfi[14+j*CC] = zzlosc[0+j*2] + 0.1;
	    }
	  if (pbf[j] == 0 && cast[j] == 1) {
	    zzlosc[1+j*2] = rfi[17+CC*j];
	    rfi[17+j*CC] = zzlosc[1+j*2] + 0.1;
	    }
	  }
        if (pff[j] == 0) {	
          if (pbf[j] == 1) {
	    tvm = rfi[14+j*CC];
            rfi[14+j*CC] = tvh = tvm + 0.1;
	    if (cast[j] == 1) {
	      zzlosc[1+j*2] = rfi[17+CC*j];
	      rfi[17+j*CC] = zzlosc[1+j*2] + 0.1;
	      }
            }
          if (pbf[j] == 0 && cast[j] == 1) {
	      tvm = rfi[17+j*CC];
              rfi[17+j*CC] = tvh = tvm + 0.1;
	    }	    
          }
	zr++;
	goto Start;
	}
      if (zr == 233 + 5*j) {
	Tprofh = Tprof;
        if (pff[j] == 1) {
          rfi[12+j*CC] = tvl = tvm - 0.1;
	  if (pbf[j] == 1) 
	    rfi[14+j*CC] = zzlosc[0+j*2] - 0.1;
	  if (pbf[j] == 0 && cast[j] == 1) 
	    rfi[17+j*CC] = zzlosc[1+j*2] - 0.1;
	  }
        if (pff[j] == 0) {	
          if (pbf[j] == 1) {
	    rfi[14+j*CC] = tvl = tvm - 0.1;
	    if (cast[j] == 1) 
	      rfi[17+j*CC] = zzlosc[1+j*2] - 0.1;
            }
          if (pbf[j] == 0 && cast[j] == 1) 
	    rfi[17+j*CC] = tvl = tvm - 0.1;
          }
        zr++;
	goto Start;
	}
      if (zr == 234 + 5*j) {
	Tprofl = Tprof;
	ew0[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
	tvh = tvm + 0.05;
	tvl = tvm - 0.05;
        if (pff[j] == 1) {
	  rfi[12+j*CC] = tvh;
	  if (pbf[j] == 1) 
	    rfi[14+j*CC] = zzlosc[0+j*2] + 0.05;
	  if (pbf[j] == 0 && cast[j] == 1) 
	    rfi[17+j*CC] = zzlosc[1+j*2] + 0.05;
	  }
        if (pff[j] == 0) {	
          if (pbf[j] == 1) {
	    rfi[14+j*CC] = tvh;
	    if (cast[j] == 1) 
	      rfi[17+j*CC] = zzlosc[1+j*2] + 0.05;
            }
          if (pbf[j] == 0 && cast[j] == 1) 
	    rfi[17+j*CC] = tvh;
          }
	zr++;
	goto Start;
	}
      if (zr == 235 + 5*j) {
	Tprofh = Tprof;
        if (pff[j] == 1) {
	  rfi[12+j*CC] = tvl;
	  if (pbf[j] == 1) 
	    rfi[14+j*CC] = zzlosc[0+j*2] - 0.05;
	  if (pbf[j] == 0 && cast[j] == 1) 
	    rfi[17+j*CC] = zzlosc[1+j*2] - 0.05;
	  }
        if (pff[j] == 0) {	
          if (pbf[j] == 1) {
	    rfi[14+j*CC] = tvl;
	    if (cast[j] == 1) 
	      rfi[17+j*CC] = zzlosc[1+j*2] - 0.05;
            }
          if (pbf[j] == 0 && cast[j] == 1) 
	    rfi[17+j*CC] = tvl;
          }
	printf("  Run #%4d\n", zr);
	zr++;
	goto Start;
	}
      if (zr == 236 + 5*j) {
	Tprofl = Tprof;
	ew[trait][j] = (Tprofh - Tprofl)/(tvh - tvl);
        if (pff[j] == 1) {
	  rfi[12+j*CC] = tvm;
	  if (pbf[j] == 1) 
	    rfi[14+j*CC] = zzlosc[0+j*2];
	  if (pbf[j] == 0 && cast[j] == 1) 
	    rfi[17+j*CC] = zzlosc[1+j*2];
	  }
        if (pff[j] == 0) {	
          if (pbf[j] == 1) {
	    rfi[14+j*CC] = tvm;
	    if (cast[j] == 1) 
	      rfi[17+j*CC] = zzlosc[1+j*2];
            }
          if (pbf[j] == 0 && cast[j] == 1) 
	    rfi[17+j*CC] = tvm;
          }
	zr++;
	goto Start;
	} 
      }
    }
  if (zr < 242) zr = 242;      
  
  /* Trait: residual daily dry matter intake of cows */
  if (zr == 242 && rfi_cow == 1) trait = 45;
  if (trait == 45 && zr < 247) {
    if (zr == 242) {
      tvm = rfi[30];
      rfi[30] = tvh = tvm + 0.1;
      zr++;
      goto Start;
      }
    if (zr == 243) {
      Tprofh = Tprof;
      rfi[30] = tvl = tvm - 0.1;
      zr++;
      goto Start;
      }
    if (zr == 244) {
      Tprofl = Tprof;
      ew0[trait][0] = (Tprofh - Tprofl)/(tvh - tvl);
      tvh = tvm + 0.05;
      tvl = tvm - 0.05;
      rfi[30] = tvh;
      zr++;
      printf("  Run #%4d\n", zr);
      goto Start;
      }
    if (zr == 245) {
      Tprofh = Tprof;
      rfi[30] = tvl;
      zr++;
      goto Start;
      }
    if (zr == 246) {
      Tprofl = Tprof;
      ew[trait][0] = (Tprofh - Tprofl)/(tvh - tvl);
      rfi[30] = tvm;
      zr++;
      goto Start;
      } 
    }
    if (zr < 247) zr = 247;
    
   /* Trait: claw disease incidence */
  if (claw_inc == 0 || ewopt == 1) zr = 252; 
  if (zr == 247 && claw_inc == 1) { trait = 46; 
    for (i = 0; i < L; i++) zzircmy[i] = 0.0;
    for (i = 0; i < DL; i++) {
      for (j = 0; j <= 2; j++) zzdmi[j][i] =  0.0;
      }
    }  
  if (trait == 46 && zr < 252) {
    if (zr == 247) {
      tvm = ycdi;
      for (i = 0; i < LL; i++) zzircmy[i] = ircdy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) zzdmi[j][i] = dcdi[j][i];
	}   
      for (i = 0; i < LL; i++) ircdy[i] = 1.01 * zzircmy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) dcdi[j][i] = 1.01 * zzdmi[j][i];
	}
      zr++;
      goto Start;
      }
    if (zr == 248) {
      Tprofh = losstcd;
      tvh = ycdi;
      for (i = 0; i < LL; i++) ircdy[i] = 0.99 * zzircmy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) dcdi[j][i] = 0.99 * zzdmi[j][i];
	}
      zr++;
      goto Start;
      }
    if (zr == 249) {
      Tprofl = losstcd;
      tvl = ycdi;
      ew0[trait][0] = -(Tprofh - Tprofl)/(tvh - tvl);
      for (i = 0; i < LL; i++) ircdy[i] = 1.005 * zzircmy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) dcdi[j][i] = 1.005 * zzdmi[j][i];
	}
      zr++;
      printf("  Run #%4d\n", zr);      
      goto Start;
      }
    if (zr == 250) {
      Tprofh = losstcd;
      tvh = ycdi;
      for (i = 0; i < LL; i++) ircdy[i] = 0.995 * zzircmy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) dcdi[j][i] = 0.995 * zzdmi[j][i];
	}
      zr++;
      goto Start;
      }
    if (zr == 251) {
      Tprofl = losstcd;
      tvl = ycdi;
      ew[trait][0] = -(Tprofh - Tprofl)/(tvh - tvl);
      for (i = 0; i < LL; i++) ircdy[i] = zzircmy[i];
      for (i = 0; i < DL; i++) {
	for (j = 0; j <= 2; j++) dcdi[j][i] = zzdmi[j][i];
	}
      zr++;
      goto Start;
      }
    }  
  if (zr < 252) zr = 252;

  /* End of calculation of economic weights */ 

  /* Gene flow and relative economic weights */
  if (zr == 252) {
    printf("Calculating gene flow\n");
    acm = acsb + acdd + acsd + acdc + 3;  
    /* Completition of matrix PM */
    /* P11 */
    if (Ncal[1] > 0.000001) for (i = 2; i <=acsb; i++) PM[i][i-1] = 1;
    /* P61 */
    if (Ncal[1] > 0.000001)
      for (j = 1; j <=acsb; j++) 
        PM[acm-1][j] = PM[acsb+acdd+acsd+1][j];
    /* P41 */	
    if (Ncal[1] < 0.000001 || utifemcr != 3) 
      for (j = 1; j <=acsb; j++) PM[acsb+acdd+acsd+1][j] = 0;
    /* P22, P52 */  
    for (j = acsb +acdd + 1 - LL; j <= acsb +acdd; j++)
      PM[acsb+1][j] = PM[acm-2][j] 
        = (double)(l3[j+LL-acsb-acdd-1]*(cal[0][j+LL-acsb-acdd-1])/(2*Ncal[0]));
    for (i = acsb + 2; i <= acsb + acdd; i++) PM[i][i-1] = 1;       
    /* P62 */
    if (Ncal[1] > 0) 
      for (j = acsb +acdd + 1 - LL; j <= acsb +acdd; j++)  
        PM[acm-1][j] =
          (double)(l3[j+LL-acsb-acdd-1]*(cal[1][j+LL-acsb-acdd-1])/(2*Ncal[1]));
     /* Part of P33 */
     for (i = acsb + acdd + 2; i <=acsb + acdd + acsd; i++) PM[i][i-1] = 1;
     /* P42 */
    if (Ncal[1] > 0 && utifemcr == 3)  
      for (j = acsb +acdd + 1 - LL; j <= acsb +acdd; j++)
        PM[acsb+acdd+acsd+1][j] = 
 	  (double)(l3[j+LL-acsb-acdd-1]*(cal[1][j+LL-acsb-acdd-1])/(2*Ncal[1]));
    /* P53 */
    for (j = acsb + acdd + 1; j <= acsb + acdd + acsd; j++)
      PM[acm-2][j] = PM[acsb+1][j];
    /* P44 */
    if (Ncal[1] > 0 && utifemcr == 3)  
      for (i = acsb + acdd + acsd + 2; i <= acm - 3; i++) 
        PM[i][i-1] = 1; 
    /* Reading data from system 3 */
    if (Ncal[1] > 0.000001 && utifemcr == 3) {
      fr3 = fopen("FROM1_3.TXT", "r");
      readcom(fr3);
      fscanf(fr3, "%d", &prodsys2);
      fscanf(fr3, "%d", &L3);      
      fscanf(fr3, "%f", &tconh3);
      aa1 = 0;
      for (i = 0; i < L3; i++) {
	fscanf(fr3, "%lf", &PM[acm][acm-2-L3+i]);
	aa1 += PM[acm][acm-2-L3+i];
	}
      for (i = 0; i < L3; i++) PM[acm][acm-2-L3+i] *= 0.5/((double)aa1);
      for (i = 1; i < 30; i++) fscanf(fr3, "%f", &ew[i][2]);
      fscanf(fr3, "%f", &ew[43][2]);
      fscanf(fr3, "%f", &ew[44][2]);
      fscanf(fr3, "%f", &ew[47][2]);
      fscanf(fr3, "%f", &ew[45][2]);
      fclose(fr3);
      }
    for (i = 0; i < NT; i++) {
      for (j = 0; j < J; j++) ewc[i][j] = 0;
      }  
    for (i = 0; i < NT; i++) {
      for (j = ja; j <= jb; j++) ewc[i][j] = ew[i][j]/Ncal[j];
      }  
    aa2 = (float)PM[acm][acm-2-L3]*aa1*2;  
    pc = 0;
    if (l1[CC+24] > 0.000001 && l1[CC+23] < 0.000001) pc = l1[CC+24]/ aa2;
    if (l1[CC+23] > 0.000001 && l1[CC+24] < 0.000001) pc = (l1[CC+23] * tconh3)/ aa2; 
    for (j = 0; j <= acm; j++) {
      hd[j] = hm[j] = 0;
      for (i = 0; i < NT; i++) ewwd[i][j] = ewwm[i][j] = 0;
      }  
    for (i = 0; i < NT; i++) {
      ewwd[i][acm-2] = ewc[i][0];
      ewwd[i][acm-1] = ewc[i][1];
      ewwd[i][acm] = ew[i][2];
      for (j = acsb+1; j <= acsb+acdd; j++) ewwm[i][j] = ew[i][0]+ew[i][1];
      for (j = acm-acdc-2; j <= acm-3; j++) ewwm[i][j] = ew[i][2];
      }
    hd[acm-2] = Ncal[0];
    hd[acm-1] = Ncal[1];
    hd[acm] = pc;
    for (j = acsb+1; j <= acsb+acdd; j++) hm[j] = (float)PM[acsb+1][j]*2;
    for (j = acm-acdc-2; j <= acm-3; j++) hm[j] = (float)PM[acm][j]*2*pc;
    for (i = 0; i <= acm; i++) m_gf0[i] = m_gf[i] = m_sum[i] = 0;
    if (gene_flow == 1) m_gf0[acsb+acdd+n_sac] = 1;
    if (gene_flow == 2) m_gf0[acsb+n_sac] = 1;
    if (gene_flow == 3) m_gf0[n_sac] = 1;
    for (i1 = 1; i1 <= l_inv; i1++) {
      for (i = 1; i <= acm; i++) {
	for (j = 1; j <= acm; j++) 
          m_gf[i] += PM[i][j]*m_gf0[j];  
	}
      for (i = 1; i <= acm; i++) { 
	m_gf0[i] = m_gf[i]; 
	m_sum[i] += m_gf0[i]/pow(u+1,i1); 
	m_gf[i] = 0;  
	}
      }
    for (i = 1; i < NT; i++) {
    for (j = 1; j <= acm; j++) {
      if (delta_d[i] == 1) ew_d[i] += hd[j]*ewwd[i][j]*m_sum[j];
      if (delta_m[i] == 1) ew_m[i] += hm[j]*ewwm[i][j]*m_sum[j];      
      }  
    }
  }
  if (zr == 252) {
    for (i = 1; i < NT; i++) {
      for (j = 0; j <= cb; j++)
        if (fabs(ew[i][j]) > 0.000001) 
	  ewdiff[i][j] = 100*(ew0[i][j]-ew[i][j])/ew[i][j];
     }
  }

  /* Relative economic weights */
  if (gstd == 2) {
    ewsum_d = ewsum_m = 0;
    for (i = 1; i < NT; i++) {
      if (delta_d[i] == 1) {
	ewst_d[i] = ew_d[i] * gstd_d[i];
	ewsum_d += fabs(ewst_d[i]);  
	}  
      if (delta_m[i] == 1) {
	ewst_m[i] = ew_m[i] * gstd_m[i];  
	ewsum_m += fabs(ewst_m[i]);
	}  
      }  
    ewsum = ewsum_d + ewsum_m;
    for (i = 1; i < NT; i++) {
      if (delta_d[i] == 1) { 
	ewr_dd[i] = 100 * fabs(ewst_d[i]) / ewsum_d;
	ewr_da[i] = 100 * fabs(ewst_d[i]) / ewsum;
      }  
      if (delta_m[i] == 1 && ewsum_m > 0.000001) { 
	ewr_mm[i] = 100 * fabs(ewst_m[i]) / ewsum_m;
	ewr_ma[i] = 100 * fabs(ewst_m[i]) / ewsum;
      }  
    }  
  }

  /* Relative marginal economic values  */
  if (gstd == 3 && (cb == 0 || (cb == 1 && utifemcr != 3 && ewopt > 0))) {
    ewsum = 0;
    for (i = 1; i < NT; i++) {
      if (to[i] == 2) {
	if (cb == 0) ewst_d[i] = ew[i][0] * gstd_d[i];
	if (cb == 1 && ewopt == 2)  
	  ewst_d[i] = (ew[i][0] + 0.5*ew[i][1]) * gstd_d[i];
	if (cb == 1 && ewopt == 1)    
	  ewst_d[i] = ew[i][1] * gstd_d[i];  
	ewsum += fabs(ewst_d[i]);  
      }  
    }  
    for (i = 1; i < NT; i++) {
      if (to[i] == 2) 
	ewr_dd[i] = 100 * fabs(ewst_d[i]) / ewsum;
    }  
  }

  /* Writing results to results file */
  if (zr == 252) { printf("Writing results to output file\n");
  
    /* 3 Results, 3.1 Structure of the cow herd */
    for (i = 1; i <=2; i++) outputrw(fr2, fw);
    fprintf(fw, "\n %8d", CC);    
    for (i = 1; i <=3; i++) outputrw(fr2, fw);
    fprintf(fw, "\nNumber of iterations: %d", k);
    for (i = 1; i <=4; i++) outputrw(fr2, fw);

    /* 3.1.1 Printing vector l2 to output file */
    fprintf(fw, "\n  Category %d: %8.4f\n", 25, l2[1]);
    for (i = 2; i <= TT; i++) { 
      fprintf(fw, "  Category %d: %8.4f\n", i+24, l2[i]);
      }

    /* 3.1.2 */  
    for (i = 1; i <=2; i++) outputrw(fr2, fw);  
    aa1 = l3[0];  
    fprintf(fw, "\nReproductive cycle %2d: %8.4f\n", 1, l3[0]);             
    for (i = 1; i < LL; i++) { 
      fprintf(fw, "Reproductive cycle %2d: %8.4f\n", i+1, l3[i]);
      aa1 += l3[i];
      }
    fprintf(fw, "Sum: %8.4f\n", aa1);

    /* 3.2 Reproduction characteristics of the herd */
    for (i = 1; i <=3; i++) outputrw(fr2, fw);  
    fprintf(fw, "%8.3f", tconh);
    outputrw(fr2, fw);
    fprintf(fw, "\n  Reproductive cycle %2d: %8.3f\n", 1, cp[0]/cmat[0]);             
    for (i = 1; i < LL-2; i++)  
      fprintf(fw, "  Reproductive cycle %2d: %8.3f\n", i+1, cp[i]/cmat[i]);
    fprintf(fw, "  Reproductive cycle %2d: %8.3f", LL-1, cp[LL-2]/cmat[LL-2]);  
    outputrw(fr2, fw);    
    fprintf(fw, "%8.3f", intconh);
    outputrw(fr2, fw);
    fprintf(fw, "\n  Reproductive cycle %2d: %8.3f\n", 1, intconc[0]);             
    for (i = 1; i < LL-2; i++)  
      fprintf(fw, "  Reproductive cycle %2d: %8.3f\n", i+1, intconc[i]);    
    fprintf(fw, "  Reproductive cycle %2d: %8.3f", LL-1, intconc[LL-2]);      
    outputrw(fr2, fw);  
    fprintf(fw, "%8.2f", ciav);
    outputrw(fr2, fw);  
    fprintf(fw, "%8.2f", avelifecl);
    outputrw(fr2, fw);  
    fprintf(fw, "%8.2f", avelifecy);
    outputrw(fr2, fw);  
    fprintf(fw, "%8.4f", dysav[0]);
    if (cb ==1) {
      outputrw(fr2, fw);  
      fprintf(fw, "%8.4f", dysav[1]);
      outputrw(fr2, fw);  
      fprintf(fw, "%8.4f", dysavave);
      }
      else for (i = 1; i <= 2; i++) outputr(fr2);

    /* 3.3 Growth ... reproductive cycles 1 to 3 */
    for (i = 1; i <=4; i++) outputrw(fr2, fw);
    fprintf(fw, "\n  %7.1f %7.1f %7.1f", wcacal[0], wcacal[1], wcacal[2]);        
    outputrw(fr2, fw);
    fprintf(fw, "\n  %7.1f %7.1f %7.1f", wcc[0], wcc[1], wcc[2]);
    outputrw(fr2, fw);
    fprintf(fw, "\n  %7.1f %7.1f %7.1f", wcd[0], wcd[1], wcd[2]);
    outputrw(fr2, fw);
    fprintf(fw, "\n  %7.1f %7.1f %7.1f", wccw[0], wccw[1], wccw[2]);
    outputrw(fr2, fw);
    fprintf(fw, "\n  %7.1f %7.1f %7.1f\n", wcdys[0], wcdys[1], wcdys[2]);
    
    /* 3.4. Characteristics of progeny */
    /* 3.4.1. Structure of the progeny */
    for (i = 1; i <=6; i++) outputrw(fr2, fw);  
    if (cb == 1) {
      fprintf(fw, "\n  Category %2d: %8.4f %8.4f %8.4f\n", 1, 
	l1[1], l1[CC+1], l1[1]+l1[CC+1]);
      for (i = 2; i <= 24; i++) { 
	fprintf(fw, "  Category %2d: %8.4f %8.4f %8.4f\n", i, 
	l1[i], l1[CC+i], l1[i]+l1[CC+i]);
	}
      }
    if (cb == 0) {
      fprintf(fw, "\n  Category %2d: %8.4f \n", 1, l1[1]);
      for (i = 2; i <= 24; i++) { 
	fprintf(fw, "  Category %2d: %8.4f \n", i, l1[i]);
	}
      }
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.4f %8.4f %8.4f", 1-avecalc, avecalc, 1.0); 
      else fprintf(fw, "%8.4f", 1-avecalc); 
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", Nfcba[0], Nfcba[1], Nfcba[0]+Nfcba[1]); 
      else fprintf(fw, "%8.4f", Nfcba[0]); 
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", Nmcba[0], Nmcba[1], Nmcba[0]+Nmcba[1]); 
      else fprintf(fw, "%8.4f", Nmcba[0]); 
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", Nfc48a[0], Nfc48a[1], Nfc48a[0]+Nfc48a[1]); 
      else fprintf(fw, "%8.4f", Nfc48a[0]); 
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", Nmc48a[0], Nmc48a[1], Nmc48a[0]+Nmc48a[1]);    
      else fprintf(fw, "%8.4f", Nmc48a[0]);
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", losfw[0], losfw[1], losfw[0]+losfw[1]); 
      else fprintf(fw, "%8.4f", losfw[0]); 
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", losmw[0], losmw[1], losmw[0]+losmw[1]); 
      else fprintf(fw, "%8.4f", losmw[0]); 
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", Nfcw[0], Nfcw[1], Nfcw[0]+Nfcw[1]); 
      else fprintf(fw, "%8.4f", Nfcw[0]); 
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", Nmcf[0], Nmcf[1], Nmcf[0]+Nmcf[1]); 
      else fprintf(fw, "%8.4f", Nmcf[0]); 
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "\n  %8.4f %8.4f %8.4f", l1[9], l1[CC+9], l1[9]+l1[CC+9]); 
      else fprintf(fw, "\n  %8.4f", l1[9]); 
    outputrw(fr2, fw);    
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", l1[17], l1[CC+17], l1[17]+l1[CC+17]); 
      else fprintf(fw, "%8.4f", l1[17]); 
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", l1[14], l1[CC+14], l1[14]+l1[CC+14]); 
      else fprintf(fw, "%8.4f", l1[14]); 
    outputrw(fr2, fw);  
    if (cb == 1) 
      fprintf(fw, "\n  %8.4f %8.4f %8.4f", l1[8], l1[CC+8], l1[8]+l1[CC+8]); 
      else fprintf(fw, "\n  %8.4f", l1[8]); 
    outputrw(fr2, fw);
    if (cb == 1) 
      fprintf(fw, "%8.4f %8.4f %8.4f", l1[12], l1[CC+12], l1[12]+l1[CC+12]); 
      else fprintf(fw, "%8.4f", l1[12]); 
    outputrw(fr2, fw);             
    fprintf(fw, "%8.4f", Nfmat);
    outputrw(fr2, fw);  
    fprintf(fw, "%8.4f", Nfrer);
    outputrw(fr2, fw);  
    fprintf(fw, "%8.4f\n", Nfav);
    
    /* 3.4.2 Growth characteristics for calves */
    for (i = 1; i <=4; i++) outputrw(fr2, fw);        
    printcb(cb, agedcw[0], agedcw[1], fw); 
    outputrw(fr2, fw);  
    printcb(cb, wwf[0], wwf[1], fw);
    outputrw(fr2, fw);  
    printcb(cb, wwm[0], wwm[1], fw);
    outputrw(fr2, fw);  
    printcb(cb, wdcwf[0], wdcwf[1], fw);

    /* 3.4.3 Reproduction and growth of replacement heifers */
    for (i = 1; i <=4; i++) outputrw(fr2, fw);        
    fprintf(fw, "%8.1f", agehmat1[0]);     
    outputrw(fr2, fw);        
    fprintf(fw, "%8.1f", ageh1cal[0]);     
    outputrw(fr2, fw);        
    fprintf(fw, "%8.1f", wh1cal);     
    outputrw(fr2, fw);        
    fprintf(fw, "%8.1f", agedmh[0]);     
    outputrw(fr2, fw);        
    fprintf(fw, "%8.1f", whdmh);     
    outputrw(fr2, fw);        
    fprintf(fw, "%8.1f", agehcmat1[0]);     
    outputrw(fr2, fw);        
    fprintf(fw, "%8.1f", whcmat);
    if (utifemp == 4) {
      outputrw(fr2, fw);        
      fprintf(fw, "%8.1f", ww[24]);
      }
      else outputr(fr2);
    if (utifemp == 3) {      
      outputrw(fr2, fw);        
      fprintf(fw, "%8.1f", ww[23]);
      }
      else outputr(fr2);
    if (cb == 1 && utifemcr == 3) {
      outputrw(fr2, fw);        
      fprintf(fw, "%8.1f", ww[23+CC]);
      }
      else outputr(fr2);
         
    /* 3.4.4 Fattening of progeny */
    if (paf[0] + paf[1] > 0) for (i = 1; i <= 3; i++) outputrw(fr2, fw);
      else for (i = 1; i <= 3; i++) outputr(fr2);
    if (l1[12] + l1[CC+12] > 0.000001) {
      outputrw(fr2, fw);          
      printcb(cb, agesf[0], agesf[1], fw); 
      }
      else outputr(fr2);
    if (l1[14] + l1[CC+14] > 0.000001) {  
      outputrw(fr2, fw);  
      printcb(cb, agesm[0], agesm[1], fw);
      }
      else outputr(fr2);
    if (pcmf[0] + pcmf[1] > 0.00001) {
      outputrw(fr2, fw);  
      printcb(cb, agesc[0], agesc[1], fw);
      }
      else outputr(fr2);
    if (l1[6] + l1[CC+6] > 0.000001) {  
      outputrw(fr2, fw);  
      printcb(cb, agedwsf[0], agedwsf[1], fw);
      outputrw(fr2, fw);  
      printcb(cb, wdwsf[0], wdwsf[1], fw);
      }
      else for (i = 1; i <= 2; i++) outputr(fr2);
    if (l1[4] + l1[CC+4] > 0.000001) {        
      outputrw(fr2, fw);  
      printcb(cb, agedwsm[0], agedwsm[1], fw);
      outputrw(fr2, fw);  
      printcb(cb, wdwsm[0], wdwsm[1], fw);
      }
      else for (i = 1; i <= 2; i++) outputr(fr2);
    if (pcmf[0] + pcmf[1] > 0.000001) {
      outputrw(fr2, fw);  
      printcb(cb, agedwsc[0], agedwsc[1], fw);
      outputrw(fr2, fw);  
      printcb(cb, wdwsc[0], wdwsc[1], fw);
      }
      else for (i = 1; i <= 2; i++) outputr(fr2);
    if (l1[13] + l1[CC+13] > 0.000001) {        
      outputrw(fr2, fw);  
      printcb(cb, agecwsf[0], agecwsf[1], fw);
      outputrw(fr2, fw);  
      printcb(cb, wcwsf[0], wcwsf[1], fw);
      }
      else for (i = 1; i <= 2; i++) outputr(fr2);
    if (l1[15] + l1[CC+15] > 0.000001) {        
      outputrw(fr2, fw);  
      printcb(cb, agecwsm[0], agecwsm[1], fw);
      outputrw(fr2, fw);  
      printcb(cb, wcwsm[0], wcwsm[1], fw);
      }
      else for (i = 1; i <= 2; i++) outputr(fr2);      
    if (pcmf[0] + pcmf[1] > 0.000001) {
      outputrw(fr2, fw);  
      printcb(cb, agecwsc[0], agecwsc[1], fw);
      outputrw(fr2, fw);  
      printcb(cb, wcwsc[0], wcwsc[1], fw);
      }
      else for (i = 1; i <= 2; i++) outputr(fr2);
          
    /* 3.4.5 Male progeny for performance test on stations */
    if (l1[10] > 0.000001) {
      for (i = 1; i <=3; i++) outputrw(fr2, fw);        
      fprintf(fw, "%8.1f", ww[10]);
      }
      else for (i = 1; i <= 3; i++) outputr(fr2);
    
    /* 3.4.6. Miscellaneous */
    for (i = 1; i <=2; i++) outputrw(fr2, fw);
    if (l1[14] + l1[CC+14] > 0.000001) {
      outputrw(fr2, fw);
      printcb(cb, Pcfcmcb[0], Pcfcmcb[1], fw);
      }
    else outputr(fr2);  
    outputrw(fr2, fw);    
    printcb(cb, Pcfcmcc[0], Pcfcmcc[1], fw);
    if (l1[17] + l1[CC+17] > 0.000001) {    
      outputrw(fr2, fw);    
      printcb(cb, Pcfcmcca[0], Pcfcmcca[1], fw);
      }
    else outputr(fr2);  
    outputrw(fr2, fw);        
    printcb(cb, Pcfcmch[0], Pcfcmch[1], fw);
    if (l1[14] + l1[CC+14] > 0.000001) {
      outputrw(fr2, fw);        
      printcb(cb, Pcflmcb[0], Pcflmcb[1], fw);
      }
    else outputr(fr2);
    outputrw(fr2, fw);    
    printcb(cb, Pcflmcc[0], Pcflmcc[1], fw);
    if (l1[17] + l1[CC+17] > 0.000001) {    
      outputrw(fr2, fw);    
      printcb(cb, Pcflmcca[0], Pcflmcca[1], fw);
      }
    else outputr(fr2);
    outputrw(fr2, fw);        
    printcb(cb, Pcflmch[0], Pcflmch[1], fw);
    outputrw(fr2, fw);        
    printcb(cb, dysfflmc[0], dysfflmc[1], fw);
    outputrw(fr2, fw);        
    printcb(cb, dysmmlmc[0], dysmmlmc[1], fw);
            
    /* 3.5 Nutrition costs */
    /* 3.5.1 Purebred male breeding calves from birth to selling (Category 10) */    for (i = 1; i <= 4; i++) outputrw(fr2, fw);
    if (l1[10] > 0.00001) {
      for (i = 1; i <= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[10]);        
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[10]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[10]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[10]);                
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[10]);                
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[10]);                
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", ddry[10]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[10]);                
      }
      else for (i = 1; i <=10; i++) outputr(fr2);
    if (l1[10] > 0.00001 && ne2[10] > 0.00001) {
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne2[10]);                
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi2[10]);                
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry2[10]);                
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", ddry2[10]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f2[10]);                
      }
      else for (i = 1; i <= 5; i++) outputr(fr2);
    if (l1[10] > 0.00001 && ne10 > 0.00001) { 
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne10);                
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi10);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry10);                
      outputrw(fr2, fw);
      fprintf(fw, "%10.3f", ddry10);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f10);                
      }
      else for (i = 1; i <= 5; i++) outputr(fr2);

    /* 3.5.2. Fattened bulls (categories 4, 15 and 14) */    
    if (l1[4] + l1[14] + l1[15] + l1[CC+4] + l1[CC+14] + l1[CC+15] > 0.00001)
      for (i = 1; i <= 2; i++) outputrw(fr2, fw);
      else for (i = 1; i <= 2; i++) outputr(fr2);
    if (l1[4] + l1[14] + l1[15] > 0.00001) {
      for (i = 1; i <= 2; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", d[4], d[15], d[14]);        
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f %8.0f %8.0f", ne[4], ne[15], ne[14]);                
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f %9.0f %9.0f", pdi[4], pdi[15], pdi[14]);               
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f %10.2f %10.2f", tdry[4], tdry[15], tdry[14]);       
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f %9.3f %9.3f", ddry[4], ddry[15], ddry[14]);       
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", f[4], f[15], f[14]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costwt[4], costwt[15], costwt[14]);      
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costf[4], costf[15], costf[14]);                }
      else for (i = 1; i <= 9; i++) outputr(fr2);
    if (l1[CC+4] + l1[CC+14] + l1[CC+15] > 0.00001) {
      for (i = 1; i <=2; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", d[CC+4], d[CC+15], d[CC+14]);        
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f %8.0f %8.0f", ne[CC+4], ne[CC+15], ne[CC+14]);      
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f %9.0f %9.0f", pdi[CC+4], pdi[CC+15], pdi[CC+14]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f %10.2f %10.2f", tdry[CC+4], tdry[CC+15], tdry[CC+14]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f %9.3f %9.3f", ddry[CC+4], ddry[CC+15], ddry[CC+14]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", f[CC+4], f[CC+15], f[CC+14]);          
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costwt[CC+4], costwt[CC+15],
        costwt[CC+14]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costf[CC+4], costf[CC+15], costf[CC+14]);
      }
      else for (i = 1; i <= 9; i++) outputr(fr2);
      
    /* 3.5.3. Fattened castrates (categories 5, 16 and 17) */
    if (pcmf[0] + pcmf[1] > 0.00001)
      for (i = 1; i <= 2; i++) outputrw(fr2, fw);
      else for (i = 1; i <= 2; i++) outputr(fr2);
    if (pcmf[0] > 0.00001) {
      for (i = 1; i <= 2; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", d[5], d[16], d[17]);        
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f %8.0f %8.0f", ne[5], ne[16], ne[17]);                
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f %9.0f %9.0f", pdi[5], pdi[16], pdi[17]);               
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f %10.2f %10.2f", tdry[5], tdry[16], tdry[17]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f %9.3f %9.3f", ddry[5], ddry[16], ddry[17]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", f[5], f[16], f[17]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costwt[5], costwt[16], costwt[17]); 
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costf[5], costf[16], costf[17]);
      }
      else for (i = 1; i <= 9; i++) outputr(fr2);      
    if (pcmf[1] > 0.00001) {
      for (i = 1; i <=2; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", d[CC+5], d[CC+16], d[CC+17]);        
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f %8.0f %8.0f", ne[CC+5], ne[CC+16], ne[CC+17]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f %9.0f %9.0f", pdi[CC+5], pdi[CC+16], pdi[CC+17]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f %10.2f %10.2f", tdry[CC+5], tdry[CC+16], tdry[CC+17]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f %9.3f %9.3f", ddry[CC+5], ddry[CC+16], ddry[CC+17]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", f[CC+5], f[CC+16], f[CC+17]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costwt[CC+5], costwt[CC+16],
        costwt[CC+17]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costf[CC+5], costf[CC+16], costf[CC+17]);
      }
      else for (i = 1; i <= 9; i++) outputr(fr2);

    /* 3.5.4. Fattened heifers (categories 6, 13, 12 and CC+6, CC+13, CC+12) */ 
    if (l1[6] + l1[12] + l1[13] + l1[CC+6] + l1[CC+12] + l1[CC+13] > 0.00001)
      for (i = 1; i <= 2; i++) outputrw(fr2, fw);
      else for (i = 1; i <= 2; i++) outputr(fr2);
    if (l1[6] + l1[12] + l1[13] > 0.00001) {
      for (i = 1; i <= 2; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", d[6], d[13], d[12]);        
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f %8.0f %8.0f", ne[6], ne[13], ne[12]);                
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f %9.0f %9.0f", pdi[6], pdi[13], pdi[12]); 
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f %10.2f %10.2f", tdry[6], tdry[13], tdry[12]); 
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f %9.3f %9.3f", ddry[6], ddry[13], ddry[12]); 
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", f[6], f[13], f[12]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costwt[6], costwt[13], costwt[12]); 
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costf[6], costf[13], costf[12]);       
      }
      else for (i = 1; i <= 9; i++) outputr(fr2);
    if (l1[CC+6] + l1[CC+12] + l1[CC+13] > 0.00001) {
      for (i = 1; i <=2; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", d[CC+6], d[CC+13], d[CC+12]);        
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f %8.0f %8.0f", ne[CC+6], ne[CC+13], ne[CC+12]);       
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f %9.0f %9.0f", pdi[CC+6], pdi[CC+13], pdi[CC+12]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f %10.2f %10.2f", tdry[CC+6], tdry[CC+13], 
        tdry[CC+12]); 
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f %9.3f %9.3f", ddry[CC+6], ddry[CC+13], ddry[CC+12]); 
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", f[CC+6], f[CC+13], f[CC+12]);    
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costwt[CC+6], costwt[CC+13],
        costwt[CC+12]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f %8.1f %8.1f", costf[CC+6], costf[CC+13], costf[CC+12]);
      }
      else for (i = 1; i <= 9; i++) outputr(fr2);
      
    /* 3.5.5. Heifers for replacement died between weaning and calving 
             (category 7) */
    for (i = 1; i <=5; i++) outputrw(fr2, fw);
    fprintf(fw, "%8.1f", d[7]);        
    outputrw(fr2, fw);
    fprintf(fw, "%8.0f", ne[7]);                
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", pdi[7]);                
    outputrw(fr2, fw);
    fprintf(fw, "%10.2f", tdry[7]);                
    outputrw(fr2, fw);
    fprintf(fw, "%9.3f", ddry[7]);                
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", f[7]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costwt[7]);                
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costf[7]);                
    if (l1[CC+7] > 0.000001) {
      for (i = 1; i <=3; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[CC+7]);        
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[CC+7]);                
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[CC+7]);                
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[CC+7]);                
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry[CC+7]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[CC+7]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[CC+7]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[CC+7]);
      }                
      else for (i = 1; i <= 10; i++) outputr(fr2);
      
    /*3.5.6. Female (category 8) and male (category 9) calves sold at 
	     weaning for export */
    if (l1[8] + l1[9] + l1[CC+8] + l1[CC+9] > 0.00001)
      for (i = 1; i <= 2; i++) outputrw(fr2, fw);
      else for (i = 1; i <= 2; i++) outputr(fr2);
    if (l1[8] > 0.000001) {
      for (i = 1; i <= 2; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne2[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi2[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry2[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry2[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f2[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[8]);
      }
      else for (i = 1; i <= 14; i++) outputr(fr2);
    if (l1[9] > 0.000001) {
      for (i = 1; i <= 2; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne2[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi2[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry2[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry2[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f2[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[9]);
      }
      else for (i = 1; i <= 14; i++) outputr(fr2);
    if (l1[CC+8] > 0.000001) {
      for (i = 1; i <=2; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne2[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi2[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry2[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry2[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f2[CC+8]);
      outputrw(fr2, fw);    
      fprintf(fw, "%8.1f", costwt[CC+8]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[CC+8]);
      }
      else for (i = 1; i <= 14; i++) outputr(fr2);
    if (l1[CC+9] > 0.000001) {
      for (i = 1; i <=2; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne2[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi2[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry2[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry2[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f2[CC+9]);
      outputrw(fr2, fw);    
      fprintf(fw, "%8.1f", costwt[CC+9]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[CC+9]);
      }
      else for (i = 1; i <= 14; i++) outputr(fr2);

    /* 3.5.7. Replacement heifers negatively selected before first mating 
              and slaughtered (category 18) */
    for (i = 1; i <=3; i++) outputrw(fr2, fw);
    fprintf(fw, "%8.1f", d[18]);        
    outputrw(fr2, fw);
    fprintf(fw, "%8.0f", ne[18]);                
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", pdi[18]); 
    outputrw(fr2, fw);
    fprintf(fw, "%10.2f", tdry[18]);                               
    outputrw(fr2, fw);
    fprintf(fw, "%9.3f", ddry[18]);                
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", f[18]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costwt[18]);                
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costf[18]);                

    /* 3.5.8. Replacement heifers slaughtered after mating because of 
              no pregnancy (category 19) */   
    for (i = 1; i <=3; i++) outputrw(fr2, fw);
    fprintf(fw, "%8.1f", d[19]);        
    outputrw(fr2, fw);
    fprintf(fw, "%8.0f", ne[19]);                
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", pdi[19]);                
    outputrw(fr2, fw);
    fprintf(fw, "%10.2f", tdry[19]);                
    outputrw(fr2, fw);
    fprintf(fw, "%9.3f", ddry[19]);                
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", f[19]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costwt[19]);                
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costf[19]);                

    /* 3.5.9. Purchased pregnant female replacement (category 20) */
    if (l1[20] > 0.000001) {
      for (i = 1; i <=3; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[20]);        
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[20]);                
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[20]);                
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[20]);                
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry[20]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[20]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[20]);                
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[20]);                
      }
      else for (i = 1; i <= 10; i++) outputr(fr2);
        
    /* 3.5.10. Replacement dairy heifers entering the first reproduction 
               cycle (category 22) */
    for (i = 1; i <=3; i++) outputrw(fr2, fw);
    fprintf(fw, "%8.1f", d[22]);        
    outputrw(fr2, fw);
    fprintf(fw, "%8.0f", ne[22]);                
    outputrw(fr2, fw);
    fprintf(fw, "%9.0f", pdi[22]);                
    outputrw(fr2, fw);
    fprintf(fw, "%10.2f", tdry[22]);
    outputrw(fr2, fw);
    fprintf(fw, "%9.3f", ddry[22]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", f[22]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costwt[22]);                
    outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costf[22]);                

    /* 3.5.11. Breeding heifers sold before mating (categories 23 and CC+23)
               and breeding heifers sold pregnant (categories 24 and CC+24) */
    if (l1[23] + l1[24] + l1[CC+23] + l1[CC+24] > 0.00001)
      for (i = 1; i <= 2; i++) outputrw(fr2, fw);
      else for (i = 1; i <= 2; i++) outputr(fr2);
    if (l1[23] > 0.000001) {
      for (i = 1; i <= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[23]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[23]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[23]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[23]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry[23]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[23]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[23]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[23]);
      }
      else for (i = 1; i <= 10; i++) outputr(fr2);
    if (l1[24] > 0.000001) {
      for (i = 1; i <= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[24]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[24]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[24]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[24]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry[24]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[24]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[24]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[24]);
      }
      else for (i = 1; i <= 10; i++) outputr(fr2);
    if (l1[CC+23] > 0.000001) {      
      for (i = 1; i <= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[CC+23]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[CC+23]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[CC+23]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[CC+23]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry[CC+23]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[CC+23]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[CC+23]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[CC+23]);
      }
      else for (i = 1; i <= 10; i++) outputr(fr2);
    if (l1[CC+24] > 0.000001) {      
      for (i = 1; i <= 3; i++) outputrw(fr2, fw);
      fprintf(fw, "%8.1f", d[CC+24]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.0f", ne[CC+24]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.0f", pdi[CC+24]);
      outputrw(fr2, fw);
      fprintf(fw, "%10.2f", tdry[CC+24]);
      outputrw(fr2, fw);
      fprintf(fw, "%9.3f", ddry[CC+24]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", f[CC+24]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costwt[CC+24]);
      outputrw(fr2, fw);
      fprintf(fw, "%8.1f", costf[CC+24]);
      }
      else for (i = 1; i <= 10; i++) outputr(fr2);

    /* 3.5.12. Cows on reproductive cycle 1 */
    for (i = 1; i<= 4; i++) outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f", d[25], d[26], 
      d[27], d[28], d[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", neg[25], neg[26], 
      neg[27], neg[28], neg[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", nem[25], nem[26], 
      nem[27], nem[28], nem[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", nepc[25], nepc[26], 
      nepc[27], nepc[28], nepc[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", nel[25], nel[26], 
      nel[27], nel[28], nel[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", ne[25], ne[26], 
      ne[27], ne[28], ne[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdig[25], pdig[26], 
      pdig[27], pdig[28], pdig[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdim[25], pdim[26], 
      pdim[27], pdim[28], pdim[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdipc[25], pdipc[26], 
      pdipc[27], pdipc[28], pdipc[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdil[25], pdil[26], 
      pdil[27], pdil[28], pdil[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdi[25], pdi[26], 
      pdi[27], pdi[28], pdi[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.2f %9.2f %9.2f %9.2f %9.2f", tdry[25], tdry[26], 
      tdry[27], tdry[28], tdry[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.3f %9.3f %9.3f %9.3f %9.3f", ddry[25], ddry[26], 
      ddry[27], ddry[28], ddry[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", f[25], f[26], 
      f[27], f[28], f[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", costwt[25], costwt[26], 
      costwt[27], costwt[28], costwt[30]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", costf[25], costf[26], 
      costf[27], costf[28], costf[30]);
	       
    /* 3.5.13. Cows on reproductive cycle 2 */
    for (i = 1; i<= 4; i++) outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f", d[31], d[32], 
      d[33], d[34], d[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", neg[31], neg[32], 
      neg[33], neg[34], neg[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", nem[31], nem[32], 
      nem[33], nem[34], nem[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", nepc[31], nepc[32], 
      nepc[33], nepc[34], nepc[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", nel[31], nel[32], 
      nel[33], nel[34], nel[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", ne[31], ne[32], 
      ne[33], ne[34], ne[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdig[31], pdig[32], 
      pdig[33], pdig[34], pdig[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdim[31], pdim[32], 
      pdim[33], pdim[34], pdim[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdipc[31], pdipc[32], 
      pdipc[33], pdipc[34], pdipc[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdil[31], pdil[32], 
      pdil[33], pdil[34], pdil[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdi[31], pdi[32], 
      pdi[33], pdi[34], pdi[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.2f %9.2f %9.2f %9.2f %9.2f", tdry[31], tdry[32], 
      tdry[33], tdry[34], tdry[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.3f %9.3f %9.3f %9.3f %9.3f", ddry[31], ddry[32], 
      ddry[33], ddry[34], ddry[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", f[31], f[32], 
      f[33], f[34], f[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", costwt[31], costwt[32], 
      costwt[33], costwt[34], costwt[36]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", costf[31], costf[32], 
      costf[33], costf[34], costf[36]);

    /* 3.5.14. Cows on reproductive cycle 3 */
    for (i = 1; i<= 4; i++) outputrw(fr2, fw);
    fprintf(fw, "\n %9.1f %9.1f %9.1f %9.1f %9.1f", d[37], d[38], 
      d[39], d[40], d[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", neg[37], neg[38], 
      neg[39], neg[40], neg[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", nem[37], nem[38], 
      nem[39], nem[40], nem[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", nepc[37], nepc[38], 
      nepc[39], nepc[40], nepc[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", nel[37], nel[38], 
      nel[39], nel[40], nel[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", ne[37], ne[38], 
      ne[39], ne[40], ne[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdig[37], pdig[38], 
      pdig[39], pdig[40], pdig[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdim[37], pdim[38], 
      pdim[39], pdim[40], pdim[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdipc[37], pdipc[38], 
      pdipc[39], pdipc[40], pdipc[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdil[37], pdil[38], 
      pdil[39], pdil[40], pdil[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", pdi[37], pdi[38], 
      pdi[39], pdi[40], pdi[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.2f %9.2f %9.2f %9.2f %9.2f", tdry[37], tdry[38], 
      tdry[39], tdry[40], tdry[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.3f %9.3f %9.3f %9.3f %9.3f", ddry[37], ddry[38], 
      ddry[39], ddry[40], ddry[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", f[37], f[38], 
      f[39], f[40], f[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", costwt[37], costwt[38], 
      costwt[39], costwt[40], costwt[42]);
    outputrw(fr2, fw);
    fprintf(fw, "\n %9.0f %9.0f %9.0f %9.0f %9.0f", costf[37], costf[38], 
      costf[39], costf[40], costf[42]);

    /* 3.5.16. Female calves from birth to the end of rearing period */
    for (i = 1; i<= 7; i++) outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", agew[0], agew[1]);
      else fprintf(fw, "%8.1f", agew[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.0f %8.0f", newf[0], newf[1]);
      else fprintf(fw, "%8.0f", newf[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.0f %8.0f", pdiwf[0], pdiwf[1]);
      else fprintf(fw, "%8.0f", pdiwf[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.0f %8.0f", tdrywf[0], tdrywf[1]);
      else fprintf(fw, "%8.0f", tdrywf[0]);
    outputrw(fr2, fw);  
    if (cb == 1) fprintf(fw, "%8.3f %8.3f", ddrywf[0], ddrywf[1]);
      else fprintf(fw, "%8.3f", ddrywf[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", fwf[0], fwf[1]);
      else fprintf(fw, "%8.1f", fwf[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.0f %8.0f", newf2[0], newf2[1]);
      else fprintf(fw, "%8.0f", newf2[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%9.0f %9.0f", pdiwf2[0], pdiwf2[1]);
      else fprintf(fw, "%9.0f", pdiwf2[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.0f %8.0f", tdrywf2[0], tdrywf2[1]);
      else fprintf(fw, "%8.0f", tdrywf2[0]);
    outputrw(fr2, fw);  
    if (cb == 1) fprintf(fw, "%8.3f %8.3f", ddrywf2[0], ddrywf2[1]);
      else fprintf(fw, "%8.3f", ddrywf2[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", fwf2[0], fwf2[1]);
      else fprintf(fw, "%8.1f", fwf2[0]);
    outputrw(fr2, fw);    
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costwwf[0], costwwf[1]);
      else fprintf(fw, "%8.1f", costwwf[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costfwf[0], costfwf[1]);
      else fprintf(fw, "%8.1f", costfwf[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costvetwf[0], costvetwf[1]);
      else fprintf(fw, "%8.1f", costvetwf[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costhwf[0], costhwf[1]);
      else fprintf(fw, "%8.1f", costhwf[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costfixwf[0], costfixwf[1]);
      else fprintf(fw, "%8.1f", costfixwf[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costwf[0], costwf[1]);
      else fprintf(fw, "%8.1f", costwf[0]);
    
    /* 3.5.17. Male calves from birth to the end of rearing period */
    for (i = 1; i<= 4; i++) outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", agew[0], agew[1]);
      else fprintf(fw, "%8.1f", agew[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.0f %8.0f", newm[0], newm[1]);
      else fprintf(fw, "%8.0f", newm[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.0f %8.0f", pdiwm[0], pdiwm[1]);
      else fprintf(fw, "%8.0f", pdiwm[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.0f %8.0f", tdrywm[0], tdrywm[1]);
      else fprintf(fw, "%8.0f", tdrywm[0]);
    outputrw(fr2, fw);  
    if (cb == 1) fprintf(fw, "%8.3f %8.3f", ddrywm[0], ddrywm[1]);
      else fprintf(fw, "%8.3f", ddrywm[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", fwm[0], fwm[1]);
      else fprintf(fw, "%8.1f", fwm[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.0f %8.0f", newm2[0], newm2[1]);
      else fprintf(fw, "%8.0f", newm2[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%9.0f %9.0f", pdiwm2[0], pdiwm2[1]);
      else fprintf(fw, "%9.0f", pdiwm2[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.0f %8.0f", tdrywm2[0], tdrywm2[1]);
      else fprintf(fw, "%8.0f", tdrywm2[0]);
    outputrw(fr2, fw);  
    if (cb == 1) fprintf(fw, "%8.3f %8.3f", ddrywm2[0], ddrywm2[1]);
      else fprintf(fw, "%8.3f", ddrywm2[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", fwm2[0], fwm2[1]);
      else fprintf(fw, "%8.1f", fwm2[0]);
    outputrw(fr2, fw);    
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costwwm[0], costwwm[1]);
      else fprintf(fw, "%8.1f", costwwm[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costfwm[0], costfwm[1]);
      else fprintf(fw, "%8.1f", costfwm[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costvetwm[0], costvetwm[1]);
      else fprintf(fw, "%8.1f", costvetwm[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costhwm[0], costhwm[1]);
      else fprintf(fw, "%8.1f", costhwm[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costfixwm[0], costfixwm[1]);
      else fprintf(fw, "%8.1f", costfixwm[0]);
    outputrw(fr2, fw);
    if (cb == 1) fprintf(fw, "%8.1f %8.1f", costwm[0], costwm[1]);
      else fprintf(fw, "%8.1f", costwm[0]);
    
    /* 3.6. Other costs and total cost per animal in each category */
    for (i = 1; i <= 6; i++) outputrw(fr2, fw);    
    for (i = 1; i <= 24; i++)  
      if (l1[i] > 0.000001) 
        fprintf(fw, "\nCategory %3d %8.1f %8.1f %8.1f %8.1f %8.1f %9.1f", i,
	  costvet[i], costh[i], costo[i], costfix[i], costf[i], cost[i]);
    outputrw(fr2, fw);
    for (i = 25; i <= CC; i++)  
      if (l1[i] > 0.000001) 
        fprintf(fw, "\nCategory %3d %8.1f %8.1f %8.1f %8.1f %8.1f %9.1f", i,
	  costvet[i], costh[i], costo[i], costfix[i], costf[i], cost[i]);
    outputrw(fr2, fw);
    for (i = CC+1; i < i4; i++)  
      if (l1[i] > 0.000001) 
        fprintf(fw, "\nCategory %3d %8.1f %8.1f %8.1f %8.1f %8.1f %9.1f", i,
	  costvet[i], costh[i], costo[i], costfix[i], costf[i], cost[i]);
    outputrw(fr2, fw);
        fprintf(fw, "\n             %8.1f %8.1f %8.1f %8.1f %8.1f %9.1f",
	  costvetc, costhc, costoc, costfixc, costfc, costc);    
    outputrw(fr2, fw);
    
    /* 3.7. Costs for dystocia */
    for (i = 1; i<= 3; i++) outputrw(fr2, fw);
    fprintf(fw, "%8.1f", costdys);

    /* 3.8. Revenues */
    for (i = 1; i<= 4; i++) outputrw(fr2, fw);
    if (l1[14] > 0.000001 && l1[17] > 0.000001)
      fprintf(fw, "\n %10.1f %10.1f %10.1f %10.1f", pr[12], pr[14], pr[17], 
        pr[30]);
    if (l1[14] > 0.000001 && l1[17] < 0.000001)	
      fprintf(fw, "\n %10.1f %10.1f        -   %10.1f", pr[12], pr[14], pr[30]);
    if (l1[14] < 0.000001 && l1[17] > 0.000001)	
      fprintf(fw, "\n %10.1f        -   %10.1f %10.1f", pr[12], pr[17], pr[30]);
    if (l1[14] < 0.000001 && l1[17] < 0.000001)	
      fprintf(fw, "\n %10.1f        -          -   %10.1f", pr[12], pr[30]);	
    if (cb ==1) {
      if (l1[CC+14] > 0.000001 && l1[CC+17] > 0.000001)
	fprintf(fw, "\n %10.1f %10.1f %10.1f", pr[CC+12], pr[CC+14], pr[CC+17]);
      if (l1[CC+14] > 0.000001 && l1[CC+17] < 0.000001)	
	fprintf(fw, "\n %10.1f %10.1f        -   ", pr[CC+12], pr[CC+14]);
      if (l1[CC+14] < 0.000001 && l1[CC+17] > 0.000001)	
	fprintf(fw, "\n %10.1f        -   %10.1f", pr[CC+12], pr[CC+17]);
      if (l1[CC+14] < 0.000001 && l1[CC+17] < 0.000001)	
	fprintf(fw, "\n %10.1f        -          -   ", pr[CC+12]);	
      }
    outputrw(fr2, fw);
    for (i = 1; i <= 24; i++)  
      if (l1[i] > 0.000001) fprintf(fw, "\n  Category %3d %15.1f", i, rev[i]);
    fprintf(fw, "\n");	  
    for (i = 25; i <= CC; i++)  
      if (l1[i] > 0.000001) fprintf(fw, "\n  Category %3d %15.1f", i, rev[i]);
    fprintf(fw, "\n");	  
    for (i = CC+1; i < i4; i++)  
      if (l1[i] > 0.000001) fprintf(fw, "\n  Category %3d %15.1f", i, rev[i]);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", revc);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", revmilkc);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", revcullc);
        
    /* 3.9. Number of discounted expressions for revenues and costs */
    for (i = 1; i<= 2; i++) outputrw(fr2, fw);
    for (i = 1; i <= 24; i++)  
      if (l1[i] > 0.000001)
        fprintf(fw, "\n  Category %3d %15.5f %15.5f", i, NDEr[i], NDEc[i]); 
    fprintf(fw, "\n");	  
    for (i = 25; i <= CC; i++)  
      if (l1[i] > 0.000001)
        fprintf(fw, "\n  Category %3d %15.5f %15.5f", i, NDEr[i], NDEc[i]); 
    fprintf(fw, "\n");	  
    for (i = CC+1; i < i4; i++)  
      if (l1[i] > 0.000001)
        fprintf(fw, "\n  Category %3d %15.5f %15.5f", i, NDEr[i], NDEc[i]); 
    fprintf(fw, "\n");
    outputrw(fr2, fw);
    fprintf(fw, "%8.3f", NDEdys);

    /* 3.10. Profit */
    for (i = 1; i<= 3; i++) outputrw(fr2, fw);
    fprintf(fw, "%10.1f", Trev);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", dot);      
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", Tcost);
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", Tprof);    
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", profitabd);    
    outputrw(fr2, fw);
    fprintf(fw, "%10.1f", profitab);    

    /* 3.11. Marginal economic values */
    outputrw(fr2, fw);
      i3 = cb;
    if (cast[1] + pbf[1] + pff[1] < 1) i3 = 0;
    for (i = 0; i <= i3; i++) {
      if (pff[i] == 0 && (pbf[i] == 1 || cast[i] == 1)) {
	fprintf(fw,"\n\n********************************************************\n");
	fprintf(fw,"* W a r n i n g !                                      *\n");
	fprintf(fw,"* Because there are no ");
	if (i == 0) fprintf(fw,"pure-bred heifers in fattening  *\n");
	if (i == 1) fprintf(fw,"cross-bred heifers in fattening *\n");
	if (i == 0) 
          fprintf(fw,"* the reference trait for daily gain of pure-bred      *\n");
	if (i == 1) 
          fprintf(fw,"* the reference trait for daily gain of cross-bred     *\n");
	fprintf(fw,"* animals in fattening was changed.                    *\n"); 
	if (i == 0) 
          fprintf(fw,"* The reference trait is now daily gain of pure-bred   *\n");
	if (i == 1) 
          fprintf(fw,"* The reference trait is now daily gain of cross-bred  *\n");
	if (pbf[i] == 1)
          fprintf(fw,"* bulls in fattening.                                  *\n");
	if (cast[i] == 1 && pbf[i] == 0)
          fprintf(fw,"* castrates in fattening.                              *\n"); 
  fprintf(fw,"********************************************************\n\n");	
      }
    }
    if (ewopt == 0) {
      outputrw(fr2, fw);
      outputr(fr2);
      }
    if (ewopt > 0) {
      outputr(fr2);
      outputrw(fr2, fw);
      }
    for (i = 1; i < NT; i++) {
      if (to[i] > 0) {
	if (to[i] == 2 && ((ewopt != 1 &&
          (fabs(ew[i][0]) + fabs(ew[i][1]) + fabs(ew[i][2]) > 0.000001))
	  || (ewopt == 1 && (fabs(ew[i][1]) + fabs(ew[i][2]) > 0.000001)))) {
          outputrw(fr2, fw);
          if (ewopt == 0) 
	    fprintf(fw, "\n%12.4f        -            -", ew[i][0]); 
          if (ewopt == 2) {
	    if (utifemcr == 3) {
	      if ((i > 30 && i < 42) || i == 46)
		fprintf(fw, "\n%12.4f        -            -", ew[i][0]);
              if (i == 11 || i == 12 || i == 13 || i == 29 || i == 45)
 		fprintf(fw, "\n%12.4f        -     %12.4f", ew[i][0], ew[i][2]);
              if (i < 6 || i == 9 || i == 10 || i == 18 || i == 23 || i == 43
	        || i == 44) 
        	fprintf(fw, "\n%12.4f %12.4f %12.4f", ew[i][0], ew[i][1], ew[i][2]);
	      if ((i > 5 && i < 9) || (i > 25 && i < 29) || i == 47)
		fprintf(fw, "\n       -            -     %12.4f", ew[i][2]);
	      if (i == 30 || i == 42)
		fprintf(fw, "\n%12.4f %12.4f        -", ew[i][0], ew[i][1]); 
              }
            if (utifemcr != 3) {
	      if (i == 11 || i == 12 || i == 13 || i == 29 || 
	        (i > 30 && i < 42) || i == 43 || i == 45 || i == 46)
		fprintf(fw, "\n%12.4f        -            -", ew[i][0]); 
	      else
		fprintf(fw, "\n%12.4f %12.4f        -", ew[i][0], ew[i][1]); 
              }
            }
          if (ewopt == 1) {	    
	    if (utifemcr == 3) {	    
	      if (i < 6 || (i > 8 && i < 11) || i == 18 || i == 23 || 
	        i == 43 || i == 44)
		fprintf(fw, "\n       -     %12.4f %12.4f", ew[i][1], ew[i][2]); 
              if ((i > 5 && i < 9) || i == 11 || i == 12 || i == 13 || 
	        (i > 25 && i < 30) || i == 45 || i == 47)
 		fprintf(fw, "\n       -            -     %12.4f", ew[i][2]);
	        }
	    if (utifemcr != 3) {  
	      if (i < 6 || (i > 8 && i < 11) || i == 18 || i == 23 || 
	        i == 43 || i == 44)
		fprintf(fw, "\n       -     %12.4f        -", ew[i][1]); 
	      }
	    if (i == 30 || i == 42)
	      fprintf(fw, "\n       -     %12.4f        -", ew[i][1]); 
	    }
	  }  
	else outputr(fr2);
      }
    }
      
    /* 3.12. Economic weights */      
    outputrw(fr2, fw);
    for (i = 1; i < NT; i++) {
      if (to[i] > 0) {      
	if (to[i] == 2) {
          if (fabs(ew_d[i]) < 0.000001 && fabs(ew_m[i]) < 0.000001)
	    outputr(fr2);  	    
	  else { 
	    outputrw(fr2, fw);
            if (tt[i] == 0)
              fprintf(fw, "\n%12.4f         -", ew_d[i]);
            if (tt[i] == 1 && (fabs(ew_m[i]) > 0.000001) 
               && (ewopt != 1 || (ewopt == 1 && utifemcr == 3)))
               fprintf(fw, "\n      -      %12.4f", ew_m[i]);
	    if (tt[i] == 2) {
              if ((ewopt != 1 || (ewopt == 1 && utifemcr == 3)) 
	        && fabs(ew_m[i]) > 0.000001)
        	fprintf(fw, "\n%12.4f %12.4f", ew_d[i], ew_m[i]);
              if ((ewopt == 1 && utifemcr != 3) || fabs(ew_m[i]) < 0.000001)
        	fprintf(fw, "\n%12.4f         -", ew_d[i]);
	    }  
          }
	}
	else outputr(fr2);
      }
    }

    /* 3.13. Relative economic weights */
    if (gstd == 2) {
      outputrw(fr2, fw);
      for (i = 1; i < NT; i++) {
        if (to[i] > 0) {
	  if (to[i] == 1) outputr(fr2);
	  else {
            if ((tt[i] == 1 && ewsum_m < 0.000001)
	      || (fabs(ew_d[i]) < 0.000001 && fabs(ew_m[i]) < 0.000001))
	      outputr(fr2);  	    
	      else outputrw(fr2, fw);
	    if (fabs(ew_d[i]) > 0.000001 || fabs(ew_m[i]) > 0.000001) {  
	      if (tt[i] == 2 && ewsum_m > 0.000001) 
        	fprintf(fw, "                                      %10.3f       %10.3f\n",
		   ewr_dd[i], ewr_mm[i]);
	      if (tt[i] == 0 || (tt[i] == 2 && ewsum_m < 0.000001)) 
        	fprintf(fw, "                                      %10.3f             -\n",
		   ewr_dd[i]);
	      if (tt[i] == 1 && ewsum_m > 0.000001) 
        	fprintf(fw, "                                            -          %10.3f\n",
		   ewr_mm[i]);
            }		 
	  }
	}
      }
    if (ewsum_m > 0.000001) {
      outputrw(fr2, fw);
      outputr(fr2);
      }
    if (ewsum_m < 0.000001) {
        outputr(fr2);
	outputrw(fr2, fw);
      }      
    }  
    else for (i = 1; i <= 40; i++) outputr(fr2);
    
    if (gstd == 2 && ewsum_m > 0.000001) {
      outputrw(fr2, fw);
      for (i = 1; i < NT; i++) {
        if (to[i] > 0) {
	  if (to[i] == 1) outputr(fr2);
	  else {
	    outputrw(fr2, fw);
	    if (tt[i] == 2) 
              fprintf(fw, "                                      %10.3f       %10.3f\n",
		 ewr_da[i], ewr_ma[i]);
	    if (tt[i] == 0) 
              fprintf(fw, "                                      %10.3f             -\n",
		 ewr_da[i]);
	    if (tt[i] == 1) 
              fprintf(fw, "                                            -          %10.3f\n",
		 ewr_ma[i]);
	  }
	}
      }
    outputrw(fr2, fw);
    fprintf(fw, "                                   %10.3f       %10.3f",
        100 * ewsum_d / ewsum, 100 * ewsum_m / ewsum);
    outputrw(fr2, fw);
    }  
    else for (i = 1; i <= 40; i++) outputr(fr2);

    /* 3.13. Relative marginal economic weights */
    if (gstd == 3 && (cb == 0 || (cb == 1 && utifemcr != 3))) {
      outputrw(fr2, fw);
      for (i = 1; i < NT; i++) {
        if (to[i] > 0) {
	  if (to[i] == 1) outputr(fr2);
	  else {
            if (ewr_dd[i] > 0.000001) {
	      outputrw(fr2, fw);
	      fprintf(fw, "                                        %7.3f",
		ewr_dd[i]);
	     }	
             else outputr(fr2);
	  }
	}
      }
    outputrw(fr2, fw);                    
    }  
    else for (i = 1; i <= 39; i++) outputr(fr2);
  outputrw(fr2, fw);                  

  fclose(fw); 
  fclose(fr2);
   
Part_20: /* Printing data to CHECKD for checking the calulation */    
    if (zr == 252) fw2 = fopen("CHECKD", "w");
    if (zr == 1) fw2 = fopen("CHECKDhelp", "w"); 
    /* Printabc: */
    fprintf(fw2, "a1 = %10.4f\n", a1);
    fprintf(fw2, "a2 = %10.4f\n", a2); 
    fprintf(fw2, "a30 = %10.2f\n", a30);  
    for (i = 0; i < LL; i++) fprintf(fw2, "ab[%d] = %f\n", i, ab[i]);  
    fprintf(fw2, "ACDC = %d\n", ACDC);
    fprintf(fw2, "acdc = %d\n", acdc);
    fprintf(fw2, "ACDD = %d\n", ACDD);
    fprintf(fw2, "acdd = %d\n", acdd);
    fprintf(fw2, "ACM = %d\n", ACM);
    fprintf(fw2, "acm = %d\n", acm);
    fprintf(fw2, "ACSB = %d\n", ACSB);
    fprintf(fw2, "acsb = %d\n", acsb);
    fprintf(fw2, "ACSD = %d\n", ACSD);
    fprintf(fw2, "acsd = %d\n", acsd);    
    for (i=0; i<i4; i++) {
      if (adg[i] > .000001) fprintf(fw2, "adg[%d] = %10.3f\n", i, adg[i]);
      } 
    fprintf(fw2, "adg1cow = %f\n",adg1cow);
    fprintf(fw2, "adg10 = %f\n",adg10);
    fprintf(fw2, "adg2cow = %f\n",adg2cow); 
    for (j = 0; j <= cb; j++) fprintf(fw2, "adgcf[%d] = %10.3f\n", j, adgcf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "adgcm[%d] = %10.3f\n", j, adgcm[j]);
    for (i = 0; i <= cb; i++) fprintf(fw2, "adghm[%d] = %f\n", i, adghm[i]);
    for (i = 0; i <= cb; i++) fprintf(fw2, "adghmc[%d] = %f\n", i, adghmc[i]);
    for (i = 0; i <= cb; i++) fprintf(fw2, "adgwsc[%d] = %f\n", i, adgwsc[i]);
    for (i = 0; i <= cb; i++) fprintf(fw2, "adgwsf[%d] = %f\n", i, adgwsf[i]);
    for (i = 0; i <= cb; i++) fprintf(fw2, "adgwsm[%d] = %f\n", i, adgwsm[i]);
    for (i=0; i<i4; i++) {
      if (age[i] > .000001) fprintf(fw2, "age[%d] = %10.2f\n", i, age[i]);
      } 
    for (j = 0; j <= cb; j++) fprintf(fw2, "agec1[%d] = %10.2f\n", j, agec1[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "agecwsc[%d] = %f\n", j, agecwsc[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "agecwsf[%d] = %f\n", j, agecwsf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "agecwsm[%d] = %f\n", j, agecwsm[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "agedcw[%d] = %f\n", j, agedcw[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "agedmh[%d] = %f\n", j, agedmh[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "agedwsc[%d] = %f\n", j, agedwsc[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "agedwsf[%d] = %f\n", j, agedwsf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "agedwsm[%d] = %f\n", j, agedwsm[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "ageh1cal[%d] = %f\n", j, ageh1cal[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "agehcmat1[%d] = %f\n", j, agehcmat1[j]);    
    for (j = 0; j <= cb; j++) fprintf(fw2, "agehmat1[%d] = %f\n",j, agehmat1[j]);;
    for (j = 0; j <= cb; j++) fprintf(fw2, "agesc[%d] = %f\n", j, agesc[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "agesf[%d] = %f\n", j, agesf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "agesm[%d] = %f\n", j, agesm[j]);  
    for (i = 0; i <= cb; i++) fprintf(fw2, "agew[%d] = %f\n", i, agew[i]);    
    fprintf(fw2, "avecalc = %10.4f\n", avecalc);
    fprintf(fw2, "avelifecl = %f\n",  avelifecl);
    fprintf(fw2, "avelifecy = %f\n",  avelifecy);  
    fprintf(fw2, "avh = %f\n",  avh);  
    fprintf(fw2, "avl = %f\n",  avl);  
    fprintf(fw2, "b1 = %f\n", b1);
    fprintf(fw2, "b2 = %f\n", b2);
    fprintf(fw2, "b3 = %f\n", b3); 
    for (i=1; i<i4; i++) {
      if (bw[i] > .000001) fprintf(fw2, "bw[%d] = %10.2f\n", i, bw[i]);
      }
    for (i = 0; i <= cb; i++) fprintf(fw2, "bwf[%d] = %f\n", i, bwf[i]);
    for (i = 0; i <= cb; i++) fprintf(fw2, "bwm[%d] = %f\n", i, bwm[i]);  
    fprintf(fw2, "C = %d\n", C);
    fprintf(fw2, "C1 = %d\n", C1);  
    fprintf(fw2, "c1 = %f\n", c1);
    fprintf(fw2, "c2 = %f\n", c2);
    fprintf(fw2, "c3 = %f\n", c3);
    for (i = 0; i< LL; i++) {    
      for (j = 0; j<= cb ; j++) 
        fprintf(fw2, "cal[%d][%d] = %f\n", j, i, cal[j][i]);
      }  
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "calfloss[%d] = %f\n", j, calfloss[j]); 
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "cast[%d] = %d\n", j, cast[j]);
    fprintf(fw2, "cb = %d\n", cb);
    fprintf(fw2, "CC = %d\n", CC);  
    for (i = 0; i < LL; i++) fprintf(fw2, "cculcm[%d] = %f\n", i, cculcm[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "cculmc[%d] = %f\n", i, cculmc[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "ci[%d] = %f\n", i, ci[i]);
    fprintf(fw2, "ciav = %f\n",  ciav); 
    fprintf(fw2, "claw_inc = %d\n", claw_inc); 
    for (i = 0; i < LL; i++) fprintf(fw2, "clcm[%d] = %f\n", i, clcm[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "clmc[%d] = %f\n", i, clmc[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "cmat[%d] = %f\n", i, cmat[i]);   
    fprintf(fw2, "cmd = %f\n",cmd); 
    for (j = 0; j < inmaxh; j++) fprintf(fw2, "conh[%d] = %f\n", j, conh[j]); 
    for (i=1; i<i4; i++) {
      if (fabs(cost[i] > .000001)) 
        fprintf(fw2, "cost[%d] = %10.2f\n", i, cost[i]);
      }
    if (claw_inc == 1) fprintf(fw2, "costacd = %10.2f\n", costacd);
    fprintf(fw2, "costc = %10.2f\n", costc);    
    for (i=1; i<i4; i++) {
      if (costd[i] > .000001) fprintf(fw2, "costd[%d] = %10.2f\n", i, costd[i]);
      }
    for (j=0; j<= cb; j++) fprintf(fw2, "costdcf[%d] = %10.2f\n", j, costdcf[j]);  
    for (j=0; j<= cb; j++) fprintf(fw2, "costdf[%d] = %10.2f\n", j, costdf[j]);  
    fprintf(fw2, "costdrug = %10.2f\n", costdrug);   
    fprintf(fw2, "costdys = %10.2f\n", costdys); 
    for (i=1; i<i4; i++) {
      if (costf[i] > .000001) fprintf(fw2, "costf[%d] = %10.2f\n", i, costf[i]);
      }
    fprintf(fw2, "costfc = %10.2f\n", costfc);    
    for (i=1; i<i4; i++) {
      if (costfix[i] > .000001) fprintf(fw2, "costfix[%d] = %10.2f\n", i, costfix[i]);
      }
    fprintf(fw2, "costfixc = %10.2f\n", costfixc);    
    for (j = 0; j <= cb; j++) fprintf(fw2, "costfixwf[%d] = %10.2f\n", j, costfixwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "costfixwm[%d] = %10.2f\n", j, costfixwm[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "costfwf[%d] = %10.2f\n", j, costfwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "costfwm[%d] = %10.2f\n", j, costfwm[j]);
    for (i=1; i<i4; i++) {
      if (fabs(costh[i]) > .000001) fprintf(fw2, "costh[%d] = %10.2f\n", i, costh[i]);
      }
    fprintf(fw2, "costhcd = %10.2f\n",costhcd);  
    fprintf(fw2, "costhc = %10.2f\n", costhc);     
    for (j = 0; j <= cb; j++) fprintf(fw2, "costhwf[%d] = %10.2f\n", j, costhwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "costhwm[%d] = %10.2f\n", j, costhwm[j]);
    for (i=0; i<= CC; i++) {
      if (costi[i] > .000001) fprintf(fw2, "costi[%d] = %10.2f\n", i, costi[i]);
      } 
    fprintf(fw2, "costlab = %10.2f\n",costlab);
    fprintf(fw2, "costlabm = %10.2f\n", costlabm); 
    fprintf(fw2, "costmach = %10.2f\n", costmach);   
    for (i=0; i<= CC; i++) {
      if (costmilkv[i] > .000001) fprintf(fw2, "costmilkv[%d] = %10.2f\n", i, costmilkv[i]);
      }
    if (claw_inc == 1) fprintf(fw2, "costnacd = %10.2f\n", costnacd);   
    for (i=1; i<i4; i++) {
      if (costo[i] > .000001) fprintf(fw2, "costo[%d] = %10.2f\n", i, costo[i]);
      }
    fprintf(fw2, "costoc = %10.2f\n", costoc);  
    fprintf(fw2, "costom = %10.2f\n", costom);      
    for (i=1; i<i4; i++) {
      if (costv[i] > .000001) fprintf(fw2, "costv[%d] = %10.3f\n", i, costv[i]);
      }
    for (i=1; i<i4; i++) {
      if (costvet[i] > .000001) fprintf(fw2, "costvet[%d] = %10.3f\n", i, costvet[i]);
      }
    fprintf(fw2, "costvet10 = %10.2f\n",costvet10);      
    fprintf(fw2, "costvetc = %10.2f\n", costvetc); 
    fprintf(fw2, "costvetcd = %10.2f\n",costvetcd);    
    fprintf(fw2, "costvetm = %10.2f\n", costvetm);       
    for (j = 0; j <= cb; j++) fprintf(fw2, "costvetwf[%d] = %10.2f\n", j, costvetwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "costvetwm[%d] = %10.2f\n", j, costvetwm[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "costwf[%d] = %10.2f\n", j, costwf[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "costwm[%d] = %10.2f\n", j, costwm[j]); 
    for (i=1; i<i4; i++) {
      if (costwt[i] > .000001) fprintf(fw2, "costwt[%d] = %10.2f\n", i, costwt[i]);
      }  
    for (j = 0; j <= cb; j++) fprintf(fw2, "costwwf[%d] = %10.2f\n", j, costwwf[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "costwwm[%d] = %10.2f\n", j, costwwm[j]); 
    fprintf(fw2, "cowyear = %10.4f\n", cowyear);
    for (i = 0; i < LL; i++) fprintf(fw2, "cp[%d] = %f\n", i, cp[i]);
    for (i = 0; i < LL-1; i++) {
      for (j = 0; j < inmax; j++)
	fprintf(fw2, "cpin[%d][%d] = %f\n", i, j, cpin[i][j]);
      }  
    for (i = 0; i < LL-1; i++) {
      for (j = 0; j < inmax; j++)
	fprintf(fw2, "cpindys[%d][%d] = %f\n", i, j, cpindys[i][j]);
      }  
    for (i = 0; i < LL-1; i++) {
      for (j = 0; j < inmax; j++)
	fprintf(fw2, "cpinndys[%d][%d] = %f\n", i, j, cpinndys[i][j]);
      }   
    fprintf(fw2, "crdys = %f\n",crdys);  
    for (i = 0; i<inmaxh; i++) fprintf(fw2, "crinh[%d] = %8.4f\n", i, crinh[i]);  
    fprintf(fw2, "CT = %d\n", CT);
    for (i = 0; i < LL; i++) fprintf(fw2, "culh[%d] = %f\n", i, culh[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "culvol[%d] = %f\n", i, culvol[i]);  
    fprintf(fw2, "D = %d\n", D);  
    for (i=0; i<i4; i++) {
      if (d[i] > .000001) fprintf(fw2, "d[%d] = %10.2f\n", i, d[i]);
      }  
    fprintf(fw2, "d1 = %f\n", d1);
    for (j = 0; j <= cb; j++) fprintf(fw2, "d1w[%d] = %10.2f\n", j, d1w[j]); 
    fprintf(fw2, "d2 = %f\n", d2);
    fprintf(fw2, "d3 = %f\n", d3);   
    for (i = 0; i <= cb; i++) fprintf(fw2, "dayshc[%d] = %f\n", i, dayshc[i]); 
    for (i = 0; i < LL; i++) fprintf(fw2, "dayslac[%d] = %f\n", i, dayslac[i]);         
    for (i=0; i<i4; i++) {
      if (dc1[i] > .000001) fprintf(fw2, "dc1[%d] = %10.2f\n", i, dc1[i]);
      } 
    for (j = 0; j <= cb; j++) {
      for (i = 8; i <= 10; i++) {
        if (i == 10 && j == 1) break;    
        fprintf(fw2, "dc2[%d] = %10.2f\n", i+CC*j, dc2[i+CC*j]);
        }
      }	
    for (i = 0; i <= cb; i++) fprintf(fw2, "dccf[%d] = %f\n", i, dccf[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "dcd[%d] = %f\n", i, dcd[i]);
    if (claw_inc == 1) {
      for (i = 0; i < 3; i++) {    
	for (j = 0; j < DL ; j++)
	  fprintf(fw2, "dcdi[%d][%d] = %f\n", i, j, dcdi[i][j]);  
	}    
      }
    for (i = 0; i < LL; i++) fprintf(fw2, "dce[%d] = %f\n", i, dce[i]);  
    for (i = 0; i <= cb; i++) fprintf(fw2, "dcw[%d] = %f\n", i, dcw[i]);
    fprintf(fw2, "DD = %d\n", DD);
    fprintf(fw2, "dd = %f\n", dd);
    for (i = 3; i < i4; i++) {
      if (l1[i] > .000001) fprintf(fw2, "ddry[%d] = %10.2f\n", i, ddry[i]);
      }
    for (j = 0; j <= cb; j++) {
      for (i = 8; i <= 10; i++) {
        if (i == 10 && j == 1) break;    
        fprintf(fw2, "ddry2[%d] = %10.2f\n", i+CC*j, ddry2[i+CC*j]);
        }
      }	
    fprintf(fw2, "ddry10 = %10.2f\n", ddry10);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "ddrywf[%d] = %10.3f\n", j, ddrywf[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "ddrywf2[%d] = %10.3f\n", j, ddrywf2[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "ddrywm[%d] = %10.3f\n", j, ddrywm[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "ddrywm2[%d] = %10.3f\n", j, ddrywm2[j]);
    for (i = 0; i< LL; i++) {    
      for (j = 0; j<= cb ; j++) 
	fprintf(fw2, "dead48f[%d][%d] = %f\n", j, i, dead48f[j][i]);
      }
    for (i = 0; i< LL; i++) {    
      for (j = 0; j<= cb ; j++) 
	fprintf(fw2, "dead48m[%d][%d] = %f\n", j, i, dead48m[j][i]); 
      }
    for (i = 0; i< LL; i++) {    
      for (j = 0; j<= cb ; j++) 
	fprintf(fw2, "deadfc[%d][%d] = %f\n", j, i, deadfc[j][i]);
      }
    for (i = 0; i< LL; i++) {    
      for (j = 0; j<= cb ; j++)
	fprintf(fw2, "deadmc[%d][%d] = %f\n", j, i, deadmc[j][i]);  
      }
    fprintf(fw2, "deltacow = %10.5f\n", deltacow);
    for (i = 1; i < NT; i++) 
      fprintf(fw2, "delta_d[%d] = %3d\n", i, delta_d[i]);
    for (i = 1; i < NT; i++) 
      fprintf(fw2, "delta_m[%d] = %3d\n", i, delta_m[i]);
    fprintf(fw2, "deltamilk = %10.2f\n", deltamilk);            
    for (i = 0; i <= cb; i++) fprintf(fw2, "dfcf[%d] = %f\n", i, dfcf[i]);  
    for (i = NCP; i <= CC; i++) {
      if (discd[i] > .000001) fprintf(fw2, "discd[%d] = %10.2f\n", i,
        discd[i]);
      } 
    for (i = NCP; i <= CC; i++) {
      if (discow[i] > .000001) fprintf(fw2, "discow[%d] = %10.2f\n", i,
        discow[i]);
      } 
    fprintf(fw2, "dismcd = %10.2f\n", dismcd);       
    fprintf(fw2, "dismilk = %10.2f\n", dismilk); 
    fprintf(fw2, "DL = %d\n", DL);     
    for (i=0; i<= CC; i++) {
      if (dl[i] > .000001) fprintf(fw2, "dl[%d] = %10.2f\n", i, dl[i]);
      } 
    for (i = 0; i <= cb; i++) fprintf(fw2, "dmcf[%d] = %f\n", i, dmcf[i]);
    for (i = 0; i < 3; i++) {    
      for (j = 0; j < DL ; j++)
	fprintf(fw2, "dmi[%d][%d] = %f\n", i, j, dmi[i][j]);  
      }    
    for (i=0; i<= CC; i++) {
      if (dmilksum[i] > .000001) fprintf(fw2, "dmilksum[%d] = %10.2f\n", i, dmilksum[i]);
      } 
    fprintf(fw2, "dot = %10.4f\n", dot); 
    fprintf(fw2, "dotcowh = %f\n",dotcowh);
    fprintf(fw2, "dotcowo = %f\n",dotcowo);
    fprintf(fw2, "dotexpm = %f\n",dotexpm);
    fprintf(fw2, "dotfati = %f\n",dotfati);
    fprintf(fw2, "dotmilk = %f\n",dotmilk);
    fprintf(fw2, "dottest = %f\n",dottest);
    for (i=0; i<i4; i++) {
      if (dp[i] > .000001) fprintf(fw2, "dp[%d] = %10.2f\n", i, dp[i]);
      }  
    fprintf(fw2, "drescw = %f\n",drescw);    
    for (j = 0; j <= cb; j++) fprintf(fw2, "dresb[%d] = %f\n", j, dresb[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "dresc[%d] = %f\n", j, dresc[j]);
    fprintf(fw2, "drescw = %f\n",drescw);
    for (i = 0; i <= cb; i++) fprintf(fw2, "dresh[%d] = %f\n", i, dresh[i]);
    for (i=0; i<i4; i++) {
      if (dryf[i] > .000001) fprintf(fw2, "dryf[%d] = %10.3f\n", i, dryf[i]);
      }   
    fprintf(fw2, "dryf10 = %f\n",dryf10);  
    for (i=0; i<i4; i++) {
      if (dryf2[i] > .000001) fprintf(fw2, "dryf2[%d] = %10.3f\n", i, dryf2[i]);
      }   
    for (j = 0; j <= cb; j++) fprintf(fw2, "dryfwf[%d] = %10.2f\n", j, dryfwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "dryfwf2[%d] = %10.2f\n", j, dryfwf2[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "dryfwm[%d] = %10.2f\n", j, dryfwm[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "dryfwm2[%d] = %10.2f\n", j, dryfwm2[j]);  
    for (i=1; i<i4; i++) {
      if (dung[i] > .000001) fprintf(fw2, "dung[%d] = %10.3f\n", i, dung[i]);
      }
    fprintf(fw2, "dung10 = %10.2f\n",dung10);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "dungwf[%d] = %10.2f\n", j, dungwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "dungwm[%d] = %10.2f\n", j, dungwm[j]);
    for (i = 0; i < LL; i++) {
      for (j = 0; j <= cb; j++) fprintf(fw2, "dys[%d][%d] = %f\n", j, i, dys[j][i]);
      }       
    for (i = 0; i <= cb; i++) fprintf(fw2, "dysav[%d] = %f\n", i, dysav[i]);  
    fprintf(fw2, "dysavave = %f\n", dysavave);  
    for (i = 0; i < DD; i++) fprintf(fw2, "dysavh[%d] = %8.4f\n", i, dysavh[i]);
    for  (j = 0; j <= cb; j++) {
      for (i1 = 0; i1 < LL; i1++)  {
	for (i = 0; i < DD; i++)
          fprintf(fw2, "dysavs[%d,%d,%d] = %8.4f\n", i, j, i1, dysavs[i][j][i1]);
	}	
      }  
    for (i = 0; i < LL; i++) fprintf(fw2, "dysc[%d] = %f\n", i, dysc[i]); 
    fprintf(fw2, "dyscl = %d\n", dyscl);     
    for  (j = 0; j <= cb; j++) {
      for (i1 = 0; i1 < LL; i1++) 
	fprintf(fw2, "dysf[%d,%d] = %8.4f\n", j, i1, dysf[j][i1]);
      }  
    for  (j = 0; j <= cb; j++) {
      for (i1 = 0; i1 < LL; i1++) {
	for (i = 0; i < DD; i++)
          fprintf(fw2, "dysff[%d,%d,%d] = %8.4f\n", i, j, i1, dysff[i][j][i1]);
	}	
      } 
    for (i = 0; i <= cb; i++) 
      fprintf(fw2, "dysfflmc[%d] = %f\n", i, dysfflmc[i]);
    for  (j = 0; j <= cb; j++) {
      for (i1 = 0; i1 < LL; i1++) 
	fprintf(fw2, "dysm[%d,%d] = %8.4f\n", j, i1, dysm[j][i1]);
      }           
    for (i = 0; i < LL; i++) fprintf(fw2, "dysmat[%d] = %f\n", i, dysmat[i]);    
    for  (j = 0; j <= cb; j++) {
      for (i1 = 0; i1 < LL; i1++) {
	for (i = 0; i < DD; i++)
	  fprintf(fw2, "dysmm[%d,%d,%d] = %8.4f\n", i, j, i1, dysmm[i][j][i1]);
	}	
      }    
    for (i = 0; i <= cb; i++) 
      fprintf(fw2, "dysmmlmc[%d] = %f\n", i, dysmmlmc[i]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "dysscoreav[%d] = %10.2f\n", j, dysscoreav[j]);    
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "dysscoreavf[%d] = %10.2f\n", j, dysscoreavf[j]);    
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "dysscoreavm[%d] = %10.2f\n", j, dysscoreavm[j]);        
    fprintf(fw2, "ecm = %10.4f\n", ecm);  
    for (i = 0; i<inmax; i++) 
      fprintf(fw2, "ecrinc[%d] = %8.4f\n", i, ecrinc[i]);  
    for (i=0; i<i4; i++) {
      if (edf[i] > .000001) fprintf(fw2, "edf[%d] = %10.3f\n", i, edf[i]);
      }
    fprintf(fw2, "edf10 = %10.3f\n",edf10);  
    for (i=0; i<i4; i++) {
      if (edf2[i] > .000001) fprintf(fw2, "edf2[%d] = %10.3f\n", i, edf2[i]);
      }
    for (j = 0; j <= cb; j++) fprintf(fw2, "edfwf[%d] = %10.2f\n", j, edfwf[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "edfwf2[%d] = %10.2f\n", j, edfwf2[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "edfwm[%d] = %10.2f\n", j, edfwm[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "edfwm2[%d] = %10.2f\n", j, edfwm2[j]);
    for (i = 1; i < NT; i++) {
      for (j = 0; j < 3; j++) {
        if (fabs(ew0[i][j]) > .000001) 
	  if (j < 2) fprintf(fw2, "ew0[%d][%d] = %10.4f\n", i, j, ew0[i][j]);
	if (fabs(ew[i][j]) > .000001) 
	  fprintf(fw2, "ew[%d][%d] = %10.4f\n", i, j, ew[i][j]);
	}
      }          
    for (i = 1; i < NT; i++) {
      for (j = 0; j <= cb; j++) {
	if (fabs(ewc[i][j]) > .000001) fprintf(fw2, "ewc[%d][%d] = %10.4f\n",
          i, j, ewc[i][j]);
	}
      } 
    for (i = 1; i < NT; i++) 
      if (fabs(ew_d[i]) > .000001)  
        fprintf(fw2, "ew_d[%d] = %10.4f\n", i, ew_d[i]);
    for (i = 1; i < NT; i++) {
      for (j = 0; j <= cb; j++)
        if (fabs(ew[i][j]) > 0.000001) 
	  fprintf(fw2, "ewdiff[%d][%d] = %10.4f\n", i, j, ewdiff[i][j]);
      } 
    for (i = 1; i < NT; i++) 
      if (fabs(ew_m[i]) > .000001)  
        fprintf(fw2, "ew_m[%d] = %10.4f\n", i, ew_m[i]);
    fprintf(fw2, "ewopt = %d\n", ewopt); 
    for (i = 1; i < NT; i++) 
      if (fabs(ewr_da[i]) > .000001) 
        fprintf(fw2, "ewr_da[%d] = %10.4f\n", i, ewr_da[i]);     
    for (i = 1; i < NT; i++) 
      if (fabs(ewr_dd[i]) > .000001) 
        fprintf(fw2, "ewr_dd[%d] = %10.4f\n", i, ewr_dd[i]);     
    for (i = 1; i < NT; i++) 
      if (fabs(ewr_ma[i]) > .000001) 
        fprintf(fw2, "ewr_ma[%d] = %10.4f\n", i, ewr_ma[i]);     
    for (i = 1; i < NT; i++) 
      if (fabs(ewr_mm[i]) > .000001) 
        fprintf(fw2, "ewr_mm[%d] = %10.4f\n", i, ewr_mm[i]);     
    for (i = 1; i < NT; i++) 
      if (fabs(ewst_d[i]) > .000001) 
        fprintf(fw2, "ewst_d[%d] = %10.4f\n", i, ewst_d[i]);     
    for (i = 1; i < NT; i++) 
      if (fabs(ewst_m[i]) > .000001) 
        fprintf(fw2, "ewst_m[%d] = %10.4f\n", i, ewst_m[i]);     
    fprintf(fw2, "ewsum = %f\n",ewsum);
    fprintf(fw2, "ewsum_d = %f\n",ewsum_d);
    fprintf(fw2, "ewsum_m = %f\n",ewsum_m);    
    for (i = 1; i < NT; i++) {
      for (j = 1; j < ACM; j++) 
	if (fabs(ewwd[i][j]) > .000001) fprintf(fw2, "ewwd[%d][%d] = %10.4f\n",
          i, j, ewwd[i][j]);     
      }          
    for (i = 1; i < NT; i++) {
      for (j = 1; j < ACM; j++) 
	if (fabs(ewwm[i][j]) > .000001) fprintf(fw2, "ewwm[%d][%d] = %10.4f\n",
          i, j, ewwm[i][j]);      
      } 
    fprintf(fw2, "exfc = %f\n", exfc);                
    for (i=0; i<i4; i++) {
      if (f[i] > .000001) fprintf(fw2, "f[%d] = %10.2f\n", i, f[i]);
      }        
    fprintf(fw2, "f10 = %f\n", f10);  
    for (i=0; i<i4; i++) {
      if (f2[i] > .000001) fprintf(fw2, "f2[%d] = %10.2f\n", i, f2[i]);
      } 
    for (i = 0; i < nSCC; i++) fprintf(fw2, "facSCC[%d] = %f\n", i, facSCC[i]);      
    fprintf(fw2, "fat = %f\n",fat);  
    fprintf(fw2, "fat305ave = %10.2f\n", fat305ave);            
    fprintf(fw2, "fatkg = %10.2f\n", fatkg);          
    for (i = 0; i < i4; i++) {
      if (fe[i] > .000001) fprintf(fw2, "fe[%d] = %10.2f\n", i, fe[i]);
      } 
    fprintf(fw2, "fe10 = %f\n", fe10);     
    for (i=0; i<i4; i++) {
      if (fe2[i] > .000001) fprintf(fw2, "fe2[%d] = %10.2f\n", i, fe2[i]);
      }   
    fprintf(fw2, "feedcost = %d\n\n", feedcost);          
    for (j = 0; j <= cb; j++) fprintf(fw2, "fewf[%d] = %10.2f\n", j, fewf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "fewf2[%d] = %10.2f\n", j, fewf2[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "fewm[%d] = %10.2f\n", j, fewm[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "fewm2[%d] = %10.2f\n", j, fewm2[j]);
    for (i=0; i<i4; i++) {
      if (fix[i] > .000001) fprintf(fw2, "fix[%d] = %10.2f\n", i, fix[i]);
      }        
    fprintf(fw2, "fix10 = %10.2f\n",fix10);      
    for (j = 0; j <= cb; j++) fprintf(fw2, "fixwf[%d] = %10.2f\n", j, fixwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "fixwm[%d] = %10.2f\n", j, fixwm[j]);
    for (i = 1; i < 9; i++) fprintf(fw2, "flag[%d] = %d\n", i, flag[i]);
    for (i = 0; i < i4; i++) {
      if (fpdi[i] > .000001) fprintf(fw2, "fpdi[%d] = %10.2f\n", i, fpdi[i]);
      } 
    fprintf(fw2, "fpdi10 = %f\n", fpdi10);       
    for (i=0; i<i4; i++) {
      if (fpdi2[i] > .000001) fprintf(fw2, "fpdi2[%d] = %10.2f\n", i, fpdi2[i]);
      }        
    for (j = 0; j <= cb; j++) fprintf(fw2, "fpdiwf[%d] = %10.2f\n", j, fpdiwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "fpdiwf2[%d] = %10.2f\n", j, fpdiwf2[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "fpdiwm[%d] = %10.2f\n", j, fpdiwm[j]); 
    for (j = 0; j <= cb; j++) fprintf(fw2, "fpdiwm2[%d] = %10.2f\n", j, fpdiwm2[j]); 
    for (j = 0; j <= cb; j++) fprintf(fw2, "fwf[%d] = %10.2f\n", j, fwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "fwf2[%d] = %10.2f\n", j, fwf2[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "fwm[%d] = %10.2f\n", j, fwm[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "fwm2[%d] = %10.2f\n", j, fwm2[j]);
    fprintf(fw2, "gene_flow = %d\n\n", gene_flow);   
    fprintf(fw2, "gstd = %d\n", gstd);  
    if (gstd == 2) {
      for (i = 1; i < NT; i++) 
	if (to[i] == 2 && (tt[i] == 0 || tt[i] == 2)) 
          fprintf(fw2, "gstd_d[%d] = %10.4f\n", i, gstd_d[i]);
    }
    if (gstd == 3) {
      for (i = 1; i < NT; i++) 
	if (to[i] == 2) 
          fprintf(fw2, "gstd_d[%d] = %10.4f\n", i, gstd_d[i]);
    }
    for (i = 1; i < NT; i++) 
      if (to[i] == 2 && tt[i] > 0) 
        fprintf(fw2, "gstd_m[%d] = %10.4f\n", i, gstd_m[i]);
    for (j = 0; j < ACM; j++) if(fabs(hd[j] > 0.000001))
      fprintf(fw2, "hd[%d] = %10.4f\n", j, hd[j]); 
    fprintf(fw2, "herdbook = %f\n",herdbook);     
    for (j = 0; j < ACM; j++) if(fabs(hm[j] > 0.000001)) 
      fprintf(fw2, "hm[%d] = %10.4f\n", j, hm[j]);
    fprintf(fw2, "hmpf = %f\n", hmpf);
    fprintf(fw2, "i4 = %d\n", i4);   
    fprintf(fw2, "ind_a30 = %d\n",ind_a30);
    fprintf(fw2, "ind_RCT = %d\n",ind_RCT);        
    fprintf(fw2, "inint = %f\n", inint);   
    fprintf(fw2, "inmax = %d\n",inmax);
    fprintf(fw2, "inmaxh = %d\n",inmaxh);
    fprintf(fw2, "INS = %d\n",INS);    
    fprintf(fw2, "intcm = %f\n", intcm);
    for (i = 0; i < LL-1; i++) fprintf(fw2, "intconc[%d] = %f\n", i, intconc[i]);  
    fprintf(fw2, "intconh = %f\n", intconh);
    if (claw_inc == 1)
      for (i = 0; i < LL; i++) fprintf(fw2, "ircdy[%d] = %f\n", i, ircdy[i]);     
    for (i = 0; i < LL; i++) fprintf(fw2, "ircmy[%d] = %f\n", i, ircmy[i]);     
    fprintf(fw2, "J = %d\n",J);    
    fprintf(fw2, "ja = %d\n",ja);
    fprintf(fw2, "jb = %d\n",jb);
    fprintf(fw2, "kbd = %f\n",kbd);
    fprintf(fw2, "kbl = %f\n",kbl);
    for (j = 0; j <= cb; j++) fprintf(fw2, "kbwmf[%d] = %f\n", j, kbwmf[j]);
    for (j=0; j<= cb; j++) fprintf(fw2, "kce[%d] = %10.4f\n", j, kce[j]);
    for (j = 0; j < inmax; j++) fprintf(fw2, "kconc[%d] = %f\n", j, kconc[j]);
    for (j = 0; j < inmaxh; j++) fprintf(fw2, "kconh[%d] = %f\n", j, kconh[j]); 
    for (j=0; j<= cb; j++) fprintf(fw2, "kcp[%d] = %10.4f\n", j, kcp[j]);
    fprintf(fw2, "kdresb = %f\n",kdresb);
    for (j = 0; j <= cb; j++) fprintf(fw2, "kdresbh[%d] = %f\n", j, kdresbh[j]);
    fprintf(fw2, "kdresc = %f\n",kdresc);
    for (j = 0; j <= cb; j++) fprintf(fw2, "kdresch[%d] = %f\n", j, kdresch[j]);
    fprintf(fw2, "kdrescwh = %f\n", kdrescwh);  
    fprintf(fw2, "kdresh = %f\n",kdresh);
    fprintf(fw2, "kff = %10.4f\n", kff);
    fprintf(fw2, "kfw = %10.4f\n", kfw);
    fprintf(fw2, "kg10 = %10.4f\n", kg10);
    for (j = 0; j <= cb; j++) fprintf(fw2, "kgaincf[%d] = %f\n", j, kgaincf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "kgainmf[%d] = %f\n", j, kgainmf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "kgcmf[%d] = %f\n", j, kgcmf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "kghccf[%d] = %f\n", j, kghccf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "kghcf[%d] = %f\n", j, kghcf[j]);  
    fprintf(fw2, "kmatc = %10.4f\n", kmatc);
    for (j = 0; j <= cb; j++) fprintf(fw2, "kp21[%d] = %f\n", j, kp21[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "kpm1[%d] = %f\n", j, kpm1[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "kpm2[%d] = %f\n", j, kpm2[j]);     
    for (i=0; i<i4; i++) {
      if (kpr[i] > .000001) fprintf(fw2, "kpr[%d] = %10.3f\n", i, kpr[i]);
      }  
    for (j = 0; j <= cb; j++) fprintf(fw2, "kslb[%d] = %f\n", j, kslb[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "kslc[%d] = %f\n", j, kslc[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "kslh[%d] = %f\n", j, kslh[j]);       
    fprintf(fw2, "kt = %10.4f\n", kt);
    fprintf(fw2, "ktb = %f\n",ktb);
    fprintf(fw2, "ktf = %f\n",ktf);    
    fprintf(fw2, "ktp = %f\n",ktp);
    fprintf(fw2, "L = %d\n",L);
    for (i=1; i<i4; i++) {
      if (l1[i] > .000001) fprintf(fw2, "l1[%d] = %10.5f\n", i, l1[i]);
      }
    for (i = 1; i <= TT; i++) fprintf(fw2, "l2[%d] = %f\n", i, l2[i]); 
    fprintf(fw2, "L3 = %d\n",L3);            
    for (i = 0; i < LL; i++) fprintf(fw2, "l3[%d] = %f\n", i, l3[i]);        
    for (i = 0; i < DD; i++) fprintf(fw2, "labdys[%d] = %f\n", i, labdys[i]);  
    fprintf(fw2, "labherd = %10.2f\n",labherd);
    if (claw_inc == 1) fprintf(fw2, "labherdcd = %10.2f\n",labherdcd);
    fprintf(fw2, "labvet = %10.2f\n",labvet);  
    if (claw_inc == 1) fprintf(fw2, "labvetcd = %10.2f\n",labvetcd);      
    fprintf(fw2, "lgpre = %f\n", lgpre);
    for (i = NCP; i <= CC; i++) fprintf(fw2, "life[%d] = %10.2f\n", i, life[i]);  
    fprintf(fw2, "l_inv = %f\n",l_inv);
    fprintf(fw2, "LL = %d\n", LL);
    fprintf(fw2, "losc = %10.4f\n",losc);   
    for (j = 0; j <= cb; j++) fprintf(fw2, "losfw[%d] = %f\n", j, losfw[j]);    
    fprintf(fw2, "losff = %f\n",losff);
    for (i = 0; i <= cb; i++) fprintf(fw2, "loshin[%d] = %f\n", i, loshin[i]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "losmw[%d] = %f\n", j, losmw[j]);  
    fprintf(fw2, "lossmcd = %10.2f\n", lossmcd);
    fprintf(fw2, "lossmilk = %10.2f\n", lossmilk);
    fprintf(fw2, "losstcd = %10.2f\n", losstcd);    
    fprintf(fw2, "losstotal = %10.2f\n", losstotal);      
    fprintf(fw2, "loswf = %f\n",loswf);
    fprintf(fw2, "mast_inc = %d\n", mast_inc);    
    fprintf(fw2, "matcross = %d\n", matcross);
    fprintf(fw2, "matpur = %d\n", matpur);
    fprintf(fw2, "mcwb = %f\n",mcwb);
    fprintf(fw2, "mcwd = %f\n",mcwd);    
    for (i=1; i<ACM; i++) 
      if (fabs(m_gf[i] > .000001)) fprintf(fw2, "m_gf[%d] = %10.5f\n", i, m_gf[i]);
    for (i=1; i<ACM; i++) 
      if (fabs(m_gf0[i] > .000001)) fprintf(fw2, "m_gf0[%d] = %10.5f\n", i, m_gf0[i]);
    fprintf(fw2, "milk = %10.0f\n",milk);    
    fprintf(fw2, "milk21 = %10.3f\n",milk21);       
    fprintf(fw2, "milk31 = %10.3f\n",milk31);           
    for (i=0; i<3; i++) fprintf(fw2, "milk305[%d] = %10.2f\n", i, milk305[i]); 
    fprintf(fw2, "milk305ave = %10.2f\n",milk305ave); 
    fprintf(fw2, "milkprice = %d\n", milkprice);    
    fprintf(fw2, "milkquota = %d\n", milkquota);    
    for (i=0; i<= CC; i++) {
      if (milksum[i] > .000001) fprintf(fw2, "milksum[%d] = %10.2f\n", i, milksum[i]);
      } 
    fprintf(fw2, "milktot = %f\n",milktot);
    fprintf(fw2, "milktoth = %f\n",milktoth);
    fprintf(fw2, "milktotl = %f\n",milktotl);
    fprintf(fw2, "milktotm = %f\n",milktotm);
    fprintf(fw2, "mSCS = %f\n",mSCS);
    for (i=1; i<ACM; i++) 
      if (fabs(m_sum[i] > .000001)) fprintf(fw2, "m_sum[%d] = %10.5f\n", i, m_sum[i]);
    for (i = 0; i <= cb; i++) fprintf(fw2, "mtest[%d] = %f\n", i, mtest[i]);
    for (i = 0; i <= cb; i++) fprintf(fw2, "mxmc[%d] = %f\n", i, mxmc[i]);
    fprintf(fw2, "n = %d\n",n);
    fprintf(fw2, "na30 = %d\n",na30);
    for (j = 0; j <= cb; j++) fprintf(fw2, "Ncal[%d] = %10.4f\n", j, Ncal[j]);   
    fprintf(fw2, "Ncalt = %f\n",Ncalt);
    for (i = 0; i <= cb; i++) fprintf(fw2, "nccf[%d] = %f\n", i, nccf[i]);
    fprintf(fw2, "NCP = %d\n",NCP);
    for (i = 0; i < LL-1; i++) fprintf(fw2, "ncp[%d] = %f\n", i, ncp[i]);  
    for (i=0; i<LL; i++) fprintf(fw2, "nd[%d] = %10.3f\n", i, nd[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "ndaycc[%d] = %f\n", i, ndaycc[i]);   
    for (i = 0; i < LL; i++) fprintf(fw2, "ndaycd[%d] = %f\n", i, ndaycd[i]);
    fprintf(fw2, "ndaydys = %f\n",ndaydys);    
    for (i=1; i<i4; i++) {
      if (NDEc[i] > .000001) fprintf(fw2, "NDEc[%d] = %10.5f\n", i, NDEc[i]);
      }
    fprintf(fw2, "NDEdys = %10.5f\n", NDEdys);  
    for (i=1; i<i4; i++) {
      if (NDEr[i] > .000001) fprintf(fw2, "NDEr[%d] = %10.5f\n", i, NDEr[i]);
      }
    for (i=1; i<i4; i++) {
      if (ne[i] > .000001) fprintf(fw2, "ne[%d] = %10.2f\n", i, ne[i]);
      }
    fprintf(fw2, "ne10 = %10.2f\n",ne10);      
    for (i=1; i<i4; i++) {
      if (ne2[i] > .000001) fprintf(fw2, "ne2[%d] = %10.2f\n", i, ne2[i]);
      }
    for (i=1; i<= CC; i++) {
      if (neg[i] > .000001) fprintf(fw2, "neg[%d] = %10.2f\n", i, neg[i]);
      } 
    for (i=1; i<= CC; i++) {
      if (nel[i] > .000001) fprintf(fw2, "nel[%d] = %10.2f\n", i, nel[i]);
      } 
    for (i=1; i<= CC; i++) {
      if (nem[i] > .000001) fprintf(fw2, "nem[%d] = %10.2f\n", i, nem[i]);
      } 
    for (i=1; i<i4; i++) {
      if (nepc[i] > .000001) fprintf(fw2, "nepc[%d] = %10.2f\n", i, nepc[i]);
      }
    for (j = 0; j <= cb; j++) fprintf(fw2, "newf[%d] = %10.2f\n", j, newf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "newf2[%d] = %10.2f\n", j, newf2[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "newm[%d] = %10.2f\n", j, newm[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "newm2[%d] = %10.2f\n", j, newm2[j]);
    fprintf(fw2, "nfat = %d\n", nfat);
    fprintf(fw2, "Nfav = %f\n", Nfav);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "Nfc48a[%d] = %f\n", j, Nfc48a[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "Nfcba[%d] = %f\n", j, Nfcba[j]);  
    for (i = 0; i <= cb; i++) fprintf(fw2, "nfcf[%d] = %f\n", i, nfcf[i]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "Nfcw[%d] = %f\n", j, Nfcw[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "Nffa[%d] = %f\n", j, Nffa[j]); 
    fprintf(fw2, "Nfmat = %f\n", Nfmat);
    fprintf(fw2, "Nfrer = %f\n", Nfrer);     
    for (i=0; i<= CC; i++) {
      if (nin[i] > .000001) fprintf(fw2, "nin[%d] = %10.4f\n", i, nin[i]);
      } 
    for (i=0; i<LL-1; i++) fprintf(fw2, "ninr[%d] = %10.4f\n", i, ninr[i]); 
    for (i=0; i<LL; i++) {
      if (nl[i] > .000001) fprintf(fw2, "nl[%d] = %10.3f\n", i, nl[i]);
      }
    for (j = 0; j <= cb; j++) fprintf(fw2, "Nmc48a[%d] = %f\n", j, Nmc48a[j]); 
    for (j = 0; j <= cb; j++) fprintf(fw2, "Nmcba[%d] = %f\n", j, Nmcba[j]); 
    for (j = 0; j <= cb; j++) fprintf(fw2, "Nmcf[%d] = %f\n", j, Nmcf[j]);  
    for (i = 0; i <= cb; i++) fprintf(fw2, "nmcf[%d] = %f\n", i, nmcf[i]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "Nmcfb[%d] = %f\n", j, Nmcfb[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "Nmcfc[%d] = %f\n", j, Nmcfc[j]);
    fprintf(fw2, "nprot = %d\n", nprot);
    fprintf(fw2, "nr = %f\n",nr); 
    fprintf(fw2, "nRCT = %d\n",nRCT);    
    fprintf(fw2, "n_sac = %d\n", n_sac);
    fprintf(fw2, "NSCC = %d\n",NSCC);
    fprintf(fw2, "nSCC = %d\n",nSCC);
    fprintf(fw2, "NT = %d\n",NT); 
    fprintf(fw2, "NTHR = %d\n",NTHR);
    fprintf(fw2, "P1 = %d\n", P1);      
    fprintf(fw2, "p1 = %d\n", p1);
    fprintf(fw2, "P2 = %d\n", P2);          
    fprintf(fw2, "p2 = %d\n", p2);
    if (claw_inc == 1)
      for (i = 0; i < LL; i++) fprintf(fw2, "pacd[%d] = %f\n", i, pacd[i]);     
    for (j=0; j<= cb; j++) fprintf(fw2, "paf[%d] = %d\n", j, paf[j]); 
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	for (i1 = 0; i1 <= cb; i1++)
          fprintf(fw2, "Pb[%d][%d][%d] = %10.4f\n", j, i, i1, Pb[j][i][i1]);
	  }  
	}
    for (j=0; j<= cb; j++) fprintf(fw2, "pbf[%d] = %d\n", j, pbf[j]); 
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) fprintf(fw2, "Pc[%d][%d][0] = %10.4f\n", j, i,
	Pc[j][i][0]);
	}
    fprintf(fw2, "pc = %10.4f\n", pc);
    for (i = 0; i < LL; i++) fprintf(fw2, "pcdys[%d] = %f\n", i, pcdys[i]);      
    for (j = 0; j <= cb; j++) fprintf(fw2, "Pcfcmcb[%d] = %10.2f\n", j, Pcfcmcb[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "Pcfcmcc[%d] = %10.2f\n", j, Pcfcmcc[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "Pcfcmcca[%d] = %10.2f\n", j, Pcfcmcca[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "Pcfcmch[%d] = %10.2f\n", j, Pcfcmch[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "Pcflmcb[%d] = %10.2f\n", j, Pcflmcb[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "Pcflmcc[%d] = %10.2f\n", j, Pcflmcc[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "Pcflmcca[%d] = %10.2f\n", j, Pcflmcca[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "Pcflmch[%d] = %10.2f\n", j, Pcflmch[j]);  
    for (i = 0; i <= cb; i++) fprintf(fw2, "pcmf[%d] = %f\n", i, pcmf[i]);
    for (i = 0; i < LL-1; i++) {
      for (j = 0; j < inmax; j++)
	fprintf(fw2, "pconc[%d][%d] = %f\n", i, j, pconc[i][j]);
      }    
    for (j = 0; j < inmaxh; j++) fprintf(fw2, "pconh[%d] = %f\n", j, pconh[j]);
    for (i = 0; i < LL-1; i++) fprintf(fw2, "pcross[%d] = %f\n", i, pcross[i]); 
    fprintf(fw2, "pcrossh = %f\n",pcrossh);  
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	for (i1 = 0; i1 <= cb; i1++)
          fprintf(fw2, "Pcs[%d][%d][%d] = %10.4f\n", j, i, i1, Pcs[j][i][i1]);
	  }  
	}
    for (i=1; i<i4; i++) {
      if (pdi[i] > .000001) fprintf(fw2, "pdi[%d] = %10.2f\n", i, pdi[i]);
      }
    fprintf(fw2, "pdi10 = %10.2f\n",pdi10);      
    for (i=1; i<i4; i++) {
      if (pdi2[i] > .000001) fprintf(fw2, "pdi2[%d] = %10.2f\n", i, pdi2[i]);
      }
    for (i=1; i<i4; i++) {
      if (pdid[i] > .000001) fprintf(fw2, "pdid[%d] = %10.3f\n", i, pdid[i]);
      }
    fprintf(fw2, "pdid10 = %10.2f\n", pdid10);     
    for (i=1; i<i4; i++) {
      if (pdid2[i] > .000001) fprintf(fw2, "pdid2[%d] = %10.3f\n", i, pdid2[i]);
      }   
    for (j = 0; j <= cb; j++) fprintf(fw2, "pdidwf[%d] = %10.2f\n", j, pdidwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "pdidwf2[%d] = %10.2f\n", j, pdidwf2[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "pdidwm[%d] = %10.2f\n", j, pdidwm[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "pdidwm2[%d] = %10.2f\n", j, pdidwm2[j]);
    for (i=0; i<= CC; i++) {
      if (pdig[i] > .000001) fprintf(fw2, "pdig[%d] = %10.2f\n", i, pdig[i]);
      } 
    for (i=0; i<= CC; i++) {
      if (pdil[i] > .000001) fprintf(fw2, "pdil[%d] = %10.2f\n", i, pdil[i]);
      } 
    for (i=0; i<= CC; i++) {
      if (pdim[i] > .000001) fprintf(fw2, "pdim[%d] = %10.2f\n", i, pdim[i]);
      } 
    fprintf(fw2, "pdiml = %f\n", pdiml);
    for (i=1; i<i4; i++) {
      if (pdipc[i] > .000001) fprintf(fw2, "pdipc[%d] = %10.2f\n", i, pdipc[i]);
      }
    for (j = 0; j <= cb; j++) fprintf(fw2, "pdiwf[%d] = %10.2f\n", j, pdiwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "pdiwf2[%d] = %10.2f\n", j, pdiwf2[j]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "pdiwm[%d] = %10.2f\n", j, pdiwm[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "pdiwm2[%d] = %10.2f\n", j, pdiwm2[j]);
    fprintf(fw2, "pdry = %f\n", pdry);
    for (j = 0; j <= cb; j++) fprintf(fw2, "pf[%d][1] = %f\n", j, pf[j][1]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "pf[%d][2] = %f\n", j, pf[j][2]); 
    for (j=0; j<= cb; j++) fprintf(fw2, "pff[%d] = %d\n", j, pff[j]);  
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) {
	for (i1 = 0; i1 <= cb; i1++)
          fprintf(fw2, "Ph[%d][%d][%d] = %10.4f\n", j, i, i1, Ph[j][i][i1]);
	  }  
	}
    for (i = 0; i < nSCC-1; i++) 
      fprintf(fw2, "Phiscc[%d] = %f\n", i, Phiscc[i]);  	
    for (j = 1; j < acm+1; j++) { 
      for (i = 1; i < acm+1; i++)
        if (PM[i][j]>0.0000001) 
	  fprintf(fw2, "PM[%d][%d] = %8.4f\n", i, j, PM[i][j]);
      }  
    for (j = 0; j <= cb; j++) fprintf(fw2, "pm[%d][1] = %f\n", j, pm[j][1]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "pm[%d][2] = %f\n", j, pm[j][2]);    
    for (i = 1; i <= CC; i++) 
      if (pp[i]>0.0000001) fprintf(fw2, "pp[%d] = %f\n", i, pp[i]);   
    for (i=1; i<i4; i++) {
      if (pr[i] > .000001) fprintf(fw2, "pr[%d] = %10.2f\n", i, pr[i]);
      }
    fprintf(fw2, "praib = %f\n",praib);
    fprintf(fw2, "praid = %f\n",praid);
    fprintf(fw2, "prairb = %f\n",prairb);
    fprintf(fw2, "praird = %f\n",praird); 
    for (i=1; i<i4; i++) {
      if (fabs(pranim[i]) > .000001) fprintf(fw2, "pranim[%d] = %10.2f\n", 
        i, pranim[i]);
      }
    fprintf(fw2, "prb = %f\n",prb);    
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) fprintf(fw2, "Prb[%d][%d] = %10.4f\n", j, i,
	Prb[j][i]);
	}
    fprintf(fw2, "prc = %f\n",prc);      
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) fprintf(fw2, "Prc[%d][%d] = %10.4f\n", j, i,
	Prc[j][i]);
	}
    fprintf(fw2, "prcs = %f\n",prcs);      
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) fprintf(fw2, "Prcs[%d][%d] = %10.4f\n", j, i,
	Prcs[j][i]);
	}
    fprintf(fw2, "prdg = %f\n",prdg);      
    for (i=1; i<i4; i++) {
      if (prf[i] > .000001) fprintf(fw2, "prf[%d] = %10.3f\n", i, prf[i]);
      }
    fprintf(fw2, "prf10 = %10.2f\n", prf10);      
    for (i=1; i<i4; i++) {
      if (prf2[i] > .000001) fprintf(fw2, "prf2[%d] = %10.3f\n", i, prf2[i]);
      }    
    for (j = 0; j <= cb; j++) fprintf(fw2, "prfwf[%d] = %10.2f\n", j, prfwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "prfwf2[%d] = %10.2f\n", j, prfwf2[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "prfwm[%d] = %10.2f\n", j, prfwm[j]); 
    for (j = 0; j <= cb; j++) fprintf(fw2, "prfwm2[%d] = %10.2f\n", j, prfwm2[j]);   
    fprintf(fw2, "prh = %f\n",prh);  
    for (j = 0; j < p1; j++) {
      for (i = 0; i < p2; i++) fprintf(fw2, "Prh[%d][%d] = %10.4f\n", j, i,
	Prh[j][i]);
	}
    if (claw_inc == 1) fprintf(fw2, "prherdcd = %10.2f\n", prherdcd);	
    fprintf(fw2, "pricedry = %f\n", pricedry);
    fprintf(fw2, "priceherd = %f\n", priceherd);
    fprintf(fw2, "pricevet = %f\n", pricevet);     	
    fprintf(fw2, "prmilk = %8.3f\n", prmilk); 
    for (i=0; i<=na30; i++) 
      fprintf(fw2, "prmilka30[%d] = %8.3f\n", i,prmilka30[i]);    
    fprintf(fw2, "prmilkb = %8.3f\n", prmilkb); 
    for (i=0; i<=nfat; i++) fprintf(fw2, "prmilkf[%d] = %8.3f\n", i,prmilkf[i]);
    fprintf(fw2, "prmilkfp = %8.3f\n", prmilkfp); 
    for (i=0; i<=nprot; i++) 
      fprintf(fw2, "prmilkp[%d] = %8.3f\n", i,prmilkp[i]);
    for (i=0; i<=nRCT; i++) 
      fprintf(fw2, "prmilkRCT[%d] = %8.3f\n", i,prmilkRCT[i]);    
    fprintf(fw2, "prodsys = %d\n", prodsys);   
    fprintf(fw2, "prodsys2 = %d\n", prodsys2);       
    fprintf(fw2, "profitab = %10.2f\n", profitab); 
    fprintf(fw2, "profitabd = %10.2f\n", profitabd);
    fprintf(fw2, "prot = %f\n",prot);     
    fprintf(fw2, "prot305ave = %10.2f\n", prot305ave);
    fprintf(fw2, "protkg = %10.2f\n", protkg);           
    for (i = 0; i < nSCC; i++) fprintf(fw2, "prSCC[%d] = %f\n", i, prSCC[i]);
    fprintf(fw2, "prscc = %10.2f\n", prscc);
    fprintf(fw2, "prst = %f\n",prst);
    if (claw_inc == 1) fprintf(fw2, "prvetcd = %10.2f\n", prvetcd);
    fprintf(fw2, "prwt = %f\n",prwt);
    for (i = 0; i < nSCC; i++) fprintf(fw2, "pSCC[%d] = %f\n", i, pSCC[i]);  
    fprintf(fw2, "psum = %f\n", psum);
    for (i = 1; i < NCP; i++) fprintf(fw2, "p_tot[%d] = %f\n", i, p_tot[i]);     
    fprintf(fw2, "pydry = %10.4f\n", pydry);      
    for (i=1; i<i4; i++) {
      if (l1[i] > .000001) fprintf(fw2, "qc[%d] = %10.3f\n", i, qc[i]);
      }
    for (i=1; i<i4; i++) {
      if (l1[i] > .000001) fprintf(fw2, "qr[%d] = %10.3f\n", i, qr[i]);
      }
    fprintf(fw2, "RCT = %10.2f\n", RCT);        
    for (i=1; i<i4; i++) {
      if (rev[i] > .000001) fprintf(fw2, "rev[%d] = %10.2f\n", i, rev[i]);
      }
    fprintf(fw2, "revc = %10.2f\n", revc);  
    fprintf(fw2, "revcullc = %10.2f\n", revcullc);    
    for (i=1; i<= CC; i++) {
      if (revmilk[i] > .000001) fprintf(fw2, "revmilk[%d] = %10.2f\n", i, revmilk[i]);
      }
    fprintf(fw2, "revmilkc = %10.2f\n", revmilkc);    
    for (j = 0; j <= na30; j++) {
      for (i = 0; i <= 2; i++) fprintf(fw2, "ra30[%d][%d] = %8.3f\n", i,j,ra30[i][j]);
      }  
    for (j = 0; j <= nfat; j++) {
      for (i = 0; i <= 2; i++) fprintf(fw2, "rf[%d][%d] = %8.3f\n", i,j,rf[i][j]);
      }
    for (i = 3; i < i4; i++) {
      if (l1[i] > .000001) fprintf(fw2, "rfi[%d] = %10.2f\n", i, rfi[i]);
      }
    for (i = 3; i < i4; i++) {
      if (i == 4) i = 8;
      if (i == 11) i = CC + 3;
      if (i == CC + 4) i = CC + 8;
      if (i == CC + 11) break;
      if (l1[i] > .000001) fprintf(fw2, "rfi2[%d] = %10.2f\n", i, rfi2[i]);
      }
    fprintf(fw2, "rfi10 = %10.2f\n", rfi10);  
    fprintf(fw2, "rfi_calf = %d\n", rfi_calf);    
    fprintf(fw2, "rfi_cow = %d\n", rfi_cow);
    fprintf(fw2, "rfi_fa = %d\n", rfi_fa);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "rfifc1[%d] = %10.2f\n", j, rfifc1[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "rfifc2[%d] = %10.2f\n", j, rfifc2[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "rfimc1[%d] = %10.2f\n", j, rfimc1[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "rfimc2[%d] = %10.2f\n", j, rfimc2[j]);
    fprintf(fw2, "rfi_h = %d\n", rfi_h);
    for (j = 0; j <= nprot; j++) {
      for (i = 0; i <= 2; i++) fprintf(fw2, "rp[%d][%d] = %8.3f\n", i,j,rp[i][j]);
      }  
    for (j = 0; j <= nRCT; j++) {
      for (i = 0; i <= 2; i++) fprintf(fw2, "rRCT[%d][%d] = %8.3f\n", i,j,rRCT[i][j]);
      }  
    fprintf(fw2, "sdcd = %10.4f\n", sdcd);
    fprintf(fw2, "sdce = %10.4f\n", sdce);
    for (i = 0; i <= cb; i++) fprintf(fw2, "sfrp[%d] = %f\n", i, sfrp[i]);    
    fprintf(fw2, "sigmaa30 = %8.3f\n",sigmaa30);
    fprintf(fw2, "sigmafat = %8.3f\n",sigmafat);
    fprintf(fw2, "sigmaprot = %8.3f\n",sigmaprot);
    fprintf(fw2, "sigmaRCT = %8.3f\n",sigmaRCT);    
    fprintf(fw2, "sigmaSCS = %f\n",sigmaSCS);
    for (i=1; i<= CC; i++) {
      if (sp[i] > .000001) fprintf(fw2, "sp[%d] = %10.4f\n", i, sp[i]);
      }
    for (i = 0; i < LL; i++) fprintf(fw2, "stcd[%d] = %f\n", i, stcd[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "stce[%d] = %f\n", i, stce[i]);    
    for (i=1; i<i4; i++) {
      if (straw[i] > .000001) fprintf(fw2, "straw[%d] = %10.3f\n", i, straw[i]);
      }
    fprintf(fw2, "straw10 = %10.2f\n", straw10);      
    for (j = 0; j <= cb; j++) fprintf(fw2, "strawwf[%d] = %10.2f\n", j, strawwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "strawwm[%d] = %10.2f\n", j, strawwm[j]);   
    fprintf(fw2, "T = %d\n", T);
    for (i=1; i<i4; i++) {
      if (tc[i] > .000001) fprintf(fw2, "tc[%d] = %10.3f\n", i, tc[i]);
      }
    fprintf(fw2, "tconh = %f\n", tconh);    
    fprintf(fw2, "tconh3 = %f\n", tconh3);    
    fprintf(fw2, "Tcost = %10.2f\n", Tcost);
    for (i = 3; i < i4; i++) {
      if (l1[i] > .000001) fprintf(fw2, "tdry[%d] = %10.2f\n", i, tdry[i]);
      }
    for (j = 0; j <= cb; j++) {
      for (i = 8; i <= 10; i++) {
        if (i == 10 && j == 1) break;    
        fprintf(fw2, "tdry2[%d] = %10.2f\n", i+CC*j, tdry2[i+CC*j]);
        }
      }	
    fprintf(fw2, "tdry10 = %10.2f\n", tdry10);      
    for (i = 3; i < i4; i++) {
      if (l1[i] > .000001) fprintf(fw2, "tdrye[%d] = %10.2f\n", i, tdrye[i]);
      }
    for (j = 0; j <= cb; j++) {
      for (i = 8; i <= 10; i++) {
        if (i == 10 && j == 1) break;    
        fprintf(fw2, "tdrye2[%d] = %10.2f\n", i+CC*j, tdrye2[i+CC*j]);
        }
      }	
    fprintf(fw2, "tdrye10 = %10.2f\n", tdrye10);            
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdryewf[%d] = %10.2f\n", j, tdryewf[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdryewf2[%d] = %10.2f\n", j, tdryewf2[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdryewm[%d] = %10.2f\n", j, tdryewm[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdryewm2[%d] = %10.2f\n", j, tdryewm2[j]);
    for (i = 3; i < i4; i++) {
      if (l1[i] > .000001) 
        fprintf(fw2, "tdrypdi[%d] = %10.2f\n", i, tdrypdi[i]);
      }
    for (j = 0; j <= cb; j++) {
      for (i = 8; i <= 10; i++) {
        if (i == 10 && j == 1) break;    
        fprintf(fw2, "tdrypdi2[%d] = %10.2f\n", i+CC*j, tdrypdi2[i+CC*j]);
        }
      }	
    fprintf(fw2, "tdrypdi10 = %10.2f\n", tdrypdi10);            
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdrypdiwf[%d] = %10.2f\n", j, tdrypdiwf[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdrypdiwf2[%d] = %10.2f\n", j, tdrypdiwf2[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdrypdiwm[%d] = %10.2f\n", j, tdrypdiwm[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdrypdiwm2[%d] = %10.2f\n", j, tdrypdiwm2[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdrywf[%d] = %10.2f\n", j, tdrywf[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdrywf2[%d] = %10.2f\n", j, tdrywf2[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdrywm[%d] = %10.2f\n", j, tdrywm[j]);
    for (j = 0; j <= cb; j++) 
      fprintf(fw2, "tdrywm2[%d] = %10.2f\n", j, tdrywm2[j]);
    fprintf(fw2, "tech1 = %d\n", tech1);
    fprintf(fw2, "tech2 = %d\n", tech2);
    for (i = 0; i < na30; i++) fprintf(fw2, "tha30[%d] = %8.2f\n", i, tha30[i]);
    for (i = 0; i < nfat; i++) fprintf(fw2, "thfat[%d] = %8.2f\n", i, thfat[i]);
    for (i = 0; i < nprot; i++) 
      fprintf(fw2, "thprot[%d] = %8.2f\n", i, thprot[i]);   
    for (i = 0; i < nRCT; i++) fprintf(fw2, "thRCT[%d] = %8.2f\n", i, thRCT[i]);
    for (i = 1; i < NT; i++) fprintf(fw2, "to[%d] = %d\n", i, to[i]);
    for (i = 43; i < NT; i++) {
      if (i == 46) i = 47;
      fprintf(fw2, "to3[%d] = %d\n", i, to3[i]);
      }
    for (i = 1; i < NT; i++) fprintf(fw2, "tt[%d] = %d\n", i, tt[i]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "totcal[%d] = %10.2f\n", j, totcal[j]);   
    fprintf(fw2, "Tprof = %10.2f\n", Tprof);  
    fprintf(fw2, "Tprofh = %10.2f\n", Tprofh);  
    fprintf(fw2, "Tprofl = %10.2f\n", Tprofl);          
    fprintf(fw2, "Tprofm = %10.2f\n", Tprofm);      
    for (i=1; i<i4; i++) {
      if (tr[i] > .000001) fprintf(fw2, "tr[%d] = %10.3f\n", i, tr[i]);
      }
    fprintf(fw2, "trait = %d\n", trait);   
    fprintf(fw2, "Trev = %10.2f\n", Trev); 
    for (i=0; i<nSCC-1; i++) fprintf(fw2, "tSCC[%d] = %8.0f\n", i, tSCC[i]);  
    for (i=0; i<nSCC-1; i++) fprintf(fw2, "tSCS[%d] = %10.2f\n", i, tSCS[i]);
    fprintf(fw2, "TT = %d\n", TT);  
    fprintf(fw2, "tvh = %f\n", tvh);  
    fprintf(fw2, "tvl = %f\n", tvl);          
    fprintf(fw2, "tvm = %f\n", tvm);      
    fprintf(fw2, "u = %f\n",u);  
    fprintf(fw2, "utifemcr = %d\n", utifemcr);
    fprintf(fw2, "utifemp = %d\n", utifemp);
    fprintf(fw2, "varmilk  = %f\n",varmilk);
    for (i = 0; i < DD; i++) fprintf(fw2, "vetdys[%d] = %8.2f\n", i, vetdys[i]);    
    for (i=1; i<i4; i++) {
      if (wat[i] > .000001) fprintf(fw2, "wat[%d] = %10.2f\n", i, wat[i]);
      }
    fprintf(fw2, "wat10 = %10.2f\n", wat10);      
    for (j = 0; j <= cb; j++) fprintf(fw2, "watwf[%d] = %10.2f\n", j, watwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "watwm[%d] = %10.2f\n", j, watwm[j]); 
    for (j = 0; j <= cb; j++) fprintf(fw2, "wbfat[%d] = %f\n", j, wbfat[j]);     
    fprintf(fw2, "wbfatb = %10.2f\n", wbfatb);
    for (i = 0; i < LL; i++) fprintf(fw2, "wcacal[%d] = %f\n", i, wcacal[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "wcc[%d] = %f\n", i, wcc[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "wccal[%d] = %f\n", i, wccal[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "wccw[%d] = %f\n", i, wccw[i]); 
    for (i = 0; i < LL; i++) fprintf(fw2, "wcd[%d] = %f\n", i, wcd[i]);
    for (i = 0; i < LL; i++) fprintf(fw2, "wcdys[%d] = %f\n", i, wcdys[i]);  
    for (j = 0; j <= cb; j++) fprintf(fw2, "wcfat[%d] = %f\n", j, wcfat[j]);    
    fprintf(fw2, "wcfatb = %10.2f\n", wcfatb);
    for (j = 0; j <= cb; j++) fprintf(fw2, "wcwsc[%d] = %f\n", j, wcwsc[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "wcwsf[%d] = %f\n", j, wcwsf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "wcwsm[%d] = %f\n", j, wcwsm[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "wdcwf[%d] = %f\n", j, wdcwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "wdwsc[%d] = %f\n", j, wdwsc[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "wdwsf[%d] = %f\n", j, wdwsf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "wdwsm[%d] = %f\n", j, wdwsm[j]);
    fprintf(fw2, "wh1cal = %10.2f\n", wh1cal);
    fprintf(fw2, "whcmat = %10.2f\n", whcmat);  
    fprintf(fw2, "whdmh = %10.2f\n", whdmh);    
    for (j = 0; j <= cb; j++) fprintf(fw2, "whfat[%d] = %f\n", j, whfat[j]);  
    fprintf(fw2, "whfatb = %10.2f\n", whfatb);
    for (i = 0; i <= cb; i++) fprintf(fw2, "whmat1[%d] = %f\n", i, whmat1[i]);
    fprintf(fw2, "wpreg = %f\n",wpreg);   
    for (i=1; i<i4; i++) {
      if (ww[i] > .000001) fprintf(fw2, "ww[%d] = %10.2f\n", i, ww[i]);
      }
    for (j = 0; j <= cb; j++) fprintf(fw2, "wwf[%d] = %f\n", j, wwf[j]);
    for (j = 0; j <= cb; j++) fprintf(fw2, "wwm[%d] = %f\n", j, wwm[j]); 
    fprintf(fw2, "yacdi = %10.4f\n", yacdi); 
    fprintf(fw2, "ycdi = %10.4f\n", ycdi);             
    fprintf(fw2, "ymi = %10.4f\n", ymi);  
    fprintf(fw2, "ynacdi = %10.4f\n", ynacdi);
    for (i = 0; i < 3; i++) {    
      for (j = 0; j < DL ; j++)
	fprintf(fw2, "zzdmi[%d][%d] = %f\n", i, j, zzdmi[i][j]);  
      }    
    for (i = 0; i < LL; i++) fprintf(fw2, "zzircmy[%d] = %f\n", i, zzircmy[i]); 
    for (i = 1; i < 21; i++) fprintf(fw2, "zzlosc[%d] = %f\n", i, zzlosc[i]);   
    for (i=1; i<= CC; i++) {
      if (zzmilksum[i] > .000001) 
	fprintf(fw2, "zzmilksum[%d] = %10.2f\n", i, zzmilksum[i]);
      }
    fclose(fw2);
    }
      
  if (trait == 0 && zr == 1) goto EW;

  printf("\nThank you for using program EWDC.\n");
  printf("The results are in the file %s.\n", out);
  printf("The values of all variables are in the file CHECKD.\n");
  kon = clock();
  printf("The program needed %f seconds.\n", ((double) (kon - zac)) / ((double) CLOCKS_PER_SEC));
END:
  printf("\n");
  return 0;
} /* End of function main */

/* Functions */

/* Maximum of two numbers */
float maxi(float a, float b) {
  float c;
  c = a;
  if (a < b) c = b;
  return c;
}

/* Minimum of two numbers */
float mini(float a, float b) {
  float c;
  c = a;
  if (a > b) c = b;
  return c;
}

/* Probit function */
double probit (double y) {
  double x1, x2, y1, y2;
  int i;
  x1=-5;
  x2=5;  
  for (i=1; i<=200; i++){
  y1=normdis(x1);
  y2=normdis(x2);
  if (y2<y) x2=x2+(x2-x1)/2;
  if (y1>y) x1=x1-(x2-x1)/2;
  if (y2-y>y-y1) x2=x2-(x2-x1)/10;
    else x1=x1+(x2-x1)/10;
    }
  return (x1+x2)/2;
  }

/* Normal distribution */    
double normdis(double x) {
  double u;
  if (x<=0) u = .5 - erf(-x/sqrt(2.))/2;  
  if (x>0) u = .5 + erf(x/sqrt(2.))/2;  
  return u;
  }

/* Function for reading system variables and writing them to output file */
void sysvar(FILE *fr, FILE *fw)
{
  int a, b, i, z;
  for (i = 1; i <= 24; i++)
  { fscanf(fr, "%d", &b);
    a = 0;
    do {z = getc(fr);
        if (z == '"') a++;
	if (z != '"') putc(z, fw); 
       } while (a<2);
    fprintf(fw, ":  %d", b);   
  }
  fprintf(fw, "\n");   
}

/* Function for reading system variables to the main program */
int readsyva(FILE *fr)
{
  int a, b, z;
  fscanf(fr, "%d", &b);
  a = 0;
  do {z = getc(fr);
      if (z=='"') a++;
  } while (a < 2);  
  return b;
}

/* Skipping the comment at the beginning of the input file */
void readcom(FILE *fr)
{
  int a, z;
  a = 0;
  do {z = getc(fr);
      if (z=='/') a++;
  } while (a < 2);  
}

/* Skipping the description and the unit of the input parameter */
void readdes(FILE *fr)
{
  int a, z;
  a = 0;
  do {z = getc(fr);
      if (z=='"') a++;
  } while (a < 4);  
}

/* Function for writing data from file INPUT15.TXT to the results file*/
void inp15a(FILE *fr, FILE *fw, int cb, float d2, float d3)
{
  wrides(fr,fw);  
  if (cb == 1) fprintf(fw,"%12.4f %12.4f", d2, d3);
  if (cb == 0) fprintf(fw,"%12.4f", d2);   
}  

/* Function for selective writing data from file INPUT15.TXT referring to castrates  to the results file */
void inp15b(FILE *fr, FILE *fw, int cb, int ca0, int ca1, float d2, float d3)
{
  if (ca0 + ca1 > 0) wrides(fr,fw);  
    else readdes(fr);
  if (ca0 > 0 && ca1 > 0 && cb == 1) fprintf(fw,"%12.4f %12.4f", d2, d3); 
  if (ca0 > 0 && ca1 == 0) fprintf(fw,"%12.4f         -", d2);
  if (ca0 == 0 && ca1 > 0 && cb == 1) fprintf(fw,"        -    %12.4f", d3);  
}  

/* Function for reading the head of a input file
   and writing it to the output file*/
void inp07(FILE *fw, int n2, int zz)
{
  if (zz<10) fprintf(fw, "2.%1d Data from file ", zz);
    else fprintf(fw, "2.%2d Data from file ", zz);
  if (n2<10) fprintf(fw, "INPUT0%d.TXT\n", n2);
  if (n2>9) fprintf(fw, "INPUT%d.TXT\n", n2);
  if (zz<10) fprintf(fw, "------------------------------\n");
    else fprintf(fw, "-------------------------------\n");
}  

/* Function for reading system variables and writing them to output file */
void wrides(FILE *fr, FILE *fw)
{
int a, a1, z;
  fprintf(fw, "\n");
  a = 0;
  do {z = getc(fr);
      if (z == '"') a++;
      if (z != '"' && a > 0) putc(z, fw); 
     } while (a<2);
  a = 0;
  a1 = 0;    
  do {z = getc(fr);
      if (z == '"') a++;
      if (a == 1 && a1 == 0)
	{ fprintf(fw, "   (");
	  a1++;
	} 
      if (z != '"') putc(z, fw); 
     } while (a<2);
  fprintf(fw,"):");
}
/* Function for reading data from file TEXTD_OUT.TXT and writing them to the output file*/
void outputrw(FILE *fr, FILE *fw)
{
  int a, z;
    a = 0;
    do {z = getc(fr);
        if (z == '"') a++;
	if (z != '"') putc(z, fw); 
       } while (a<2);
}
/* Function for reading data from file TEXTD_OUT.TXT without writing them to the output file*/
void outputr(FILE *fr)
{
  int a, z;
    a = 0;
    do {z = getc(fr);
        if (z == '"') a++;	
       } while (a<2);
}
/* Linear regression on fat or protein content */
float linregm (float xave, float sigma, float xmin, float xmax, float b0, float b1, float xbar) {
  double Phimin, Phimax, sum, dif, inc;
  int i;
  if (xmax > xave + 4*sigma) xmax = xave + 4*sigma;
  if (xmin < xave - 4*sigma) xmin = xave - 4*sigma;  
  Phimin= normdis((double) ((xmin-xave)/sigma));
  Phimax= normdis((double) ((xmax-xave)/sigma));
  sum = 0;
  if (fabs(b1) > 0.000001) {
    inc = (xmax-xmin)/500;
    for (i=1; i<=500; i++) {
      dif = normdis((double) ((xmin+i*inc-xave)/sigma)) -
              normdis((double) ((xmin+(i-1)*inc-xave)/sigma));
      sum += b1*dif*(xmin-xbar+(2*i-1)*inc/2);	    
      }
    }
  if (fabs(b0) > 0.000001) sum += b0*(Phimax-Phimin);  
  return (float) sum;
  }
/* Function for printing results with or without crossbreeding */
void printcb(int cb, float par1, float par2, FILE *fw)
{
  if (cb == 1) fprintf(fw, "%10.3f %10.3f", par1, par2);
  if (cb == 0) fprintf(fw, "%10.3f", par1);
}  
/* Function for the calculation of the somatic cell score from the somatic
   cell count */
float scs(float x) 
{
  float y;
  y = log((double)(x/100000))/0.69314718+3;
  return y;
}   
/* Function for reading data in format int and writing them to results */
float readint(FILE *fw, FILE *fr)
{
  int a, a1, z, d2;
  fscanf(fr, "%d", &d2);
  a = 0;
  do {z = getc(fr);
      if (z == '"') a++;
      if (z != '"') putc(z, fw); 
     } while (a<2);
  a = 0;
  a1 = 0;    
  do {z = getc(fr);
      if (z == '"') a++;
      if (a == 1 && a1 == 0)
	{ fprintf(fw, "   (");
	  a1++;
	} 
      if (z != '"') putc(z, fw); 
     } while (a<2);
    fprintf(fw,"):  %d ", d2);   
  return d2;
}
/* Function for reading data in format float and writing them to results */
float readfloat(FILE *fw, FILE *fr)
{
  int a, a1, z;
  float d2;
  fscanf(fr, "%f", &d2);
  a = 0;
  do {z = getc(fr);
      if (z == '"') a++;
      if (z != '"') putc(z, fw); 
     } while (a<2);
  a = 0;
  a1 = 0;    
  do {z = getc(fr);
      if (z == '"') a++;
      if (a == 1 && a1 == 0)
	{ fprintf(fw, "   (");
	  a1++;
	} 
      if (z != '"') putc(z, fw); 
     } while (a<2);
    fprintf(fw,"):%12.4f ", d2);   
  return d2;
}
/* Wrong proportions of male calves */
void nonsense1(int i)
{
  printf("\nSomething is going wrong. The sum of the proportions of ");
  if (i == 0) printf("pure-bred ");
  if (i == 1) printf("cross-bred ");   
  printf("male calves\n");
  printf("alive at 48 hours determined for export and for breeding is > 1.\n");
  printf("Correct the error in INPUT15.TXT and restart the program.\n\n\n");
  }
/* Are there castrates for fattening or not - that's the question */
void nonsense2(int i)
{
  printf("\nSomething is going wrong. In PARAD.TXT you state that there are \n");
  if (i == 0) printf("  pure-bred ");
  if (i == 1) printf("  cross-bred ");   
  printf("castrates for fattening, but in INPUT15.TXT you give a\n");
  printf("  proportion of zero for ");
  if (i == 0) printf("pure-bred ");
  if (i == 1) printf("cross-bred ");   
  printf("castrates for fattening.\n");
  printf("  Resolve this problem and restart the program.\n\n\n");
  }
/* Wrong parameter(s) in PARAD.TXT */
void nonsense3()
{
  printf("\nSomething is going wrong with your parameters in PARAD.TXT.\n");
  printf("When you state that there is no cross-breeding in the system,\n"); 
  printf("you cannot calculate the economic weight for beef sires.\n");
  printf("Therefore, the option for the selection group for which gene flow\n");   printf("is calculated cannot be 3.\n");
  printf("Correct the error and restart the program.\n\n");
  }
/* Wrong input parameters for gene flow */
void nonsense4(int i)
{
  printf("\n\n\nSomething is going wrong. The proportions of genes for the path\n");
  if (i == 1) printf("sires to sires ");
  if (i == 2) printf("sires to dams ");
  if (i == 3) printf("dams to sires ");
  if (i == 4) printf("beef sires to crossbred progeny ");    
  printf("do not sum to 0.5.\n");
  printf("Correct the error in INPUT27.TXT and restart the program.\n\n\n");
  }
/* Wrong number of age classes for dairy dams */
void nonsense5(int i)
{
  printf("\n\n\nSomething is going wrong. The number of age classes for \n");
  printf("dairy dams is not correct. You should use the value %d .\n",i);
  printf("Correct the error in INPUT27.TXT and restart the program.\n\n\n");
  }
/* Wrong inputs for price of animals */
void nonsense6(int i, int j, int CC)
{
  printf("\n\n\nSomething is going wrong. You cannot sell the animals of\n");
  printf("category %d per kg live weight and in the same time per head.\n",i+CC*j);
  printf("Correct the error in INPUT21.TXT and restart the program.\n\n\n");
  }
/* Wrong parameter(s) in PARAD.TXT */
void nonsense7()
{
  printf("\nSomething is going wrong with your parameters in PARAD.TXT.\n");
  printf("When you state that there is cross-breeding in the system,\n"); 
  printf("the option for the calculation of economic values must be\n");
  printf("1 or 2, it cannot be 0.\n");
  printf("Correct the error and restart the program.\n\n");
  }
/* Wrong parameter(s) in PARAD.TXT */
void nonsense8()
{
  printf("\nSomething is going wrong with your parameters in PARAD.TXT.\n");
  printf("When there is cross-breeding in the system and the option for\n"); 
  printf("the calculation of economic values is 1, then the option for\n");
  printf("the selection group for which gene flow is calculated must be 3.\n");
  printf("Correct the error and restart the program.\n\n");
  }
/* Wrong parameter(s) in PARAD.TXT */
void nonsense9()
{
  printf("\nSomething is going wrong with your parameters in PARAD.TXT.\n");
  printf("When there is cross-breeding in the system and the option for\n"); 
  printf("the calculation of economic values is 2, then the option for\n");
  printf("the selection group for which gene flow is calculated must not be 3.\n");
  printf("Correct the error and restart the program.\n\n");
  }
/* Wrong parameter(s) in PARAD.TXT */
void nonsense10()
{  
  printf("\nSomething is going wrong with your parameters in PARAD.TXT.\n");
  printf("You intend to calculate the economic weights for a pure-bred system.\n");
  printf("In this system, the option for the calculation of economic\n"); 
  printf("weights must be always 0.\n");
  printf("Correct the error and restart the program.\n\n");
  }  
/* Wrong input parameters for herd structure */
void nonsense11(int i)
{
  if (i == 1) {
    printf("\nSomething is going wrong. There are not enough dairy heifers for \n");
    printf("replacement. Decrease the proportion of cows mated with beef bulls\n");
    printf("and/or change one or more of the following parameters in INPUT07.TXT:\n"); 
    printf("cow losses, culling for health, culling for low milk production and\n");
    printf("conception rate for cows and/or heifers. Furthermore, the value for \n");   
    printf("heifers negatively selected before mating may be too high (INPUT15.TXT).\n\n\n");    
    }
  if (i == 0) {
    printf("\nSomething is going wrong. There are not enough dairy heifers for \n");
    printf("replacement. Change one or more of the following parameters in \n"); 
    printf("INPUT07.TXT: cow losses, culling for health, culling for low milk \n");
    printf("production and conception rate for cows and/or heifers.\n");
    printf("Furthermore, the value for heifers negatively selected before \n");   
    printf("mating may be too high (INPUT15.TXT).\n\n\n");    
    }
  }
/* Wrong input parameter adg1cow */
void nonsense12()
{
  printf("\nOne of your input parameters is wrong.\n");
  printf("Decrease the parameter Average daily gain of cows in 1st reproduction\n"); 
  printf("cycle in INPUT11.TXT and restart the program.\n");
  }
/* Wrong input parameters in INPUT30.TXT or INPUT38.TXT */
void nonsense13(int i)
{
  printf("\nYour input parameters in INPUT%2d.TXT are not correct. Correct this file\n",i);
  printf("and restart the program.\n");
  }
/* Wrong parameter(s) in PARAD.TXT */
void nonsense14()
{  
  printf("\nSomething is going wrong with your parameters in PARAD.TXT.\n");
  printf("The option for Genetic standard deviation of the traits is in \n");
  printf("contradiction with other parameter values in  PARAD.TXT.\n"); 
  printf("You can only use values 1 or 2.\n");
  printf("Correct the error and restart the program.\n\n");
  }  
/* Wrong parameter(s) in PARAD.TXT */
void nonsense15()
{  
  printf("\nSomething is going wrong with your parameters in PARAD.TXT.\n");
  printf("You cannot calculate the economic value for residual dry\n");
  printf("matter intake in fattening if there is no fattening.\n"); 
  printf("Correct the error in  PARAD.TXT and restart the program.\n\n");
  }  
